(function (exports,React,ReactDOM,axios) {
'use strict';

var React__default = 'default' in React ? React['default'] : React;
axios = 'default' in axios ? axios['default'] : axios;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};











var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};



var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};











var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

// 兼容ES7的includes
if (!window.Array.prototype.includes) {
  window.Array.prototype.includes = function (searchElement) {
    return this.some(function (el) {
      return el === searchElement;
    });
  };
}

// 幂集 如:[1,2],返回[[1],[2],[1,2]]
window.Array.prototype.powerset = function () {
  var ps = [[]];
  for (var i = 0; i < this.length; i++) {
    for (var j = 0, len = ps.length; j < len; j++) {
      ps.push(ps[j].concat(this[i]));
    }
  }
  return ps;
};

// 二维数组转为一维数组
window.Array.prototype.toOneColumn = function () {
  var reg = /[\d\.]+\,([\d\.]+)/g; // eslint-disable-line
  return this.join(',').replace(reg, '$1').split(',');
};

// 包含，支持传数组包含数组
window.Array.prototype.contains = function (arg) {
  if (toString.call(arg) !== '[object Array]') {
    return this.indexOf(arg) > -1;
  }
  return this.filter(function (elem) {
    return arg.indexOf(elem) > -1;
  }).length === arg.length;
};

// 比较两个数组是否相同, 比较不了包含{x: 20}的数组
if (window.Array.prototype.equals) {
  console.warn('覆盖现有的window.Array.prototype.equals。 可能的原因：新的API定义了方法，存在框架冲突，或者在代码中包含了双重包含。');
}
window.Array.prototype.equals = function (array) {
  if (!array) return false;

  // 比较长度可以节省很多时间
  if (this.length !== array.length) return false;

  for (var i = 0; i < this.length; i++) {
    // 检查是否有嵌套的数组
    if (this[i] instanceof Array && array[i] instanceof Array) {
      // 递归到嵌套数组中
      if (!this[i].equals(array[i])) return false;
    }
    // 检查是否有JSON数据,只比较一层
    else if (this[i] instanceof Object && array[i] instanceof Object) {
        for (var n in this[i]) {
          if (this[i][n] !== array[i][n]) return false;
        }
      } else if (this[i] !== array[i]) {
        // 警告 - 两个不同的对象实例永远不会相同：{x：20}!= {x：20}
        return false;
      }
  }
  return true;
};
// 从for-in循环隐藏方法
Object.defineProperty(window.Array.prototype, "equals", { enumerable: false });

// 判断数组中是否有重复数据,只能比较数字字符串
window.Array.prototype.isRepeatArray = function () {
  var arrStr = this.join(',') + ',';
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = this[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var item = _step.value;

      if (arrStr.replace(item + ',', '').indexOf(item + ',') >= 0) return true;
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return false;
};
// 移除数组json中的项
window.Array.prototype.removeProperties = function (properties) {
  var _iteratorNormalCompletion2 = true;
  var _didIteratorError2 = false;
  var _iteratorError2 = undefined;

  try {
    for (var _iterator2 = this[Symbol.iterator](), _step2; !(_iteratorNormalCompletion2 = (_step2 = _iterator2.next()).done); _iteratorNormalCompletion2 = true) {
      var item = _step2.value;

      for (var n in item) {
        var _iteratorNormalCompletion3 = true;
        var _didIteratorError3 = false;
        var _iteratorError3 = undefined;

        try {
          for (var _iterator3 = properties[Symbol.iterator](), _step3; !(_iteratorNormalCompletion3 = (_step3 = _iterator3.next()).done); _iteratorNormalCompletion3 = true) {
            var property = _step3.value;

            if (n === property) delete item[n];
          }
        } catch (err) {
          _didIteratorError3 = true;
          _iteratorError3 = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion3 && _iterator3.return) {
              _iterator3.return();
            }
          } finally {
            if (_didIteratorError3) {
              throw _iteratorError3;
            }
          }
        }
      }
    }
  } catch (err) {
    _didIteratorError2 = true;
    _iteratorError2 = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion2 && _iterator2.return) {
        _iterator2.return();
      }
    } finally {
      if (_didIteratorError2) {
        throw _iteratorError2;
      }
    }
  }

  return this;
};
// 将数组中的项都转成字符串
window.Array.prototype.toStringOption = function () {
  return this.map(function (item) {
    if ((typeof item === 'undefined' ? 'undefined' : _typeof(item)) === 'object' || typeof item === 'function') return JSON.stringify(item);
    return item;
  });
};

/* -------------------
解决加减乘除精度
------------------- */
Math.Calc = function () {
  // 判断obj是否为一个整数
  function isInteger(obj) {
    return Math.floor(obj) === obj;
  }

  /* -----------------------------------------------------
  将一个浮点数转成整数，返回整数和倍数。如 3.14 >> 314，倍数是 100
  @param floatNum {number} 小数
  @return ret {times:100, num: 314}
  ----------------------------------------------------- */
  function toInteger(floatNum) {
    var ret = { times: 1, num: 0 };
    var isNegative = floatNum < 0;
    if (isInteger(floatNum)) {
      ret.num = floatNum;
      return ret;
    }
    var strfi = floatNum + '';
    var dotPos = strfi.indexOf('.');
    var len = strfi.substr(dotPos + 1).length;
    var times = Math.pow(10, len);
    var intNum = parseInt(Math.abs(floatNum) * times + 0.5, 10);
    ret.times = times;
    if (isNegative) {
      intNum = -intNum;
    }
    ret.num = intNum;
    return ret;
  }

  /* -----------------------------------------------------
  核心方法，实现加减乘除运算，确保不丢失精度
  思路：把小数放大为整数（乘），进行算术运算，再缩小为小数（除）
   @param a {number} 运算数1
  @param b {number} 运算数2
  @param digits {number} 精度，保留的小数点数，比如 2, 即保留为两位小数
  @param op {string} 运算类型，有加减乘除（add/subtract/multiply/divide）
  ----------------------------------------------------- */
  function operation(a, b, digits, op) {
    var o1 = toInteger(a);
    var o2 = toInteger(b);
    var n1 = o1.num;
    var n2 = o2.num;
    var t1 = o1.times;
    var t2 = o2.times;
    var max = t1 > t2 ? t1 : t2;
    var result = null;
    switch (op) {
      case 'add':
        if (t1 === t2) {
          // 两个小数位数相同
          result = n1 + n2;
        } else if (t1 > t2) {
          // o1 小数位 大于 o2
          result = n1 + n2 * (t1 / t2);
        } else {
          // o1 小数位 小于 o2
          result = n1 * (t2 / t1) + n2;
        }
        result = result / max;
        break;
      case 'subtract':
        if (t1 === t2) {
          result = n1 - n2;
        } else if (t1 > t2) {
          result = n1 - n2 * (t1 / t2);
        } else {
          result = n1 * (t2 / t1) - n2;
        }
        result = result / max;
        break;
      case 'multiply':
        result = n1 * n2 / (t1 * t2);
        break;
      case 'divide':
        result = n1 / n2 * (t2 / t1);
        break;
      default:
        result = 0;
    }
    if (digits && !isNaN(digits)) {
      // 精度设置
      return toDigits(result, digits);
    }
    return result;
  }

  // 加减乘除的四个接口
  function add(a, b, digits) {
    return operation(a, b, digits, 'add');
  }
  function subtract(a, b, digits) {
    return operation(a, b, digits, 'subtract');
  }
  function multiply(a, b, digits) {
    return operation(a, b, digits, 'multiply');
  }
  function divide(a, b, digits) {
    return operation(a, b, digits, 'divide');
  }
  // toFixed 修复两位小数不会四舍五入的问题
  function toFixed(num, digits) {
    var times = Math.pow(10, digits);
    var result = num * times + 0.5;
    result = parseInt(result, 10) / times;
    return result;
  }
  // toDigits 精度
  function toDigits(argNum, digits) {
    if (Number(digits) === 0) return Math.floor(argNum);
    if (!digits) return argNum;
    var digitsMatch = new RegExp('[0-9]+(\\.[0-9]{1,' + digits + '})?');
    var num = ('' + argNum).match(digitsMatch);
    if (num && num[0]) return Number(num[0]);
    return argNum;
  }
  // 转换为千分位字符
  function toThousandth(num) {
    if (!num) return '0';
    var sExpr = /^(\d+)((\.\d+)?)$/;
    var n1 = num.toString().replace(sExpr, function (s, s1, s2) {
      var reExpr = /\d{1,3}(?=(\d{3})+$)/g;
      return s1.replace(reExpr, '$&,') + s2;
    });
    return n1;
  }
  // exports
  return {
    add: add,
    subtract: subtract,
    multiply: multiply,
    divide: divide,
    toFixed: toFixed,
    toDigits: toDigits,
    toThousandth: toThousandth
  };
}();

/* -------------------
判断是否是空对象
------------------- */
Object.isEmptyObject = function (obj) {
  for (var n in obj) {
    if (obj.hasOwnProperty(n)) {
      return false;
    }
  }
  return true;
};
/* -------------------
判断是否是纯对象
------------------- */
Object.isPlainObject = function (obj) {
  var proto;
  var Ctor;
  if (!obj || toString.call(obj) !== '[object Object]') {
    return false;
  }

  proto = Object.getPrototypeOf(obj);

  // 没有原型的对象（例如`Object.create（null）`），则直接返回true
  if (!proto) {
    return true;
  }

  // 如果原型的对象是由全局Object函数构造的，则它们是纯对象
  Ctor = {}.hasOwnProperty.call(proto, 'constructor') && proto.constructor;
  return typeof Ctor === 'function' && {}.hasOwnProperty.toString.call(Ctor) === {}.hasOwnProperty.toString.call(Object);
};

/* -------------------
  克隆对象字面量、Array
  ------------------- */
Object.clone = function (obj) {
  var copy;
  if ((typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object') {
    if (obj === null) {
      copy = null;
    } else {
      if (obj instanceof Array) {
        copy = [];
        for (var i = 0; i < obj.length; i++) {
          copy.push(this.clone(obj[i]));
        }
      } else {
        copy = {};
        for (var j in obj) {
          copy[j] = this.clone(obj[j]);
        }
      }
    }
  } else {
    copy = obj;
  }
  return copy;
};

/*
  * 用于get请求,将Json参数转为params字符串
  * 参数: obj:请求参数; splitter:dot点 | bracket中括号, isNotEnCode:是否不使用encodeURIComponent编码
  * 返回: splitter为dot时,返回obj.key=value&obj.key=value; bracket时,返回obj[key]=value&obj[key]=value
  * */
Object.params = function (obj, splitter, isNotEnCode) {
  if (!Object.isPlainObject(obj)) return obj;
  if (obj instanceof Object && obj.length > 0) return '';
  // 把{jsonReq:[{0:'0', 1:'1'}]}转成jsonReq=[{0:'0', 1:'1'}]的方式
  if (splitter === 'dot') {
    var arr = [];
    for (var n in obj) {
      arr.push(n + '=' + JSON.stringify(obj[n]));
    }
    return arr.join('&');
  }
  // 把{jsonReq:[{0:'0', 1:'1'}]}转成jsonReq.0=0&jsonReq.1=1的方式(支持嵌套Json)
  var result = '';
  function buildParams(obj, prevKey) {
    for (var key in obj) {
      if (obj[key] instanceof Object) {
        var prefix = prevKey ? prevKey + '.' + key : key;
        buildParams(obj[key], prefix);
      } else {
        if (prevKey) {
          // result += '&' + prevKey + '.' + key + '=' + obj[key]
          if (splitter !== 'bracket') result += '&' + prevKey + '.' + key + '=' + (isNotEnCode ? obj[key] : encodeURIComponent(obj[key]));
          if (splitter === 'bracket') result += '&' + prevKey + '[' + key + ']=' + (isNotEnCode ? obj[key] : encodeURIComponent(obj[key]));
        } else {
          // result += '&' + key + '=' + obj[key]
          result += '&' + key + '=' + (isNotEnCode ? obj[key] : encodeURIComponent(obj[key]));
        }
      }
    }
    return result;
  }
  buildParams(obj);
  // 删除result第一个字符
  if (result) {
    result = result.slice(1);
  }
  return result;
};
/* Object.params = function (obj, isNotEnCode) {
  var result = ''
  var item
  for (item in obj) {
    if (isNotEnCode) result += '&' + item + '=' + obj[item]
    else result += '&' + item + '=' + encodeURIComponent(obj[item]) // 使用decodeURIComponent解码
  }
  if (result) {
    result = result.slice(1)
  }
  return result
} */

/* -------------------
  获得类型, boolean | number | string | function | array | date | regexp
  ------------------- */
Object.type = function (obj) {
  if (!obj) {
    return obj + '';
  }
  return Object.prototype.toString.call(obj).replace('[', '').replace(']', '').split(' ')[1].toLowerCase();
};

/* -------------------
  是否是方法
  ------------------- */
Object.isFunction = function (obj) {
  return Object.type(obj) === 'function';
};

/* -------------------
  是否是窗口
  ------------------- */
Object.isWindow = function (obj) {
  return obj != null && obj === obj.window;
};

/* -------------------
  继承合并
  ------------------- */
Object.extend = function () {
  var options;
  var name;
  var src;
  var copy;
  var copyIsArray;
  var clone;
  var target = arguments[0] || {};
  var i = 1;
  var length = arguments.length;
  var deep = false;

  // Handle a deep copy situation
  if (typeof target === 'boolean') {
    deep = target;

    // Skip the boolean and the target
    target = arguments[i] || {};
    i++;
  }

  // Handle case when target is a string or something (possible in deep copy)
  if ((typeof target === 'undefined' ? 'undefined' : _typeof(target)) !== 'object' && !Object.isFunction(target)) {
    target = {};
  }

  // Extend jQuery itself if only one argument is passed
  if (i === length) {
    target = this;
    i--;
  }

  for (; i < length; i++) {
    // 只处理非空/未定义的值
    options = arguments[i];
    if (options != null) {
      // 扩展基础对象
      for (name in options) {
        src = target[name];
        copy = options[name];

        // 防止永无止境的循环
        if (target === copy) {
          continue;
        }

        // 如果我们合并了普通的对象或数组，就会重新出现
        if (deep && copy && (Object.isPlainObject(copy) || (copyIsArray = Array.isArray(copy)))) {
          // eslint-disable-line
          if (copyIsArray) {
            copyIsArray = false;
            clone = src && Array.isArray(src) ? src : [];
          } else {
            clone = src && Object.isPlainObject(src) ? src : {};
          }

          // 永远不要修改原始对象，而是克隆它们
          target[name] = Object.extend(deep, clone, copy);

          // 不要带入未定义的值
        } else if (copy !== undefined) {
          target[name] = copy;
        }
      }
    }
  }

  // 返回修改后的对象
  return target;
};
/* -------------------
  生成唯一标识
  ------------------- */
Object.generateGUID = function () {
  var d = new Date().getTime();
  var uuid = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
    var r = (d + Math.random() * 16) % 16 | 0;
    d = Math.floor(d / 16);
    return (c === 'x' ? r : r & 0x3 | 0x8).toString(16); // eslint-disable-line
  });
  return uuid;
};
/* -------------------
  比较两个对象是否相同
  ------------------- */
Object.equals = function (object1, object2) {
  // 用window.Object.prototype.equals在react或者vue中会默认为组件绑定此方法而报错,故不用
  // 第一个循环，只检查类型
  for (var propName in object1) {
    // 检查继承的方法和属性 - 比如.equals本身
    // 如果返回值不同，则返回false
    if (object1.hasOwnProperty(propName) !== object2.hasOwnProperty(propName)) {
      return false;
    }
    // 检查实例类型
    else if (_typeof(object1[propName]) !== _typeof(object2[propName])) {
        // 不同的类型=>不等于
        return false;
      }
  }
  // 现在更深入地检查使用其他对象的属性名称
  for (propName in object2) {
    // 无论如何必须检查实例，可能有一个只存在于object2中的属性
    if (object1.hasOwnProperty(propName) !== object2.hasOwnProperty(propName)) {
      return false;
    } else if (_typeof(object1[propName]) !== _typeof(object2[propName])) {
      return false;
    }
    // 如果该属性是继承的，则不要再检查（如果两个对象都继承它，则必须相等）
    if (!object1.hasOwnProperty(propName)) continue;

    // 现在详细检查和递归

    // 这将脚本返回到数组比较
    /** 需要Array.equals **/
    if (object1[propName] instanceof Array && object2[propName] instanceof Array) {
      // 递归到嵌套数组中
      if (!Object.equals(object1[propName], object2[propName])) return false;
    } else if (object1[propName] instanceof Object && object2[propName] instanceof Object) {
      // 递归到另一个对象中
      // console.log('递归比较 ', object1[propName],'和',object2[propName], ' 都命名 \''+propName+'\'')
      if (!Object.equals(object1[propName], object2[propName])) return false;
    }
    // 字符串和数字的正常值比较
    else if (object1[propName] !== object2[propName]) {
        return false;
      }
  }
  // 如果一切顺利,返回true
  return true;
};

// 转为json，目的是字符串去重
window.String.prototype.toJson = function (split) {
  var array = this.split(split);
  var json = {};
  for (var i in array) {
    var ary = array[i];
    json[ary] ? json[ary]++ : json[ary] = 1;
  }
  return json;
};
function left_zero_4(str) {
  if (str && str.length === 2) {
    return '00' + str;
  }
  return str;
}
// 转为ASCII编码
window.String.prototype.toASCII = function () {
  var value = '';
  for (var i = 0; i < this.length; i++) {
    value += '\\u' + left_zero_4(parseInt(this.charCodeAt(i), 10).toString(16));
  }
  return value;
};
// 转为unicode编码
window.String.prototype.toUnicode = function () {
  var value = '';
  for (var i = 0; i < this.length; i++) {
    value += '&#' + this.charCodeAt(i) + ';';
  }return value;
};
// 转为UTF8编码
window.String.prototype.toUTF8 = function () {
  var value = '';
  for (var i = 0; i < this.length; i++) {
    value += '&#x' + left_zero_4(parseInt(this.charCodeAt(i), 10).toString(16)) + ';';
  }
  return value;
};
// 转为URI编码
window.String.prototype.toURI = function () {
  return encodeURI(this);
};
// 转为URI全编码
window.String.prototype.toURIComponent = function () {
  return encodeURIComponent(this);
};
// ASCII,unicode,UTF8解码
window.String.prototype.decode = function () {
  var str = this;
  str = str.replace(/(\\u)(\w{1,4})/gi, function ($0) {
    return String.fromCharCode(parseInt(escape($0).replace(/(%5Cu)(\w{1,4})/g, "$2"), 16));
  });
  str = str.replace(/(&#x)(\w{1,4});/gi, function ($0) {
    return String.fromCharCode(parseInt(escape($0).replace(/(%26%23x)(\w{1,4})(%3B)/g, "$2"), 16));
  });
  str = str.replace(/(&#)(\d{1,6});/gi, function ($0) {
    return String.fromCharCode(parseInt(escape($0).replace(/(%26%23)(\d{1,6})(%3B)/g, "$2"), 10));
  });
  return decodeURIComponent(str);
};

// 去除字符串左右两端的空格
window.String.prototype.trim = function (trimPos) {
  if (trimPos === 'left') {
    return this.replace(/(^\s*)/g, '');
  } else if (trimPos === 'right') {
    return this.replace(/(\s*$)/g, '');
  }
  return this.replace(/(^\s*)|(\s*$)/g, '');
};

// 判断是否是#的形式
window.String.prototype.isQueryId = function () {
  if (!this.length) return false;
  var idExpr = /^#([\w-]*)$/; // 匹配id(#id)
  var match = idExpr.exec(this);
  if (!match || !match[1]) {
    return false;
  }
  return true;
};
// 判断是否是合法的日期
window.String.prototype.isDate = function () {
  if (!this.length) return false;
  var patt = '^[0-9]{4}-[0-9]{2}-[0-9]{2}$'; // yyyy-MM-dd
  if (new RegExp(patt).test(this)) return true;
  return false;
};
// 判断是否是合法的月份
window.String.prototype.isMonth = function () {
  if (!this.length) return false;
  var patt = '^[0-9]{4}-[0-9]{2}$'; // yyyy-MM
  if (new RegExp(patt).test(this)) return true;
  return false;
};
// 判断是否是日期格式
window.String.prototype.isDateTime = function () {
  if (!this.length) return false;
  var patts = ['^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}$', // yyyy-MM-dd HH:mm
  '^[0-9]{4}-[0-9]{2}-[0-9]{2} [0-9]{2}:[0-9]{2}:[0-9]{2}$' // yyyy-MM-dd HH:mm:ss
  ];
  for (var i in patts) {
    if (new RegExp(patts[i]).test(this)) return true;
  }
  return false;
};
// 判断是否是时间格式
window.String.prototype.isTime = function () {
  if (!this.length) return false;
  var patts = ['^[0-9]{2}:[0-9]{2}$', // HH:mm
  '^[0-9]{2}:[0-9]{2}:[0-9]{2}$' // HH:mm:ss
  ];
  for (var i in patts) {
    if (new RegExp(patts[i]).test(this)) return true;
  }
  return false;
};
// 判断是否包含class名称
window.String.prototype.hasClass = function (name) {
  var classStr = this;
  if (this.indexOf('class=') > -1) {
    var res = classStr.match(/class=["'](.*)["']/);
    if (res[1]) {
      classStr = res[1];
    } else {
      classStr = '';
    }
  }
  var names = classStr.split(' ');
  for (var i = 0; i < names.length; i++) {
    if (names[i] === name) return true;
  }
  return false;
};
// 添加class名称
window.String.prototype.addClass = function (name) {
  var str = String(this);
  var className = 'class="' + name + '"';
  if (this.indexOf('class=') > -1) {
    // 如果有class,并且class名称不存在,则增加class
    var res = this.match(/class=["'](.*)["']/);
    if (res[1] && !res[1].hasClass(name)) {
      // 新增class不存在,则新增
      className = 'class="' + res[1] + ' ' + name + '"';
      str = str.replace(/class=["'](.*)["']/, className);
      return str;
    }
    return str;
  } else {
    // 如果没有class,则创建一个class
    res = str.match(/<\w+/);
    if (res[0]) {
      return str.replace(/<\w+/, res[0] + ' ' + className);
    }
    return str;
  }
};

// 清除img字符串的"https:"和"http:", 例如‘<img src="http:’转换后‘<img src="’
window.String.prototype.clearImgProtocol = function () {
  return this.replace(/<img\s+src="https:/gim, '<img src="').replace(/<img\s+src="http:/gim, '<img src="');
};

// 清除字符串的"https:"和"http:"
window.String.prototype.clearProtocol = function () {
  return this.replace(/https:/gim, '').replace(/http:/gim, '');
};

// 判断是否是queryId
window.String.prototype.isQueryId = function () {
  if (!this.length) return false;
  var idExpr = /^#([\w-]*)$/;
  var match = idExpr.exec(this);
  if (match && match.length > 0) {
    return match[1];
  }
  return false;
};
// 判断是否是queryClass
window.String.prototype.isQueryClass = function () {
  if (!this.length) return false;
  var classExpr = /^\.([\w-]*)$/;
  var match = classExpr.exec(this);
  if (match && match.length > 0) {
    return match[1];
  }
  return false;
};
// 判断是否是query标签
window.String.prototype.isTag = function () {
  if (!this.length) return false;
  var tagExpr = /^<(\w+)\s*.*\/\w*>$/im;
  var match = tagExpr.exec(this);
  if (match && match.length > 0) {
    return true;
  }
  return false;
};
// 获取指定后缀的数值(允许是小数和整数),例如:'44px'.getUnitValue() / '44em'.getUnitValue('em')
window.String.prototype.getUnitValue = function (argSuffix) {
  // 默认后缀为px
  var suffix = argSuffix || 'px';
  var patt = new RegExp('^[+-]?(0|([1-9][0-9]*))(.[0-9]?)' + suffix + '$');
  if (patt.test(this)) {
    return this.substring(0, this.indexOf(suffix));
  }
  return 0;
};
// 密码等级
String.charType = function (char) {
  if (char >= 48 && char <= 57) return 'number'; // 数字
  if (char >= 65 && char <= 90) return 'capitalize'; // 大写
  if (char >= 97 && char <= 122) return 'lowercase'; // 小写
  else return 'other';
};
window.String.prototype.safeLvl = function () {
  if (this.length > 0 && this.length < 6) return 1;
  var mode = {};
  for (var i = 0; i < this.length; i++) {
    mode[String.charType(this.charCodeAt(i))] = '';
  }
  return Object.values(mode).length;
};

// DateUtil
window.Date.prototype.minuteMilliSecond = 60 * 1000;
window.Date.prototype.hourMilliSecond = 60 * 60 * 1000;
window.Date.prototype.dayMilliSecond = 24 * 60 * 60 * 1000;
window.Date.prototype.weekMilliSecond = 7 * 24 * 60 * 60 * 1000;

/*
  * 年操作
  * */
// 年
window.Date.prototype.year = function (year) {
  if (year) this.setYear(year);
  return this.getFullYear().toString();
};
// 上一年
window.Date.prototype.prevYear = function (count) {
  this.setYear(this.getFullYear() - (count || 1));
  return this;
};
// 下一年
window.Date.prototype.nextYear = function (count) {
  this.setYear(this.getFullYear() + (count || 1));
  return this;
};
// 是否是闰年
window.Date.prototype.isLeap = function () {
  var year = this.getFullYear();
  return year % 4 === 0 && (year % 100 !== 0 || year % 400 === 0);
};
// 当年第一天
window.Date.prototype.firstYearDate = function () {
  this.setMonth(0, 1);
  return this;
};
// 当年最后一天
window.Date.prototype.lastYearDate = function () {
  this.setMonth(11, 31);
  return this;
};
// 返回当月共多少天
window.Date.prototype.getYearDate = function () {
  return this.isLeap() ? 366 : 365;
};

/*
  * 季操作
  * */
// 季, 返回:0.季度,1.季度第一天,2.季度最后一天
window.Date.prototype.season = function (argCount) {
  var count = argCount || Math.ceil((this.getMonth() + 1) / 3);
  // 修改月
  this.setMonth(count * 3 - 3, 1);
  return count;
};
// 上一季
window.Date.prototype.prevSeason = function (count) {
  // 获得当前季的第一个月
  this.setMonth(this.getMonth() - 3 * (count || 1), 1);
  return Math.ceil((this.getMonth() + 1) / 3);
};
// 下一季
window.Date.prototype.nextSeason = function (count) {
  // 获得当前季的第一个月
  this.setMonth(this.getMonth() + 3 * (count || 1), 1);
  return Math.ceil((this.getMonth() + 1) / 3);
};
// 第一季
window.Date.prototype.firstSeason = function () {
  this.season(1);
  return 1;
};
// 第四季
window.Date.prototype.lastSeason = function () {
  this.season(4);
  return 4;
};
// 当季第一天
window.Date.prototype.firstSeasonDate = function () {
  var count = Math.ceil((this.getMonth() + 1) / 3);
  this.setYear(this.getFullYear());
  this.setMonth(count * 3 - 3, 1);
  return this;
};
// 当季最后一天
window.Date.prototype.lastSeasonDate = function () {
  var count = Math.ceil((this.getMonth() + 1) / 3);
  this.setYear(this.getFullYear());
  this.setMonth(count * 3, 0);
  return this;
};
// 返回当季共多少天
window.Date.prototype.getSeasonDate = function () {
  // 季度
  var count = Math.ceil((this.getMonth() + 1) / 3);
  // 平闰年2月的差别
  if (count === 1) return this.isLeap() ? 91 : 90;
  if (count === 2) return 91;
  if (count === 3 || count === 4) return 92;
};
/*
  * 月操作
  * */
// 月, 参数:1-12或者字符串'yyyy-MM', 如果当前日期大于目标月最大日期,则取目标月最大日期
window.Date.prototype.month = function (month) {
  var targetYear = null; // 目标年份
  var targetMonth = null; // 目标月份
  var targetMaxDate = null;
  // 如果有值,则修改为目标月份
  if (month) {
    if (/^\d{1,2}$/.test(month)) {
      targetMonth = month - 1;
      targetMaxDate = new Date(this.getFullYear(), targetMonth + 1, 0).getDate();
      if (this.getMonthDate() > targetMaxDate) {
        this.setMonth(targetMonth, targetMaxDate);
      } else {
        this.setMonth(targetMonth);
      }
    } else if (/^(\d{4}).(\d{1,2})/.test(month)) {
      var arr = month.match(/^(\d{4}).(\d{1,2})/);
      targetYear = Number(arr[1]);
      targetMonth = arr[2] - 1;
      targetMaxDate = new Date(targetYear, targetMonth + 1, 0).getDate();
      if (this.getMonthDate() > targetMaxDate) {
        this.setYear(targetYear);
        this.setMonth(targetMonth, targetMaxDate);
      } else {
        this.setYear(targetYear);
        this.setMonth(targetMonth);
      }
    }
  }
  var num = this.getMonth() + 1;
  return num < 10 ? '0' + num : num;
};
// 上一月
window.Date.prototype.prevMonth = function (count) {
  var targetMonth = this.getMonth() - (count || 1);
  var targetMaxDate = new Date(this.getFullYear(), targetMonth + 1, 0).getDate();
  if (this.getDate() > targetMaxDate) {
    this.setMonth(targetMonth, targetMaxDate);
  } else {
    this.setMonth(targetMonth);
  }
  return targetMonth < 10 ? '0' + targetMonth : targetMonth;
};
// 下一月
window.Date.prototype.nextMonth = function (count) {
  var targetMonth = this.getMonth() + (count || 1);
  var targetMaxDate = new Date(this.getFullYear(), targetMonth + 1, 0).getDate();
  if (this.getDate() > targetMaxDate) {
    this.setMonth(targetMonth, targetMaxDate);
  } else {
    this.setMonth(targetMonth);
  }
  return targetMonth < 10 ? '0' + targetMonth : targetMonth;
};
// 一月
window.Date.prototype.firstMonth = function () {
  this.setMonth(0);
  return '01';
};
// 十二月
window.Date.prototype.lastMonth = function () {
  this.setMonth(11);
  return '12';
};
// 当月第一天
window.Date.prototype.firstMonthDate = function () {
  this.setDate(1);
  return this;
};
// 当月最后一天
window.Date.prototype.lastMonthDate = function () {
  this.setMonth(this.getMonth() + 1, 0);
  return this;
};
// 返回当月共多少天
window.Date.prototype.getMonthDate = function () {
  return new Date(this.getFullYear(), this.getMonth() + 1, '0').getDate();
};

/*
  * 周操作
  * */
// 周几,参数:zh_cn
window.Date.prototype.day = function (language) {
  var chDay = { 1: '一', 2: '二', 3: '三', 4: '四', 5: '五', 6: '六', 0: '日' };
  if (language === 'zh_cn') {
    return chDay[this.getDay()];
  }
  return this.getDay();
};
// 周数
window.Date.prototype.week = function (count) {
  // 当年的1月1日
  var january1 = new Date(this.getFullYear(), 0, 1);
  var january1Day = january1.getDay();
  if (january1Day === 0) january1Day = 7;
  // 如果传入周数,则设置周数
  if (count) {
    this.setTime(january1.getTime() + this.weekMilliSecond * count);
    return count;
  }
  // 计算当前天到1月1号相差周数
  var num = Math.ceil((this.getTime() - january1.getTime()) / this.weekMilliSecond);
  return num;
};
// 上一周
window.Date.prototype.prevWeek = function (count) {
  this.setTime(this.getTime() - this.weekMilliSecond * (count || 1));
  return this;
};
// 下一周
window.Date.prototype.nextWeek = function (count) {
  this.setTime(this.getTime() + this.weekMilliSecond * (count || 1));
  return this;
};
// 周日,日历都是从周日开始的
window.Date.prototype.sunday = function () {
  var day = this.getDay();
  this.setTime(this.getTime() - this.dayMilliSecond * day);
  return this;
};
// 周一
window.Date.prototype.monday = function () {
  var day = this.getDay();
  this.setTime(this.getTime() + this.dayMilliSecond * (1 - day));
  return this;
};
// 周二
window.Date.prototype.tuesday = function () {
  var day = this.getDay();
  this.setTime(this.getTime() + this.dayMilliSecond * (2 - day));
  return this;
};
// 周三
window.Date.prototype.wednesday = function () {
  var day = this.getDay();
  this.setTime(this.getTime() + this.dayMilliSecond * (3 - day));
  return this;
};
// 周四
window.Date.prototype.thursday = function () {
  var day = this.getDay();
  this.setTime(this.getTime() + this.dayMilliSecond * (4 - day));
  return this;
};
// 周五
window.Date.prototype.friday = function () {
  var day = this.getDay();
  this.setTime(this.getTime() + this.dayMilliSecond * (5 - day));
  return this;
};
// 周六
window.Date.prototype.saturday = function () {
  var day = this.getDay();
  this.setTime(this.getTime() + this.dayMilliSecond * (6 - day));
  return this;
};
/*
  * 日操作
  * */
// 日
window.Date.prototype.date = function (date) {
  if (date) this.setDate(date);
  var num = this.getDate();
  return num < 10 ? '0' + num : num;
};
// 上一天
window.Date.prototype.prevDate = function (count) {
  this.setTime(this.getTime() - this.dayMilliSecond * (count || 1));
  return this;
};
// 下一天
window.Date.prototype.nextDate = function (count) {
  this.setTime(this.getTime() + this.dayMilliSecond * (count || 1));
  return this;
};

/*
  * 时操作
  * */
// 时
window.Date.prototype.hour = function (hour) {
  if (hour) this.setHours(hour);
  var num = this.getHours();
  return num < 10 ? '0' + num : num;
};
// 上一小时
window.Date.prototype.prevHour = function (count) {
  this.setTime(this.getTime() - this.hourMilliSecond * (count || 1));
  return this;
};
// 下一小时
window.Date.prototype.nextHour = function (count) {
  this.setTime(this.getTime() + this.hourMilliSecond * (count || 1));
  return this;
};
/*
  * 分操作
  * */
// 分
window.Date.prototype.minute = function (minute) {
  if (minute) this.setMinutes(minute);
  var num = this.getMinutes();
  return num < 10 ? '0' + num : num;
};
// 上一分钟
window.Date.prototype.prevMinute = function (count) {
  this.setTime(this.getTime() - this.minuteMilliSecond * (count || 1));
  return this;
};
// 下一分钟
window.Date.prototype.nextMinute = function (count) {
  this.setTime(this.getTime() + this.minuteMilliSecond * (count || 1));
  return this;
};
// 返回当前分钟的下档位时间
window.Date.prototype.nextMinuteSpace = function (argSpace) {
  var space = argSpace ? argSpace : 5; // 间隔
  var minute = this.getMinutes(); // 分钟
  var hasRemainder = minute % space === 0; // 是否有余数

  var percentNum = Math.ceil(minute / space); // 档位
  percentNum = hasRemainder ? parseInt(percentNum, 10) + 1 : percentNum;

  var result = percentNum * space; // 根据档位计算结果
  this.setMinutes(result);
  return this.minute();
};
// 返回当前分钟的上档位时间
window.Date.prototype.prevMinuteSpace = function (argSpace) {
  var space = argSpace ? argSpace : 5; // 间隔
  var minute = this.getMinutes(); // 分钟
  var hasRemainder = minute % space === 0; // 是否有余数

  var percentNum = Math.floor(minute / space); // 档位
  percentNum = hasRemainder ? parseInt(percentNum, 10) - 1 : percentNum;

  var result = percentNum * space; // 根据档位计算结果
  this.setMinutes(result);
  return this.minute();
};
/*
  * 比较操作
  * */
// 比较Date对象,返回相差天时分秒等信息
window.Date.prototype.diff = function (date) {
  var dateStart = this; // 开始时间
  var dateEnd = date; // 结束时间

  var secondMilli = 1000; // 一分钟的毫秒数
  var minuteMilli = 60 * secondMilli; // 一分钟的毫秒数
  var hourMilli = 60 * minuteMilli; // 一小时的毫秒数
  var dayMilli = 24 * hourMilli; // 一天的毫秒数

  var timeDiff = dateEnd.getTime() - dateStart.getTime(); // 毫秒差

  // 计算出相差天数
  var daysDiff = Math.floor(timeDiff / dayMilli);
  // 计算出剩余小时数
  var dayMilliRemainder = timeDiff % dayMilli;
  var hoursDiff = Math.floor(dayMilliRemainder / hourMilli);
  // 计算剩余分钟数
  var minuteMilliRemainder = dayMilliRemainder % hourMilli;
  var minutesDiff = Math.floor(minuteMilliRemainder / minuteMilli);
  // 计算剩余秒数
  var secondMilliRemainder = minuteMilliRemainder % minuteMilli;
  var secondsDiff = Math.round(secondMilliRemainder / secondMilli);

  // 计算相差小时数
  var hoursAllDiff = Math.floor(timeDiff / hourMilli);
  // 计算相差分钟数
  var minutesAllDiff = Math.floor(timeDiff / minuteMilli);
  // 计算相差秒数
  var secondsAllDiff = Math.floor(timeDiff / secondMilli);

  return {
    days: daysDiff,
    hours: hoursDiff,
    minutes: minutesDiff,
    seconds: secondsDiff,
    hoursAll: hoursAllDiff,
    minutesAll: minutesAllDiff,
    secondsAll: secondsAllDiff
  };
};
// 比较年月日时分秒，大于返回1,等于返回0,小于返回-1
window.Date.prototype.compareDateTime = function (date) {
  var date1 = new Date(this);
  var date2 = new Date(date);
  date1.setSeconds(0, 0);
  date2.setSeconds(0, 0);
  var t1 = date1.getTime();
  var t2 = date2.getTime();

  if (t1 === t2) return 0;
  return t1 > t2 ? 1 : -1;
};
// 比较年月日,大于返回1,等于返回0,小于返回-1
window.Date.prototype.compareDate = function (date) {
  var date1 = new Date(this);
  var date2 = new Date(date);
  date1.setHours(0, 0, 0, 0);
  date2.setHours(0, 0, 0, 0);
  var t1 = date1.getTime();
  var t2 = date2.getTime();

  if (t1 === t2) return 0;
  return t1 > t2 ? 1 : -1;
};
// 比较年月,大于返回1,等于返回0,小于返回-1
window.Date.prototype.compareMonth = function (date) {
  var date1 = new Date(this);
  var date2 = new Date(date);
  date1.setDate(0);
  date1.setHours(0, 0, 0, 0);
  date2.setDate(0);
  date2.setHours(0, 0, 0, 0);
  var t1 = date1.getTime();
  var t2 = date2.getTime();

  if (t1 === t2) return 0;
  return t1 > t2 ? 1 : -1;
};
// 比较时分,格式:hh:mm,大于返回1,等于返回0,小于返回-1
window.Date.prototype.compareTime = function (date) {
  var date1 = new Date(this);
  date1.setYear(0);
  date1.setMonth(0, 0);
  var date2 = new Date();
  if (date.isTime) {
    date2.setHours(date.split(':')[0], date.split(':')[1], date.split(':')[2] || 0, 0);
  } else if (date instanceof Date) {
    date2 = date;
  } else {
    console.log('请传入hh:mm的字符串,或者一个Date对象');
    return false;
  }
  date2.setYear(0);
  date2.setMonth(0, 0);
  var t1 = date1.getTime();
  var t2 = date2.getTime();

  if (t1 === t2) return 0;
  return t1 > t2 ? 1 : -1;
};
/*
  * 返回时效,例如:new Date().expires('today'),返回
  * 参数: Date | String(小时数 | 'today')
  * 返回: Date (增加时效后的日期)
  * */
window.Date.prototype.expires = function (expires) {
  // 如果没传参数, 默认返回2小时后的时效
  if (!expires) {
    this.nextHour(2);
    return this;
  }
  // 如果参数是日期
  if (expires instanceof Date === true) {
    // 如果小于当前时间, 则返回设置的时效日期
    if (expires.compareDateTime(this) === 1) {
      return expires;
    }
    return this;
  }
  // 如果参数是小时
  if (!isNaN(expires)) {
    this.nextHour(expires);
    return this;
  }
  // 如果参数是今天
  if (expires === 'today') {
    this.setHours(0, 0, 0, 0);
    this.nextDate();
    return this;
  }
};

/*
  * 格式化
  * */
// 格式化日期,参数:yyyy-MM-dd hh:mm:ss WW EE
window.Date.prototype.format = function (fmtModel) {
  var fmt = typeof fmtModel === 'string' ? fmtModel : 'yyyy-MM-dd hh:mm:ss';
  var year = this.getFullYear();
  var month = this.getMonth() + 1;
  var date = this.getDate();
  var hour = this.getHours();
  var minute = this.getMinutes();
  var second = this.getSeconds();
  var weeksCount = this.week();
  var week = this.day('zh_cn');

  var dateJson = {
    'M+': month,
    'd+': date,
    'h+': hour,
    'm+': minute,
    's+': second,
    'W+': weeksCount,
    'E+': week
  };
  if (/(y+)/.test(fmt)) {
    // 匹配年
    fmt = fmt.replace(RegExp.$1, (year + '').substr(4 - RegExp.$1.length));
  }
  for (var k in dateJson) {
    // 逐个匹配
    // '('+ k +')'=(M+)、(d+)、(h+)...
    if (new RegExp('(' + k + ')').test(fmt)) {
      fmt = fmt.replace(RegExp.$1, RegExp.$1.length === 1 ? dateJson[k] : ('00' + dateJson[k]).substr(('' + dateJson[k]).length));
    }
  }
  return fmt;
};

/*
  * 日历操作
  * */
// 月数据
window.Date.prototype.getMonthData = function () {
  // 获得本月日历, 返回42天
  // 月头的位置
  var firstDay = new Date(this).firstMonthDate();
  var firstDayIndex = firstDay.getDay();
  // 根据起始毫秒数，逐天增加天数
  var startDayMs = firstDay.getTime() - this.dayMilliSecond * firstDayIndex;

  var data = [];
  // 生成月
  for (var i = 0; i < 42; i++) {
    data.push(new Date());
    if (i === 0) data[0].setTime(startDayMs);else data[i].setTime(data[i - 1].getTime() + this.dayMilliSecond);

    // 设置当年标识isCurrent
    data[i].isCurrent = false;
    if (data[i].month() === this.month()) data[i].isCurrent = true;
  }
  return data;
};
window.Date.prototype.getPrevMonthData = function () {
  // 获得上月日历
  var date = new Date(this);
  date.prevMonth();
  return date.getMonthData();
};
window.Date.prototype.getNextMonthData = function () {
  // 获得下月日历
  var date = new Date(this);
  date.nextMonth();
  return date.getMonthData();
};
window.Date.prototype.getCalendarData = function () {
  // 获取三个月的日历数据
  var data = this.getPrevMonthData().concat(this.getMonthData()).concat(this.getNextMonthData());
  // 设置选中项与选中行
  // 当前日期+当月第一天的周几=选中位置(由于索引是从0开始的,所以在后面要再减掉1)
  var activeIndex = this.getDate() + new Date(this).firstMonthDate().getDay();
  // 用Math.floor(位置/7)获取行数
  data.activeRowIndex = Math.floor(activeIndex / 7);
  // 上个月日历42天+当月位置=当前位置
  data.activeIndex = activeIndex + 41;
  return data;
};

window.Date.prototype.getPrevMonth = function (count) {
  // 获得前几个月日期
  if (count) {
    var months = [];
    var tempDate = new Date(this);
    for (var i = 0; i < count; i++) {
      tempDate.prevMonth();
      var prevMonth = new Date(tempDate);
      months.push(prevMonth);
    }
    return months;
  }
  var date = new Date(this);
  date.prevMonth();
  return date;
};

// 周数据
window.Date.prototype.getWeekData = function () {
  // 获得本周日历, 返回7天
  var date = new Date(this);
  var sunday = date.sunday();
  var data = [];
  for (var i = 0; i < 7; i++) {
    data.push(new Date(sunday.getTime() + this.dayMilliSecond * i));
  }
  return data;
};
window.Date.prototype.getPrevWeekData = function () {
  // 获得上周日历
  var date = new Date(this);
  date.prevWeek();
  return date.getWeekData();
};
window.Date.prototype.getNextWeekData = function () {
  // 获得下周日历
  var date = new Date(this);
  date.nextWeek();
  return date.getWeekData();
};

window.Date.prototype.getPrevWeek = function (count) {
  // 获得前几个周日期
  if (count) {
    var days = [];
    var tempDate = new Date(this);
    for (var i = 0; i < count; i++) {
      tempDate.prevWeek();
      var prevWeek = new Date(tempDate);
      days.push(prevWeek);
    }
    return days;
  }
  var date = new Date(this);
  date.prevDate();
  return date;
};

// 天数据
window.Date.prototype.getPrevDate = function (count) {
  // 获得前几个天日期
  if (count) {
    var dates = [];
    var tempDate = new Date(this);
    for (var i = 0; i < count; i++) {
      tempDate.prevDate();
      var prevDate = new Date(tempDate);
      dates.push(prevDate);
    }
    return dates;
  }
  var date = new Date(this);
  date.prevDate();
  return date;
};

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/

/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret;

var printWarning$1 = function() {};

{
  var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};

  printWarning$1 = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
  {
    for (var typeSpecName in typeSpecs) {
      if (typeSpecs.hasOwnProperty(typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error(
              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
            );
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning$1(
            (componentName || 'React class') + ': type specification of ' +
            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
            'You may have forgotten to pass an argument to the type checker ' +
            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
            'shape all require an argument).'
          );

        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning$1(
            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
          );
        }
      }
    }
  }
}

var checkPropTypes_1 = checkPropTypes;

var printWarning = function() {};

{
  printWarning = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker,
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret_1) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error(
            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
            'Use `PropTypes.checkPropTypes()` to call them. ' +
            'Read more at http://fb.me/use-check-prop-types'
          );
          err.name = 'Invariant Violation';
          throw err;
        } else if ("development" !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (
            !manualPropTypeCallCache[cacheKey] &&
            // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3
          ) {
            printWarning(
              'You are manually calling a React.PropTypes validation ' +
              'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
              'and will throw in the standalone `prop-types` package. ' +
              'You may be seeing this warning due to a third-party PropTypes ' +
              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
            );
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      printWarning('Invalid argument supplied to oneOf, expected an instance of array.');
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues);
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + propValue + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (propValue.hasOwnProperty(key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      printWarning('Invalid argument supplied to oneOfType, expected an instance of array.');
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning(
          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
        );
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = objectAssign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError(
            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
          );
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue;
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes_1;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

var propTypes = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

{
  var REACT_ELEMENT_TYPE = (typeof Symbol === 'function' &&
    Symbol.for &&
    Symbol.for('react.element')) ||
    0xeac7;

  var isValidElement = function(object) {
    return typeof object === 'object' &&
      object !== null &&
      object.$$typeof === REACT_ELEMENT_TYPE;
  };

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = factoryWithTypeCheckers(isValidElement, throwOnDirectAccess);
}
});

var Actionsheet$1 = function (_Component) {
  inherits(Actionsheet, _Component);

  function Actionsheet(props) {
    classCallCheck(this, Actionsheet);

    var _this = possibleConstructorReturn(this, (Actionsheet.__proto__ || Object.getPrototypeOf(Actionsheet)).call(this, props));

    _this.componentDidMount = function () {};

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(_this.getArgs(e));
      e.stopPropagation();
    };

    _this.onClickCancel = function (e) {
      if (_this.props.onClickCancel) _this.props.onClickCancel(_this.getArgs(e));
      e.stopPropagation();
    };

    _this.onClick = function (e) {
      var target = e.target;
      var index = target.getAttribute('data-index');
      if (_this.props.onClick) {
        _this.props.onClick(_this.props.list[index], Number(index));
        e.stopPropagation();
      }
    };

    return _this;
  }

  createClass(Actionsheet, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          duration = _props.duration,
          show = _props.show,
          maskClassName = _props.maskClassName,
          maskStyle = _props.maskStyle,
          className = _props.className,
          style = _props.style,
          list = _props.list,
          groupStyle = _props.groupStyle,
          groupClassName = _props.groupClassName,
          optionStyle = _props.optionStyle,
          optionClassName = _props.optionClassName,
          cancelCaption = _props.cancelCaption,
          cancelStyle = _props.cancelStyle,
          cancelClassName = _props.cancelClassName,
          onClickCancel = _props.onClickCancel;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'mask actionsheet-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle), onClick: this.onClickMask },
        React__default.createElement(
          'div',
          { className: 'actionsheet' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style), 'data-animation': 'slideUp' },
          React__default.createElement(
            'div',
            { className: 'actionsheet-group' + (groupClassName ? ' ' + groupClassName : ''), style: groupStyle },
            list && list.map(function (item, index) {
              return React__default.createElement(
                'a',
                { className: 'actionsheet-option' + (optionClassName ? ' ' + optionClassName : ''), style: optionStyle, key: index, 'data-index': index, onClick: _this2.onClick },
                item.caption
              );
            })
          ),
          onClickCancel && React__default.createElement(
            'a',
            { className: 'actionsheet-cancel' + (cancelClassName ? ' ' + cancelClassName : ''), style: cancelStyle, onClick: this.onClickCancel },
            cancelCaption
          )
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Actionsheet;
}(React.Component);

Actionsheet$1.propTypes = {
  portal: propTypes.object,
  args: propTypes.any,
  show: propTypes.bool,

  duration: propTypes.number,

  list: propTypes.array, // [{caption: string, onClick: func}]

  maskStyle: propTypes.object,
  maskClassName: propTypes.string,
  onClickMask: propTypes.func,

  style: propTypes.object,
  className: propTypes.string,

  cancelStyle: propTypes.object,
  cancelClassName: propTypes.string,
  cancelCaption: propTypes.node,
  onClickCancel: propTypes.func
};
Actionsheet$1.defaultProps = {
  cancelCaption: '取消'
};

var Badge$1 = function (_Component) {
  inherits(Badge, _Component);

  function Badge(props) {
    classCallCheck(this, Badge);

    var _this = possibleConstructorReturn(this, (Badge.__proto__ || Object.getPrototypeOf(Badge)).call(this, props));

    _this.state = {};
    return _this;
  }

  createClass(Badge, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          children = _props.children,
          limit = _props.limit,
          ellipsis = _props.ellipsis;
      // 标题

      var caption = children;
      // 自动宽度,当大于两位时变宽
      var autoWidthClass = '';
      if (children && (typeof children === 'string' || typeof children === 'number')) {
        // 数字大于99,则显示99+
        if (!isNaN(children)) {
          caption = children.length > limit ? '99999'.substring(0, limit) + ellipsis : children;
        }
        // 数字大于2位以及2位以上,显示最大宽度
        autoWidthClass = children.length >= 2 ? 'badge-max-width' : '';
      }
      return React__default.createElement(
        'span',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'badge' + (autoWidthClass ? ' ' + autoWidthClass : '') + (className ? ' ' + className : ''), style: style },
        caption
      );
    }
  }]);
  return Badge;
}(React.Component);

Badge$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,
  children: propTypes.node,
  limit: propTypes.number,
  ellipsis: propTypes.string
};
Badge$1.defaultProps = {
  children: '0',
  limit: 2,
  ellipsis: '+'
};

var Icon$1 = function (_Component) {
  inherits(Icon, _Component);

  function Icon(props) {
    classCallCheck(this, Icon);

    var _this = possibleConstructorReturn(this, (Icon.__proto__ || Object.getPrototypeOf(Icon)).call(this, props));

    _this.state = {};
    return _this;
  }

  createClass(Icon, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          onClick = _props.onClick,
          style = _props.style,
          className = _props.className,
          src = _props.src,
          lazyLoad = _props.lazyLoad,
          children = _props.children,
          badgeCaption = _props.badgeCaption,
          badgeClassName = _props.badgeClassName,
          badgeStyle = _props.badgeStyle,
          badgeLimit = _props.badgeLimit,
          badgeEllipsis = _props.badgeEllipsis;

      var nodataIconClassName = '';
      var newStyle = style;
      // 懒人加载时,先显示一张默认的背景图,然后在子元素上显示在线图片
      if (lazyLoad && src) {
        newStyle = style;
        nodataIconClassName = 'bg-no-img';
      } else if (src) {
        nodataIconClassName = '';
        newStyle = Object.assign({ backgroundImage: 'url(' + src + ')' }, style);
      }

      return React__default.createElement(
        'i',
        { ref: function ref(el) {
            _this2.$el = el;
          }, onClick: onClick, className: 'icon' + (nodataIconClassName ? ' ' + nodataIconClassName : '') + (className ? ' ' + className : ''), style: newStyle },
        lazyLoad && src && React__default.createElement('span', { className: 'icon-img', style: { backgroundImage: 'url(' + src + ')' } }),
        children,
        badgeCaption && badgeCaption !== '0' && React__default.createElement(
          Badge$1,
          { className: badgeClassName, style: badgeStyle, limit: badgeLimit, ellipsis: badgeEllipsis },
          badgeCaption
        )
      );
    }
  }]);
  return Icon;
}(React.Component);

Icon$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  src: propTypes.string,
  lazyLoad: propTypes.bool,
  onClick: propTypes.func,

  badgeCaption: propTypes.string,
  badgeClassName: propTypes.string,
  badgeStyle: propTypes.object,
  badgeLimit: propTypes.number,
  badgeEllipsis: propTypes.string,

  children: propTypes.node
};
Icon$1.defaultProps = {
  lazyLoad: false
};

var Alert$1 = function (_Component) {
  inherits(Alert, _Component);

  function Alert(props) {
    classCallCheck(this, Alert);

    var _this = possibleConstructorReturn(this, (Alert.__proto__ || Object.getPrototypeOf(Alert)).call(this, props));

    _this.componentDidMount = function () {};

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(_this.getArgs(e));
      e.stopPropagation();
    };

    _this.onClickCancel = function (e) {
      if (_this.props.onClickCancel) _this.props.onClickCancel(_this.getArgs(e));
      e.stopPropagation();
    };

    _this.onClickSubmit = function (e) {
      if (_this.props.onClickSubmit) _this.props.onClickSubmit(_this.getArgs(e));
      e.stopPropagation();
    };

    return _this;
  }

  createClass(Alert, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          duration = _props.duration,
          show = _props.show,
          maskClassName = _props.maskClassName,
          maskStyle = _props.maskStyle,
          className = _props.className,
          style = _props.style,
          caption = _props.caption,
          captionStyle = _props.captionStyle,
          captionClassName = _props.captionClassName,
          contentStyle = _props.contentStyle,
          contentClassName = _props.contentClassName,
          icon = _props.icon,
          iconSrc = _props.iconSrc,
          iconStyle = _props.iconStyle,
          iconClassName = _props.iconClassName,
          children = _props.children,
          submitCaption = _props.submitCaption,
          submitStyle = _props.submitStyle,
          submitClassName = _props.submitClassName,
          onClickSubmit = _props.onClickSubmit,
          disabled = _props.disabled,
          cancelCaption = _props.cancelCaption,
          cancelStyle = _props.cancelStyle,
          cancelClassName = _props.cancelClassName,
          onClickCancel = _props.onClickCancel;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'mask alert-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle), onClick: this.onClickMask },
        React__default.createElement(
          'div',
          { className: 'alert' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style), 'data-animation': 'zoom' },
          caption && React__default.createElement(
            'h1',
            { className: captionClassName, style: captionStyle },
            caption
          ),
          React__default.createElement(
            'div',
            { className: 'alert-content' + (contentClassName ? ' ' + contentClassName : ''), style: contentStyle },
            (iconSrc || iconClassName) && React__default.createElement(Icon$1, { className: 'alert-content-icon' + (iconClassName ? ' ' + iconClassName : ''), src: iconSrc ? iconSrc : '', style: iconStyle }),
            icon,
            children
          ),
          React__default.createElement(
            'div',
            { className: 'alert-handler' },
            onClickCancel && React__default.createElement(
              'a',
              { className: 'alert-cancel button lg' + (cancelClassName ? ' ' + cancelClassName : ''), style: cancelStyle, onClick: this.onClickCancel },
              cancelCaption
            ),
            onClickSubmit && React__default.createElement(
              'a',
              { className: 'alert-submit button lg' + (submitClassName ? ' ' + submitClassName : ''), style: submitStyle, onClick: this.onClickSubmit, disabled: disabled },
              submitCaption
            )
          )
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Alert;
}(React.Component);

Alert$1.propTypes = {
  portal: propTypes.object,
  args: propTypes.any,
  show: propTypes.bool,

  duration: propTypes.number,

  maskStyle: propTypes.object,
  maskClassName: propTypes.string,
  onClickMask: propTypes.func,

  style: propTypes.object,
  className: propTypes.string,

  caption: propTypes.node,
  captionStyle: propTypes.object,
  captionClassName: propTypes.string,

  icon: propTypes.node,
  iconSrc: propTypes.string,
  iconStyle: propTypes.object,
  iconClassName: propTypes.string,

  contentStyle: propTypes.object,
  contentClassName: propTypes.string,
  children: propTypes.node,

  submitStyle: propTypes.object,
  submitClassName: propTypes.string,
  submitCaption: propTypes.node,
  disabled: propTypes.bool,
  onClickSubmit: propTypes.func,

  cancelStyle: propTypes.object,
  cancelClassName: propTypes.string,
  cancelCaption: propTypes.node,
  onClickCancel: propTypes.func
};
Alert$1.defaultProps = {
  submitCaption: '确定',
  cancelCaption: '取消'
};

var Article$1 = function (_Component) {
  inherits(Article, _Component);

  function Article(props, context) {
    classCallCheck(this, Article);
    return possibleConstructorReturn(this, (Article.__proto__ || Object.getPrototypeOf(Article)).call(this, props, context));
  }

  createClass(Article, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          caption = _props.caption,
          captionClassName = _props.captionClassName,
          captionStyle = _props.captionStyle,
          sndcaption = _props.sndcaption,
          sndcaptionClassName = _props.sndcaptionClassName,
          sndcaptionStyle = _props.sndcaptionStyle,
          paragraphs = _props.paragraphs,
          paragraphClassName = _props.paragraphClassName,
          paragraphStyle = _props.paragraphStyle,
          children = _props.children;

      return React__default.createElement(
        'div',
        { className: 'article-box' },
        caption && React__default.createElement(
          'div',
          { className: 'article-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
          { caption: caption }
        ),
        sndcaption && React__default.createElement(
          'div',
          { className: 'article-sndcaption' + (sndcaptionClassName ? ' ' + sndcaptionClassName : ''), style: sndcaptionStyle },
          { sndcaption: sndcaption }
        ),
        paragraphs.map(function (paragraph) {
          return React__default.createElement(
            'div',
            { className: 'article-paragraph' + (paragraphClassName ? ' ' + paragraphClassName : ''), style: paragraphStyle },
            { paragraph: paragraph }
          );
        }),
        children
      );
    }
  }]);
  return Article;
}(React.Component);

Article$1.propTypes = {
  caption: propTypes.node, // 标题
  captionClassName: propTypes.string,
  captionStyle: propTypes.node,

  sndcaption: propTypes.node, // 内容
  sndcaptionClassName: propTypes.string,
  sndcaptionStyle: propTypes.node,

  paragraphs: propTypes.array, // 段落
  paragraphClassName: propTypes.string,
  paragraphStyle: propTypes.node,
  children: propTypes.node
};
Article$1.defaultProps = {};

var Attributes = function (_Component) {
  inherits(Attributes, _Component);

  function Attributes(props, context) {
    classCallCheck(this, Attributes);

    var _this = possibleConstructorReturn(this, (Attributes.__proto__ || Object.getPrototypeOf(Attributes)).call(this, props, context));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.onClick) _this.props.onClick(_this.getArgs(e));
    };

    _this.state = {};
    return _this;
  }

  createClass(Attributes, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          name = _props.name,
          required = _props.required,
          value = _props.value,
          showValidValue = _props.showValidValue,
          showValidName = _props.showValidName,
          className = _props.className,
          style = _props.style,
          cellClassName = _props.cellClassName,
          cellStyle = _props.cellStyle,
          requiredClassName = _props.requiredClassName,
          requiredStyle = _props.requiredStyle,
          nameClassName = _props.nameClassName,
          nameStyle = _props.nameStyle,
          valueClassName = _props.valueClassName,
          valueStyle = _props.valueStyle,
          rowAfter = _props.rowAfter,
          children = _props.children;

      var isShow = true;
      if (showValidValue && !children) isShow = false;
      if (showValidName && !name) isShow = false;
      return isShow && React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'attribute' + (className ? ' ' + className : ''), style: style, onClick: this.onClick },
        name && React__default.createElement(
          'div',
          { className: 'attribute-left' + (cellClassName ? ' ' + cellClassName : '') + ' ' + (nameClassName ? nameClassName : ''), style: Object.assign({}, cellStyle, nameStyle) },
          required && React__default.createElement(
            'span',
            { className: 'required required-left' + (requiredClassName ? ' ' + requiredClassName : ''), style: requiredStyle },
            required
          ),
          name
        ),
        name && React__default.createElement(
          'div',
          { className: 'attribute-right' + (cellClassName ? ' ' + cellClassName : '') + '  ' + (valueClassName ? valueClassName : ''), style: Object.assign({}, cellStyle, valueStyle) },
          value,
          children
        ),
        !name && children,
        rowAfter && rowAfter
      );
    }
  }]);
  return Attributes;
}(React.Component);

Attributes.propTypes = {
  name: propTypes.node, // 标题
  value: propTypes.node, // 内容
  required: propTypes.string, // 必填项

  showValidValue: propTypes.bool, // 值合法时显示
  showValidName: propTypes.bool, // name合法时显示

  className: propTypes.string, // align(左右对齐布局) | start(左端对齐) | between(两端对齐)
  style: propTypes.object,

  cellClassName: propTypes.string, // 列className
  cellStyle: propTypes.object,

  nameClassName: propTypes.string, // name的className
  nameStyle: propTypes.object,
  requiredClassName: propTypes.string, // required的className
  requiredStyle: propTypes.object,
  valueClassName: propTypes.string, // value的className
  valueStyle: propTypes.object,

  rowAfter: propTypes.node,
  children: propTypes.node,
  onClick: propTypes.func
};
Attributes.defaultProps = {
  args: null,
  className: 'attribute-margin'
};

var Button$1 = function (_Component) {
  inherits(Button, _Component);

  function Button(props) {
    classCallCheck(this, Button);

    var _this = possibleConstructorReturn(this, (Button.__proto__ || Object.getPrototypeOf(Button)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.onClick) _this.props.onClick(_this.getArgs(e));
    };

    _this.state = {};
    return _this;
  }

  createClass(Button, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          disabled = _props.disabled,
          children = _props.children;

      return React__default.createElement(
        'a',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'button' + (className ? ' ' + className : ''), disabled: disabled, style: style, onClick: this.onClick },
        children
      );
    }
  }]);
  return Button;
}(React.Component);

Button$1.propTypes = {
  args: propTypes.any,
  style: propTypes.object,
  className: propTypes.string,
  disabled: propTypes.bool,
  onClick: propTypes.func,

  children: propTypes.node
};
Button$1.defaultProps = {
  args: null
};

var Price$1 = function (_Component) {
  inherits(Price, _Component);

  function Price(props, context) {
    classCallCheck(this, Price);
    return possibleConstructorReturn(this, (Price.__proto__ || Object.getPrototypeOf(Price)).call(this, props, context));
  }

  createClass(Price, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          showSymbol = _props.showSymbol,
          showThousandth = _props.showThousandth,
          price = _props.price,
          unit = _props.unit,
          className = _props.className,
          digits = _props.digits,
          digitsFixed = _props.digitsFixed,
          style = _props.style;
      // 价格字符串

      var priceString = '';
      // 如果价格不是数字,则直接显示
      if (isNaN(price)) {
        priceString = price;
        // 如果价格是数字,则加入千分位和小数位
      } else {
        var newPrice = price;
        // 加小数位
        if (typeof digits === 'number') {
          newPrice = digitsFixed ? String(Number(price).toFixed(digits)) : Math.Calc.toFixed(Number(price), digits);
        }
        // 加千分位
        priceString = showThousandth ? Math.Calc.toThousandth(newPrice) : '' + newPrice;
      }
      // 应用格式:整数与小数分开显示
      var priceInteger = null;
      var priceDecimal = null;
      if (priceString && priceString.indexOf('.') !== -1) {
        priceInteger = priceString.substring(0, priceString.indexOf('.'));
        priceDecimal = '.' + priceString.substring(priceString.indexOf('.') + 1);
      } else {
        priceInteger = priceString;
      }
      return React__default.createElement(
        'span',
        { style: style, className: 'price ' + className },
        showSymbol && React__default.createElement(
          'span',
          { className: 'price-symbol' },
          '\uFFE5'
        ),
        React__default.createElement(
          'span',
          { className: 'price-integer' },
          priceInteger
        ),
        priceDecimal && React__default.createElement(
          'span',
          { className: 'price-digits' },
          priceDecimal
        ),
        unit && React__default.createElement(
          'span',
          { className: 'price-unit' },
          unit
        )
      );
    }
  }]);
  return Price;
}(React.Component);

Price$1.propTypes = {
  showSymbol: propTypes.bool, // 是否显示货币符号
  showThousandth: propTypes.bool, // 是否显示千分位
  className: propTypes.string,
  style: propTypes.object,
  price: propTypes.oneOfType([propTypes.string, propTypes.number]),
  unit: propTypes.string,
  digitsFixed: propTypes.bool, // 固定小数, 例如100仍然显示100.00
  digits: propTypes.oneOfType([// 如果设置了小数位控制,则控制小数位,如不控制,则原样显示
  propTypes.bool, propTypes.number])
};
Price$1.defaultProps = {
  showSymbol: true,
  showThousandth: true,
  className: 'capitalize',
  digitsFixed: true,
  digits: false
};

var Mark$1 = function (_Component) {
  inherits(Mark, _Component);

  function Mark(props) {
    classCallCheck(this, Mark);
    return possibleConstructorReturn(this, (Mark.__proto__ || Object.getPrototypeOf(Mark)).call(this, props));
  }

  createClass(Mark, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          children = _props.children,
          onClick = _props.onClick;

      return children ? React__default.createElement(
        'span',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'mark ' + className, style: style, onClick: onClick },
        children
      ) : null;
    }
  }]);
  return Mark;
}(React.Component);

Mark$1.propTypes = {
  className: propTypes.string, // info/success/cancel/warn/disable/primary
  style: propTypes.object,
  onClick: propTypes.func,
  children: propTypes.node
};
Mark$1.defaultProps = {
  className: 'info'
};

// Clipboard 剪贴板
var Clipboard = {
  // 选择元素的内容
  selectContent: function selectContent(element) {
    // 首先创建一个范围
    var rangeToSelect = document.createRange();
    rangeToSelect.selectNodeContents(element);

    // 选择内容
    var selection = window.getSelection();
    selection.removeAllRanges();
    selection.addRange(rangeToSelect);
  },
  // 为execCommand方法创建一个临时元素
  createElementForExecCommand: function createElementForExecCommand(textToClipboard) {
    var forExecElement = document.createElement('div');
    // 放置在可见区域之外
    forExecElement.style.position = 'absolute';
    forExecElement.style.left = '-10000px';
    forExecElement.style.top = '-10000px';
    // 将必要的文本写入元素并追加到文档中
    forExecElement.textContent = textToClipboard;
    document.body.appendChild(forExecElement);
    // contentEditable模式对于Firefox中的execCommand方法是必需的
    forExecElement.contentEditable = true;

    return forExecElement;
  },
  // 复制到剪贴板
  copy: function copy(input) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var textToClipboard = input;

    var success = true;
    if (window.clipboardData) {
      // Internet Explorer
      window.clipboardData.setData('Text', textToClipboard);
    } else {
      // 为execCommand方法创建一个临时元素
      var forExecElement = this.createElementForExecCommand(textToClipboard);

      // 选择元素的内容 ('copy'方法的execCommand在选择上起作用)
      this.selectContent(forExecElement);

      // UniversalXPConnect是Firefox中剪贴板访问所必需的
      try {
        if (window.netscape && window.netscape.security) {
          window.netscape.security.PrivilegeManager.enablePrivilege('UniversalXPConnect');
        }
        // 将选定内容复制到剪贴板
        // 适用于Firefox和Safari 5之前的版本
        success = document.execCommand('copy', false, null);
      } catch (e) {
        success = false;
      }

      // 删除临时元素
      document.body.removeChild(forExecElement);
    }

    if (success) {
      if (params && params.onSuccess) params.onSuccess(params.successMsg || '复制到剪贴板成功');
    } else {
      if (params && params.onError) params.onError(params.errorMsg || '当前设备不允许访问剪贴板');
    }
  }
};

// Device
var Device = function () {
  var ua = navigator.userAgent.toLowerCase();
  // 内核
  var kernel = '';
  if (ua.indexOf('trident') > -1) {
    kernel = 'trident';
  } else if (ua.indexOf('presto') > -1) {
    kernel = 'presto';
  } else if (ua.indexOf('applewebkit') > -1) {
    kernel = 'webkit';
  } else if (ua.indexOf('gecko') > -1 && ua.indexOf('khtml') === -1) {
    kernel = 'gecko';
  }
  // 设备
  var device = '';
  if (ua.match(/applewebkit.*mobile.*/)) {
    device = 'mobile';
  } else {
    device = 'pc';
  }
  // 系统
  var os = '';
  var osVersion = '';
  var andriodExp = ua.match(/android\s*(\d*\.*\d*)/);
  var iosExp = ua.match(/cpu iphone os (.*?) like mac os/);
  if (andriodExp) {
    os = 'andriod';
    osVersion = andriodExp[1];
  } else if (iosExp) {
    os = 'ios';
    osVersion = iosExp[1];
  }
  // 平台
  var platform = '';
  if (ua.indexOf('micromessenger') > -1) {
    platform = 'weixin';
    if (device === 'pc') {
      platform = 'browser';
    }
  } else if (ua.indexOf('mqqbrowser') > -1) {
    platform = 'qq';
  } else if (ua.indexOf('ucbrowser') > -1) {
    platform = 'uc';
  } else if (ua.indexOf('dinghuoappversion') > -1) {
    platform = 'dinghuo';
  } else if (ua.indexOf('wqappversion') > -1) {
    platform = 'waiqin';
  } else {
    platform = 'browser';
  }
  // 获得苹果机型
  function appleModel() {
    // 获取设备型号
    var ua = navigator.userAgent.toLocaleLowerCase();
    if (ua && /(iphone|ipad|ipod|ios)/i.test(ua)) {
      var m = ua.match(/mobile\/([\w.]*)/);
      if (m && m[1]) {
        return m[1];
      }
    }
    return '';
  }
  function getAppleDevice() {
    // 获取弱设备
    if (/iphone/gi.test(navigator.userAgent) && window.screen.height === 812 && window.screen.width === 375) return 'iPhoneX';
    var model = appleModel();
    switch (model) {
      case '15b150':
        return 'iPhone6s';
      case '15b202':
        return 'iPhone6';
      case '13g36':
        return 'iPhone5SE';
      case '14e304':
        return 'iPhone6P';
      default:
        return '';
    }
  }
  // 网络监听
  var onLineCallback;
  function handleOnline(e) {
    onLineCallback(true);
  }
  function handleOffline(e) {
    onLineCallback(false);
  }
  function onLine(callback) {
    onLineCallback = callback;
    window.removeEventListener('online', handleOnline, false);
    window.removeEventListener('offline', handleOffline, false);
    window.addEventListener('online', handleOnline, false);
    window.addEventListener('offline', handleOffline, false);
  }
  // 适配iPhoneX
  var isX = getAppleDevice() === 'iPhoneX';
  var root = document.getElementById('root');
  function adjustIphoneX() {
    if (isX && root) {
      switch (window.orientation) {
        case 0:
          // 竖屏
          root.style.left = '0';
          root.style.right = '0';
          root.style.bottom = '34px';
          break;
        case 90:
          // 向左横屏
          root.style.left = '40px';
          root.style.right = '40px';
          root.style.bottom = '34px';
          break;
        case -90:
          // 向右横屏
          root.style.left = '40px';
          root.style.right = '40px';
          root.style.bottom = '34px';
          break;
        default:
          break;
      }
    }
  }
  function adapterMobile() {
    // iPhoneX布局自适应
    adjustIphoneX();
    window.addEventListener('orientationchange', adjustIphoneX, false);
    // 安卓5.0以下去掉最小高度,为解决在app中webview收缩输入法上面空白的问题
    if (os === 'andriod' && osVersion < '5.0') {
      if (root) root.style.minHeight = 'auto';
    }
  }
  // 动态加载桥接库
  function dynamicLoadBridge() {
    if (platform === 'weixin') {
      // 微信
      var wxScript = document.createElement('script');
      wxScript.src = '//res.wx.qq.com/open/js/jweixin-1.3.2.js';
      document.body.appendChild(wxScript);
    } else if (platform === 'waiqin') {
      // 外勤
      var wqScript = document.createElement('script');
      wqScript.src = '//res.waiqin365.com/d/common_mobile/component/cordova/cordova.js';
      document.body.appendChild(wqScript);
    }
  }
  // 获取地址栏参数
  function getUrlParameter(argName, argSearch) {
    var url = window.location.href;
    if (argSearch) url = argSearch;
    var params = {};
    // 如果url中包含?说明有参数
    if (url.indexOf('?') !== -1) {
      // 获取所有参数options: 如?a=1&b=2转为['a=1','b=2']
      var options = url.split('?')[1].split('&');
      if (options.length) {
        for (var i = 0; i < options.length; i++) {
          // 获取单项option: 如'a=1'转为['a', '1']
          var option = options[i].split('=');
          if (option.length === 2) {
            if (argName) {
              if (argName === option[0]) return option[1];
            } else {
              params[option[0]] = option[1];
            }
          }
        }
      }
    }
    if (Object.keys(params).length) return params;
    return '';
  }
  return {
    protocol: window.location.protocol,
    host: window.location.host,
    domain: window.location.protocol + '//' + window.location.host,
    kernel: kernel,
    device: device,
    os: os,
    osVersion: osVersion,
    platform: platform,
    appleDevice: getAppleDevice(),
    // 应用程序判断
    language: (window.navigator.browserLanguage || window.navigator.language).toLowerCase(),
    appVersion: window.navigator.appVersion,
    onLine: onLine,
    isOnLine: window.navigator.onLine || true,
    ua: ua,
    orientation: window.orientation || '请在真机上测试', // 设备方向0:竖屏,90:左横屏,-90:右横屏
    adapterMobile: adapterMobile, // 适配iPhoneX
    dynamicLoadBridge: dynamicLoadBridge, // 动态加载桥接库
    getUrlParameter: getUrlParameter
  };
}();

/**
 * Callback index.
 */

var count = 0;

/**
 * Noop function.
 */

function noop() {}

/**
 * JSONP handler
 *
 * Options:
 *  - param {String} qs parameter (`callback`)
 *  - prefix {String} qs parameter (`__jp`)
 *  - name {String} qs parameter (`prefix` + incr)
 *  - timeout {Number} how long after a timeout error is emitted (`60000`)
 *
 * @param {String} url
 * @param {Object|Function} optional options / callback
 * @param {Function} optional callback
 */

function jsonp(url, opts, fn) {
  if ('function' === typeof opts) {
    fn = opts;
    opts = {};
  }
  if (!opts) opts = {};

  var prefix = opts.prefix || '__jp';

  // use the callback name that was passed if one was provided.
  // otherwise generate a unique name by incrementing our counter.
  var id = opts.name || prefix + count++;

  var param = opts.param || 'callback';
  var timeout = null != opts.timeout ? opts.timeout : 60000;
  var enc = encodeURIComponent;
  var target = document.getElementsByTagName('script')[0] || document.head;
  var script;
  var timer;

  if (timeout) {
    timer = setTimeout(function () {
      cleanup();
      if (fn) fn(new Error('Timeout'));
    }, timeout);
  }

  function cleanup() {
    if (script.parentNode) script.parentNode.removeChild(script);
    window[id] = noop;
    if (timer) clearTimeout(timer);
  }

  function cancel() {
    if (window[id]) {
      cleanup();
    }
  }

  window[id] = function (data) {
    cleanup();
    if (fn) fn(null, data);
  };

  // add qs component
  url += (~url.indexOf('?') ? '&' : '?') + param + '=' + enc(id);
  url = url.replace('?&', '?');

  // create script
  script = document.createElement('script');
  script.src = url;
  target.parentNode.insertBefore(script, target);

  return cancel;
}

// DB 本地数据库
var DB = function () {
  function checkManifest() {
    window.addEventListener('updateready', function (e) {
      console.log('离线缓存状态：' + window.applicationCache.status);
      if (window.applicationCache.status === window.applicationCache.UPDATEREADY) {
        window.applicationCache.swapCache();
        if (window.confirm('发现此manifest文件有更新，是否更新？')) {
          window.location.reload();
        }
      } else {
        console.log('manifest文件没有变化');
      }
    }, false);
  }
  function stringifyData(val) {
    if (typeof val === 'number') {
      return '_number:' + val.toString();
    }
    if (typeof val === 'boolean') {
      return '_boolean:' + val.toString();
    }
    if (!val) {
      return '';
    }
    if (typeof val === 'string') {
      return val;
    }
    if (val instanceof Function) {
      return '_function:' + val.toString();
    }
    if (val instanceof Object) {
      return '_json:' + JSON.stringify(val);
    }
  }
  function parseData(val) {
    if (!val) {
      return null;
    }
    if (val.indexOf('_number:') === 0) {
      return Number(val.replace(/^_number:/, ''));
    }
    if (val.indexOf('_boolean:') === 0) {
      return Boolean(val.replace(/^_boolean:/, ''));
    }
    if (val.indexOf('_function:') === 0) {
      return val.replace(/^_function:/, '');
    }
    if (val.indexOf('_json:') === 0) {
      return JSON.parse(val.replace(/^_json:/, ''));
    }
    return val;
  }
  var store = window.localStorage;
  var session = window.sessionStorage;
  return {
    // application cache
    checkManifest: checkManifest,

    setStore: function setStore(key, val) {
      store.setItem(key.toString(), stringifyData(val));
    },
    getStore: function getStore(key) {
      if (typeof key === 'number') {
        return parseData(store.key(key));
      }
      return parseData(store.getItem(key));
    },
    getAllStore: function getAllStore() {
      return store.valueOf();
    },
    removeStore: function removeStore(key) {
      store.removeItem(key);
    },
    clearStore: function clearStore() {
      store.clear();
    },

    setSession: function setSession(key, value) {
      session.setItem(key.toString(), stringifyData(value));
    },
    getSession: function getSession(key) {
      if (typeof key === 'number') {
        return parseData(session.key(key));
      }
      return parseData(session.getItem(key));
    },
    getAllSession: function getAllSession() {
      return session.valueOf();
    },
    removeSession: function removeSession(key) {
      session.removeItem(key);
    },
    clearSession: function clearSession() {
      session.clear();
    },
    setCookie: function setCookie(key, value, second) {
      var cookieStr = key + '=' + escape(value);
      if (second) {
        var expires = new Date();
        expires.setTime(expires.getTime() + second * 1000);
        cookieStr += ';expires=' + expires.toGMTString();
      }
      document.cookie = cookieStr;
    },
    getCookie: function getCookie(key) {
      var arrCookie = document.cookie.split('; ');
      //遍历cookie数组, 处理每个cookie对
      for (var i = 0, item; item = arrCookie[i++];) {
        // eslint-disable-line
        var arrItem = item.split("=");
        //找到名称为userId的cookie，并返回它的值 
        if (String(key) === arrItem[0]) {
          return unescape(arrItem[1]);
        }
      }
      return null;
    },
    removeCookie: function removeCookie(key) {
      var expires = new Date();
      expires.setTime(expires.getTime() - 1);
      var val = this.getCookie(key);
      if (val != null) {
        document.cookie = key + '=' + val + 'expires=' + expires.toGMTString();
      }
    },
    clearCookie: function clearCookie() {
      alert('抱歉，cookie不可以全部清空!');
    }
  };
}();

//  EventUtil 事件函数
var EventUtil = function () {
  // 多次点击事件, multipleclick
  var _listenMultipleClickEvent = function _listenMultipleClickEvent(element, type, handler, isDetach) {
    function attach() {
      element.addEventListener('click', multipleclickHandler, false);
    }
    function detach() {
      console.log('移除click');
      element.removeEventListener('click', multipleclickHandler, false);
    }
    // 添加或移除事件
    if (isDetach) {
      detach();
    } else {
      attach();
    }
    var allcount = 10; // 点击多少次触发
    var space = 5000; // 点击间隔秒数
    function multipleclickHandler(e) {
      // 次数
      var counter = DB.getSession('onMultipleClick_counter') || 0;
      if (counter === 0) {
        DB.setSession('onMultipleClick_time', new Date().getTime());
      }
      // 时间
      var time = DB.getSession('onMultipleClick_time');

      // 设置次数
      counter += 1;
      DB.setSession('onMultipleClick_counter', counter);
      // 到达设定次数
      if (counter === allcount) {
        // 点击小于间隔秒钟有效
        if (new Date().getTime() - time < space) {
          handler(e);
          DB.setSession('onMultipleClick_counter', 0);
        } else {
          DB.setSession('onMultipleClick_counter', 0);
          return;
        }
      }
    }
  };
  // 滑动事件,tap | swipeleft | swiperight | swipedown | swipeup
  var _listenTouchEvent = function _listenTouchEvent(element, type, handler, isDetach) {
    var params = {
      threshold: 0
      /* ------------------------
      Model
      ------------------------ */
    };var touches = {
      direction: 0,
      vertical: 0,
      horizontal: 0,
      startX: 0,
      startY: 0,
      endX: 0,
      endY: 0,
      diffX: 0,
      diffY: 0
      /* ------------------------
      Touch Handler
      ------------------------ */
    };var onTouchStart = function onTouchStart(e) {
      touches.startX = e.touches[0].clientX;
      touches.startY = e.touches[0].clientY;
    };
    var onTouchEnd = function onTouchEnd(e) {
      var eventName = '';
      touches.endX = e.changedTouches[0].clientX;
      touches.endY = e.changedTouches[0].clientY;
      touches.diffX = touches.startX - touches.endX;
      touches.diffY = touches.startY - touches.endY;
      // 单击事件
      if (Math.abs(touches.diffX) < 6 && Math.abs(touches.diffY) < 6) {
        eventName = 'tap';
      }

      // 设置方向
      if (touches.direction === 0) {
        // 设置滑动方向(-1上下 | 1左右)
        touches.direction = Math.abs(touches.diffX) > Math.abs(touches.diffY) ? 1 : -1;
      }
      if (touches.direction === -1) {
        // 设置垂直方向(-1上 | 1下)
        touches.vertical = touches.diffY < 0 ? 1 : -1;
      }
      if (touches.direction === 1) {
        // 设置左右方向(-1左 | 1右)
        touches.horizontal = touches.diffX < 0 ? 1 : -1;
      }

      // swipeleft | swiperight | swipedown | swipeup 事件
      if (touches.vertical === -1) {
        // 上
        if (Math.abs(touches.diffY) > params.threshold) {
          eventName = 'swipeup';
        }
      } else if (touches.vertical === 1) {
        // 下
        if (Math.abs(touches.diffY) > params.threshold) {
          eventName = 'swipedown';
        }
      } else if (touches.horizontal === -1) {
        // 左
        if (Math.abs(touches.diffY) > params.threshold) {
          eventName = 'swipeleft';
        }
      } else if (touches.horizontal === 1) {
        // 右
        if (Math.abs(touches.diffY) > params.threshold) {
          eventName = 'swiperight';
        }
      }
      // 清空方向
      touches.direction = 0;
      touches.vertical = 0;
      touches.horizontal = 0;
      // 执行函数
      for (var n in element.touchEvents) {
        if (eventName === n) element.touchEvents[n](e);
      }
    };
    /* ------------------------
    Touch Events
    ------------------------ */
    // 绑定事件
    var attach = function attach() {
      if (Object.keys(element.touchEvents || {}).length === 0) {
        element.touchEvents = {};
        element['addEventListener']('touchstart', onTouchStart, false);
        element['addEventListener']('touchend', onTouchEnd, false);
      }
      element.touchEvents[type] = handler;
    };
    // 移除事件
    var detach = function detach() {
      if (element.touchEvents) delete element.touchEvents[type];
      if (Object.keys(element.touchEvents || {}).length === 0) {
        element['removeEventListener']('touchstart', onTouchStart, false);
        element['removeEventListener']('touchend', onTouchEnd, false);
      }
    };
    // 添加或移除事件
    if (isDetach) {
      detach();
    } else {
      attach();
    }
  };
  // 摇动事件, shake
  var _listenShakeEvent = function _listenShakeEvent(element, type, handler, isDetach) {
    var threshold = 3000; // 晃动速度
    var lastUpdate = 0; // 设置最后更新时间，用于对比
    var curShakeX = 0;
    var curShakeY = 0;
    var curShakeZ = 0;
    var lastShakeX = 0;
    var lastShakeY = 0;
    var lastShakeZ = 0;
    function deviceMotionHandler(e) {
      var acceleration = e.accelerationIncludingGravity; // 获得重力加速
      var curTime = new Date().getTime(); // 获得当前时间戳
      if (curTime - lastUpdate > 100) {
        var diffTime = curTime - lastUpdate; // 时间差
        lastUpdate = curTime;
        curShakeX = acceleration.x; // x轴加速度
        curShakeY = acceleration.y; // y轴加速度
        curShakeZ = acceleration.z; // z轴加速度
        var speed = Math.abs(curShakeX + curShakeY + curShakeZ - lastShakeX - lastShakeY - lastShakeZ) / diffTime * 10000;
        if (speed > threshold) {
          var ev = e;
          ev.speed = speed;
          handler(ev);
        }
        lastShakeX = curShakeX;
        lastShakeY = curShakeY;
        lastShakeZ = curShakeZ;
      }
    }
    function attach() {
      if (!window.DeviceMotionEvent) {
        alert('您好，你目前所用的设备好像不支持重力感应哦！');
        return;
      }
      window.addEventListener('devicemotion', deviceMotionHandler, false);
    }
    function detach() {
      window.removeEventListener('devicemotion', deviceMotionHandler, false);
    }
    // 添加或移除事件
    if (isDetach) {
      detach();
    } else {
      attach();
    }
  };
  return {
    addHandler: function addHandler(element, type, handler) {
      // 自定义事件 multipleclick
      if (type === 'multipleclick') {
        _listenMultipleClickEvent(element, type, handler);
        return;
      }
      // touch兼容PC事件
      var isSupportTouch = 'ontouchstart' in window;
      if (!isSupportTouch) {
        if (type === 'touchstart') type = 'mousedown';
        if (type === 'touchmove') type = 'mousemove';
        if (type === 'touchend') type = 'mouseup';
        if (type === 'touchcancel') type = 'mouseup';
        if (type === 'tap') type = 'click';
      } else {
        // 自定义事件 tap | swipeleft | swiperight | swipedown | swipeup
        if (type === 'tap' || type === 'swipeleft' || type === 'swiperight' || type === 'swipedown' || type === 'swipeup') {
          _listenTouchEvent(element, type, handler);
          return;
        }
        // 自定义事件 shake
        if (type === 'shake') {
          _listenShakeEvent(element, type, handler);
          return;
        }
      }
      // 系统事件
      if (element.addEventListener) {
        element.addEventListener(type, handler, false);
      } else if (element.attachEvent) {
        element.attachEvent('on' + type, handler);
      } else {
        element['on' + type] = handler;
      }
    },
    removeHandler: function removeHandler(element, type, handler) {
      // 自定义事件 multipleclick
      if (type === 'multipleclick') {
        _listenMultipleClickEvent(element, type, handler, true);
        return;
      }
      // touch兼容PC事件
      var isSupportTouch = 'ontouchstart' in window;
      if (!isSupportTouch) {
        if (type === 'touchstart') type = 'mousedown';
        if (type === 'touchmove') type = 'mousemove';
        if (type === 'touchend') type = 'mouseup';
        if (type === 'touchcancel') type = 'mouseup';
        if (type === 'tap') type = 'click';
      } else {
        // 自定义事件 tap | swipeleft | swiperight | swipedown | swipeup
        if (type === 'tap' || type === 'swipeleft' || type === 'swiperight' || type === 'swipedown' || type === 'swipeup') {
          _listenTouchEvent(element, type, handler, true);
          return;
        }
        // 自定义事件 shake
        if (type === 'shake') {
          _listenShakeEvent(element, type, handler, true);
          return;
        }
      }
      // 系统事件
      if (element.removeEventListener) {
        element.removeEventListener(type, handler, false);
      } else if (element.detachEvent) {
        element.detachEvent('on' + type, handler);
      } else {
        element['on' + type] = null;
      }
    },
    preventDefault: function preventDefault(e) {
      if (e.preventDefault) {
        e.preventDefault();
      } else {
        e.returnValue = false;
      }
    },
    stopPropagation: function stopPropagation(e) {
      if (e.stopPropagation) {
        e.stopPropagation();
      } else {
        e.cancelBubble = true;
      }
    },
    event: function event(e) {
      return e || window.e;
    },
    type: function type(e) {
      return e.type;
    },
    target: function target(e) {
      return e.target || e.srcElement;
    }
  };
}();

// Toast 提示框
var Toast = function Toast(params) {
  /* --------------------
  Model
  -------------------- */
  var defaults = {
    mask: null,
    parent: document.body, // 创建于哪个元素下

    maskClass: 'mask toast-mask', // 加toast-propagation允许点击
    maskActiveClass: 'active',

    toastClass: 'toast bottom',
    toastActiveClass: 'active',
    wrapperClass: 'toast-wrapper',
    captionClass: 'toast-caption',
    iconClass: 'toast-icon',

    duration: 300,
    delay: 0,
    html: '',
    icon: '' // 传入icon的class

    /* callbacks
    onShowed(Toast)// 显示动画结束后回调
    onHid(Toast)// 隐藏动画结束后回调
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  s.parent = typeof s.params.parent === 'string' ? document.querySelector(s.params.parent) : s.params.parent;
  s.toast = null;
  s.wrapper = null;
  // Mask
  s.createMask = function () {
    var mask = document.createElement('div');
    mask.setAttribute('class', s.params.maskClass);
    return mask;
  };
  s.createToast = function () {
    var toast = document.createElement('div');
    toast.setAttribute('class', s.params.toastClass);
    return toast;
  };
  s.createToastWrapper = function () {
    var wrapper = document.createElement('div');
    wrapper.setAttribute('class', s.params.wrapperClass);
    return wrapper;
  };
  s.createToastIcon = function () {
    var icon = document.createElement('span');
    if (!s.params.icon) return icon;
    icon.setAttribute('class', s.params.iconClass + (s.params.icon ? ' ' + s.params.icon : ''));
    return icon;
  };
  s.createToastCaption = function () {
    var caption = document.createElement('span');
    caption.setAttribute('class', s.params.captionClass);
    if (s.params.html) caption.innerHTML = s.params.html;
    return caption;
  };
  s.create = function () {
    s.mask = s.createMask();
    s.toast = s.createToast();
    s.wrapper = s.createToastWrapper();
    s.caption = s.createToastCaption();
    s.icon = s.createToastIcon();
    if (s.icon) s.wrapper.appendChild(s.icon);
    s.wrapper.appendChild(s.caption);
    s.toast.appendChild(s.wrapper);
    s.mask.appendChild(s.toast);
    s.parent.appendChild(s.mask);
  };
  s.update = function () {
    if (s.params.mask) s.mask = typeof s.params.mask === 'string' ? document.querySelector(s.params.mask) : s.params.mask;
    if (s.mask) {
      s.toast = s.mask.querySelector('.' + s.params.toastClass);
      s.wrapper = s.mask.querySelector('.' + s.params.wrapperClass);
    } else {
      s.create();
    }
    s.toast.style.webkitTransitionDuration = s.params.duration + 'ms';
  };
  s.update();

  /* --------------------
  Method
  -------------------- */
  s.setMaskClassName = function (className) {
    s.params.maskClass = className;
    s.mask.setAttribute('class', s.params.maskClass);
  };
  s.setToastClassName = function (className) {
    s.params.toastClass = className;
    s.toast.setAttribute('class', s.params.toastClass);
  };
  s.setIcon = function (className) {
    s.params.icon = className;
    if (s.params.icon) {
      s.icon.setAttribute('class', s.params.iconClass + (s.params.icon ? ' ' + s.params.icon : ''));
    } else {
      s.icon.setAttribute('class', '');
    }
  };
  s.setHTML = function (html) {
    s.caption.innerHTML = html;
  };
  s.setDelay = function (delay) {
    s.params.delay = delay;
  };

  s.showMask = function () {
    s.mask.classList.add(s.params.maskActiveClass);
  };
  s.hideMask = function () {
    s.mask.classList.remove(s.params.maskActiveClass);
  };
  s.destroyMask = function () {
    s.mask.parentNode.removeChild(s.mask);
  };

  s.showToast = function () {
    s.toast.classList.add(s.params.toastActiveClass);
  };
  s.hideToast = function () {
    s.toast.classList.remove(s.params.toastActiveClass);
  };

  s.isHid = true;
  s.hide = function () {
    s.isHid = true;
    s.hideMask();
    s.hideToast();
    if (s.params.duration === 0) s.onTransitionEnd();
  };
  s.show = function () {
    s.isHid = false;
    s.showMask();
    s.showToast();
    if (s.params.duration === 0) s.onTransitionEnd();

    // 显示数秒后，自动消失
    if (s.params.delay) {
      if (s.delayer) window.clearTimeout(s.delayer);
      s.delayer = setTimeout(function () {
        s.hide();
      }, s.params.delay);
    }
  };
  s.destroy = function () {
    s.destroyMask();
  };
  /* --------------------
  Controller
  -------------------- */
  s.events = function (detach) {
    var target = s.toast;
    var action = detach ? 'removeEventListener' : 'addEventListener';
    target[action]('webkitTransitionEnd', s.onTransitionEnd, false);
    // target[action]('webkitAnimationEnd',s.onAnimationEnd,false)
  };
  s.attach = function () {
    s.events();
  };
  s.detach = function () {
    s.events(false);
  };
  s.transitionFlag = true;
  // Events Handler
  s.onTransitionEnd = function (e) {
    if (e.propertyName === 'visibility') return;
    // 防止animationend和transitionend多次执行的问题
    if (s.transitionFlag) {
      s.transitionFlag = false;
      if (s.isHid) {
        // Callback onHid
        if (s.params.onHid) s.params.onHid(s);
      } else {
        // Callback onShowed
        if (s.params.onShowed) s.params.onShowed(s);
      }
    }
  };
  /* --------------------
  Init
  -------------------- */
  s.init = function () {
    s.attach();
  };
  s.init();
};

// Alert 提示框
var Alert$3 = function Alert(params) {
  /* --------------------
  Model
  -------------------- */
  var defaults = {
    mask: null,
    parent: document.body, // 创建于哪个元素下
    overflowContainer: document.body,
    overflowContainerActiveClass: 'overflow-hidden',

    maskClass: 'mask alert-mask',
    maskActiveClass: 'active',

    duration: 300,
    animationAttr: 'data-animation',
    animation: 'zoom',

    alertClass: 'alert',
    alertActiveClass: 'active',
    contentClass: 'alert-content',
    handlerClass: 'alert-handler',
    buttonSubmitClass: 'alert-submit button',
    buttonCancelClass: 'alert-cancel button',

    caption: '',
    html: '',
    buttonSubmitHTML: '确定',
    buttonCancelHTML: '取消',

    isClickMaskHide: false,
    args: null
    /*
    Callbacks:
    onClick:function(Alert)
    onClickSubmit:function(Alert)
    onClickCancel:function(Alert)
    onClickMask:function(Alert)
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  // Parent | OverflowContainer
  s.parent = typeof s.params.parent === 'string' ? document.querySelector(s.params.parent) : s.params.parent;
  s.overflowContainer = typeof s.params.overflowContainer === 'string' ? document.querySelector(s.params.overflowContainer) : s.params.overflowContainer;
  // Alert | Mask
  s.mask = null;
  s.alert = null;
  s.html = null;
  s.buttonBox = null;
  s.buttonSubmit = null;
  s.buttonCancel = null;
  // Mask
  s.createMask = function () {
    s.mask = document.createElement('div');
    s.mask.setAttribute('class', s.params.maskClass);
  };
  // Alert
  s.createButton = function (html, className) {
    var button = document.createElement('a');
    button.setAttribute('class', className);
    button.innerHTML = html;
    return button;
  };
  s.createAlert = function () {
    s.alert = document.createElement('div');
    s.alert.setAttribute('class', s.params.alertClass);
    s.alert.setAttribute(s.params.animationAttr, s.params.animation);

    s.html = document.createElement('div');
    s.html.setAttribute('class', s.params.contentClass);
    s.html.innerHTML = s.params.html;

    s.buttonBox = document.createElement('div');
    s.buttonBox.setAttribute('class', s.params.handlerClass);

    // 如果有取消按钮
    if (s.params.onClickCancel) {
      s.buttonCancel = s.createButton(s.params.buttonCancelHTML, s.params.buttonCancelClass);
      s.buttonBox.appendChild(s.buttonCancel);
    }
    s.buttonSubmit = s.createButton(s.params.buttonSubmitHTML, s.params.buttonSubmitClass);

    s.buttonBox.appendChild(s.buttonSubmit);

    if (s.params.caption && s.params.caption !== '') {
      s.caption = document.createElement('h1');
      s.caption.innerHTML = s.params.caption;
      s.alert.appendChild(s.caption);
    }

    s.alert.appendChild(s.html);
    s.alert.appendChild(s.buttonBox);
  };
  s.create = function () {
    s.createMask();
    s.createAlert();
    s.mask.appendChild(s.alert);
    s.parent.appendChild(s.mask);
  };
  s.update = function () {
    if (s.params.mask) s.mask = typeof s.params.mask === 'string' ? document.querySelector(s.params.mask) : s.params.mask;
    if (s.mask) {
      if (!s.alert) s.alert = s.mask.querySelector('.' + s.params.alertClass);
      if (!s.buttonSubmit) s.buttonSubmit = s.alert.querySelector('.' + s.params.buttonSubmitClass);
      if (!s.buttonCancel) s.buttonCancel = s.alert.querySelector('.' + s.params.buttonCancelClass);
    } else {
      s.create();
    }
    s.mask.style.webkitTransitionDuration = s.params.duration + 'ms';
    s.alert.style.webkitTransitionDuration = s.params.duration + 'ms';
  };
  s.update();
  /* --------------------
  Method
  -------------------- */
  s.showMask = function () {
    s.mask.classList.add(s.params.maskActiveClass);
  };
  s.hideMask = function () {
    s.mask.classList.remove(s.params.maskActiveClass);
  };
  s.destroyMask = function () {
    s.mask.parentNode.removeChild(s.mask);
  };
  s.showAlert = function () {
    s.alert.classList.add(s.params.alertActiveClass);
  };
  s.hideAlert = function () {
    s.alert.classList.remove(s.params.alertActiveClass);
  };
  s.isHid = true;
  s.hide = function () {
    s.isHid = true;
    // 隐藏遮罩
    s.hideMask();
    // 隐藏弹出框
    s.hideAlert();
    // 显示滚动条
    if (s.overflowContainer) s.overflowContainer.classList.remove(s.params.overflowContainerActiveClass);
    // 执行回调
    if (s.params.duration === 0) s.onTransitionEnd();
  };
  s.show = function () {
    s.isHid = false;
    // 显示遮罩
    s.showMask();
    // 显示弹出框
    s.showAlert();
    // 禁用滚动条
    if (s.overflowContainer) s.overflowContainer.classList.add(s.params.overflowContainerActiveClass);
    // 执行回调
    if (s.params.duration === 0) s.onTransitionEnd();
  };
  s.destroy = function () {
    s.destroyMask();
  };
  // 动态设置
  s.setHTML = function (html) {
    s.html.innerHTML = html;
  };
  s.setCaption = function (caption) {
    s.caption.innerHTML = caption;
  };
  s.setOnClick = function (fn) {
    s.params.onClick = fn;
  };
  s.setOnClickSubmit = function (fn) {
    s.params.onClickSubmit = fn;
  };
  s.setOnClickCancel = function (fn) {
    // 如果没有取消按钮，创建一个
    if (!s.params.onClickCancel) {
      s.buttonCancel = s.createButtonCancel();
      s.buttonBox.insertBefore(s.buttonCancel, s.buttonSubmit);
    }
    s.params.onClickCancel = fn;
  };
  /* --------------------
  Control
  -------------------- */
  s.events = function (detach) {
    var touchTarget = s.alert;
    var action = detach ? 'removeEventListener' : 'addEventListener';
    touchTarget[action]('click', s.onClick, false);
    touchTarget[action]('webkitTransitionEnd', s.onTransitionEnd, false);
    // 遮罩
    s.mask[action]('click', s.onClickMask, false);
  };
  // attach、dettach事件
  s.attach = function (event) {
    s.events();
  };
  s.detach = function (event) {
    s.events(true);
  };
  s.getArgs = function (e) {
    var args = s.params.args;
    if (args !== undefined) {
      if (typeof args === 'string' && args === '$event') {
        args = e;
      } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
        args[args.indexOf('$event')] = e;
      }
    } else {
      args = e;
    }
    return args;
  };
  s.onClick = function (e) {
    s.target = e.target;

    if (s.params.onClick) s.params.onClick(s, s.getArgs(e));
    if (e.target.className.indexOf(s.params.buttonSubmitClass) !== -1) {
      if (s.params.onClickSubmit) s.params.onClickSubmit(s, s.getArgs(e));else s.hide();
    } else if (e.target.className.indexOf(s.params.buttonCancelClass) !== -1) {
      if (s.params.onClickCancel) s.params.onClickCancel(s, s.getArgs(e));else s.hide();
    }
  };
  s.setOnClick = function (fn) {
    s.params.onClick = fn;
  };
  s.setOnClickSubmit = function (fn) {
    s.params.onClickSubmit = fn;
  };
  s.setOnClickCancel = function (fn) {
    s.params.onClickCancel = fn;
  };
  s.onClickMask = function (e) {
    if (e.target === s.mask) {
      s.target = e.target;
      if (s.params.onClickMask) s.params.onClickMask(s, s.getArgs(e));
      if (s.params.isClickMaskHide) s.hide();
    }
  };
  s.setOnClickMask = function (fn) {
    s.params.onClickMask = fn;
  };
  s.onTransitionEnd = function (e) {
    if (e && e.propertyName === 'visibility') return;
    if (s.isHid) {
      // Callback onHid
      if (s.params.onHid) s.params.onHid(s, s.getArgs(e));
    } else {
      // Callback onShowed
      if (s.params.onShowed) s.params.onShowed(s, s.getArgs(e));
    }
  };
  /* --------------------
  Init
  -------------------- */
  s.init = function () {
    s.attach();
  };
  s.init();
};

// Loading 进度条
var Loading = function Loading(params) {
  /* --------------------
  Model
  -------------------- */
  var defaults = {
    mask: null,
    parent: document.body, // 创建于哪个元素下

    maskCss: '',
    maskClass: 'mask loading-mask', // 加loading-propagation允许点击
    maskActiveClass: 'active',
    loadingClass: 'loading',
    loadingActiveClass: 'active',

    types: ['floating', 'filling', 'custom'],
    type: 'floating', // floating流光 | filling填料环 | custom自定义
    iconSrc: '',
    caption: '正在加载...'
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  s.parent = typeof s.params.parent === 'string' ? document.querySelector(s.params.parent) : s.params.parent;
  s.mask = null;
  s.loading = null;

  // Mask
  s.createMask = function () {
    var mask = document.createElement('div');
    mask.setAttribute('class', s.params.maskClass);
    mask.setAttribute('style', s.params.maskCss);
    return mask;
  };
  s.create = function (html) {
    s.mask = s.createMask();
    s.mask.innerHTML = html;
    s.parent.appendChild(s.mask);
    s.loading = s.mask.querySelector('.' + s.params.loadingClass);
  };
  // Loading
  s.getLoadingHTML = function () {
    // 流光loading-floating
    var html = '<div class="' + s.params.loadingClass + ' loading-floating animated">' + '<div class="loading-floating-wrapper">' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '<div class="loading-floating-blade"></div>' + '</div>' + '<div class="loading-floating-caption">' + s.params.caption + '</div>' + '</div>';
    if (s.params.type === 'filling') {
      // 填料环loading-filling
      html = '<div class="' + s.params.loadingClass + ' loading-filling active">' + '<div class="loading-filling-wrapper"></div>' + '</div>';
    } else if (s.params.type === 'custom') {
      // 自定义样式,icon
      html = '<div class="' + s.params.loadingClass + ' loading-wrapper">' + '<img alt="" src="' + s.params.iconSrc + '" class="loading-icon"/>' + '<p>' + s.params.caption + '</p>' + '</div>';
    }
    return html;
  };
  s.update = function (params) {
    if (s.params.mask) s.mask = typeof s.params.mask === 'string' ? document.querySelector(s.params.mask) : s.params.mask;
    if (s.mask) {
      if (params && params.type) {
        var loadingHTML = s.getLoadingHTML();
        s.mask.innerHTML = loadingHTML;
      }
      s.loading = s.mask.querySelector('.' + s.params.loadingClass);
    } else {
      var html = s.getLoadingHTML();
      s.create(html);
    }
  };
  s.update();

  /* --------------------
  Method
  -------------------- */
  s.setMaskCss = function (css) {
    if (css) s.params.maskCss = css;
    s.mask.setAttribute('style', s.params.maskCss);
  };
  s.setMaskClassName = function (className) {
    if (className) s.params.maskClass = className;
    s.mask.setAttribute('class', s.params.maskClass);
  };
  s.setType = function (type) {
    if (s.params.type === type || s.params.types.indexOf(type) === -1) return;
    s.params.type = type;
    s.update({ type: type });
  };
  s.setHTML = function (html) {
    s.mask.innerHTML = html;
  };

  s.showMask = function () {
    s.mask.classList.add(s.params.maskActiveClass);
  };
  s.hideMask = function () {
    s.mask.classList.remove(s.params.maskActiveClass);
  };
  s.destroyMask = function () {
    s.mask.parentNode.removeChild(s.mask);
  };

  s.showLoading = function () {
    s.loading.classList.add(s.params.loadingActiveClass);
  };
  s.hideLoading = function () {
    s.loading.classList.remove(s.params.loadingActiveClass);
  };

  s.hide = function () {
    s.hideMask();
    s.hideLoading();
  };
  s.show = function () {
    s.showMask();
    s.showLoading();
  };
  s.destroy = function () {
    s.destroyMask();
  };
};

var Bridge$3 = {
  platform: 'browser',
  debug: false,
  // 初始化配置
  config: function config() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (params.debug) this.debug = params.debug;
    if (!this.debug) {
      console.log('config方法仅在微信上工作');
      return;
    }
    DB.setSession('bridge_isready', '1');
    if (params.onSuccess) params.onSuccess();
  },
  // 获得版本信息
  getAppVersion: function getAppVersion() {
    return window.navigator.appVersion;
  },
  // 拍照、本地选图
  chooseImage: function chooseImage() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!this.debug) {
      this.showToast('此功能仅可在微信或APP中使用', { mask: false });
      return;
    }
    var res = {
      sourceType: 'camera', // 微信返回的两种来源: 'camera', 'album'
      errMsg: 'chooseImage:ok',
      localIds: ['https://static.zcool.cn/git_z/z/common/images/svg/logo.svg', 'https://static.zcool.cn/v3.5.180706.5/zcool/client/image/logo.png']
    };
    if (params.success) params.success(res);
  },
  // 上传图片
  uploadImage: function uploadImage() {
    var _this = this;

    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!this.debug) {
      this.showToast('此功能仅可在微信或APP中使用', { mask: false });
      return;
    }
    this.showLoading('正在上传...');
    setTimeout(function () {
      _this.hideLoading();
      _this.showToast('上传完成', { mask: false });
      var res = {
        errMsg: 'uploadImage:ok',
        mediaUrl: '',
        serverId: '1237378768e7q8e7r8qwesafdasdfasdfaxss111'
      };
      if (params.success) params.success(res);
    }, 1000);
  },
  // 图片预览
  previewImage: function previewImage(params) {
    console.log('previewImage方法在浏览器上无法运行');
  },
  /**
   * 人员插件
   * params: {onSuccess: fn}
   */
  getContact: function getContact() {
    this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
  },
  getContactMore: function getContactMore() {
    this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
  },
  /**
   * 客户插件
   * params: {superTradeType | tradeType: 默认值为1(1.客户 2.经销商 3.门店), selectedIds: '', onSuccess: fn}
   */
  customerMore: [{
    "check": true,
    "distance": 31,
    "labelType": 0,
    "addr": "南京市建邺区康文路康缘智汇港附近",
    "approval_status": "3",
    "code": "20180403004",
    "cooperate_status": "1",
    "district_id": "",
    "id": "5330457627710680963",
    "lat": "",
    "location": "31.983362,118.73069",
    "lon": "",
    "manager_name": "",
    "name": "20180403003",
    "name_py": "20180403004 20180403004",
    "trade_type": "3",
    "type_id": "",
    "type_image": ""
  }, {
    "check": true,
    "distance": 5,
    "labelType": 0,
    "addr": "江苏省南京市建邺区康文路康缘智汇港附近",
    "approval_status": "3",
    "code": "storethree",
    "cooperate_status": "1",
    "district_id": "",
    "id": "8834765014408029232",
    "lat": "",
    "location": "31.983679,118.730766",
    "lon": "",
    "manager_name": "",
    "name": "门店3",
    "name_py": "mendian3 md3",
    "trade_type": "3",
    "type_id": "",
    "type_image": ""
  }, {
    "addr": "南京市建邺区康文路南京金贝网络科技有限公司附近",
    "approval_status": "3",
    "check": false,
    "code": "CUS000084",
    "cooperate_status": "1",
    "distance": -1,
    "district_id": "-1",
    "id": "8045732772848971055",
    "labelType": 2,
    "lat": "31.983311",
    "location": "31.983311,118.730527",
    "lon": "118.730527",
    "manager_name": "大表哥",
    "name": "201801171557",
    "name_py": "201801171557 201801171557",
    "trade_type": "3",
    "type_id": "-1",
    "type_image": ""
  }, {
    "addr": "南京市建邺区康文路南京金贝网络科技有限公司附近",
    "approval_status": "3",
    "check": true,
    "code": "CUS000085",
    "cooperate_status": "1",
    "distance": 46,
    "district_id": "",
    "id": "8353170616312361122",
    "labelType": 0,
    "lat": "",
    "location": "31.983301,118.730517",
    "lon": "",
    "manager_name": "",
    "name": "201801171624",
    "name_py": "201801171624 201801171624",
    "trade_type": "3",
    "type_id": "",
    "type_image": ""
  }],
  customerMoreLen: 1,
  getCustomerMore: function getCustomerMore() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!this.debug) {
      this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
      return;
    }
    var result = [];
    for (var i = 0; i < this.customerMoreLen; i++) {
      result.push(this.customerMore[i]);
    }
    this.customerMoreLen++;
    if (this.customerMoreLen > this.customerMore.length) {
      this.customerMoreLen = 1;
    }
    if (params.onSuccess) params.onSuccess(result);
  },
  getCustomer: function getCustomer() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!this.debug) {
      this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
      return;
    }
    if (params.onSuccess) params.onSuccess({
      id: '5365268129453435373',
      name: '门店1号'
    });
  },
  getCustomerType: function getCustomerType(params) {
    this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
  },
  getCustomerArea: function getCustomerArea(params) {
    this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
  },
  /**
   * 部门插件
   * params: {selectedIds: '',onSuccess: fn}
   */
  getDepartmentMore: function getDepartmentMore(params) {
    this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
  },
  getDepartment: function getDepartment() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!this.debug) {
      this.showToast('此功能仅可在外勤客户端中使用', { mask: false });
      return;
    }
    params.onSuccess({
      id: '5343180131602024954',
      name: '开发一部'
    });
  },
  /*
  * 打开新的窗口
  * params: {url:''}
  * */
  openWindow: function openWindow() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (params.url) window.location.href = params.url;
  },
  // 关闭窗口
  closeWindow: function closeWindow() {
    window.history.go(-1);
  },
  // 回到主页
  goHome: function goHome() {
    window.history.go(-2);
  },
  // 判断是否是主页
  isHomePage: function isHomePage(callback, rule) {
    if (rule && window.location.href.indexOf(rule) >= 0) {
      callback(true);
      return;
    }
    callback(false);
  },
  // 客户端默认返回控制
  back: function back() {
    var isFromApp = Device.getUrlParameter('isFromApp', location.search) || '';
    if (isFromApp === '1') {
      window.history.go(-1);
    } else if (isFromApp === 'home') {
      window.history.go(-1);
    } else if (isFromApp === 'confirm') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          window.history.go(-1);
        }
      });
    } else if (isFromApp === 'confirm-close') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          window.history.go(-1);
        }
      });
    } else {
      window.history.go(-1);
    }
  },
  // 客户端返回绑定
  addBackPress: function addBackPress() {
    console.log('addBackPress方法在浏览器上无法运行');
  },
  // 客户端移除返回绑定
  removeBackPress: function removeBackPress() {
    console.log('removeBackPress方法在浏览器上无法运行');
  },
  /*
   * 获取当前地理位置
   * type：'wgs84'|'gcj02'坐标类型，微信默认使用国际坐标'wgs84'
   * 返回：{latitude:'纬度',longitude:'经度',speed:'速度',accuracy:'位置精度'}
   * */
  getLocation: function getLocation() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!this.debug) {
      this.showToast('定位功能仅可在微信或APP中使用', { mask: false });
      if (params.onError) params.onError({ code: 'locationFail', msg: '定位功能仅可在微信或APP中使用' });
    }
    setTimeout(function () {
      if (params.onSuccess) params.onSuccess({ longitude: '118.730515', latitude: '31.982473', speed: '0.0', accuracy: '3.0.0' });
    }, 500);
  },
  /*
   * 百度地图:获取当前位置名称
   * params：{type: 'gcj02', longitude: '', latitude: '', onSuccess: fn, onFail: fn}
   * 返回：{address:'地址全称'}
   * */
  getAddress: function getAddress() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var url = 'https://api.map.baidu.com/geocoder/v2/?callback=renderReverse&location=' + params.latitude + ',' + params.longitude + '&output=json&pois=1&ak=IlfRglMOvFxapn5eGrmAj65H&ret_coordtype=gcj02ll';
    jsonp(url, null, function (err, data) {
      if (err) {
        if (params.onError) params.onError({ code: 'addressFail', msg: '获取位置名称失败,请稍后重试' + err });
      } else {
        var addrs = {};
        if (data.result && data.result.formatted_address) {
          addrs.address = data.result.formatted_address;
          if (params.onSuccess) params.onSuccess(addrs);
        } else {
          if (params.onError) params.onError({ code: 'addressFail', msg: '获取位置名称失败,请稍后重试' });
        }
      }
    });
  },
  /*
   * 百度地图:获得两个点之间的距离
   * params: {point1: {longitude: '', latitude: ''}, point2: {longitude: '', latitude: ''}, onError: fn)
   * 返回km
   * */
  getDistance: function getDistance() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!params.point1 || !params.point1.latitude || !params.point1.longitude || !params.point2 || !params.point2.latitude || !params.point2.longitude) {
      if (params.onError) params.onError({ code: 'distanceFail', msg: '传入的坐标不正确' });
      return;
    }
    var lat1 = params.point1.latitude;
    var lng1 = params.point1.longitude;
    var lat2 = params.point2.latitude;
    var lng2 = params.point2.longitude;
    var radLat1 = lat1 * Math.PI / 180.0;
    var radLat2 = lat2 * Math.PI / 180.0;
    var a = radLat1 - radLat2;
    var b = lng1 * Math.PI / 180.0 - lng2 * Math.PI / 180.0;
    var s = 2 * Math.asin(Math.sqrt(Math.pow(Math.sin(a / 2), 2) + Math.cos(radLat1) * Math.cos(radLat2) * Math.pow(Math.sin(b / 2), 2)));
    s = s * 6378.137; // EARTH_RADIUS;
    s = Math.round(s * 10000) / 10000;
    return s;
  },
  /*
   * 扫描二维码并返回结果
   * 返回：{resultStr:''}
   * */
  scanQRCode: function scanQRCode() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    this.showToast('扫码功能仅可在微信或APP中使用', { mask: false });
    if (params.onError) params.onError({ code: 'qrcodeFail', msg: '此功能仅可在微信或APP中使用' });
  },

  // 退出到登陆页面
  logOut: function logOut() {
    console.log('logOut方法仅在app上工作');
  },
  /* 封装图片控件,使用示例见ImgUploader组件
  bridge.Image({
    onChooseSuccess: function (imgMap) {},
    onUploadSuccess:function(imgMap,res) // 单张上传成功
    onUploadFail:function(index, item) // 单张上传失败
    onUploadsSuccess:function(imgMap) // 全部上传成功
  })
  */
  Image: function Image() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var s = this;
    var msg = '';
    // 选择照片
    s.choose = function () {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      if (!this.debug) {
        Bridge$3.showToast('拍照功能只能在APP或者微信中使用', { mask: false });
        return;
      }
      var option = {
        enableSafe: args.enableSafe || false, // 安全上传,第次只能传一张
        max: args.max || 5,
        currentCount: args.currentCount || 1,
        sourceType: args.sourceType || ['album', 'camera'],
        sizeType: args.sizeType || ['original', 'compressed']
      };
      var count = option.max - option.currentCount;
      if (count <= 0) {
        msg = '最多只能传' + option.max + '张照片';
        Bridge$3.showToast(msg);
        return;
      }
      // 如果设置了安全上传,则每次只允许上传一张
      if (option.enableSafe) count = 1;
      Bridge$3.chooseImage({
        count: count, // 默认5
        sizeType: option.sizeType, // 可以指定是原图还是压缩图，默认二者都有
        sourceType: option.sourceType, // 可以指定来源是相册还是相机，默认二者都有camera|album
        success: function success(res) {
          var imgMap = {};
          for (var i = 0, localId; localId = res.localIds[i++];) {
            // eslint-disable-line
            imgMap[localId] = {
              serverId: '',
              sourceType: res.sourceType
            };
          }
          if (params.onChooseSuccess) params.onChooseSuccess(imgMap, res);
          s.upload(imgMap);
        },
        fail: function fail(res) {
          Bridge$3.showToast('选择照片失败,请检查是否开启定位权限', { mask: false });
        },
        cancel: function cancel() {},
        complete: function complete() {}
      });
    };
    // 上传照片
    s.upload = function (imgMap) {
      var imgs = Object.keys(imgMap);
      var loop = function loop(index) {
        if (index >= imgs.length) {
          return;
        }
        var img = imgs[index];
        if (imgMap[img].serverId) {
          loop(++index);
          return;
        }
        Bridge$3.uploadImage({
          localId: img, // 需要上传的图片的本地ID，由chooseImage接口获得
          isShowProgressTips: 1, // 默认为1，显示进度提示
          success: function success(res) {
            var serverId = res.serverId; // 返回图片的服务器端ID
            imgMap[img].serverId = serverId;
            if (params.onUploadSuccess) params.onUploadSuccess(imgMap, res);
            if (index >= imgs.length - 1 && params.onUploadsSuccess) params.onUploadsSuccess(imgMap);
            loop(++index);
          },
          fail: function fail() {
            var msg = '您选择的第' + index + '张图片上传失败，稍后请重试';
            Bridge$3.showToast(msg, { mask: false });
            if (params.onUploadFail) params.onUploadFail(index, imgMap[img]);
            loop(++index);
          }
        });
      };
      loop(0);
    };
  },
  /*
   * 打印日志
   * 参数: el绑定点击5次的元素, log日志文字
   * 结果：显示日志信息
   * */
  logger: function logger(el) {
    // 监听触发的元素,点击十次显示
    var subscribeEl = el || document.body;
    // 日志盒子
    var logBox = document.createElement('div');
    logBox.setAttribute('style', 'position:absolute;top:0;left:0;right:0;bottom:0;z-index:9999;background:rgba(0, 0, 0, 0.85);color:white;');

    var logClose = document.createElement('div');
    logClose.setAttribute('style', 'height:44px;line-height:44px;text-align:center;background:rgba(200,50,50,1);');
    logClose.innerHTML = '关闭';
    logClose.addEventListener('click', function () {
      document.body.removeChild(logBox);
    }, false);
    var logContent = document.createElement('div');
    logContent.setAttribute('style', 'position:absolute;top:44px;left:0;right:0;bottom:0;padding:10px;overflow:auto;');
    logBox.appendChild(logClose);
    logBox.appendChild(logContent);
    logBox.addEventListener('click', stopPropagationHandler, false);
    function stopPropagationHandler(e) {
      e.stopPropagation();
    }
    if (subscribeEl.getAttribute('data-multipleclick')) return;
    EventUtil.addHandler(subscribeEl, 'multipleclick', function () {
      logContent.innerHTML = DB.getSession('app_logger') || '无日志';
      document.body.appendChild(logBox);
    });
    subscribeEl.setAttribute('data-multipleclick', '1');
  },
  // 拨打电话
  tel: function tel(number) {
    if (Device.device === 'pc') {
      this.showToast('此功能仅可在微信或APP中使用');
      return;
    }
    if (isNaN(number)) return;
    window.location.href = 'tel:' + number;
  },
  // 弹出toast
  toast: null,
  showToast: function showToast(msg) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (!msg) return;
    if (!this.toast) {
      // 提示错误
      this.toast = new Toast({
        parent: document.body,
        maskClass: 'mask toast-mask' + (params.mask === false ? ' toast-propagation' : ''),
        toastClass: 'toast ' + (params.position ? params.position : 'middle'),
        icon: params.icon || '',
        html: msg,
        delay: params.delay || 2000
      });
    } else {
      this.toast.setHTML(msg);
      this.toast.setMaskClassName('mask toast-mask' + (params.mask === false ? ' toast-propagation' : ''));
      this.toast.setToastClassName('toast ' + (params.position ? params.position : 'middle'));
      this.toast.setIcon(params.icon || '');
    }
    this.toast.show();
    if (params.onSuccess) {
      setTimeout(function () {
        params.onSuccess();
      }, params.duration ? Math.round(params.duration / 2) : 1000);
    }
  },
  // 弹出loading
  loading: null,
  showLoading: function showLoading() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!this.loading) {
      this.loading = new Loading({
        type: params.type,
        maskCss: params.css || null
      });
    } else {
      if (params.type) this.loading.setType(params.type);
      if (params.css) this.loading.setMaskCss(params.css);
      this.loading.setMaskClassName('mask loading-mask ' + (params.mask === false ? ' loading-propagation' : ''));
    }
    this.loading.show();
  },
  hideLoading: function hideLoading() {
    if (!this.loading) {
      this.toast.showToast('请先showLoading才能hideLoading');
    } else {
      this.loading.hide();
    }
  },
  // 弹出Alert
  alert: null,
  showAlert: function showAlert(msg) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (!this.alert) {
      this.alert = new Alert$3({
        caption: params.caption || '',
        html: msg,
        onClickSubmit: function onClickSubmit(e) {
          if (params.onSuccess) params.onSuccess(e);else e.hide();
        }
      });
    } else {
      if (params.caption) this.alert.setCaption(params.caption);
      this.alert.setHTML(msg);
    }
    this.alert.show();
  },
  // 弹出Confirm
  confirm: null,
  showConfirm: function showConfirm(msg) {
    var params = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    if (!this.confirm) {
      this.confirm = new Alert$3({
        caption: params.caption || '',
        html: msg,
        onClickSubmit: function onClickSubmit(e) {
          if (params.onSuccess) params.onSuccess(e);
        },
        onClickCancel: function onClickCancel(e) {
          if (params.onError) params.onError(e);else e.hide();
        }
      });
    } else {
      if (params.caption) this.confirm.setCaption(params.caption);
      if (params.onSuccess) this.confirm.setOnClickSubmit(params.onSuccess);
      if (params.onError) this.confirm.setOnClickCancel(params.onError);
      this.confirm.setHTML(msg);
    }
    this.confirm.show();
  }
};

// axios 默认配置
// axios.defaults.timeout = 5000
// 设置头
axios.defaults.headers.post['Content-Type'] = 'application/jsoncharset=UTF-8';

// 构建get请求参数
function buildGetUrl(url, params) {
  var result = Object.params(params);
  if (result) return url + '?' + result;
  return url;
}
// 请求拦截器
axios.interceptors.request.use(function (config) {
  var conf = Object.clone(config);
  // 设置请求数据
  var data = '';
  try {
    data = JSON.parse(config.data);
  } catch (e) {
    data = config.data;
  }
  if (data && data.data) {
    conf.data = data.data;
  }
  // 设置头
  var head = '';
  if (data && data.head) {
    head = config.data.head;
    Object.keys(head).forEach(function (key) {
      var value = head[key];
      conf.headers[key] = value;
    });
  }
  if (config.method === 'get') {
    conf.url = buildGetUrl(conf.url, conf.data);
  }
  return conf;
}, function (error) {
  return Promise.reject(error);
});
// 响应拦截器
axios.interceptors.response.use(function (response) {
  var result = response.data || response;
  if (typeof result === 'string') {
    try {
      return JSON.parse(result);
    } catch (error) {
      console.log('result转换JSON失败' + error);
      return result;
    }
  }
  return result;
}, function (error) {
  if (error.response) {
    switch (error.response.status) {
      case 401:
        // 401 跳转到登录页面
        Bridge$1.logOut(error.response.data.message);
        break;
      default:
      // alert(JSON.stringify(error.response))
    }
  }
  return Promise.reject(error);
});

// 封装成Api类
function buildParams(params) {
  if (params && !params.data) return { data: params };
  return params;
}
var Api = {
  setBaseURL: function setBaseURL(baseURL) {
    axios.defaults.baseURL = baseURL;
  },
  post: function post(url, params) {
    return axios.post(url, params);
  },
  get: function get(url, params) {
    var newParams = buildParams(params);
    return axios.get(url, newParams);
  },
  all: function all(requests) {
    var _this = this;

    var methods = requests.map(function (request) {
      if (request.method === 'post') {
        return _this.post(request.url, request.data || null);
      } else {
        return _this.get(request.url, request.data || null);
      }
    });
    return axios.all(methods);
  }
};

var Bridge$2 = {
  platform: 'weixin',
  /**
   * 初始化配置
   * @opts {url: string, params: object, onSuccess: func, onError: func}
   */
  config: function config() {
    var opts = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var ticketUrl = opts.url || '/wxapi/getJsApiTicket.action';
    // 记录进入app的url，后面微信sdk
    var url = encodeURIComponent(window.location.href.split('#')[0]);
    var ticketParams = {
      appId: DB.getStore('app_appId') || '',
      url: url
      // 记录日志
    };DB.setSession('app_logger', DB.getSession('app_logger') + '<br/><br/>1.微信鉴权接口参数:' + JSON.stringify(ticketParams));
    Api.get(ticketUrl, opts.params || ticketParams).then(function (response) {
      var result = response;
      if (result.code === '1') {
        var params = {
          debug: false, // 开启调试模式,调用的所有api的返回值会在客户端alert出来，若要查看传入的参数，可以在pc端打开，参数信息会通过log打出，仅在pc端时才会打印。
          appId: result.data.appId, // 必填，公众号的唯一标识
          timestamp: result.data.timestamp, // 必填，生成签名的时间戳
          nonceStr: result.data.nonceStr, // 必填，生成签名的随机串
          signature: result.data.signature, // 必填，签名，见附录1
          jsApiList: ['getLocation', 'chooseImage', 'uploadImage', 'previewImage', 'onHistoryBack', 'closeWindow', 'hideOptionMenu', 'hideMenuItems', 'scanQRCode']
        };
        if (!wx) {
          // eslint-disable-line
          if (opts.onError) opts.onError({ code: 'bridgeInitFail', msg: '微信组件下载失败,如需使用本地能力,请返回重试' });
          return;
        }
        // 记录日志
        DB.setSession('app_logger', DB.getSession('app_logger') + '<br/><br/>2.微信config的参数' + JSON.stringify(params));
        wx.config(params); // eslint-disable-line
        wx.ready(function () {
          // eslint-disable-line
          // 隐藏右上角按钮
          // wx.hideOptionMenu() // eslint-disable-line
          // 桥接成功
          DB.setSession('bridge_isready', '1');
          // Callback
          if (opts.onSuccess) opts.onSuccess();
        });
        wx.error(function (res) {
          // eslint-disable-line
          // 记录日志
          DB.setSession('app_logger', DB.getSession('app_logger') + '<br/><br/>3.微信鉴权错误信息:' + JSON.stringify(res));
          // 桥接失败
          DB.setSession('bridge_isready', '-1');
          // Callback
          var errMsg = '微信鉴权失败,请退出重试' + JSON.stringify(res);
          Bridge$3.showToast(errMsg, { mask: false });
          if (opts.onError) opts.onError({ code: 'oauthFail', msg: errMsg });
        });
      } else {
        var errMsg = response.message;
        Bridge$3.showToast(errMsg, { mask: false });
        if (opts.onError) opts.onError({ code: 'oauthInterfaceFail', msg: errMsg });
      }
    }).catch(function (err) {
      if (opts.onError) {
        opts.onError({ code: 'oauthInterfaceFail', msg: 'getJsApiTicket微信鉴权失败,请稍后重试' });
      } else {
        alert('getJsApiTicket微信鉴权失败,请稍后重试');
      }
    });
  },
  // 客户端默认返回控制
  back: function back() {
    var isFromApp = Device.getUrlParameter('isFromApp', location.search) || '';
    if (isFromApp === '1') {
      window.history.go(-1);
    } else if (isFromApp === 'home') {
      window.history.go(-1);
    } else if (isFromApp === 'confirm') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          window.history.go(-1);
        }
      });
    } else if (isFromApp === 'confirm-close') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          window.history.go(-1);
        }
      });
    } else {
      window.history.go(-1);
    }
  },
  // 客户端返回绑定
  addBackPress: function addBackPress() {
    if (wx.onHistoryBack) wx.onHistoryBack(function () {
      // eslint-disable-line
      this.back();
      return false;
    });
  },
  // 客户端移除返回绑定
  removeBackPress: function removeBackPress() {
    if (wx.onHistoryBack) wx.onHistoryBack(function () {
      // eslint-disable-line
      return true;
    });
  },
  /*
   * 获取当前地理位置
   * type：'wgs84'|'gcj02'坐标类型，微信默认使用国际坐标'wgs84'
   * 返回：{latitude:'纬度',longitude:'经度',speed:'速度',accuracy:'位置精度'}
   * */
  getLocation: function getLocation() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    // 先从cookie中读取位置信息
    var appLocation = DB.getCookie('app_location');
    if (appLocation === 'undefined') {
      DB.removeCookie('app_location');
      appLocation = '';
    }
    try {
      if (appLocation) appLocation = JSON.parse(appLocation);
    } catch (error) {
      appLocation = '';
    }
    if (appLocation) {
      if (params.onSuccess) params.onSuccess(appLocation);
      return;
    }
    // 定位超时
    setTimeout(function () {
      if (!DB.getCookie('app_location')) {
        var errMsg = '请确认微信定位权限是否开启,如未开启将影响图片上传功能';
        Bridge$3.showToast(errMsg, { mask: false });
        if (params.onError) params.onError({ code: 'locationFail', msg: errMsg });
      }
    }, 5000);
    // 定位
    wx.getLocation({ // eslint-disable-line
      // 默认为wgs84的gps坐标，如果要返回直接给openLocation用的火星坐标，可传入'gcj02'
      type: 'gcj02',
      success: function success(res) {
        // 将位置信息存储到cookie中60秒
        if (res.latitude && res.latitude) {
          DB.setCookie('app_location', JSON.stringify(res), 60);
          if (params.onSuccess) params.onSuccess(res);
        } else {
          var errMsg = '定位失败,请重新进入此页面';
          Bridge$3.showToast(errMsg, { mask: false });
          if (params.onError) params.onError({ code: 'locationFail', msg: errMsg });
        }
      },
      fail: function fail() {
        var errMsg = '定位失败,请检查微信定位权限是否开启';
        Bridge$3.showToast(errMsg, { mask: false });
        if (params.onError) params.onError({ code: 'locationFail', msg: errMsg });
      },
      cancel: function cancel(res) {
        if (params.onCancel) params.onCancel(res);
      },
      complete: function complete(res) {
        if (params.onComplete) params.onComplete(res);
      }
    });
  },
  /*
   * 扫描二维码并返回结果
   * 返回：{resultStr:''}
   * */
  scanQRCode: function scanQRCode() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wx.scanQRCode({ // eslint-disable-line
      needResult: params.needResult || 1, // 默认为0，扫描结果由微信处理，1则直接返回扫描结果
      scanType: params.scanType || ['qrCode', 'barCode'],
      desc: 'scanQRCode desc',
      success: function success(res) {
        if (!params.onSuccess) return;
        var wxRes = res;
        // 如果没有设置needResult,则清除前缀
        if (isNaN(params.needResult)) {
          if (res.resultStr.indexOf('QR,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('QR,'.length);
          } else if (res.resultStr.indexOf('EAN_13,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('EAN_13,'.length);
          } else if (res.resultStr.indexOf('EAN_8,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('EAN_8,'.length);
          } else if (res.resultStr.indexOf('AZTEC,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('AZTEC,'.length);
          } else if (res.resultStr.indexOf('DATAMATRIX,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('DATAMATRIX,'.length);
          } else if (res.resultStr.indexOf('UPCA,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('UPCA,'.length);
          } else if (res.resultStr.indexOf('UPCE,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('UPCE,'.length);
          } else if (res.resultStr.indexOf('CODABAR,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODABAR,'.length);
          } else if (res.resultStr.indexOf('CODE_39,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODE_39,'.length);
          } else if (res.resultStr.indexOf('CODE_93,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODE_93,'.length);
          } else if (res.resultStr.indexOf('CODE_128,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('CODE_128,'.length);
          } else if (res.resultStr.indexOf('ITF,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('ITF,'.length);
          } else if (res.resultStr.indexOf('MAXICODE,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('MAXICODE,'.length);
          } else if (res.resultStr.indexOf('PDF_417,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('PDF_417,'.length);
          } else if (res.resultStr.indexOf('RSS_14,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('RSS_14,'.length);
          } else if (res.resultStr.indexOf('RSSEXPANDED,') >= 0) {
            wxRes.resultStr = res.resultStr.substring('RSSEXPANDED,'.length);
          }
        }
        // 回调
        params.onSuccess(wxRes);
      },
      fail: function fail(res) {
        if (params.onError) params.onError({ code: 'qrcodeFail', msg: '扫码失败,请退出重试' + res });
      },
      cancel: function cancel(res) {
        if (params.onCancel) params.onCancel(res);
      },
      complete: function complete(res) {
        if (params.onComplete) params.onComplete(res);
      }
    });
  },

  /*
  * 拍照、本地选图
  * params：{sourceType:['album:相册', 'camera:拍照'],sizeType:['original:原图', 'compressed:压缩'],count:'最大张数', success:fn, fail:fn, cancel: fn, complete: fn}
  * 返回选定照片的本地ID列表{localIds:[]'}
  */
  chooseImage: function chooseImage(params) {
    wx.chooseImage(params); // eslint-disable-line
  },
  /*
  * 上传图片
  params：{
    localId: '', // 需要上传的图片的本地ID，由chooseImage接口获得
    isShowProgressTips: 1, // 默认为1，显示进度提示
    success: function (res) {
      var serverId = res.serverId; // 返回图片的服务器端ID
    }
  }
  */
  uploadImage: function uploadImage(params) {
    wx.uploadImage(params); // eslint-disable-line
  },
  /*
  * 图片预览
  * params：{urls:'需要预览的图片http链接列表',current:'当前显示图片的http链接'}
  */
  previewImage: function previewImage(params) {
    wx.previewImage(params); // eslint-disable-line
  },
  /* 封装图片控件,使用示例见ImgUploader组件
  bridge.Image({
    onChooseSuccess: function (imgMap) {},
    onUploadSuccess:function(imgMap,res) // 单张上传成功
    onUploadFail:function(index, item) // 单张上传失败
    onUploadsSuccess:function(imgMap) // 全部上传成功
  })
  */
  Image: function Image(params) {
    var s = this;
    var msg = '';
    // 选择照片
    s.choose = function () {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var option = {
        enableSafe: args.enableSafe || false, // 安全上传,第次只能传一张
        max: args.max || 5,
        currentCount: args.currentCount || 1,
        sourceType: args.sourceType || ['album', 'camera'],
        sizeType: args.sizeType || ['original', 'compressed']
      };
      var count = option.max - option.currentCount;
      if (count <= 0) {
        msg = '最多只能传' + option.max + '张照片';
        Bridge$3.showToast(msg);
        return;
      }
      // 如果设置了安全上传,则每次只允许上传一张
      if (option.enableSafe) count = 1;
      Bridge$2.chooseImage({
        count: count, // 默认5
        sizeType: option.sizeType, // 可以指定是原图还是压缩图，默认二者都有
        sourceType: option.sourceType, // 可以指定来源是相册还是相机，默认二者都有camera|album
        success: function success(res) {
          var imgMap = {};
          for (var i = 0, localId; localId = res.localIds[i++];) {
            // eslint-disable-line
            imgMap[localId] = {
              serverId: '',
              sourceType: res.sourceType
            };
          }
          if (params.onChooseSuccess) params.onChooseSuccess(imgMap, res);
          s.upload(imgMap);
        },
        fail: function fail(res) {
          Bridge$3.showToast('选择照片失败,请检查是否开启定位权限', { mask: false });
        },
        cancel: function cancel() {},
        complete: function complete() {}
      });
    };
    // 上传照片
    s.upload = function (imgMap) {
      var imgs = Object.keys(imgMap);
      var loop = function loop(index) {
        if (index >= imgs.length) {
          return;
        }
        var img = imgs[index];
        if (imgMap[img].serverId) {
          loop(++index);
          return;
        }
        Bridge$2.uploadImage({
          localId: img, // 需要上传的图片的本地ID，由chooseImage接口获得
          isShowProgressTips: 1, // 默认为1，显示进度提示
          success: function success(res) {
            var serverId = res.serverId; // 返回图片的服务器端ID
            imgMap[img].serverId = serverId;
            if (params.onUploadSuccess) params.onUploadSuccess(imgMap, res);
            if (index >= imgs.length - 1 && params.onUploadsSuccess) params.onUploadsSuccess(imgMap);
            loop(++index);
          },
          fail: function fail() {
            var msg = '您选择的第' + index + '张图片上传失败，稍后请重试';
            Bridge$3.showToast(msg, { mask: false });
            if (params.onUploadFail) params.onUploadFail(index, imgMap[img]);
            loop(++index);
          }
        });
      };
      loop(0);
    };
  }
};

var BridgeWeixin = Object.assign({}, Bridge$3, Bridge$2);

var Bridge$4 = {
  platform: 'dinghuo',
  config: function config() {
    DB.setSession('bridge_isready', '1');
    this.registerHandler(['getGoodsByApp', 'getCartGoodsByApp', 'onBackPress', 'setOnlineByApp']);
  },
  /* 获得版本信息 */
  getAppVersion: function getAppVersion() {
    var ua = navigator.userAgent;
    var verExp = ua.match(/DinghuoAppVersion\/.{0,}(\d+\.\d+\.\d+)/);
    if (verExp && verExp[1]) return verExp[1].trim();
    return '';
  },
  /* 公共方法，通过桥接调用原生方法公共入口 */
  invoke: function invoke(name, param, callback) {
    if (/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)) {
      /* 判断iPhone|iPad|iPod|iOS */
      /* eslint-disable */
      this.setup(function (bridge) {
        bridge.callHandler(name, param, function (response) {
          if (callback) {
            try {
              callback(JSON.parse(response));
            } catch (e) {
              callback(response);
            }
          }
        });
      });
      /* eslint-enable */
    } else if (/(Android)/i.test(navigator.userAgent)) {
      /* 判断Android */
      // 注册分类页面事件
      if (window.WebViewJavascriptBridge) {
        window.WebViewJavascriptBridge.callHandler(name, param && JSON.stringify(param), function (response) {
          if (callback) {
            try {
              callback(JSON.parse(response));
            } catch (e) {
              callback(response);
            }
          }
        });
      } else {
        document.addEventListener('WebViewJavascriptBridgeReady', function () {
          window.WebViewJavascriptBridge.callHandler(name, param && JSON.stringify(param), function (response) {
            if (callback) {
              try {
                callback(JSON.parse(response));
              } catch (e) {
                callback(response);
              }
            }
          });
        }, false);
      }
    }
  },
  setup: function setup(callback) {
    /* eslint-disable */
    if (window.WebViewJavascriptBridge) {
      return callback(WebViewJavascriptBridge);
    }
    if (window.WVJBCallbacks) {
      return window.WVJBCallbacks.push(callback);
    }
    window.WVJBCallbacks = [callback];
    var WVJBIframe = document.createElement('iframe');
    WVJBIframe.style.display = 'none';
    WVJBIframe.src = 'https://__bridge_loaded__';
    document.documentElement.appendChild(WVJBIframe);
    setTimeout(function () {
      document.documentElement.removeChild(WVJBIframe);
    }, 0);
    /* eslint-enable */
  },

  /**
   * 注册事件
   */
  registerHandler: function registerHandler(events) {
    if (typeof window !== 'undefined') {
      if (/(iPhone|iPad|iPod|iOS)/i.test(navigator.userAgent)) {
        /* 判断iPhone|iPad|iPod|iOS */
        /* eslint-disable */
        this.setup(function (bridge) {
          events.forEach(function (eventName) {
            bridge.registerHandler(eventName, function () {
              var event = new CustomEvent(eventName);
              // 分发事件
              window.dispatchEvent(event);
            });
          });
        });
        /* eslint-enable */
      } else if (/(Android)/i.test(navigator.userAgent)) {
        /* 判断Android */
        // 注册分类页面事件
        if (window.WebViewJavascriptBridge) {
          events.forEach(function (eventName) {
            window.WebViewJavascriptBridge.registerHandler(eventName, function () {
              var event = new CustomEvent(eventName);
              // 分发事件
              window.dispatchEvent(event);
            });
          });
        } else {
          document.addEventListener('WebViewJavascriptBridgeReady', function () {
            events.forEach(function (eventName) {
              window.WebViewJavascriptBridge.registerHandler(eventName, function () {
                var event = new CustomEvent(eventName);
                // 分发事件
                window.dispatchEvent(event);
              });
            });
          }, false);
        }
      }
    }
  },
  /*
  * 判断是否是首页
  * params: {url:''}默认为打开一个webview页面，如果打开原生页面需要加前缀：nyNative://
  * */
  isHomePage: function isHomePage(callback) {
    this.invoke('isHomePage', null, function (data) {
      if (data.result.toString() === '1') {
        callback(true);
      } else {
        callback(false);
      }
    });
  },
  /*
  * 商联支付
  * params: {appKey:'', dealerCode:'', orderId:'', payAmount:''}
  * */
  slopenpay: function slopenpay(params, callback) {
    this.invoke('slopenpay', params, callback);
  },
  /*
  * 打开新的窗口
  * params: {url:''}默认为打开一个webview页面，如果打开原生页面需要加前缀：nyNative://
  * */
  openWindow: function openWindow(params, callback) {
    this.invoke('openWindow', params, callback);
  },
  /* 关闭当前窗 */
  closeWindow: function closeWindow(callback) {
    this.invoke('closeWindow', null, callback);
  },
  /*
  * 文件操作
  * */
  /* 文件是否存在
  isExistsFile({
    "fileName": "ss.txt",
    "size": 200
  }，(result) => {
  // 返回{{"isExists":"","filePath":"","fileName":""}，isExists:'0'不存在，'1'存在
  })
  */
  isExistsFile: function isExistsFile(params, callback) {
    this.invoke('isExistsFile', params, callback);
  },
  /* 附件下载
  downloadFile({
    "id": "id",
    "fileName": "ss.txt",
    "downloadUrl": "http://...",
    "size": 200
  }，(result) => {
  // 返回{{"code":"","filePath":"","message":""}，code:'0'失败，'1'成功，message失败原因
  }) */
  downloadFile: function downloadFile(params, callback) {
    this.invoke('downloadFile', params, callback);
  },
  /* 附件打开
  openFile（{
    "filePath": ""
  }，(result) => {
  // 返回{{"code":"","message":""}，code:'0'失败，'1'成功，message失败原因
  }） */
  openFile: function openFile(params, callback) {
    this.invoke('openFile', params, callback);
  },
  /*
   * 扫描二维码并返回结果
   * 返回：{resultStr:''}
   * */
  scanQRCode: function scanQRCode(params) {
    this.invoke('scanQRCode', null, params.onSuccess);
  },
  /*
   * 获取当前地理位置
   * type：坐标类型，订货365默认使用国测局'gcj02'
   * 返回：{latitude:'纬度',longitude:'经度',speed:'速度',accuracy:'位置精度',address:'地址',country:'国',province:'省',city:'市',area:'区',street:'街道'}
   * */
  getLocation: function getLocation() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    // 先从cookie中读取位置信息
    var appLocation = DB.getCookie('app_location') || '';
    if (appLocation) {
      if (params.onSuccess) params.onSuccess(JSON.parse(appLocation));
      return;
    }
    this.invoke('getLocation', 'gcj02', function (res) {
      if (res && res.latitude) {
        // 将位置信息存储到cookie中10秒
        DB.setCookie('app_location', JSON.stringify(res), 10);
        if (params.onSuccess) params.onSuccess(res);
      } else {
        if (params.onError) params.onError({ code: 'locationFail', msg: '定位失败,请检查订货365定位权限是否开启' });
      }
    });
  },
  /*
   * 获取当前位置名称
   * params：{type: 'gcj02', longitude: 'xx', latitude: 'xx', onSuccess: (), onError: ()}
   * 返回：{latitude:'纬度',longitude:'经度',speed:'速度',accuracy:'位置精度'}
   * */
  getAddress: function getAddress() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    // 先从cookie中读取位置信息
    var appLocation = DB.getCookie('app_location') || '';
    if (appLocation) {
      if (params.onSuccess) params.onSuccess(JSON.parse(appLocation));
      return;
    }
    if (params.onError) params.onError({ code: 'addressFail', msg: '获取位置名称失败,请稍后重试' });else alert('获取位置名称失败,请稍后重试');
  },
  /*
  * 获取当前网络状态
  * 返回：{networkType:'返回网络类型2g，3g，4g，wifi'}
  * */
  getNetworkType: function getNetworkType(callback) {
    this.invoke('getNetworkType', null, callback);
  },
  /*
  * 拍照、本地选图
  * params：{sourceType:['album:相册', 'camera:拍照'],sizeType:['original:原图', 'compressed:压缩'],count:'最大张数'}
  * 返回选定照片的本地ID列表{localIds:[id,id,id]'}, src需要增加前缀'LocalResource://imageid'+id才能显示
  */
  chooseImage: function chooseImage(params) {
    this.invoke('chooseImage', params, params.success);
  },
  /*
  * 上传图片
  * params：{dir:'',localIds:['localId', 'localId'], tenantId: ''}
  */
  uploadImage: function uploadImage() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!params.dir) {
      Bridge$3.showToast('请传入上传路径dir后再上传图片');
      return;
    }
    if (!params.localIds || Object.isEmptyObject(params.localIds)) {
      Bridge$3.showToast('请传入上传图片列表后再上传图片');
      return;
    }
    // 格式化params
    var uploadParams = {
      localIds: params.localIds,
      uploadDir: params.dir
    };
    if (uploadParams.tenantId) params.tenantId = params.tenantId;
    this.invoke('uploadImage', uploadParams);
  },
  /**
   * 获取带前缀的图片
   */
  getPreviewImages: function getPreviewImages(imgIds) {
    return imgIds.map(function (imgId) {
      return 'LocalResource://imageid' + imgId;
    });
  },
  getPreviewImage: function getPreviewImage(imgId) {
    return 'LocalResource://imageid' + imgId;
  },
  /*
  * 图片预览
  * params：{urls:'需要预览的图片http链接列表',current:'当前显示图片的http链接',index:'图片索引'}
  * 备注：图片url后面带localId为标识为本地，客户端优先从本地查找，本地没有再从网络加载
  */
  previewImage: function previewImage(argParams) {
    if (!argParams.urls || !argParams.urls.length) return;
    var self = this;
    // 如果是网络图片直接显示,如果是本地图片,则加上前缀再显示
    var params = argParams;
    params.urls = argParams.urls.map(function (url) {
      if (url.indexOf('//') === -1 && url.indexOf('http://') === -1 && url.indexOf('https://') !== -1) {
        return self.getPreviewImage(url);
      }
      return url;
    });
    this.invoke('previewImage', params);
  },
  /*
    * 监听/取消监听物理返回事件(仅android)
    * flag（true：监听，false：取消监听）
    */
  setBackEnable: function setBackEnable(flag) {
    if (/(Android)/i.test(navigator.userAgent)) {
      /* 判断Android */
      this.invoke('setBackEnable', flag);
    }
  },
  /*
  * 获取图片前缀
  * */
  getImagePrefix: function getImagePrefix() {
    return 'LocalResource://imageid';
  },
  /*
  * 下载图片
  */
  downloadImage: function downloadImage() {},
  /* 分享给朋友 */
  onMenuShareAppMessage: function onMenuShareAppMessage() {},
  /* 分享到朋友圈 */
  onMenuShareTimeline: function onMenuShareTimeline() {},
  /* 退出到登陆页面 */
  logOut: function logOut() {
    this.invoke('logOut');
  },
  /* 获取登陆信息 */
  loginInfo: function loginInfo(callback) {
    this.invoke('getLoginInfo', null, callback);
  },
  /* 根据key获取登陆信息 */
  getLoginInfo: function getLoginInfo(key, callback) {
    this.loginInfo(function (result) {
      callback(result[key]);
    });
  },

  /* 获取系统参数 */
  systemParameter: function systemParameter(callback) {
    this.invoke('getSystemParameter', null, callback);
  },

  /*
   * 设置系统参数
   * @param data: {appId: '', openId: '', image_url: '', mobile: '', selectedSupplier: object, sysParms: object}
   * */
  setSystemParameter: function setSystemParameter(data) {
    // 设置系统参数
    if (data.sysParms) DB.setStore('app_sysparams', data.sysParms);
    // 设置图片主域名
    var imgDomain = data.image_url ? data.image_url.clearProtocol() : '';
    if (imgDomain && imgDomain.length - 1 !== imgDomain.lastIndexOf('/')) {
      imgDomain = imgDomain + '/';
      DB.setStore('app_imgDomain', decodeURIComponent(imgDomain));
    } else {
      console.log('图片域名未定义');
      return { code: 'imgDomainFail', msg: '图片域名未定义' };
    }
    // 设置uid
    DB.setStore('app_uid', data.uid || '');
    // 设置手机号
    DB.setStore('app_mobile', data.mobile || '');
    // 设置appId和openId
    if (data.openId) DB.setStore('app_openId', data.openId || '');
    if (data.appId) DB.setStore('app_appId', data.appId || '');
    // 设置选中的供货商
    if (data.selectedSupplier && _typeof(data.selectedSupplier) === 'object') {
      DB.setStore('app_selectedSupplier', data.selectedSupplier);
    } else {
      console.log('没有供货商');
      return { code: 'selectedSupplierFail', msg: '请选择供货商' };
    }
  },
  /* 修改原生角标 */
  changeBadgeNum: function changeBadgeNum(count) {
    this.invoke('setBadgeNum', { key: count });
  },
  /* 去首页 */
  goHome: function goHome(callback) {
    this.invoke('goHome', null, callback);
  },
  /* 返回按键处理 */
  back: function back() {
    var isFromApp = Device.getUrlParameter('isFromApp', location.search) || '';
    if (isFromApp === '1') {
      try {
        Bridge$4.closeWindow();
      } catch (error) {
        console.log(error);
      }
    } else if (isFromApp === 'home') {
      try {
        Bridge$4.goHome();
      } catch (error) {
        console.log(error);
      }
    } else if (isFromApp === 'confirm') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          window.history.go(-1);
        }
      });
    } else if (isFromApp === 'confirm-close') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          Bridge$4.closeWindow();
        }
      });
    } else {
      window.history.go(-1);
    }
  },
  // 客户端添加返回绑定
  addBackPress: function addBackPress() {
    var _this = this;

    try {
      this.setBackEnable(true);
      window.addEventListener('onBackPress', this.back);
    } catch (error) {
      console.log(error);
    }
    // 使用桥接初始化系统参数
    this.loginInfo(function (loginData) {
      _this.systemParameter(function (sysData) {
        var data = {};
        data.image_url = loginData.image_url;
        data.uid = loginData.uid;
        data.mobile = loginData.mobile;
        data.selectedSupplier = loginData.selectedSupplier;
        data.sysParms = sysData;
        Bridge$3.setSystemParameter(data);
      });
    });
  },
  // 客户端移除返回绑定
  removeBackPress: function removeBackPress() {
    try {
      this.setBackEnable(false);
      window.removeEventListener('onBackPress', this.back);
    } catch (error) {
      console.log(error);
    }
  },
  /* 封装图片控件,使用示例见ImgUploader组件
  bridge.Image({
    onChooseSuccess: function (imgMap) {},
  })
  */
  Image: function Image() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var s = this;
    var msg = '';
    // 选择照片
    s.choose = function () {
      var args = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

      var option = {
        enableSafe: args.enableSafe || false, // 安全上传,第次只能传一张
        max: args.max || 5,
        currentCount: args.currentCount || 1,
        sourceType: args.sourceType || ['album', 'camera'],
        sizeType: args.sizeType || ['original', 'compressed'],
        watermark: args.watermark || {}
        /* watermark: {
          orderNo: 'xx', // 编号
          submitName: 'xx', // 提交人
          customerName: 'xx', // 客户
          cmLocation: '118.730515, 31.982473', // 位置算偏差
          isWaterMark: '1', // 是否启用水印
        } */
      };var count = option.max - option.currentCount;
      if (count <= 0) {
        msg = '最多只能传' + option.max + '张照片';
        Bridge$3.showToast(msg);
        return;
      }
      // 如果设置了安全上传,则每次只允许上传一张
      if (option.enableSafe) count = 1;
      Bridge$4.chooseImage(Object.assign({
        count: count, // 默认5
        sizeType: option.sizeType, // 可以指定是原图还是压缩图，默认二者都有
        sourceType: option.sourceType, // 可以指定来源是相册还是相机，默认二者都有camera|album
        success: function success(res) {
          var imgMap = {};
          for (var i = 0, localId; localId = res.localIds[i++];) {
            // eslint-disable-line
            imgMap[localId] = {
              serverId: '',
              sourceType: JSON.stringify(option.sourceType) === JSON.stringify(['camera']) ? 'camera' : 'album'
            };
          }
          if (params.onChooseSuccess) params.onChooseSuccess(imgMap, res);
        }
      }, option.watermark));
    };
  }
};

var BridgeDinghuo = Object.assign({}, Bridge$3, Bridge$4);

var Bridge$5 = {
  platform: 'waiqin',
  config: function config() {
    var _this = this;

    document.addEventListener('deviceready', function () {
      _this.addBackPress();
      DB.setSession('bridge_isready', '1');
    });
  },
  // 获得版本信息
  getAppVersion: function getAppVersion() {
    var ua = navigator.userAgent;
    var verExp = ua.match(/WqAppVersion\/.{0,}(\d+\.\d+\.\d+)/);
    if (verExp && verExp[1]) return verExp[1].trim();
    return '';
  },
  /*
  * 打开新的窗口
  * params: {url:'', title: ''}默认为打开一个webview页面
  * */
  openWindow: function openWindow(params, callback) {
    wq.wqload.wqOpenUrl(callback ? callback : null, null, params ? JSON.stringify(params) : null); // eslint-disable-line
  },
  // 关闭当前窗
  closeWindow: function closeWindow() {
    wq.wqload.wqClosePage(); // eslint-disable-line
  },
  /*
  * 商联支付
  * params: {appKey:'', dealerCode:'', orderId:'', payAmount:''}
  * */
  slopenpay: function slopenpay(params, callback) {
    wq.wqpay.slopenpay(function (result) {
      // eslint-disable-line
      if (callback) callback(result);
    }, null, params ? JSON.stringify(params) : null);
  },
  /*
  * 文件操作
  * */
  /* 文件是否存在
  isExistsFile({
    "fileName": "ss.txt",
    "size": 200
  }，(result) => {
  // 返回{{"isExists":"","filePath":"","fileName":""}，isExists:'0'不存在，'1'存在
  })
  */
  isExistsFile: function isExistsFile(params, callback) {
    wq.wqio.verifyFileHasExist(function (result) {
      // eslint-disable-line
      if (callback) callback(result);
    }, params ? JSON.stringify(params) : null);
  },
  /* 附件下载
  downloadFile({
    "id": "id",
    "fileName": "ss.txt",
    "downloadUrl": "http://...",
    "size": 200
  }，(result) => {
  // 返回{{"code":"","filePath":"","message":""}，code:'0'失败，'1'成功，message失败原因
  }) */
  downloadFile: function downloadFile(params, callback) {
    wq.wqio.downloadFile(function (result) {
      // eslint-disable-line
      if (callback) callback(result);
    }, params ? JSON.stringify(params) : null);
  },
  /* 附件打开
  openFile（{
    "filePath": ""
  }，(result) => {
  // 返回{{"code":"","message":""}，code:'0'失败，'1'成功，message失败原因
  }） */
  openFile: function openFile(params, callback) {
    wq.wqio.openFile(function (result) {
      // eslint-disable-line
      if (callback) callback(result);
    }, params ? JSON.stringify(params) : null);
  },
  /*
   * 扫描二维码并返回结果
   * 返回：{resultStr:''}
   * */
  scanQRCode: function scanQRCode() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqhardware.getQrCode(function (res) {
      // eslint-disable-line
      if (res && res.qrCode) {
        var wqRes = res;
        wqRes.resultStr = res.qrCode;
        if (params && params.onSuccess) params.onSuccess(wqRes);
      } else {
        if (params.onError) params.onError({ code: 'qrcodeFail', msg: '扫码失败请稍后重试' });
      }
    });
  },
  /*
   * 获取当前地理位置
   * 外勤365默认使用国测局'gcj02'定位,没有参数控制
   * 返回：{latitude:'纬度',longitude:'经度',speed:'速度',accuracy:'位置精度',address:'地址',country:'国',province:'省',city:'市',area:'区',street:'街道'}
   * */
  getLocation: function getLocation() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    // 先从cookie中读取位置信息
    var appLocation = DB.getCookie('app_location') || '';
    if (appLocation) {
      if (params.onSuccess) params.onSuccess(JSON.parse(appLocation));
      return;
    }
    wq.wqlocation.getLocationBackground(function (res) {
      // eslint-disable-line
      if (res && res.wqLatitude) {
        // 格式化为标准的返回信息
        var location = {
          latitude: res.wqLatitude,
          longitude: res.wqLongitude,
          speed: null,
          accuracy: res.radius,
          address: res.wqAddress,
          country: '中国',
          province: res.province,
          city: res.city,
          area: res.district,
          street: res.street
          // 将位置信息存储到cookie中10秒
        };DB.setCookie('app_location', JSON.stringify(location), 10);
        if (params.onSuccess) params.onSuccess(location);
      } else {
        if (params.onError) params.onError({ code: 'locationFail', msg: '定位失败,请检查订货365定位权限是否开启' });
      }
    }, JSON.stringify({ locationType: '1' })); // "0"双定位百度优先，"1"双定位高德优先，"2"单百度定位，"3"单高德定位
  },
  /*
   * 获取当前位置名称
   * params：{type: 'gcj02', longitude: 'xx', latitude: 'xx', onSuccess: (), onError: ()}
   * 返回：{latitude:'纬度',longitude:'经度',speed:'速度',accuracy:'位置精度'}
   * */
  getAddress: function getAddress() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    // 先从cookie中读取位置信息
    var appLocation = DB.getCookie('app_location') || '';
    if (appLocation) {
      if (params.onSuccess) params.onSuccess(JSON.parse(appLocation));
      return;
    }
    if (params.onError) params.onError({ code: 'addressFail', msg: '获取位置名称失败,请稍后重试' });else alert('获取位置名称失败,请稍后重试');
  },
  /*
  * 拍照、本地选图
  * params：{sourceType:['album', 'camera'],sizeType:['original', 'compressed'],count:'最大张数', success:fn, fail:fn, photoType:'', customerName: ''}
  * 返回选定照片的本地ID列表{localIds:[LocalResource://imageid123456789987654321]'}
  */
  chooseImage: function chooseImage(argParams) {
    var params = {};
    // 格式化sourceType
    var operation = '2';
    if (argParams && argParams.sourceType) {
      if (argParams.sourceType.indexOf('album') >= 0 && argParams.sourceType.indexOf('camera') >= 0) {
        operation = '2';
      } else if (argParams.sourceType.indexOf('album') >= 0) {
        operation = '1';
      } else {
        operation = '0';
      }
      params.operation = operation;
    }
    // 格式化sizeType
    var pwidth = null;
    if (argParams && argParams.sizeType) {
      if (argParams.sizeType === 'compressed') {
        pwidth = '750';
        params.operation = pwidth;
      }
    }
    // 格式化count
    var max = 5;
    if (argParams && argParams.count) {
      max = argParams.count;
      params.max = '' + max;
    }
    // viewId
    params.viewId = '' + parseInt(Math.random() * 1000, 10);
    // photoType
    if (argParams && argParams.photoType) {
      params.photoType = argParams.photoType;
    }
    // customerName
    if (argParams && argParams.customerName) {
      params.customerName = argParams.customerName;
    }
    // submitName
    if (argParams && argParams.submitName) {
      params.submitName = argParams.submitName;
    }
    // cmLocation
    if (argParams && argParams.cmLocation) {
      params.cmLocation = argParams.cmLocation;
    }
    wq.wqphoto.getPhoto(function (result) {
      // eslint-disable-line
      if (argParams && argParams.success) {
        // 格式化返回结果[{src:地址, path: base64: name: 文件名}] 为 imgMap{path: {serverId: '', sourceType: ''} }
        var imgMap = {};
        for (var i = 0, item; item = result[i++];) {
          // eslint-disable-line
          imgMap[item.name] = {
            serverId: '',
            name: item.name,
            sourceType: operation === '0' ? 'camera' : 'album',
            base64: item.path,
            src: item.src
          };
        }
        argParams.success(imgMap);
      }
    }, null, JSON.stringify(params));
  },
  /*
  * 上传图片
  * params：{dir:'上传路径',localIds:['图片集合'], tenantId: '企业Id'}
  */
  uploadImage: function uploadImage() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    if (!params.dir) {
      Bridge$3.showToast('请传入上传路径dir后再上传图片');
      return;
    }
    if (!params.localIds || Object.isEmptyObject(params.localIds)) {
      Bridge$3.showToast('请传入上传图片列表后再上传图片');
      return;
    }
    // 格式化params
    var uploadParams = {
      filePathList: params.localIds.map(function (item) {
        return { path: item };
      }),
      url: params.dir
    };
    if (params.tenantId) uploadParams.tenantId = params.tenantId;
    wq.wqphoto.startUpload(JSON.stringify(uploadParams)); // eslint-disable-line
  },
  /*
  * 图片预览
  * params：{urls:'需要预览的图片http链接列表',current:'当前显示图片的http链接',index:'图片索引'}
  * 备注：图片url后面带localId为标识为本地，客户端优先从本地查找，本地没有再从网络加载
  */
  previewImage: function previewImage(argParams) {
    // 格式化index
    var position = 0;
    if (argParams && argParams.index) position = argParams.index;
    // 格式化urls
    var photos = [];
    if (argParams && argParams.urls && argParams.urls.length) {
      photos = argParams.urls.map(function (item) {
        return {
          path: item
        };
      });
    }
    var params = {
      position: position,
      photos: photos
    };
    wq.wqphoto.photoPreview(JSON.stringify(params)); // eslint-disable-line
  },
  // 退出到登陆页面
  logOut: function logOut(msg) {
    wq.wqload.wqBackToLogin(JSON.stringify({ message: msg || '' })); // eslint-disable-line
  },
  /**
   * 人员插件
   * params: {onSuccess: fn}
   */
  getContactMore: function getContactMore() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqcontact.getContactMore(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"selectedIds":"' + (params.selectedIds || '') + '","aclType":"' + (params.aclType || '') + '"}'); // aclType:人员权限（0：只能看到下属;不传或者其他的参数为全部人员）
  },
  getContact: function getContact() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqcontact.getContact(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"id":"' + (params.id || '') + '","aclType":"' + (params.aclType || '') + '"}');
  },
  /**
   * 客户插件
   * params: {superTradeType | tradeType: 默认值为1(1.客户 2.经销商 3.门店), selectedIds: '', onSuccess: fn}
   */
  getCustomerMore: function getCustomerMore() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqcustomer.getCustomerMore(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"selectedIds":"' + (params.selectedIds || '') + '","tradeType":"' + (params.tradeType || '') + '","hiddenAdd":true}');
  },
  getCustomer: function getCustomer() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqcustomer.getCustomer(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"id":"' + (params.id || '') + '","name":"' + (params.name || '') + '","tradeType":"' + (params.tradeType || '') + '"}');
  },
  getCustomerType: function getCustomerType() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqcustomer.getCustomerType(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"id":"' + (params.id || '') + '","name":"' + (params.name || '') + '","tradeType":"' + (params.tradeType || '') + '"}');
  },
  getCustomerArea: function getCustomerArea() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqcustomer.getCustomerArea(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"id":"' + (params.id || '') + '","name":"' + (params.name || '') + '"}');
  },
  /**
   * 部门插件
   * params: {selectedIds: '',onSuccess: fn}
   */
  getDepartmentMore: function getDepartmentMore() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqdepartment.getDepartmentMore(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"selectedIds":"' + (params.selectedIds || '') + '"}');
  },
  getDepartment: function getDepartment() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    wq.wqdepartment.getDepartment(function (args) {
      // eslint-disable-line
      if (params.onSuccess) params.onSuccess(args);
    }, '{"id":"' + (params.id || '') + '","name":"' + (params.name || '') + '"}');
  },
  // 客户端默认返回控制
  back: function back() {
    var isFromApp = Device.getUrlParameter('isFromApp', location.search) || '';
    if (isFromApp === '1') {
      try {
        Bridge$5.closeWindow();
      } catch (error) {
        console.log(error);
      }
    } else if (isFromApp === 'home') {
      try {
        Bridge$5.closeWindow();
      } catch (error) {
        console.log(error);
      }
    } else if (isFromApp === 'confirm') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          window.history.go(-1);
        }
      });
    } else if (isFromApp === 'confirm-close') {
      Bridge$3.showConfirm('您确定要离开此页面吗?', {
        onSuccess: function onSuccess(e) {
          e.hide();
          Bridge$5.closeWindow();
        }
      });
    } else {
      window.history.go(-1);
    }
  },
  // 客户端返回绑定
  addBackPress: function addBackPress() {
    document.addEventListener('backbutton', this.back, false); // eslint-disable-line
  },
  // 客户端移除返回绑定
  removeBackPress: function removeBackPress() {
    document.removeEventListener('backbutton', this.back, false); // eslint-disable-line
  },
  /* 封装图片控件,使用示例见ImgUploader组件
  bridge.Image({
    onChooseSuccess: function (imgMap) {},
  })
  */
  Image: function Image() {
    var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    var s = this;
    var msg = '';
    // 选择照片
    s.choose = function (args) {
      var option = {
        enableSafe: args.enableSafe || false, // 安全上传,第次只能传一张
        max: args.max || 5,
        currentCount: args.currentCount || 1,
        sourceType: args.sourceType || ['album', 'camera'],
        sizeType: args.sizeType || ['original', 'compressed'],
        watermark: args.watermark || {}
        /* watermark: {
          photoType: 'xx', // 水印名称
          customerName: 'xx', // 客户名
        } */
      };var count = option.max - option.currentCount;
      if (count <= 0) {
        msg = '最多只能传' + option.max + '张照片';
        Bridge$3.showToast(msg);
        return;
      }
      // 如果设置了安全上传,则每次只允许上传一张
      if (option.enableSafe) count = 1;
      Bridge$5.chooseImage(Object.assign({
        count: count, // 默认5
        sizeType: option.sizeType, // 可以指定是原图还是压缩图，默认二者都有
        sourceType: option.sourceType, // 可以指定来源是相册还是相机，默认二者都有camera|album
        success: function success(res) {
          if (params.onChooseSuccess) params.onChooseSuccess(res);
        }
      }, option.watermark));
    };
  }
};

var BridgeWaiqin = Object.assign({}, Bridge$3, Bridge$5);

var Bridge = {};
if (Device.platform === 'weixin') {
  Bridge = BridgeWeixin;
} else if (Device.platform === 'dinghuo') {
  Bridge = BridgeDinghuo;
  Bridge.config();
} else if (Device.platform === 'waiqin') {
  Bridge = BridgeWaiqin;
  Bridge.config();
} else {
  Bridge = Bridge$3;
}

var Bridge$1 = Bridge;

var Attributes$2 = function (_Component) {
  inherits(Attributes, _Component);

  function Attributes(props, context) {
    var _arguments = arguments;
    classCallCheck(this, Attributes);

    var _this = possibleConstructorReturn(this, (Attributes.__proto__ || Object.getPrototypeOf(Attributes)).call(this, props, context));

    _this.onCopyToClipboard = function (text) {
      var onCopy = _this.props.onCopy;

      Clipboard.copy(text, {
        onSuccess: function onSuccess(msg) {
          if (onCopy) onCopy(text, msg);
        },
        onError: function onError(msg) {
          if (onCopy) onCopy(text, msg);
        }
      });
    };

    _this.onClick = function (item, index, item2, index2) {
      // eslint-disable-line
      if (_this.props.onClick) _this.props.onClick(_arguments);
    };

    _this.getValueDOM = function (item, index) {
      // 价格
      if (item.price) {
        var priceValue = item.value || '';
        if (typeof item.price === 'string') {
          priceValue = item.price;
        }
        return React__default.createElement(Price$1, { digits: item.priceDigits, key: 'price' + index, style: item.priceStyle, className: item.priceClassName ? item.priceClassName : 'capitalize', price: priceValue, unit: item.priceUnit || '' });
        // 按钮
      } else if (item.button) {
        var buttonValue = item.value || '';
        if (typeof item.button === 'string') {
          buttonValue = item.button;
        }
        return React__default.createElement(
          Button$1,
          { key: 'button' + index, style: item.buttonStyle, className: item.buttonClassName, onClick: function onClick(e) {
              e.stopPropagation();if (item.buttonClick) item.buttonClick(item.buttonArgs || '');
            } },
          buttonValue
        );
        // html
      } else if (item.html) {
        var htmlValue = item.value || '';
        if (typeof item.html === 'string') {
          htmlValue = item.html;
        }
        return React__default.createElement('div', { dangerouslySetInnerHTML: { __html: htmlValue } });
      }
      return item.value;
    };

    _this.getOpDOM = function (item, index) {
      // 复制
      if (item.copy) {
        var copyValue = item.value || '';
        if (typeof item.copy === 'string') {
          copyValue = item.copy;
        }
        return React__default.createElement(
          Button$1,
          { key: index, className: 'ricon sm', style: { borderRadius: '3px' }, args: copyValue, onClick: _this.onCopyToClipboard },
          '\u590D\u5236'
        );
      }
      // 电话
      if (item.tel) {
        var telValue = item.value || '';
        if (typeof item.tel === 'string') {
          telValue = item.tel;
        }
        return React__default.createElement(
          'a',
          { key: index, className: 'ricon', onClick: function onClick() {
              Bridge$1.tel(telValue);
            } },
          React__default.createElement('i', { className: 'icon bg-tel' })
        );
      }
      // 标签
      if (item.mark) {
        return React__default.createElement(
          Mark$1,
          { className: item.markClassName, style: item.markStyle },
          item.mark
        );
      }
    };

    _this.getCol2ValueDOM = function (item, index) {
      var dom = [];
      dom.push(_this.getValueDOM(item, index));
      var opDOM = _this.getOpDOM(item, index);
      if (opDOM) dom.push(opDOM);
      return dom;
    };

    _this.getRowClassName = function () {
      var rowClassName = _this.props.rowClassName;

      return 'attribute' + (rowClassName ? ' ' + rowClassName : ' attribute-margin');
    };

    return _this;
  }
  // 获得值DOM

  // 获得操作DOM

  // 获得2列的value的DOM

  // 获得一行的className


  createClass(Attributes, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          showValidValue = _props.showValidValue,
          showValidName = _props.showValidName,
          col = _props.col,
          list = _props.list,
          className = _props.className,
          style = _props.style,
          rowStyle = _props.rowStyle,
          colClassName = _props.colClassName,
          colStyle = _props.colStyle,
          cellClassName = _props.cellClassName,
          cellStyle = _props.cellStyle,
          nameClassName = _props.nameClassName,
          nameStyle = _props.nameStyle,
          valueClassName = _props.valueClassName,
          valueStyle = _props.valueStyle,
          rowAfter = _props.rowAfter,
          rowAfterExclude = _props.rowAfterExclude,
          children = _props.children;

      var attrsDOM = [];

      var _loop = function _loop(_i) {
        if (col === '2') {
          attrsDOM.push(React__default.createElement(
            'div',
            { key: 'row' + _i, className: _this2.getRowClassName(), style: rowStyle, onClick: function onClick() {
                _this2.onClick(list[_i], _i, list[_i + 1], _i + 1);
              } },
            React__default.createElement(
              'div',
              { className: 'attribute-half' + (colClassName ? ' ' + colClassName : ''), style: colStyle },
              React__default.createElement(
                'div',
                { className: 'attribute-left' + (cellClassName ? ' ' + cellClassName : '') + (nameClassName ? ' ' + nameClassName : ''), style: Object.assign({}, cellStyle, nameStyle) },
                list[_i].name
              ),
              React__default.createElement(
                'div',
                { className: 'attribute-right' + (cellClassName ? ' ' + cellClassName : '') + (valueClassName ? ' ' + valueClassName : ''), style: Object.assign({}, cellStyle, valueStyle) },
                _this2.getCol2ValueDOM(list[_i], _i),
                list[_i].ricon && React__default.createElement(
                  'span',
                  null,
                  list[_i].ricon
                )
              )
            ),
            list[_i + 1] && React__default.createElement(
              'div',
              { className: 'attribute-half' + (colClassName ? ' ' + colClassName : ''), style: colStyle },
              React__default.createElement(
                'div',
                { className: 'attribute-left' + (cellClassName ? ' ' + cellClassName : '') + ' ' + (nameClassName ? nameClassName : ''), style: Object.assign({}, cellStyle, nameStyle) },
                list[_i + 1].name ? list[_i + 1].name : ''
              ),
              React__default.createElement(
                'div',
                { className: 'attribute-right' + (cellClassName ? ' ' + cellClassName : '') + '  ' + (valueClassName ? valueClassName : ''), style: Object.assign({}, cellStyle, valueStyle) },
                _this2.getCol2ValueDOM(list[_i + 1], _i + 1),
                list[_i + 1].ricon && React__default.createElement(
                  'span',
                  null,
                  list[_i + 1].ricon
                )
              )
            )
          ), rowAfter && rowAfterExclude !== _i ? React__default.createElement(
            'div',
            { key: 'rowafter' + _i },
            rowAfter
          ) : null);
          _i += 2;
        } else {
          var isShow = true;
          if (showValidValue && !list[_i].value) isShow = false;
          if (showValidName && !list[_i].name) isShow = false;
          if (list[_i].show !== undefined) isShow = list[_i].show;
          if (isShow) {
            attrsDOM.push(React__default.createElement(
              'div',
              { key: 'row' + _i, className: _this2.getRowClassName(), style: rowStyle, onClick: function onClick() {
                  _this2.onClick(list[_i], _i);
                } },
              React__default.createElement(
                'div',
                { className: 'attribute-left' + (cellClassName ? ' ' + cellClassName : '') + (nameClassName ? ' ' + nameClassName : ''), style: Object.assign({}, cellStyle, nameStyle) },
                list[_i].name
              ),
              React__default.createElement(
                'div',
                { className: 'attribute-right' + (cellClassName ? ' ' + cellClassName : '') + (valueClassName ? ' ' + valueClassName : ''), style: Object.assign({}, cellStyle, valueStyle) },
                _this2.getValueDOM(list[_i], _i),
                list[_i].ricon && React__default.createElement(
                  'span',
                  null,
                  list[_i].ricon
                )
              ),
              _this2.getOpDOM(list[_i], _i)
            ), rowAfter && rowAfterExclude !== _i ? React__default.createElement(
              'div',
              { key: 'rowafter' + _i },
              rowAfter
            ) : null);
          }
          _i++;
        }
        i = _i;
      };

      for (var i = 0; i < list.length;) {
        _loop(i);
      }
      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'attributes' + (className ? ' ' + className : ''), style: style },
        attrsDOM,
        children
      );
    }
  }]);
  return Attributes;
}(React.Component);

Attributes$2.propTypes = {
  showValidValue: propTypes.bool, // 值合法时显示
  showValidName: propTypes.bool, // name合法时显示

  col: propTypes.string, // 列数, 默认1
  list: propTypes.array,
  // [
  //   {
  //     name: string,
  //     value: string,
  //     copy: bool | string,
  //     tel: bool | string,
  //     price: bool | string,
  //     priceClassName: string,
  //     priceStyle: object,
  //     button: bool | string,
  //     buttonClassName: string,
  //     buttonStyle: object,
  //     buttonClick: func,
  //     buttonArgs: array,
  //     show: bool,
  //     mark: string,
  //     markClassName: string,
  //     markStyle: object
  //   }
  // ]
  className: propTypes.string, // align(左右对齐布局) | start(左端对齐) | between(两端对齐)
  style: propTypes.object,

  rowClassName: propTypes.string, // 行className
  rowStyle: propTypes.object,

  colClassName: propTypes.string, // 2列的情况,列className
  colStyle: propTypes.object,

  cellClassName: propTypes.string, // 列className
  cellStyle: propTypes.object,

  nameClassName: propTypes.string, // name的className
  nameStyle: propTypes.object,
  valueClassName: propTypes.string, // value的className
  valueStyle: propTypes.object,

  rowAfter: propTypes.node,
  rowAfterExclude: propTypes.number,
  children: propTypes.node,
  onCopy: propTypes.func,
  onClick: propTypes.func // 点击行
};
Attributes$2.defaultProps = {
  list: [],
  rowAfterExclude: -1
};

var BiDoughnut$1 = function (_Component) {
  inherits(BiDoughnut, _Component);

  function BiDoughnut(props, context) {
    classCallCheck(this, BiDoughnut);

    var _this = possibleConstructorReturn(this, (BiDoughnut.__proto__ || Object.getPrototypeOf(BiDoughnut)).call(this, props, context));

    _this.getDuration = function () {
      var _this$props = _this.props,
          duration = _this$props.duration,
          rotate = _this$props.rotate;

      var correctRotate = rotate > 360 ? 360 : rotate;
      var duration1 = duration / 360;
      var durationRotate = duration1 * correctRotate;
      var durationLeft = 0;
      var durationRight = durationRotate;
      if (correctRotate > 180) {
        durationRight = duration1 * 180;
        durationLeft = duration1 * (correctRotate - 180);
      }
      return {
        durationRotate: durationRotate,
        delayLeft: durationRight,
        durationLeft: durationLeft,
        durationRight: durationRight
      };
    };

    _this.getRotate = function () {
      var rotate = _this.props.rotate;

      var rotateLeft = -135; // 左circle旋转角度
      var rotateRight = -135 + rotate; // 右circle旋转角度
      if (rotate > 180) {
        rotateRight = 45;
        rotateLeft = -135 + (rotate - 180);
      }
      return {
        rotateLeft: rotateLeft,
        rotateRight: rotateRight
      };
    };

    _this.aniRotate = function () {
      // 时长与延时
      var duration = _this.getDuration();
      var durationLeft = duration.durationLeft;
      var delayLeft = duration.delayLeft;
      var durationRight = duration.durationRight;
      // 旋转
      var rotate = _this.getRotate();
      var rotateLeft = rotate.rotateLeft;
      var rotateRight = rotate.rotateRight;
      setTimeout(function () {
        if (_this.$elLeftCircle) {
          _this.$elLeftCircle.style.WebkitTransitionDuration = durationLeft + 'ms';
          _this.$elLeftCircle.style.WebkitTransitionDelay = delayLeft + 'ms';
        }
        if (_this.$elRightCircle) {
          _this.$elRightCircle.style.WebkitTransitionDuration = durationRight + 'ms';
        }
        if (_this.$elLeftCircle) {
          _this.$elLeftCircle.style.WebkitTransform = 'rotate(' + rotateLeft + 'deg)';
        }
        if (_this.$elRightCircle) {
          _this.$elRightCircle.style.WebkitTransform = 'rotate(' + rotateRight + 'deg)';
        }
      }, _this.props.delay);
    };

    return _this;
  }
  // 只有延迟100毫秒动画才会生效


  createClass(BiDoughnut, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          lineWidth = _props.lineWidth,
          size = _props.size,
          className = _props.className,
          children = _props.children,
          childrenClassName = _props.childrenClassName,
          childrenStyle = _props.childrenStyle;
      // 动画旋转

      this.aniRotate();
      return React__default.createElement(
        'div',
        { className: 'bi-doughtut ' + className, style: { width: size + 'px', height: size + 'px' } },
        React__default.createElement(
          'div',
          { className: 'bi-doughtut-wrapper left' },
          React__default.createElement('div', { ref: function ref(el) {
              _this2.$elLeftCircle = el;
            }, className: 'bi-doughtut-circle left', style: { borderWidth: lineWidth + 'px', width: size - lineWidth * 2 + 'px', height: size - lineWidth * 2 + 'px' } })
        ),
        React__default.createElement(
          'div',
          { className: 'bi-doughtut-wrapper right' },
          React__default.createElement('div', { ref: function ref(el) {
              _this2.$elRightCircle = el;
            }, className: 'bi-doughtut-circle right', style: { borderWidth: lineWidth + 'px', width: size - lineWidth * 2 + 'px', height: size - lineWidth * 2 + 'px' } })
        ),
        React__default.createElement(
          'div',
          { className: 'bi-doughtut-label' + (childrenClassName ? ' ' + childrenClassName : ''), style: childrenStyle },
          children
        )
      );
    }
  }]);
  return BiDoughnut;
}(React.Component);

BiDoughnut$1.propTypes = {
  lineWidth: propTypes.number, // 边框宽度
  size: propTypes.number, // 大小,px
  duration: propTypes.number, // 时长
  rotate: propTypes.number, // 最大360
  delay: propTypes.number, // 延时

  className: propTypes.string,
  children: propTypes.node,
  childrenClassName: propTypes.string,
  childrenStyle: propTypes.object
};
BiDoughnut$1.defaultProps = {
  lineWidth: 3,
  size: 50,
  duration: 1000,
  rotate: 0,
  delay: 100,
  className: 'disabled'
};

var BiGauge$1 = function (_Component) {
  inherits(BiGauge, _Component);

  function BiGauge(props, context) {
    classCallCheck(this, BiGauge);

    var _this = possibleConstructorReturn(this, (BiGauge.__proto__ || Object.getPrototypeOf(BiGauge)).call(this, props, context));

    _this.getDuration = function () {
      var _this$props = _this.props,
          duration = _this$props.duration,
          rotate = _this$props.rotate;

      return duration / 270 * rotate;
    };

    _this.getRotate = function () {
      var rotate = _this.props.rotate;

      return rotate > 270 ? 270 : rotate;
    };

    _this.getBgLvl = function () {
      var rotate = _this.props.rotate;

      var lvl = Math.round(rotate / 27);
      return lvl > 10 ? 10 : 1;
    };

    _this.aniRotate = function () {
      // 时长
      var duration = _this.getDuration();
      // 旋转
      var rotate = _this.getRotate();
      // 背景
      var bgLvl = 'bg' + _this.getBgLvl();
      setTimeout(function () {
        if (_this.$el) {
          _this.$el.style.WebkitAnimationDuration = duration + 'ms';
          _this.$el.classList.add(bgLvl);
        }
        if (_this.$elPointer) {
          _this.$elPointer.style.WebkitTransitionDuration = duration + 'ms';
          _this.$elPointer.style.WebkitTransform = 'rotate(' + rotate + 'deg)';
        }
      }, _this.props.delay);
    };

    return _this;
  }
  // 只有延迟100毫秒动画才会生效


  createClass(BiGauge, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          children = _props.children,
          childrenClassName = _props.childrenClassName,
          childrenStyle = _props.childrenStyle;
      // 动画旋转

      this.aniRotate();
      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'bi-gauge-box' + (className ? ' ' + className : ''), style: style },
        React__default.createElement(
          'div',
          { className: 'bi-gauge' },
          React__default.createElement('div', { ref: function ref(el) {
              _this2.$elPointer = el;
            }, className: 'bi-gauge-pointer' }),
          React__default.createElement(
            'div',
            { className: 'bi-gauge-text' + (childrenClassName ? ' ' + childrenClassName : ''), style: childrenStyle },
            children
          )
        )
      );
    }
  }]);
  return BiGauge;
}(React.Component);

BiGauge$1.propTypes = {
  duration: propTypes.number, // 时长
  rotate: propTypes.number, // 最大360
  delay: propTypes.number, // 延时

  className: propTypes.string,
  style: propTypes.object,
  children: propTypes.node,
  childrenClassName: propTypes.string,
  childrenStyle: propTypes.object
};
BiGauge$1.defaultProps = {
  duration: 1000,
  rotate: 0,
  delay: 100
};

// Calendar 日历 (require dateutil.js)
var Calendar$3 = function Calendar(container, params) {
  /* --------------------
  Model
  -------------------- */
  var defaults = {
    viewType: 'month', // 值为month|week
    disableBeforeDate: null, // 禁用之前的日期
    disableAfterDate: null, // 禁用之后的日期
    defaultDate: null, // 默认选中的日期
    threshold: '50',
    duration: '300',
    dateHeight: '40',
    verticalDrag: true, // 是否允许垂直拖动
    showTitleWeek: false, // 是否显示周数
    showTitleDay: false, // 是否显示周几
    // DOM
    calendarClass: 'calendar',
    disableClass: 'calendar-disabled',

    headerClass: 'calendar-header',
    titleClass: 'calendar-title',
    prevClass: 'calendar-prev',
    nextClass: 'calendar-next',
    prevHTML: '&lt',
    nextHTML: '&gt',

    weekContainerClass: 'calendar-day-box',
    weekClass: 'calendar-day',

    wrapperClass: 'calendar-wrapper',
    wrapperXClass: 'calendar-wrapper-x',
    wrapperYClass: 'calendar-wrapper-y',
    monthClass: 'calendar-month',
    monthRowClass: 'calendar-monthrow',
    dateClass: 'calendar-date',
    dateNumClass: 'calendar-datenum',

    // 状态
    currentClass: 'calendar-current',
    notcurrentClass: 'calendar-notcurrent',
    todayClass: 'calendar-today',
    activeClass: 'calendar-active',
    selectedClass: 'calendar-selected'

    /*
    Callbacks:
    onClick:function(Calendar)
    onChange:function(Calendar)
    onHeightChange:function(Calendar)// 高度变化
    onTransitionEnd:function(Calendar)// 动画结束
    onHorizontalTransitionEnd:function(Calendar)// 横滑动画结束
    onVerticalTransitionEnd:function(Calendar)// 竖滑动画结束
    onError:function(msg) // 错误回调
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  s.params.wrapperHeight = s.params.dateHeight * 6;
  if (!s.params.defaultDate) s.params.defaultDate = new Date();
  // 禁止修改默认值
  Object.defineProperty(s.params, 'defaultDate', {
    enumerable: true,
    configurable: true,
    writable: false
  });

  // 今天
  s.today = new Date();
  // 激活天
  s.activeDate = new Date(s.params.defaultDate);
  // 选中天
  s.selectedDate = new Date(s.params.defaultDate);
  // Container
  s.container = typeof container === 'string' ? document.querySelector(container) : container;
  if (!s.container) {
    console.log('SeedsUI Error：未找到Calendar的DOM对象，请检查传入参数是否正确');
    return;
  }
  s.container.width = s.container.clientWidth;
  if (!s.container.width) s.container.width = window.innerWidth || document.documentElement.clientWidth;
  // Header
  s.header = null;
  s.title = null;
  s.prev = null;
  s.next = null;
  // Week
  s.weekContainer = null;
  s.weeks = [];
  // Wrapper
  s.wrapper = null;
  s.wrapperX = null;
  s.wrapperY = null;
  s.months = new Array(3);
  s.dates = [];
  // Touch信息
  s.touches = {
    startX: 0,
    startY: 0,
    currentX: 0,
    currentY: 0,
    endX: 0,
    endY: 0,
    diffX: 0,
    diffY: 0,
    posX: 0,
    posY: 0,
    maxPosY: s.params.wrapperHeight - s.params.dateHeight,
    h: s.params.wrapperHeight,
    direction: 0,
    horizontal: 0,
    vertical: 0
    // Header
  };s.createHeader = function () {
    var header = document.createElement('div');
    header.setAttribute('class', s.params.headerClass);
    return header;
  };
  s.createPrev = function () {
    var prev = document.createElement('div');
    prev.setAttribute('class', s.params.prevClass);
    prev.innerHTML = s.params.prevHTML;
    return prev;
  };
  s.createNext = function () {
    var next = document.createElement('div');
    next.setAttribute('class', s.params.nextClass);
    next.innerHTML = s.params.nextHTML;
    return next;
  };
  s.createTitle = function () {
    var title = document.createElement('div');
    title.setAttribute('class', s.params.titleClass);
    return title;
  };
  // WeekContainer
  s.createWeekContainer = function () {
    var weekContainer = document.createElement('div');
    weekContainer.setAttribute('class', s.params.weekContainerClass);

    var weekNames = ['日', '一', '二', '三', '四', '五', '六'];
    /* eslint-disable */
    for (var i = 0, weekName; weekName = weekNames[i++];) {
      var week = document.createElement('div');
      week.setAttribute('class', s.params.weekClass);
      week.innerHTML = weekName;
      weekContainer.appendChild(week);
      s.weeks.push(week);
    }
    /* eslint-enable */

    return weekContainer;
  };
  // Wrapper
  s.createWrapper = function () {
    var wrapper = document.createElement('div');
    wrapper.setAttribute('class', s.params.wrapperClass);
    return wrapper;
  };
  s.createWrapperY = function () {
    var wrapperY = document.createElement('div');
    wrapperY.setAttribute('class', s.params.wrapperYClass);
    return wrapperY;
  };
  s.createWrapperX = function () {
    var wrapperX = document.createElement('div');
    wrapperX.setAttribute('class', s.params.wrapperXClass);
    wrapperX.width = s.container.width * 3;
    wrapperX.style.width = s.container.width * 3 + 'px';
    /*
    wrapperX.width=s.container.width*3
    wrapperX.style.width=wrapperX.width+'px'
    */
    for (var i = 0; i < 3; i++) {
      s.months[i] = document.createElement('div');
      s.months[i].setAttribute('class', s.params.monthClass);
      s.months[i].style.width = s.container.width + 'px';
      wrapperX.appendChild(s.months[i]);
    }
    return wrapperX;
  };
  s.createDates = function () {
    for (var i = 0; i < 3; i++) {
      // 注入到月
      for (var j = 0; j < 6; j++) {
        // 注入行
        var monthRow = document.createElement('div');
        monthRow.setAttribute('class', s.params.monthRowClass);

        for (var k = 0; k < 7; k++) {
          // 注入到星期
          var elDate = document.createElement('div');
          elDate.setAttribute('class', s.params.dateClass);
          elDate.style.height = s.params.dateHeight + 'px';
          elDate.style.lineHeight = s.params.dateHeight + 'px';
          var elDateNum = document.createElement('div');
          elDateNum.setAttribute('class', s.params.dateNumClass);

          elDate.appendChild(elDateNum);
          monthRow.appendChild(elDate);

          s.dates.push(elDateNum);
        }
        s.months[i].appendChild(monthRow);
      }
    }
  };
  // 创建DOM
  s.create = function () {
    // 创建头部
    if (s.container.querySelector('.' + s.params.headerClass)) {
      s.header = s.container.querySelector('.' + s.params.headerClass);
      s.prev = s.container.querySelector('.' + s.params.prevClass);
      s.next = s.container.querySelector('.' + s.params.nextClass);
      s.title = s.container.querySelector('.' + s.params.titleClass);
    } else {
      s.header = s.createHeader();
      s.prev = s.createPrev();
      s.next = s.createNext();
      s.title = s.createTitle();

      s.header.appendChild(s.prev);
      s.header.appendChild(s.title);
      s.header.appendChild(s.next);
      s.container.appendChild(s.header);
    }
    // 创建周
    if (s.container.querySelector('.' + s.params.weekContainerClass)) {
      s.weekContainer = s.container.querySelector('.' + s.params.weekContainerClass);
    } else {
      s.weekContainer = s.createWeekContainer();

      s.container.appendChild(s.weekContainer);
    }
    // 创建主体
    s.wrapper = s.createWrapper();
    s.wrapperX = s.createWrapperX();
    s.wrapperY = s.createWrapperY();
    s.wrapperY.appendChild(s.wrapperX);
    s.wrapper.appendChild(s.wrapperY);
    s.container.appendChild(s.wrapper);
    s.createDates();
  };
  s.create();
  /* --------------------
  Method
  -------------------- */
  // 容器操作类
  s.addDuration = function () {
    s.wrapper.style.webkitTransitionDuration = s.params.duration + 'ms';
    s.wrapperY.style.webkitTransitionDuration = s.params.duration + 'ms';
    s.wrapperX.style.webkitTransitionDuration = s.params.duration + 'ms';
  };
  s.removeDuration = function () {
    s.wrapper.style.webkitTransitionDuration = '0ms';
    s.wrapperY.style.webkitTransitionDuration = '0ms';
    s.wrapperX.style.webkitTransitionDuration = '0ms';
  };
  s.updateTranslateX = function () {
    s.removeDuration();
    s.touches.posX = -s.container.width;
    s.wrapperX.style.webkitTransform = 'translateX(' + s.touches.posX + 'px)';
  };
  s.updateContainerHeight = function () {
    // 更新高度
    if (s.params.viewType === 'month') {
      // 展开
      s.touches.h = s.params.wrapperHeight;
    } else if (s.params.viewType === 'week') {
      // 收缩
      s.touches.h = s.params.dateHeight;
    }
    s.wrapper.style.height = s.touches.h + 'px';
    s.wrapperY.style.webkitTransform = 'translateY(-' + s.touches.posY + 'px)';
  };
  s.updateContainerWidth = function () {
    // 更新宽度
    s.container.width = s.container.clientWidth;
    s.wrapperX.width = s.container.width * 3 + 'px';
    /*
    s.wrapperX.width=s.container.width*3
    s.wrapperX.style.width=s.wrapperX.width.width+'px'
    */
    for (var i = 0; i < 3; i++) {
      s.months[i].style.width = s.container.width + 'px';
    }
  };
  s.updateContainerSize = function () {
    s.updateContainerHeight();
    s.updateContainerWidth();
    s.updateTranslateX();
  };
  s.updateClasses = function () {
    // 更新容器尺寸
    s.updateContainerHeight();
    // 位置还原
    s.updateTranslateX();
  };
  s.updateClasses();
  // 左右滑动
  s.slideXTo = function (index) {
    s.touches.posX = -s.container.width * index;
    s.addDuration();
    s.wrapperX.style.webkitTransform = 'translateX(' + s.touches.posX + 'px)';
    // 刷新数据
    if (index === 0) {
      // 上一页
      if (s.params.viewType === 'month') {
        s.activeDate.prevMonth();
      } else if (s.params.viewType === 'week') {
        s.wrapperY.style.webkitTransitionDuration = '0ms';
        s.activeDate.prevWeek();
      }
    } else if (index === 2) {
      // 下一页
      if (s.params.viewType === 'month') {
        s.activeDate.nextMonth();
      } else if (s.params.viewType === 'week') {
        s.wrapperY.style.webkitTransitionDuration = '0ms';
        s.activeDate.nextWeek();
      }
    }
    /*
    // 滑动到禁用
    if((s.params.disableBeforeDate && s.activeDate < s.params.disableBeforeDate)||(s.params.disableAfterDate && s.activeDate > s.params.disableAfterDate)){
      return
    }
    */
    s.draw();
  };
  // 上下滑动
  s.dragY = function (heightY) {
    s.wrapper.style.height = heightY + 'px';
    var translateY = s.params.wrapperHeight - heightY;
    if (translateY <= s.touches.maxPosY) {
      s.wrapperY.style.webkitTransform = 'translateY(-' + translateY + 'px)';
    }
  };
  s.slideYTo = function (index) {
    s.addDuration();
    if (index === 1) {
      // 展开
      s.params.viewType = 'month';
      s.touches.posY = 0;
      s.draw(1);
    } else if (index === -1) {
      // 收缩
      s.params.viewType = 'week';
      s.touches.posY = s.touches.maxPosY;
      s.draw(-1);
    } else {
      s.dragY(s.touches.h);
    }
  };
  // 绘制日历
  var today = new Date();
  s.isToday = function (date) {
    if (date.getDate() === today.getDate() && date.getMonth() === today.getMonth() && date.getFullYear() === today.getFullYear()) return true;
    return false;
  };
  s.data = [];
  s.updateData = function () {
    s.data = s.activeDate.getCalendarData();
    var activeRowIndex = s.data.activeRowIndex;
    if (s.params.viewType === 'week') {
      s.touches.maxPosY = activeRowIndex * s.params.dateHeight;
      s.touches.posY = s.touches.maxPosY;
      var prevWeek = s.activeDate.getPrevWeekData();
      var nextWeek = s.activeDate.getNextWeekData();
      var start1 = activeRowIndex * 7;
      var start2 = start1 + 84;
      // 修改同行上周
      for (var i = 0, datIndex1 = start1; i < 7; i++) {
        s.data[datIndex1] = prevWeek[i];
        datIndex1++;
      }
      // 修改同行下周
      for (var j = 0, datIndex2 = start2; j < 7; j++) {
        s.data[datIndex2] = nextWeek[j];
        datIndex2++;
      }
    }
  };
  var chinaWeek = { 1: '一', 2: '二', 3: '三', 4: '四', 5: '五', 6: '六', 0: '日' };
  s.drawHeader = function () {
    var activeDate = s.activeDate;
    var activeDay = '';
    if (s.params.showTitleDay) {
      activeDay = '&nbsp&nbsp周' + chinaWeek[activeDate.getDay()];
    }
    var activeWeek = '';
    if (s.params.showTitleWeek) {
      activeWeek = '&nbsp&nbsp第' + activeDate.week() + '周';
    }
    // 注入头部数据
    var year = activeDate.getFullYear();
    var month = activeDate.getMonth() + 1;
    month = month < 10 ? '0' + month : month;
    var date = activeDate.getDate();
    date = date < 10 ? '0' + date : date;
    s.title.innerHTML = year + '-' + month + '-' + date + activeDay + activeWeek;
  };
  s.draw = function (vertical) {
    // vertical:上下拖动(-1上 | 1下 | 其它为非上下拖动)
    // 更新选中日期
    s.updateData();
    // 注入身体
    var activeIndex = s.data.activeIndex;
    for (var i = 0; i < s.dates.length; i++) {
      s.dates[i].innerHTML = s.data[i].getDate();
      // index
      s.dates[i].index = i;
      // class
      s.dates[i].className = s.params.dateNumClass;
      // class-currentClass
      if (s.data[i].isCurrent) s.dates[i].classList.add(s.params.currentClass);else s.dates[i].classList.add(s.params.notcurrentClass);
      // class-todayClass
      if (s.isToday(s.data[i])) s.dates[i].classList.add(s.params.todayClass);
      // class-activeClass
      if (i === activeIndex && s.activeDate) s.dates[i].classList.add(s.params.activeClass);
      // class-selectedClass
      if (s.data[i].toLocaleDateString() === s.selectedDate.toLocaleDateString()) {
        s.dates[i].classList.add(s.params.selectedClass);
      }
      // 禁用日期
      if (s.params.disableBeforeDate && s.data[i].setHours(0, 0, 0, 0) < s.params.disableBeforeDate.setHours(0, 0, 0, 0)) {
        s.dates[i].classList.add(s.params.disableClass);
      }
      if (s.params.disableAfterDate && s.data[i].setHours(0, 0, 0, 0) > s.params.disableAfterDate.setHours(0, 0, 0, 0)) {
        s.dates[i].classList.add(s.params.disableClass);
      }
    }
    s.updateContainerHeight();
    // 滑动到禁用
    if (s.params.disableBeforeDate && s.activeDate < s.params.disableBeforeDate) {
      var msg = '禁止访问' + s.params.disableBeforeDate.format('yyyy年MM月dd') + '前的日期';
      console.log('SeedsUI Warn：' + msg);
      if (s.params.onError) s.params.onError(msg);
      s.activeDate.nextMonth();
      s.draw();
      return;
    }
    if (s.params.disableAfterDate && s.activeDate > s.params.disableAfterDate) {
      msg = '禁止访问' + s.params.disableAfterDate.format('yyyy年MM月dd') + '后的日期';
      console.log('SeedsUI Warn：' + msg);
      if (s.params.onError) s.params.onError(msg);
      s.activeDate.prevMonth();
      s.draw();
      return;
    }
    // 注入头部
    s.drawHeader();
    if (vertical) {
      s.vertical = vertical;
      // Callback onHeightChange
      if (s.params.onHeightChange) s.params.onHeightChange(s);
    } else {
      // Callback onChange
      if (s.params.onChange) s.params.onChange(s);
    }
  };
  s.draw();
  s.setActiveDate = function (target) {
    for (var i = 0; i < s.dates.length; i++) {
      s.dates[i].classList.remove(s.params.activeClass);
      s.dates[i].classList.remove(s.params.selectedClass);
    }
    // 选中日期
    s.activeDate.setTime(s.data[target.index].getTime());
    s.selectedDate.setTime(s.data[target.index].getTime());
    // 重新绘制
    s.draw();
  };
  s.showMonth = function () {
    s.slideYTo(1);
  };
  s.showWeek = function () {
    s.slideYTo(-1);
  };
  s.showToday = function () {
    s.activeDate.setTime(s.today.getTime());
    s.draw();
  };
  s.reset = function () {
    // 选中日期
    s.activeDate.setTime(s.params.defaultDate.getTime());
    // 重新绘制
    s.draw();
  };
  /* --------------------
  Control
  -------------------- */
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    s.wrapper[action]('touchstart', s.onTouchStart, false);
    s.wrapper[action]('touchmove', s.onTouchMove, false);
    s.wrapper[action]('touchend', s.onTouchEnd, false);
    s.wrapper[action]('touchcancel', s.onTouchEnd, false);
    s.wrapper[action]('webkitTransitionEnd', s.onTransitionEnd, false);
    s.wrapper[action]('click', s.onClick, false);

    s.prev[action]('click', s.onClickPrev, false);
    s.next[action]('click', s.onClickNext, false);
  };
  // attach、dettach事件
  s.attach = function (event) {
    s.events();
  };
  s.detach = function (event) {
    s.events(true);
  };
  s.preventDefault = function (e) {
    e.preventDefault();
  };
  // Event Handler
  s.onClickPrev = function (e) {
    s.slideXTo(0);
  };
  s.onClickNext = function (e) {
    s.slideXTo(2);
  };
  s.onClick = function (e) {
    s.target = e.target;
    // 点击禁用日期
    if (e.target.classList.contains(s.params.disableClass)) return;
    // 点击日期
    s.removeDuration();
    if (e.target.classList.contains(s.params.dateNumClass)) {
      s.setActiveDate(e.target);
    }
    // Callback onClick
    if (s.params.onClick) s.params.onClick(s);
  };
  s.onTouchStart = function (e) {
    s.container.addEventListener('touchmove', s.preventDefault, false);
    s.touches.startX = e.touches[0].clientX;
    s.touches.startY = e.touches[0].clientY;
  };
  s.onTouchMove = function (e) {
    s.touches.currentX = e.touches[0].clientX;
    s.touches.currentY = e.touches[0].clientY;
    s.touches.diffX = s.touches.startX - s.touches.currentX;
    s.touches.diffY = s.touches.startY - s.touches.currentY;

    // 设置滑动方向(-1上下 | 1左右)
    if (s.touches.direction === 0) {
      s.touches.direction = Math.abs(s.touches.diffX) > Math.abs(s.touches.diffY) ? 1 : -1;
    }

    if (s.touches.direction === 1) {
      // 左右滑动
      var moveX = s.touches.posX - s.touches.diffX;
      if (moveX < 0 && Math.abs(moveX) < s.container.width * 2) {
        // 判断是否是边缘
        s.touches.horizontal = moveX < s.touches.posX ? 1 : -1; // 设置方向(左右)
        s.wrapperX.style.webkitTransform = 'translateX(' + moveX + 'px)';
      }
    } else if (s.touches.direction === -1) {
      // 上下滑动
      if (s.params.verticalDrag === true) {
        // 允许Y滑动的情况下
        var heightY = s.touches.h - s.touches.diffY;
        if (heightY > s.params.dateHeight && heightY < s.params.wrapperHeight) {
          // 判断是否是边缘
          s.touches.vertical = heightY > s.touches.h ? 1 : -1; // 设置方向(上下)
          s.dragY(heightY);
        }
      } else {
        s.container.removeEventListener('touchmove', s.preventDefault, false);
      }
    }
  };
  s.onTouchEnd = function (e) {
    if (s.touches.direction === 1) {
      // 左右滑动
      if (Math.abs(s.touches.diffX) < s.params.threshold) s.touches.horizontal = 0;
      if (s.touches.horizontal === 1) s.slideXTo(2); // 下一页
      else if (s.touches.horizontal === -1) s.slideXTo(0); // 上一页
        else s.slideXTo(1); // 还原当前页
    } else if (s.touches.direction === -1) {
      // 上下滑动
      if (s.params.verticalDrag === true) {
        // 允许Y滑动的情况下
        if (Math.abs(s.touches.diffY) < s.params.threshold) s.touches.vertical = 0;
        if (s.touches.vertical === 1) s.slideYTo(1); // 展开
        else if (s.touches.vertical === -1) s.slideYTo(-1); // 收缩
          else s.slideYTo(0); // 还原当前页
      }
    }

    // 清空滑动方向
    s.touches.direction = 0;
    s.touches.horizontal = 0;
    s.touches.vertical = 0;
  };
  s.onTransitionEnd = function (e) {
    s.target = e.target;
    // 横向滑动时需要还原位置
    if (s.target.classList.contains(s.params.wrapperXClass)) {
      // 还原位置
      s.updateTranslateX();
      // Callback onHorizontalTransitionEnd
      if (s.params.onHorizontalTransitionEnd) s.params.onHorizontalTransitionEnd(s);
    }
    // 竖向滑动
    if (s.target.classList.contains(s.params.wrapperYClass)) {
      // Callback onVerticalTransitionEnd
      if (s.params.onVerticalTransitionEnd) s.params.onVerticalTransitionEnd(s);
    }
    // Callback onTransitionEnd
    if (s.params.onTransitionEnd) s.params.onTransitionEnd(s);
  };
  /* --------------------
  Init
  -------------------- */
  s.init = function () {
    s.attach();
  };
  s.init();
};

var Calendar$1 = function (_Component) {
  inherits(Calendar, _Component);

  function Calendar(props) {
    classCallCheck(this, Calendar);

    var _this = possibleConstructorReturn(this, (Calendar.__proto__ || Object.getPrototypeOf(Calendar)).call(this, props));

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(Calendar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.instance) return;
      var _props = this.props,
          type = _props.type,
          showTitleDay = _props.showTitleDay,
          showTitleWeek = _props.showTitleWeek,
          disableBeforeDate = _props.disableBeforeDate,
          disableAfterDate = _props.disableAfterDate,
          verticalDrag = _props.verticalDrag,
          defaultDate = _props.defaultDate,
          prevHTML = _props.prevHTML,
          nextHTML = _props.nextHTML,
          onChange = _props.onChange,
          onError = _props.onError;

      var instance = new Calendar$3(this.$el, {
        viewType: type,
        showTitleDay: showTitleDay,
        showTitleWeek: showTitleWeek,
        disableBeforeDate: disableBeforeDate,
        disableAfterDate: disableAfterDate,
        verticalDrag: verticalDrag,
        defaultDate: defaultDate,
        prevHTML: prevHTML,
        nextHTML: nextHTML,
        onChange: onChange,
        onError: onError
      });
      this.setState({
        instance: instance
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React__default.createElement('div', { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'calendar' });
    }
  }]);
  return Calendar;
}(React.Component);

Calendar$1.propTypes = {
  type: propTypes.string, // week|month
  showTitleDay: propTypes.bool, // 是否显示周几
  showTitleWeek: propTypes.bool, // 是否显示周数
  disableBeforeDate: propTypes.object, // 禁用之前日期
  disableAfterDate: propTypes.object, // 禁用之后日期
  verticalDrag: propTypes.bool, // 是否允许垂直拖动
  defaultDate: propTypes.object, // 默认日期
  prevHTML: propTypes.string, // 左箭头
  nextHTML: propTypes.string, // 右箭头
  onChange: propTypes.func,
  onError: propTypes.func
};
Calendar$1.defaultProps = {
  type: 'month',
  showTitleDay: true,
  showTitleWeek: false,
  verticalDrag: true,
  defaultDate: new Date(),
  prevHTML: '&lt',
  nextHTML: '&gt'
};

var Card$1 = function (_Component) {
  inherits(Card, _Component);

  function Card(props) {
    classCallCheck(this, Card);
    return possibleConstructorReturn(this, (Card.__proto__ || Object.getPrototypeOf(Card)).call(this, props));
  }

  createClass(Card, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          style = _props.style,
          className = _props.className,
          onClick = _props.onClick;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'card' + (className ? ' ' + className : ''), style: style, onClick: onClick },
        children
      );
    }
  }]);
  return Card;
}(React.Component);

Card$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  children: propTypes.node,
  onClick: propTypes.func
};

// Carrousel 滑动控件
var Carrousel$3 = function Carrousel(container, params) {
  function getPureChildren(children, className) {
    var arr = [];
    for (var i = 0; i < children.length; i++) {
      if (children[i].classList.contains(className)) arr.push(children[i]);
    }
    return arr;
  }
  function getElementByParent(parent, selector) {
    return typeof selector === 'string' && selector !== '' ? parent.querySelector(selector) : selector;
  }

  /* --------------------
  Model
  -------------------- */
  var defaults = {
    pagination: null, // 小点点
    controlPrev: null, // 左箭头
    controlNext: null, // 右箭头
    autoplay: 0, // 设置毫秒数，0为不自动播放
    slidesPerView: 1,
    threshold: '50',
    duration: '300',
    height: null, // 固定高度
    imglazyQuery: '.carrousel-lazy', // 图片懒加载
    imgLoadAttr: 'data-load-src',

    // loop
    loop: false,
    slideDuplicateClass: 'carrousel-slide-duplicate',

    // dom class
    pageClass: 'carrousel-page', // 轮播页模式,则不需要算高度
    wrapperClass: 'carrousel-wrapper',
    slideClass: 'carrousel-slide',
    slideActiveClass: 'active',
    bulletClass: 'bullet',
    bulletActiveClass: 'active',
    controlPrevClass: 'carrousel-prev',
    controlNextClass: 'carrousel-next'

    /*
    callbacks
    onInit:function(Carrousel)
    onClick:function(Carrousel)
    onSlideChange:function(Carrousel)
    onSlideChangeEnd:function(Carrousel)
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  // Slider
  var s = this;

  // Params
  s.params = params;

  // Container
  s.container = getElementByParent(document, container);
  if (!s.container) {
    console.log('SeedsUI Error：未找到Slider的ID，请检查传入参数是否正确');
    return;
  }
  s.container.width = s.container.clientWidth;

  // Wrapper
  s.wrapper = s.container.querySelector('.' + s.params.wrapperClass); // [es6]s.wrapper=s.container.querySelector(':scope > .'+s.params.wrapperClass)

  // Pagination
  s.pagination = getElementByParent(s.container, s.params.pagination);
  s.bullets = [];
  s.updateBullets = function () {
    if (!s.pagination) return;

    s.bullets = [];
    s.pagination.innerHTML = '';
    // s.numberOfBullets = s.params.loop ? s.slides.length - s.params.slidesPerView * 2 : s.slides.length
    for (var i = 0; i < s.slides.length; i++) {
      var bullet = document.createElement('span');
      bullet.setAttribute('class', s.params.bulletClass);
      bullet.setAttribute('data-index', i);
      s.pagination.appendChild(bullet);
      s.bullets.push(bullet);
    }
  };
  // Control左右切换
  s.controlPrev = getElementByParent(s.container, s.params.controlPrev);
  s.controlNext = getElementByParent(s.container, s.params.controlNext);
  // 索引
  s.activeIndexTruth = 0;
  s.max = 0;
  // Slides
  s.updateSlides = function () {
    s.slides = getPureChildren(s.wrapper.children, s.params.slideClass); // [es6]s.slides=s.wrapper.querySelectorAll(':scope > .'+s.params.slideClass)
  };
  // loop dupSlides
  s.dupSlides = [];
  s.createLoop = function () {
    if (!s.params.loop) return;
    // 删除循环
    s.destroyLoop();
    var beforeDupSlides = [];
    var afterDupSlides = [];

    if (s.params.slidesPerView > s.slides.length) return;
    var i;
    var dup;
    s.slides.forEach(function (n, i, a) {
      if (i < s.params.slidesPerView) afterDupSlides.push(n.cloneNode(true));
      if (i < s.slides.length && i >= s.slides.length - s.params.slidesPerView) beforeDupSlides.push(n.cloneNode(true));
    });
    for (i = 0; i < afterDupSlides.length; i++) {
      dup = s.wrapper.appendChild(afterDupSlides[i]);
      dup.classList.add(s.params.slideDuplicateClass);
      dup.classList.remove(s.params.slideClass);
    }
    for (i = beforeDupSlides.length - 1; i >= 0; i--) {
      dup = s.wrapper.insertBefore(beforeDupSlides[i], s.wrapper.firstElementChild);
      dup.classList.add(s.params.slideDuplicateClass);
      dup.classList.remove(s.params.slideClass);
    }
    s.activeIndexTruth = s.params.slidesPerView;
    s.dupSlides = beforeDupSlides.concat(afterDupSlides);
  };
  s.destroyLoop = function () {
    var slideDuplicate = getPureChildren(s.wrapper.children, s.params.slideDuplicateClass);
    //  var slideDuplicate=s.wrapper.querySelectorAll(':scope > .'+s.params.slideDuplicateClass)
    /* eslint-disable */
    for (var i = 0, slideDu; slideDu = slideDuplicate[i++];) {
      s.wrapper.removeChild(slideDu);
    }
    /* eslint-enable */
  };
  // Touch信息
  s.touches = {
    direction: 0,
    vertical: 0,
    horizontal: 0,
    startX: 0,
    startY: 0,
    currentX: 0,
    currentY: 0,
    endX: 0,
    endY: 0,
    diffX: 0,
    diffY: 0,
    posX: 0
    /* --------------------
    Update
    -------------------- */
  };s.activeIndex = s.activeIndexTruth; // 去除duplicate，滑动页索引
  // 根据index更新选中class
  s.updateClasses = function () {
    s.activeIndex = s.activeIndexTruth;
    if (s.params.loop) {
      s.activeIndex = s.activeIndexTruth - s.params.slidesPerView;
      if (s.max - s.params.slidesPerView === s.activeIndexTruth) {
        // 正向滑动
        s.activeIndex = 0;
      }
      if (s.activeIndex < 0) {
        // 反向滑动
        s.activeIndex = s.slides.length + s.activeIndex;
      }
    }
    var i;
    // Slide
    for (i = 0; i < s.slides.length; i++) {
      s.slides[i].classList.remove(s.params.slideActiveClass);
    }
    s.slides[s.activeIndex].classList.add(s.params.slideActiveClass);

    //  Pagination
    if (!s.pagination) return;
    for (i = 0; i < s.bullets.length; i++) {
      s.bullets[i].classList.remove(s.params.bulletActiveClass);
    }
    s.bullets[s.activeIndex].classList.add(s.params.bulletActiveClass);
  };

  // 更新容器尺寸
  s.updateContainerSize = function () {
    s.max = parseInt(s.slides.length, 10) + parseInt(s.dupSlides.length, 10);
    // Slide width
    s.container.width = s.container.clientWidth;
    s.width = Math.floor(s.container.width / s.params.slidesPerView);

    // 设置wrapper宽度
    s.wrapper.width = s.width * s.max;

    s.wrapper.style.width = s.wrapper.width + 'px';

    // 设置单个slide宽度
    s.slides.forEach(function (n, i, a) {
      n.style.width = s.width + 'px';
    });

    // 设置dupSlide宽度
    s.dupSlides.forEach(function (n, i, a) {
      n.style.width = s.width + 'px';
    });
    // 如果不是page模式,则需要算高度
    if (!s.container.classList.contains(s.params.pageClass)) {
      // Slide height
      if (s.params.height) {
        s.height = s.params.height;
      } else if (s.container.style.height) {
        s.height = s.container.style.height;
      } else {
        s.height = (s.container.clientHeight ? s.container.clientHeight : s.wrapper.clientHeight) + 'px';
      }
      // 设置wrapper高度
      s.wrapper.style.height = s.height;
      // 设置单个slide高度
      s.slides.forEach(function (n, i, a) {
        n.style.height = s.height;
      });
      // 设置dupSlide高度
      s.dupSlides.forEach(function (n, i, a) {
        n.style.height = s.height;
      });
    }

    // 更新active index
    s.updateClasses();

    // 如果有循环的话
    if (s.params.loop) {
      moveToIndex(0);
    }
  };
  // 图片懒加载
  var imgs = [];
  var cacheImgs = [];
  function imgLoad(e) {
    var target = e.target;
    var imgTarget = imgs[target.index];
    if (!imgTarget) return;
    if (imgTarget.tagName === 'IMG') {
      imgTarget.src = target.src;
    } else {
      imgTarget.style.backgroundImage = 'url(' + target.src + ')';
    }
  }
  s.updateLazyImg = function () {
    imgs = this.container.querySelectorAll(s.params.imglazyQuery);
    for (var i = 0; i < imgs.length; i++) {
      var src = imgs[i].getAttribute(s.params.imgLoadAttr);
      cacheImgs[i] = new Image();
      cacheImgs[i].index = i;
      cacheImgs[i].src = src;
      cacheImgs[i].addEventListener('load', imgLoad, false);
    }
  };

  // 更新
  s.update = function () {
    s.updateSlides();
    s.updateBullets();
    s.createLoop();
    s.updateContainerSize();
    if (s.params.imglazyQuery) s.updateLazyImg();
  };
  s.update();
  if (s.slides.length <= 0) {
    return;
  }
  /* --------------------
  Touch Events
  -------------------- */
  // 绑定事件
  s.isSupportTouch = 'ontouchstart' in window;
  s.events = function (detach) {
    var touchTarget = s.container;
    var action = detach ? 'removeEventListener' : 'addEventListener';
    // touch兼容pc事件
    if (s.isSupportTouch) {
      touchTarget[action]('touchstart', s.onTouchStart, false);
      touchTarget[action]('touchmove', s.onTouchMove, false);
      touchTarget[action]('touchend', s.onTouchEnd, false);
      touchTarget[action]('touchcancel', s.onTouchEnd, false);
    } else {
      // pc端禁用拖动功能,不然会与下拉刷新冲突
      touchTarget[action]('mousedown', s.onTouchStart, false);
      // touchTarget[action]('mousemove', s.onTouchMove, false)
      touchTarget[action]('mouseup', s.onTouchEnd, false);
    }
  };
  // attach、dettach事件
  s.attach = function (event) {
    s.events();
  };
  s.detach = function (event) {
    s.events(true);
  };
  /* --------------------
  Touch Handler
  -------------------- */
  function preventDefault(e) {
    e.preventDefault();
  }
  s.startMouseMove = false;
  s.onTouchStart = function (e) {
    s.startMouseMove = true;
    s.container.addEventListener(s.startMouseMove ? 'touchmove' : 'mousemove', preventDefault, false);
    s.touches.startX = e.clientX || e.touches[0].clientX;
    s.touches.startY = e.clientY || e.touches[0].clientY;
    // 关闭自动播放
    s.stopAutoplay();
  };
  s.onTouchMove = function (e) {
    if (!s.startMouseMove) return;
    s.touches.currentX = e.clientX || e.touches[0].clientX;
    s.touches.currentY = e.clientY || e.touches[0].clientY;
    s.touches.diffX = s.touches.startX - s.touches.currentX;
    s.touches.diffY = s.touches.startY - s.touches.currentY;
    // runCallBack
    if (s.params.onSlideChange) s.params.onSlideChange(s);

    // 设置滑动方向
    if (s.touches.direction === 0) {
      // 设置滑动方向(-1上下 | 1左右)
      s.touches.direction = Math.abs(s.touches.diffX) > Math.abs(s.touches.diffY) ? 1 : -1;
    }
    if (s.touches.direction === -1) {
      // 设置垂直方向(-1上 | 1下)
      s.touches.vertical = s.touches.diffY < 0 ? 1 : -1;
    }
    if (s.touches.direction === 1) {
      // 设置左右方向(-1左 | 1右)
      s.touches.horizontal = s.touches.diffX < 0 ? 1 : -1;
    }

    // 如果是上下滑动则不工作
    if (s.touches.vertical !== 0) {
      s.container.removeEventListener(s.startMouseMove ? 'touchmove' : 'mousemove', preventDefault, false);
      return;
    }

    // 如果滑动了，则禁止事件向下传播
    e.stopPropagation();

    // x轴距离左边的像素，向左为负数，向右为正数
    var moveX = s.touches.posX - s.touches.diffX;
    // 判断是否是边缘
    if (moveX > 0 || -moveX + s.container.width >= s.wrapper.width) {
      return;
    }
    s.wrapper.style.webkitTransform = 'translate(' + moveX + 'px,0px)';
  };
  s.onTouchEnd = function (e) {
    s.startMouseMove = false;
    // s.container.removeEventListener(s.startMouseMove ? 'touchmove' : 'mousemove',preventDefault,false)
    // 左右拉动
    if (s.touches.direction === 1) {
      if (s.touches.diffX > s.params.threshold) {
        // 下一页
        s.activeIndexTruth++;
      } else if (s.touches.diffX < -s.params.threshold) {
        // 上一页
        s.activeIndexTruth--;
      }
      s.slideTo(s.activeIndexTruth);
    }
    // 清空滑动方向
    s.touches.direction = 0;
    s.touches.vertical = 0;
    s.touches.horizontal = 0;
    // 单击事件
    s.touches.endX = e.clientX || e.changedTouches[0].clientX;
    s.touches.endY = e.clientY || e.changedTouches[0].clientY;
    if (Math.abs(s.touches.startX - s.touches.endX) < 6 && Math.abs(s.touches.startY - s.touches.endY) < 6) {
      // PC单击页码需要翻页
      if (!s.isSupportTouch && e.target.classList.contains(s.params.bulletClass)) {
        s.onClickBullet(e);
      } else if (e.target.classList.contains(s.params.controlPrevClass)) {
        s.onClickPrev(e);
      } else if (e.target.classList.contains(s.params.controlNextClass)) {
        s.onClickNext(e);
      } else {
        if (s.params.onClick) s.params.onClick(s);
      }
    }
    // 开启自动播放
    s.startAutoplay();
  };
  s.onClickBullet = function (e) {
    var index = Number(e.target.getAttribute('data-index')) || 0;
    // 如果是循环,需要计算真实的索引
    if (s.params.loop) {
      index += s.params.slidesPerView;
    }
    s.slideTo(index);
  };
  s.onClickPrev = function (e) {
    s.slideTo(s.activeIndexTruth - 1);
  };
  s.onClickNext = function (e) {
    s.slideTo(s.activeIndexTruth + 1);
  };
  /* --------------------
  Autoplay
  -------------------- */
  s.startAutoplay = function () {
    if (!s.params.autoplay) return;
    s.autoplayer = window.setInterval(function () {
      s.activeIndexTruth++;
      if (s.activeIndexTruth >= s.max) {
        s.activeIndexTruth = 0;
      }
      s.slideTo(s.activeIndexTruth);
    }, s.params.autoplay);
  };

  s.stopAutoplay = function (internal) {
    if (s.autoplayer) {
      window.clearInterval(s.autoplayer);
    }
  };

  /* --------------------
  Method
  -------------------- */
  function moveToIndex(speed) {
    s.wrapper.style.webkitTransitionDuration = speed + 'ms';
    s.touches.posX = -s.activeIndexTruth * s.width;
    s.wrapper.style.webkitTransform = 'translate(' + s.touches.posX + 'px,0px)';
  }
  s.slideTo = function (slideIndex, speed, runCallbacks) {
    var duration = isNaN(speed) ? s.params.duration : speed;
    if (slideIndex >= 0) {
      s.activeIndexTruth = slideIndex;
    }
    // 索引不能小于0
    if (s.activeIndexTruth < 0) {
      s.activeIndexTruth = 0;
    }
    // 索引不能大于slide总数
    if (s.activeIndexTruth > s.max - 1) {
      s.activeIndexTruth = s.max - 1;
    }
    // 一页多屏，索引不能露出空白区域
    if (s.params.slidesPerView > 1 && s.activeIndexTruth > s.max - params.slidesPerView) {
      s.activeIndexTruth = s.max - s.params.slidesPerView;
    }

    // 更新class
    s.updateClasses();
    // 移动至index
    moveToIndex(duration);
    // 移动位置并触发回调onSlideChangeEnd
    setTimeout(function () {
      s.wrapper.style.webkitTransitionDuration = '0ms';
      // callback onSlideChangeEnd
      s.target = s.slides[s.activeIndexTruth];
      if (s.params.onSlideChangeEnd && runCallbacks !== false) s.params.onSlideChangeEnd(s);
      // 循环的情况
      if (s.params.loop) {
        if (s.touches.posX === 0) {
          s.activeIndexTruth = s.max - s.params.slidesPerView * 2;
          // console.log('最左侧，应跳转到：'+s.activeIndexTruth)
          moveToIndex(0);
          return;
        }
        if (-s.touches.posX + s.container.width >= s.wrapper.width) {
          s.activeIndexTruth = s.params.slidesPerView;
          // console.log('最右侧，应跳转到：'+s.activeIndexTruth)
          moveToIndex(0);
          return;
        }
      }
    }, duration);
  };

  // 主函数
  s.init = function () {
    // s.update()
    s.attach();
    if (s.params.autoplay) s.startAutoplay();
    // runCallBack
    s.target = s.slides[s.activeIndexTruth];
    if (s.params.onInit) s.params.onInit(s);
  };
  // 执行主函数
  s.init();
  //  Return slider instance
  return s;
};

var Carrousel$1 = function (_Component) {
  inherits(Carrousel, _Component);

  function Carrousel(props) {
    classCallCheck(this, Carrousel);

    var _this = possibleConstructorReturn(this, (Carrousel.__proto__ || Object.getPrototypeOf(Carrousel)).call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (_this.state.instance && _this.state.instance.activeIndex !== _this.props.activeIndex) {
        _this.state.instance.slideTo(_this.props.activeIndex, _this.props.speed, _this.props.enableOnChange);
      }
      if (!_this.props.list.equals(prevProps.list)) {
        _this.update();
      }
    };

    _this.componentDidMount = function () {
      if (_this.state.instance || _this.props.list.length === 0 && !_this.props.children) return;
      setTimeout(function () {
        var instance = new Carrousel$3(_this.$el, {
          height: _this.props.style && _this.props.style.height ? _this.props.style.height : null,
          pagination: '.carrousel-pagination',
          autoplay: _this.props.autoplay,
          slidesPerView: _this.props.slidesPerView,
          loop: _this.props.loop,
          onClick: _this.onClick,
          onSlideChangeEnd: _this.props.onChange ? _this.props.onChange : null
        });
        _this.setState({
          instance: instance
        });
      }, 300);
    };

    _this.onClick = function (e) {
      var index = e.activeIndex;
      if (_this.props.onClick) _this.props.onClick(_this.props.list[index], index);
    };

    _this.getCarrouselClassName = function () {
      var _this$props = _this.props,
          className = _this$props.className,
          list = _this$props.list;

      if (className) {
        if (className.indexOf('carrousel-container') !== -1 || className.indexOf('carrousel-page') !== -1) {
          return className;
        }
      }
      return (list.length > 0 ? 'carrousel-container' : 'carrousel-page') + (className ? ' ' + className : '');
    };

    _this.getSlideStyle = function () {
      return Object.assign({ backgroundImage: 'url(' + _this.props.defaultSrc + ')' }, _this.props.slideStyle);
    };

    _this.update = function () {
      // 更新为默认图片
      var imgs = _this.$el.querySelectorAll('.carrousel-lazy');
      for (var i = 0; i < imgs.length; i++) {
        var imgTarget = imgs[i];
        if (!imgTarget) continue;
        if (imgTarget.tagName === 'IMG') {
          imgTarget.src = _this.props.defaultSrc;
        } else {
          imgTarget.style.backgroundImage = 'url(' + _this.props.defaultSrc + ')';
        }
      }
      // 更新Carrousel
      if (_this.state.instance) _this.state.instance.update();
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(Carrousel, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          slideClassName = _props.slideClassName,
          defaultSrc = _props.defaultSrc,
          list = _props.list,
          pagination = _props.pagination;

      var children = React__default.Children.toArray(this.props.children);
      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: this.getCarrouselClassName(), style: style },
        React__default.createElement(
          'div',
          { className: 'carrousel-wrapper' },
          list.length > 0 && list.map(function (item, index) {
            return React__default.createElement(
              'div',
              { className: 'carrousel-slide' + (slideClassName ? ' ' + slideClassName : '' + item.bg ? ' carrousel-lazy' : ''), style: _this2.getSlideStyle(), key: index, 'data-load-src': item.bg },
              item.img && React__default.createElement('img', { className: 'carrousel-slide-img carrousel-lazy', alt: '', src: defaultSrc, 'data-load-src': item.img }),
              item.caption && React__default.createElement(
                'div',
                { className: 'carrousel-summary' },
                item.iconClassName && React__default.createElement('i', { className: 'icon carrousel-summary-icon' + (item.iconClassName ? ' ' + item.iconClassName : '') }),
                React__default.createElement(
                  'span',
                  { className: 'nowrap carrousel-summary-font', style: { marginRight: '20px' } },
                  item.caption
                )
              )
            );
          }),
          list.length === 0 && children && children.map(function (item, index) {
            return React__default.createElement(
              'div',
              { className: 'carrousel-slide', key: index },
              item
            );
          })
        ),
        pagination && React__default.createElement('div', { className: 'carrousel-pagination' }),
        list.length > 1 && React__default.createElement('div', { className: 'carrousel-prev' }),
        list.length > 1 && React__default.createElement('div', { className: 'carrousel-next' })
      );
    }
  }]);
  return Carrousel;
}(React.Component);

Carrousel$1.propTypes = {
  style: propTypes.object, // 设置容器Style
  className: propTypes.string, // 设置容器className
  slideStyle: propTypes.object, // 设置块style
  slideClassName: propTypes.string, // 设置块className
  children: propTypes.node, // 轮播页,例<Carrousel><div>第1页</div></Carrousel>
  loop: propTypes.bool, // 是否循环显示
  activeIndex: propTypes.number, // 默认选中第几块
  pagination: propTypes.bool, // 是否显示小点点
  autoplay: propTypes.number, // 是否自动播放
  slidesPerView: propTypes.number, // 一屏显示几块,默认1块
  defaultSrc: propTypes.string, // 默认图片
  list: propTypes.array, // [{bg: 'xx', img: 'xx', iconClassName: 'xx', caption: 'xx'}]
  enableOnChange: propTypes.bool, // 启用改变事件回调
  speed: propTypes.number, // 动画过渡的速度
  onClick: propTypes.func,
  onChange: propTypes.func
};
Carrousel$1.defaultProps = {
  activeIndex: 0,
  page: 0,
  loop: false,
  pagination: false,
  autoplay: 0,
  slidesPerView: 1,
  list: [],
  defaultSrc: '//res.waiqin365.com/d/seedsui/carrousel/default.png',
  enableOnChange: true,
  speed: 300
};

var Chat$1 = function (_Component) {
  inherits(Chat, _Component);

  function Chat(props) {
    classCallCheck(this, Chat);

    var _this = possibleConstructorReturn(this, (Chat.__proto__ || Object.getPrototypeOf(Chat)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      var onClick = _this.props.onClick;

      if (onClick) {
        onClick(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickContent = function (e) {
      if (_this.props.onClickContent) {
        _this.props.onClickContent(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickAvatar = function (e) {
      if (_this.props.onClickAvatar) {
        _this.props.onClickAvatar(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.state = {};
    return _this;
  }

  createClass(Chat, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          showAvatar = _props.showAvatar,
          avatarSrc = _props.avatarSrc,
          avatarClassName = _props.avatarClassName,
          avatarStyle = _props.avatarStyle,
          avatarAfter = _props.avatarAfter,
          author = _props.author,
          authorClassName = _props.authorClassName,
          authorStyle = _props.authorStyle,
          contentClassName = _props.contentClassName,
          contentStyle = _props.contentStyle,
          children = _props.children;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'chat' + (className ? ' ' + className : ''), style: style, onClick: this.onClick },
        showAvatar && React__default.createElement(
          'div',
          { className: 'chat-photo', onClick: this.onClickAvatar },
          React__default.createElement(
            'div',
            { className: 'chat-avatar' + (avatarClassName ? ' ' + avatarClassName : ''), style: Object.assign(avatarSrc ? { backgroundImage: 'url(' + avatarSrc + ')' } : {}, avatarStyle) },
            avatarAfter
          ),
          author && React__default.createElement(
            'div',
            { className: 'chat-author' + (authorClassName ? ' ' + authorClassName : ''), style: authorStyle },
            author
          )
        ),
        React__default.createElement(
          'div',
          { className: 'chat-content-box' },
          React__default.createElement(
            'div',
            { onClick: this.onClickContent, className: 'chat-content' + (contentClassName ? ' ' + contentClassName : ''), style: contentStyle },
            children
          )
        )
      );
    }
  }]);
  return Chat;
}(React.Component);

Chat$1.propTypes = {
  args: propTypes.any,
  style: propTypes.object,
  className: propTypes.string,
  onClick: propTypes.func,

  showAvatar: propTypes.bool,
  avatar: propTypes.bool,
  avatarClassName: propTypes.string,
  avatarStyle: propTypes.object,
  avatarSrc: propTypes.string,
  avatarAfter: propTypes.node,
  onClickAvatar: propTypes.func,

  author: propTypes.string,
  authorClassName: propTypes.string,
  authorStyle: propTypes.object,

  contentClassName: propTypes.string,
  contentStyle: propTypes.object,
  onClickContent: propTypes.func,

  children: propTypes.node
};
Chat$1.defaultProps = {
  args: null
};

var Checkbox$1 = function (_Component) {
  inherits(Checkbox, _Component);

  function Checkbox(props) {
    classCallCheck(this, Checkbox);

    var _this = possibleConstructorReturn(this, (Checkbox.__proto__ || Object.getPrototypeOf(Checkbox)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.disabled) return;
      if (_this.props.onClick) _this.props.onClick(_this.$input.checked, _this.getArgs(e));
    };

    return _this;
  }

  createClass(Checkbox, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          name = _props.name,
          value = _props.value,
          checked = _props.checked,
          caption = _props.caption,
          captionClassName = _props.captionClassName,
          captionStyle = _props.captionStyle;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'checkbox-box' + (className ? ' ' + className : ''), onClick: this.onClick, style: style },
        React__default.createElement('input', { readOnly: true, checked: checked, type: 'checkbox', className: 'checkbox events-none', name: name, value: value, ref: function ref(el) {
            _this2.$input = el;
          } }),
        caption && React__default.createElement(
          'span',
          { className: 'checkbox-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
          caption
        )
      );
    }
  }]);
  return Checkbox;
}(React.Component);

Checkbox$1.propTypes = {
  args: propTypes.any,
  style: propTypes.object,
  className: propTypes.string,
  onClick: propTypes.func,

  name: propTypes.string,
  value: propTypes.string,
  checked: propTypes.bool,
  disabled: propTypes.bool,

  caption: propTypes.string,
  captionClassName: propTypes.string,
  captionStyle: propTypes.object
};
Checkbox$1.defaultProps = {
  args: null,
  value: '',
  checked: false
};

var Clock$1 = function (_Component) {
  inherits(Clock, _Component);

  function Clock(props) {
    classCallCheck(this, Clock);

    var _this = possibleConstructorReturn(this, (Clock.__proto__ || Object.getPrototypeOf(Clock)).call(this, props));

    _this.getHourDeg = function (hour) {
      return hour * 30;
    };

    _this.getMinuteDeg = function (minute) {
      return minute * 6;
    };

    return _this;
  }

  createClass(Clock, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          time = _props.time,
          style = _props.style,
          className = _props.className,
          onClick = _props.onClick;

      var hour = '00';
      var minute = '00';
      if (/\d{2}:\d{2}/.test(time)) {
        hour = time.split(':')[0];
        minute = time.split(':')[0];
      }
      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'clock' + (className ? ' ' + className : ''), style: style, onClick: onClick },
        React__default.createElement('div', { ref: function ref(el) {
            _this2.$hour = el;
          }, className: 'clock-hour', style: { WebkitTransform: 'rotate(' + this.getHourDeg(hour) + 'deg)' } }),
        React__default.createElement('div', { ref: function ref(el) {
            _this2.$minute = el;
          }, className: 'clock-minute', style: { WebkitTransform: 'rotate(' + this.getMinuteDeg(minute) + 'deg)' } }),
        React__default.createElement('div', { 'class': 'clock-origin' })
      );
    }
  }]);
  return Clock;
}(React.Component);

Clock$1.propTypes = {
  time: propTypes.string, // hh:mm
  style: propTypes.object,
  className: propTypes.string,
  onClick: propTypes.func
};

var Close$1 = function (_Component) {
  inherits(Close, _Component);

  function Close(props) {
    classCallCheck(this, Close);

    var _this = possibleConstructorReturn(this, (Close.__proto__ || Object.getPrototypeOf(Close)).call(this, props));

    _this.state = {};
    return _this;
  }

  createClass(Close, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          iconClassName = _props.iconClassName,
          iconStyle = _props.iconStyle,
          _onClick = _props.onClick;

      return React__default.createElement(
        'span',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'close' + (className ? ' ' + className : ''), style: style, onClick: function onClick(e) {
            _onClick && _onClick(e);
          } },
        React__default.createElement(Icon$1, { className: iconClassName, style: iconStyle })
      );
    }
  }]);
  return Close;
}(React.Component);

Close$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,
  iconClassName: propTypes.string,
  iconStyle: propTypes.object,
  onClick: propTypes.func
};
Close$1.defaultProps = {
  iconClassName: 'close-icon close-icon-clear size18'
};

var Container$1 = function (_Component) {
  inherits(Container, _Component);

  function Container(props) {
    classCallCheck(this, Container);

    var _this = possibleConstructorReturn(this, (Container.__proto__ || Object.getPrototypeOf(Container)).call(this, props));

    _this.state = {};
    return _this;
  }

  createClass(Container, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          onScroll = _props.onScroll,
          onTouchStart = _props.onTouchStart,
          onTouchMove = _props.onTouchMove,
          onTouchEnd = _props.onTouchEnd;

      var touchTarget = this.$el;
      if (onTouchStart) {
        touchTarget['addEventListener']('touchstart', onTouchStart, false);
      }
      if (onTouchStart) {
        touchTarget['addEventListener']('touchmove', onTouchMove, false);
      }
      if (onTouchEnd) {
        touchTarget['addEventListener']('touchend', onTouchEnd, false);
        touchTarget['addEventListener']('touchcancel', onTouchEnd, false);
      }
      if (onScroll) {
        touchTarget['addEventListener']('scroll', onScroll, false);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          style = _props2.style,
          className = _props2.className,
          children = _props2.children;

      return React__default.createElement(
        'article',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'container' + (className ? ' ' + className : ''), style: style },
        children
      );
    }
  }]);
  return Container;
}(React.Component);

Container$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  onScroll: propTypes.func,
  onTouchStart: propTypes.func,
  onTouchMove: propTypes.func,
  onTouchEnd: propTypes.func,
  children: propTypes.node
};

// Counter 动态数字
var Counter$3 = function Counter(counter, params) {
  /* ----------------------
  Model
  ---------------------- */
  var defaults = {
    fromAttr: 'data-from',
    toAttr: 'data-to',
    durationAttr: 'data-duration',
    suffixAttr: 'data-suffix', // 分母
    maxMilliSec: 50, // 最快50毫秒执行一次
    maxCountSec: 20 // 平均一秒执行20次
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  // Counter
  var s = this;

  // Params
  s.params = params;

  // Counter
  s.counter = typeof counter === 'string' ? document.querySelector(counter) : counter;

  // From(开始数字)
  s.from = s.counter.getAttribute(s.params.fromAttr) ? s.counter.getAttribute(s.params.fromAttr) : 0;
  // To(结束数字)
  s.to = s.counter.getAttribute(s.params.toAttr) ? s.counter.getAttribute(s.params.toAttr) : 0;
  // suffix(后缀)
  s.suffix = s.counter.getAttribute(s.params.suffixAttr) ? s.counter.getAttribute(s.params.suffixAttr) : '';
  // Current(当前数字)
  s.current = s.from;
  // Duration(执行秒数)
  s.duration = s.counter.getAttribute(s.params.durationAttr) ? s.counter.getAttribute(s.params.durationAttr) : 5000;

  // Diff(差值)
  s.diff = s.to - s.from;
  if (s.diff < 0 || isNaN(s.from) || isNaN(s.to)) {
    console.log('请确定开始时间与结束时间是否输入正确！');
    return;
  }

  // 每秒需要走完的数字
  var secNum = Math.round(s.diff / (s.duration / 1000));
  // 每次增加的数字
  s.step = 1;
  // 毫秒/次
  s.milliSec = Math.round(s.params.maxMilliSec);
  if (secNum > s.params.maxCountSec) {
    // 如果每秒走完的数字，大于最大每秒执行次数，则要步进加快
    s.step = Math.round(secNum / s.params.maxCountSec);
    s.milliSec = s.params.maxMilliSec; // 用最快的速度：50毫秒执行一次
  } else {
    s.step = secNum;
    s.milliSec = 1000 / secNum; // 1秒执行的次数
  }

  // console.log('从'+s.from+'到'+s.to+'，共'+s.duration/1000+'秒走完，每秒需要增加'+secNum+'，每'+s.milliSec+'毫秒执行一次，一秒执行'+Math.round(1000/s.milliSec)+'次，一次递增：'+s.step+'')

  // Interval
  s.interval = null;
  /* ----------------------
  Method
  ---------------------- */
  s.play = function () {
    s.interval = window.setInterval(function () {
      s.current = parseInt(s.current, 10) + parseInt(s.step, 10);
      s.counter.innerHTML = s.current + s.suffix;
      if (s.current >= s.to) {
        s.counter.innerHTML = s.to + s.suffix;
        clearInterval(s.interval);
      }
    }, s.milliSec);
  };
};

var Counter$1 = function (_Component) {
  inherits(Counter$$1, _Component);

  function Counter$$1(props) {
    classCallCheck(this, Counter$$1);

    var _this = possibleConstructorReturn(this, (Counter$$1.__proto__ || Object.getPrototypeOf(Counter$$1)).call(this, props));

    _this.componentDidMount = function () {
      _this.init();
    };

    _this.init = function () {
      var instance = new Counter$3(_this.$el);
      instance.play();
      _this.setState({
        instance: instance
      });
    };

    return _this;
  }

  createClass(Counter$$1, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          duration = _props.duration,
          from = _props.from,
          to = _props.to,
          suffix = _props.suffix;

      return React__default.createElement(
        'span',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'counter' + (className ? ' ' + className : ''), style: style, 'data-duration': duration, 'data-from': from, 'data-to': to, 'data-suffix': suffix },
        '1'
      );
    }
  }]);
  return Counter$$1;
}(React.Component);

Counter$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,

  duration: propTypes.number,
  from: propTypes.number,
  to: propTypes.number,
  suffix: propTypes.string // 后缀
};
Counter$1.defaultProps = {
  from: 0
};

var Dialog$1 = function (_Component) {
  inherits(Dialog, _Component);

  function Dialog(props) {
    classCallCheck(this, Dialog);

    var _this = possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this, props));

    _this.componentDidUpdate = function (prevProps) {};

    _this.componentDidMount = function () {};

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(_this.getArgs(e));
      e.stopPropagation();
    };

    _this.onClickDialog = function (e) {
      e.stopPropagation();
    };

    return _this;
  }
  /* shouldComponentUpdate = (nextProps) => { // 因为是容器,不能使用此方法,不然会影响内部元素的更新
    if (this.props.show === nextProps.show) {
      return false;
    }
    return true;
  } */


  createClass(Dialog, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          duration = _props.duration,
          show = _props.show,
          maskClassName = _props.maskClassName,
          maskStyle = _props.maskStyle,
          className = _props.className,
          style = _props.style,
          animation = _props.animation,
          children = _props.children;

      var transformOrigin = 'middle';
      switch (animation) {
        case 'slideLeft':
          transformOrigin = 'right-middle';
          break;
        case 'slideRight':
          transformOrigin = 'left-middle';
          break;
        case 'slideUp':
          transformOrigin = 'bottom-center';
          break;
        case 'slideDown':
          transformOrigin = 'top-center';
          break;
        case 'zoom':
          transformOrigin = 'middle';
          break;
        case 'fade':
          transformOrigin = 'middle';
          break;
        default:
          transformOrigin = 'middle';
      }
      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'mask dialog-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle), onClick: this.onClickMask },
        React__default.createElement(
          'div',
          { className: 'dialog' + (transformOrigin ? ' ' + transformOrigin : '') + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style), 'data-animation': animation, onClick: this.onClickDialog },
          children && children
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Dialog;
}(React.Component);

Dialog$1.propTypes = {
  portal: propTypes.object,
  args: propTypes.any,
  show: propTypes.bool,

  animation: propTypes.string, // slideLeft | slideRight | slideUp | slideDown | zoom | fade
  duration: propTypes.number,
  isClickMaskHide: propTypes.bool,
  onClickMask: propTypes.func,
  onShowed: propTypes.func,
  onHid: propTypes.func,

  maskClassName: propTypes.string,
  maskStyle: propTypes.object,

  className: propTypes.string,
  style: propTypes.object,

  children: propTypes.node
};
Dialog$1.defaultProps = {
  args: null,
  isClickMaskHide: false,
  animation: 'fade'
};

var Dot$1 = function (_Component) {
  inherits(Dot, _Component);

  function Dot(props) {
    classCallCheck(this, Dot);
    return possibleConstructorReturn(this, (Dot.__proto__ || Object.getPrototypeOf(Dot)).call(this, props));
  }

  createClass(Dot, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          size = _props.size;

      return React__default.createElement('i', { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'dot' + (className ? ' ' + className : ''), style: Object.assign(style, size ? { width: size, height: size } : {}) });
    }
  }]);
  return Dot;
}(React.Component);

Dot$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,
  size: propTypes.string
};
Dot$1.defaultProps = {
  style: {}
};

var Notice$1 = function (_Component) {
  inherits(Notice, _Component);

  function Notice(props) {
    classCallCheck(this, Notice);

    var _this = possibleConstructorReturn(this, (Notice.__proto__ || Object.getPrototypeOf(Notice)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(_this.getArgs(e));
      }
    };

    _this.state = {};
    return _this;
  }

  createClass(Notice, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          show = _props.show,
          className = _props.className,
          style = _props.style,
          icon = _props.icon,
          iconSrc = _props.iconSrc,
          iconStyle = _props.iconStyle,
          iconClassName = _props.iconClassName,
          caption = _props.caption,
          sndcaption = _props.sndcaption,
          children = _props.children;

      return show ? React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'notice' + (className ? ' ' + className : ''), style: style },
        React__default.createElement(
          'div',
          { className: 'notice-content', onClick: this.onClick },
          (iconSrc || iconClassName) && React__default.createElement(Icon$1, { className: 'notice-icon' + (iconClassName ? ' ' + iconClassName : ''), src: iconSrc ? iconSrc : '', style: iconStyle }),
          icon,
          React__default.createElement(
            'div',
            { className: 'notice-caption' },
            caption
          ),
          sndcaption && React__default.createElement(
            'div',
            { className: 'notice-sndcaption' },
            sndcaption
          ),
          children
        )
      ) : null;
    }
  }]);
  return Notice;
}(React.Component);

Notice$1.propTypes = {
  onClick: propTypes.func,
  show: propTypes.bool,
  // args: PropTypes.array

  className: propTypes.string,
  style: propTypes.object,
  icon: propTypes.node,
  iconSrc: propTypes.string,
  iconStyle: propTypes.object,
  iconClassName: propTypes.string, // notice-icon-nodata | notice-icon-error
  caption: propTypes.string,
  sndcaption: propTypes.string,
  children: propTypes.node
};
Notice$1.defaultProps = {
  args: null,
  show: true,
  caption: '',
  sndcaption: '',
  style: {}
};

// Dragrefresh 下拉刷新
var Dragrefresh$3 = function Dragrefresh(params) {
  /* ----------------------
  Model
  ---------------------- */
  var defaults = {
    container: document.body,
    duration: 150, // 头部下拉的隐藏动画时长
    threshold: 100, // 头部下拉的触发位置
    begin: 0, // 头部下拉的起始位置
    end: 300, // 头部下拉的结束位置

    isTopPosition: 0, // 如果scrollTop小于等于isTopPosition时，则认为是到顶部了(不建议修改)

    topContainer: null, // 头部容器
    errorContainerClass: 'SID-Dragrefresh-ErrorContainer' // 错误容器的class

    /* callbacks
    onScroll: function(e) // 滚动
    
    onPull:function(s)// 头部拖动中
    onShowTop:function(s)// 开始显示头部
    onHideTop:function(s)// 开始隐藏头部
    onTopShowed(s)// 头部显示动画结束
    onTopHid(s)// 头部隐藏动画结束
    onTransitionEnd:function(Dragrefresh)// 头部动画结束
     onTopRefresh:function(s)// 头部刷新
    onTopComplete:function(s)// 头部完成加载
     onBottomRefresh:function(s)// 底部刷新
    onBottomComplete:function(s)// 底部完成加载
    onNoData:function(s)// 底部无数据
     onError:function(s)// 网络错误
    onClickError:function(s)//点击错误容器
     */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  // Container
  s.container = typeof s.params.container === 'string' ? document.querySelector(s.params.container) : s.params.container;
  if (!s.container) {
    console.log('SeedsUI Error : Dragrefresh container不存在，请检查页面中是否有此元素');
    return;
  }
  // topContainer
  s.topContainer = typeof s.params.topContainer === 'string' ? document.querySelector(s.params.topContainer) : s.params.topContainer;
  if (!s.topContainer) {
    console.log('SeedsUI Warn : topContainer不存在，请检查页面中是否有此元素');
  }
  // 正在刷新(默认为不允许下拉，当发生一次请求调用setPagination后才允许下拉)
  s.isRefreshed = false;
  /* ----------------------
  Method
  ---------------------- */
  s.isHid = false;
  // 隐藏
  s.hideTop = function () {
    s.topContainer.style.webkitTransitionDuration = s.params.duration + 'ms';
    s.touches.posY = s.params.begin;
    s.touches.currentPosY = s.params.begin;
    s.isHid = true;
    // 拖动完成
    s.isOnPull = false;
    // 实体操作
    if (s.params.onHideTop) s.params.onHideTop(s);
  };
  // 显示
  s.showTop = function () {
    s.topContainer.style.webkitTransitionDuration = s.params.duration + 'ms';
    s.touches.posY = s.params.threshold;
    s.touches.currentPosY = s.params.begin;
    s.isHid = false;
    // 实体操作
    if (s.params.onShowTop) s.params.onShowTop(s);
  };
  // 销毁对象
  s.destroyTop = function () {
    s.container.removeChild(s.topContainer);
  };
  s.destroy = function () {
    s.destroyTop();
    // 销毁事件
    s.detach();
  };
  // 是否有滚动条
  s.hasScroll = function () {
    var clientHeight = s.container.clientHeight; // || window.innerHeight
    var scrollHeight = s.container.scrollHeight;
    /* var scrollTop = s.container === document.body ? document.documentElement.scrollTop : s.container.scrollTop
    console.log(clientHeight + ':' + scrollHeight + ':' + scrollTop) */

    if (clientHeight === scrollHeight) {
      return false;
    }
    return true;
  };
  // 头部刷新
  s.topRefresh = function () {
    if (!s.isRefreshed) return;
    // 正在刷新
    s.isRefreshed = false;
    // CallBack onTopRefresh
    if (s.params.onTopRefresh) s.params.onTopRefresh(s);
  };
  // 底部刷新
  s.bottomRefresh = function () {
    // 底部无数据、底部正在刷新、下拉中、头部刷新的情况，不执行
    if (s.isNoData || !s.isRefreshed || s.isOnPull) return;
    // 正在刷新
    s.isRefreshed = false;
    // CallBack onBottomRefresh
    if (s.params.onBottomRefresh) s.params.onBottomRefresh(s);
  };
  // 头部刷新完成
  s.topComplete = function () {
    if (!s.topContainer) return;
    // 收起
    s.hideTop();
    // 头部完成
    s.isRefreshed = true;
    // Callback onTopComplete
    if (s.params.onTopComplete) s.params.onTopComplete(s);
    // Callback onNoData (无更多数据)
    if (s.isNoData) {
      if (s.params.onNoData) s.params.onNoData(s);
      return;
    }
    // 如果还有数据，如果没有滚动条，则继续加载
    if (!s.params.onBottomRefresh) return;
    setTimeout(function () {
      if (!s.isNoData && !s.hasScroll()) {
        s.bottomRefresh();
      }
    }, s.params.duration * 2);
  };
  // 底部刷新完成
  s.bottomComplete = function () {
    if (!s.params.onBottomRefresh) return;
    // 底部完成
    s.isRefreshed = true;
    // Callback onBottomComplete
    if (s.params.onBottomComplete) s.params.onBottomComplete(s);
    // Callback onNoData (无更多数据)
    if (s.isNoData) {
      if (s.params.onNoData) s.params.onNoData(s);
      return;
    }
    // 如果还有数据，并且如果没有滚动条，则继续加载
    if (!s.hasScroll()) {
      s.bottomRefresh();
    }
  };
  // 网络错误
  s.error = function () {
    s.isNoData = true;
    s.isRefreshed = true;
    // 收起头部
    if (s.topContainer) s.hideTop();
    // 网络错误回调
    if (s.params.onError) s.params.onError(s);
  };
  s.noData = function () {
    s.isNoData = true;
    s.isRefreshed = true;
    // 收起头部
    if (s.topContainer) s.hideTop();
    // 底部显示无数据
    if (s.params.onNoData) s.params.onNoData(s);
  };
  s.setPagination = function (isNext, isNoData, isError) {
    // 下一页 | 无数据 | 错误
    s.isNoData = isNoData;
    // 如果加载错误
    if (isError) {
      s.error();
      return;
    }
    // 如果已经没有数据,并且是下一页则不加载
    if (s.isNoData && isNext) {
      s.noData();
      return;
    }
    // 加载数据
    if (!isNext && s.topContainer) {
      // 第一页
      s.topComplete();
    } else {
      // 下一页
      s.bottomComplete();
    }
  };
  /* ----------------------
  Events
  ---------------------- */
  s.isSupportTouch = 'ontouchstart' in window;
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    var touchTarget = s.container;
    // 头部下拉
    if (s.topContainer) {
      // touch兼容pc事件
      if (s.isSupportTouch) {
        s.container[action]('touchstart', s.onTouchStart, false);
        s.container[action]('touchmove', s.onTouchMove, false);
        s.container[action]('touchend', s.onTouchEnd, false);
        s.container[action]('touchcancel', s.onTouchEnd, false);
      } else {
        s.container[action]('mousedown', s.onTouchStart, false);
        s.container[action]('mousemove', s.onTouchMove, false);
        s.container[action]('mouseup', s.onTouchEnd, false);
      }
      // 头部动画监听
      s.topContainer[action]('webkitTransitionEnd', s.onTransitionEnd, false);
    }
    // 底部刷新
    if (s.params.onBottomRefresh) {
      // 绑定底部事件，区分一般容器和body
      if (touchTarget === document.body) {
        touchTarget = window;
      }
      touchTarget[action]('scroll', s.onScroll, false);
    }
    // 点击错误面板
    var errorContainer = s.container.querySelector('.' + s.params.errorContainerClass);
    if (errorContainer) errorContainer[action]('click', s.onClickError, false);
  };
  // attach、detach事件
  s.attach = function () {
    s.events();
  };
  s.detach = function () {
    s.events(true);
  };

  // Touch信息
  s.touches = {
    direction: 0,
    vertical: 0,
    isTop: true,
    startX: 0,
    startY: 0,
    currentX: 0,
    currentY: 0,
    endX: 0,
    endY: 0,
    diffX: 0,
    diffY: 0,
    posY: 0,
    currentPosY: 0
  };
  s.preventDefault = function (e) {
    e.preventDefault();
  };
  s.startMouseMove = false;
  // touchmove的preventDefault事件监听，防止与滚动条冲突
  s.preventMove = false;
  s.onTouchStart = function (e) {
    s.startMouseMove = true;
    s.container.addEventListener(s.isSupportTouch ? 'touchmove' : 'mousemove', s.preventDefault, false);
    s.preventMove = true;
    // 如果不在顶部，则不触发
    if (s.getScrollTop() <= s.params.isTopPosition) s.touches.isTop = true;else s.touches.isTop = false;

    s.topContainer.style.webkitTransitionDuration = '0ms';

    s.touches.startX = e.clientX || e.touches[0].clientX;
    s.touches.startY = e.clientY || e.touches[0].clientY;
  };
  // 标识头部正在拖动
  s.isOnPull = false;
  s.onTouchMove = function (e) {
    if (!s.startMouseMove) return;
    s.touches.currentX = e.clientX || e.touches[0].clientX;
    s.touches.currentY = e.clientY || e.touches[0].clientY;
    s.touches.diffY = s.touches.currentY - s.touches.startY;
    s.touches.diffX = s.touches.startX - s.touches.currentX;

    // 设置滑动方向(-1上下 | 1左右)
    if (s.touches.direction === 0) {
      s.touches.direction = Math.abs(s.touches.diffX) > Math.abs(s.touches.diffY) ? 1 : -1;
    }
    // 设置垂直方向(-1上 | 1下)
    if (s.touches.direction === -1) {
      s.touches.vertical = s.touches.diffY < 0 ? 1 : -1;
    }
    // 在顶部下拉
    if (s.touches.isTop && s.touches.vertical === -1) {
      if (!s.isRefreshed) return;
      if (s.preventMove === false) {
        s.container.addEventListener(s.isSupportTouch ? 'touchmove' : 'mousemove', s.preventDefault, false);
        s.preventMove = true;
      }
      s.touches.currentPosY = s.touches.posY + s.touches.diffY;
      if (s.touches.currentPosY > s.params.end) {
        s.touches.currentPosY = s.params.end;
      }
      // 实体操作
      if (s.params.onPull) s.params.onPull(s);
      // 标识头部正在拖动
      s.isOnPull = true;
    } else {
      if (s.preventMove === true) {
        s.container.removeEventListener(s.isSupportTouch ? 'touchmove' : 'mousemove', s.preventDefault, false);
        s.preventMove = false;
      }
    }
  };
  s.onTouchEnd = function (e) {
    s.startMouseMove = false;
    // 清除move时记录的方向
    s.touches.direction = 0;
    s.touches.vertical = 0;
    // 下拉的情况
    if (s.touches.currentPosY > 0) {
      if (s.touches.currentPosY > s.params.threshold) {
        // 如果大于hold值，则展示
        s.showTop();
      } else {
        // 小于则收起
        s.hideTop();
      }
    }
  };
  s.onTransitionEnd = function (e) {
    if (e.target !== s.topContainer || e.propertyName === 'visibility') return;
    // 有效的显示状态
    if (s.touches.posY === s.params.threshold && s.isRefreshed) {
      s.topRefresh();
    }

    // 显示与隐藏的回调
    // Callback onTransitionEnd
    if (s.params.onTransitionEnd) s.params.onTransitionEnd(s);
    if (s.isHid) {
      // Callback onTopHid
      if (s.params.onTopHid) s.params.onTopHid(s);
    } else {
      // Callback onTopShowed
      if (s.params.onTopShowed) s.params.onTopShowed(s);
    }
  };
  s.isNoData = false;
  s.getScrollTop = function (e) {
    var scrollTop = s.container === document.body ? document.documentElement.scrollTop : s.container.scrollTop;
    return scrollTop;
  };
  s.onScroll = function (e) {
    if (s.params.onScroll) s.params.onScroll(e);
    var clientHeight = s.container.clientHeight; // || window.innerHeight
    var scrollHeight = s.container.scrollHeight;
    var scrollTop = s.container === document.body ? document.documentElement.scrollTop : s.container.scrollTop;
    // console.log(clientHeight + ':' + scrollHeight + ':' + scrollTop)
    if (scrollTop + clientHeight >= scrollHeight - 2) {
      s.bottomRefresh();
    }
  };
  s.onClickError = function (e) {
    if (s.params.onClickError) {
      s.params.onClickError(s);
    } else {
      s.isNoData = false;
      // 底部刷新
      s.bottomRefresh();
    }
  };
  // 主函数
  s.init = function () {
    s.attach();
  };

  s.init();
};

var DragPull = function DragPull(params) {
  // 参数改写
  var _onTopComplete = params.onTopComplete;
  var _onBottomRefresh = params.onBottomRefresh;
  var _onNoData = params.onNoData;
  var _onError = params.onError;
  params.onTopComplete = undefined;
  params.onBottomRefresh = undefined;
  params.onNoData = undefined;
  params.onError = undefined;

  // 必须参数
  var container = typeof params.container === 'string' ? document.querySelector(params.container) : params.container;
  if (!container) {
    console.log('SeedsUI Error : DragPull container不存在，请检查页面中是否有此元素');
  }
  var topContainer;
  var topIcon;
  var topCaption;
  if (params.onTopRefresh) {
    topContainer = container.querySelector('.SID-Dragrefresh-TopContainer');
    if (!topContainer) {
      topContainer = document.createElement('div');
      topContainer.setAttribute('class', 'SID-Dragrefresh-TopContainer df-pull');
      topContainer.innerHTML = '<div class="df-pull-box">' + '<div class="df-pull-icon"></div>' + '<div class="df-pull-caption">下拉可以刷新</div>' + '</div>';
      container.insertBefore(topContainer, container.childNodes[0]);
    }
    topIcon = topContainer.querySelector('.df-pull-icon');
    topCaption = topContainer.querySelector('.df-pull-caption');
  }
  var bottomContainer;
  var nodataContainer;
  var errorContainer;
  if (_onBottomRefresh) {
    bottomContainer = container.querySelector('.SID-Dragrefresh-BottomContainer');
    if (!bottomContainer) {
      bottomContainer = document.createElement('div');
      bottomContainer.setAttribute('class', 'SID-Dragrefresh-BottomContainer df-pull');
      bottomContainer.setAttribute('style', 'height: 50px');
      bottomContainer.innerHTML = '<div class="df-pull-box">' + '<div class="df-pull-icon df-pull-icon-loading"></div>' + '<div class="df-pull-caption">正在加载...</div>' + '</div>';
      container.appendChild(bottomContainer);
    }

    nodataContainer = container.querySelector('.SID-Dragrefresh-NoDataContainer');
    if (!errorContainer) {
      nodataContainer = document.createElement('div');
      nodataContainer.setAttribute('class', 'SID-Dragrefresh-NoDataContainer df-pull hide');
      nodataContainer.setAttribute('style', 'height: 50px;');
      nodataContainer.innerHTML = '<div class="df-pull-box">' + '<div class="df-pull-caption">没有更多数据了</div>' + '</div>';
      container.appendChild(nodataContainer);
    }

    errorContainer = container.querySelector('.SID-Dragrefresh-ErrorContainer');
    if (!errorContainer) {
      errorContainer = document.createElement('div');
      errorContainer.setAttribute('class', 'SID-Dragrefresh-ErrorContainer df-pull hide');
      errorContainer.setAttribute('style', 'height: 50px;');
      errorContainer.innerHTML = '<div class="df-pull-box">' + '<div class="df-pull-caption">加载失败，请稍后重试</div>' + '</div>';
      container.appendChild(errorContainer);
    }
  }

  /* ----------------------
  params
  ---------------------- */
  var defaults = {
    container: container,
    topContainer: topContainer,
    threshold: 50,
    onTopComplete: function onTopComplete(e) {
      if (bottomContainer && !e.isNoData) {
        bottomContainer.classList.remove('hide');
        nodataContainer.classList.add('hide');
        errorContainer.classList.add('hide');
      }
      // 回调
      if (_onTopComplete) _onTopComplete(e);
    },
    onBottomRefresh: function onBottomRefresh(e) {
      if (bottomContainer) {
        bottomContainer.classList.remove('hide');
        nodataContainer.classList.add('hide');
        errorContainer.classList.add('hide');
      }
      // 回调
      if (_onBottomRefresh) _onBottomRefresh(e);
    },
    onNoData: function onNoData(e) {
      // 显示无数据容器,隐藏底部和错误容器
      if (bottomContainer) {
        bottomContainer.classList.add('hide');
        nodataContainer.classList.remove('hide');
        errorContainer.classList.add('hide');
      }
      // 回调
      if (_onNoData) _onNoData(e);
    },
    onError: function onError(e) {
      // 显示错误容器,隐藏底部和无数据容器
      if (bottomContainer) {
        bottomContainer.classList.add('hide');
        nodataContainer.classList.add('hide');
        errorContainer.classList.remove('hide');
      }
      // 回调
      if (_onError) _onError(e);
    },
    onClickError: function onClickError(e) {
      console.log('点击错误容器');
    },
    // 实体操作
    onPull: function onPull(e) {
      topContainer.style.height = e.touches.currentPosY + 'px';
      if (e.isRefreshed) {
        if (e.touches.currentPosY >= e.params.threshold) {
          topIcon.classList.add('df-pull-icon-down');
          topCaption.innerHTML = '释放立即刷新';
        } else {
          topIcon.classList.remove('df-pull-icon-down');
          topCaption.innerHTML = '下拉可以刷新';
        }
      }
    },
    onShowTop: function onShowTop(e) {
      topContainer.style.height = e.params.threshold + 'px';
      topIcon.classList.remove('df-pull-icon-down');
      topIcon.classList.add('df-pull-icon-loading');
      topCaption.innerHTML = '正在刷新...';
    },
    onHideTop: function onHideTop(e) {
      topContainer.style.height = '0';
    },
    onTopHid: function onTopHid(e) {
      topIcon.classList.remove('df-pull-icon-down');
      topIcon.classList.remove('df-pull-icon-loading');
    }
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = new Dragrefresh$3(params);
  return s;
};

// ImgLazy 图片预加载
var ImgLazy = function ImgLazy(params) {
  /* --------------------
  Model
  -------------------- */
  var defaults = {
    overflowContainer: document.body,
    isScrollLoad: true, // 滚动加载
    threshold: 300, // 滚动加载时，显示区域扩张上下像素
    imgLoadAttr: 'data-load-src', // 图片地址
    imgErrowAttr: 'data-error-src' // 错误图片地址
    /*
    callbacks
    onScroll:function(e)
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  // Container
  s.overflowContainer = typeof s.params.overflowContainer === 'string' ? document.querySelector(s.params.overflowContainer) : s.params.overflowContainer;
  if (!s.overflowContainer) {
    console.log('SeedsUI Error : Dragrefresh overflowContainer不存在，请检查页面中是否有此元素');
    return;
  }
  // 所有图片
  s.imgs = [];
  // 对应缓存图片
  s.cacheImgs = [];

  // 屏幕高度
  s.windowHeight = window.innerHeight;
  s.scrollTop = null;
  /* --------------------
  Method
  -------------------- */
  // 获得所有懒人图片
  s.updateImgs = function () {
    s.imgs = s.overflowContainer.querySelectorAll('[' + s.params.imgLoadAttr + ']');
    for (var i = 0; i < s.imgs.length; i++) {
      s.cacheImgs[i] = new Image();
      s.cacheImgs[i].index = i;
      s.cacheImgs[i].errorSrc = s.imgs[i].getAttribute(s.params.imgErrowAttr);
      // 如果没有选择滚动加载，则一次性加载
      if (!s.params.isScrollLoad) {
        var src = s.imgs[i].getAttribute(s.params.imgLoadAttr);
        s.cacheImgs[i].src = src;
      }
    }
  };
  s.updateImgs();
  s.update = function () {
    // 重新获取图片
    s.updateImgs();
    // 重新绑定图片事件
    s.imgsDetach();
    s.imgsAttach();
    // 加载屏幕中的图片
    for (var i = 0; i < s.imgs.length; i++) {
      var flag = s.isInScreen(s.imgs[i]);
      if (flag && s.cacheImgs[i].src === '') {
        // console.log('加载第'+i+'张：'+flag)
        var src = s.imgs[i].getAttribute(s.params.imgLoadAttr);
        s.cacheImgs[i].src = src;
      }
    }
  };
  // 获得头部位置
  s.getOffsetTop = function (el) {
    var offsetTop = el.offsetTop;
    if (el.offsetParent != null) offsetTop += s.getOffsetTop(el.offsetParent);

    return offsetTop;
  };
  // 元素是否在显示区域内
  s.isInScreen = function (el) {
    var offsetTop = s.getOffsetTop(el);
    if (offsetTop > s.scrollTop - s.params.threshold && offsetTop < parseInt(s.scrollTop, 10) + parseInt(s.windowHeight, 10)) {
      return true;
    }
    return false;
  };
  /* --------------------
  Events
  -------------------- */
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    if (s.params.isScrollLoad) {
      var scrollTarget = s.overflowContainer === document.body ? window : s.overflowContainer;
      scrollTarget[action]('scroll', s.onScroll, false);
    }
  };
  s.attach = function () {
    s.events();
    // 初始化时执行一次，让首屏可加载
    s.onScroll();
  };
  s.detach = function () {
    s.events(false);
  };
  s.imgsEvents = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    // 缓存图片绑定onLoad事件|和绑定onError事件
    for (var i = 0; i < s.cacheImgs.length; i++) {
      s.cacheImgs[i][action]('load', s.onLoad, false);
      s.cacheImgs[i][action]('error', s.onError, false);
    }
  };
  s.imgsAttach = function () {
    s.imgsEvents();
  };
  s.imgsDetach = function () {
    s.imgsEvents(false);
  };
  // Events Handler
  s.onLoad = function (e) {
    var target = e.target;
    var imgTarget = s.imgs[target.index];
    if (imgTarget.tagName === 'IMG') {
      imgTarget.src = target.src;
    } else {
      imgTarget.style.backgroundImage = 'url(' + target.src + ')';
    }

    // console.log('加载图片'+target.index)
  };
  s.onError = function (e) {
    var target = e.target;
    if (!target.errorSrc) return;

    var imgTarget = s.imgs[target.index];
    if (imgTarget.tagName === 'IMG') {
      imgTarget.src = target.errorSrc;
    } else {
      imgTarget.style.backgroundImage = 'url(' + target.errorSrc + ')';
    }
    // console.log('错误图片'+target.index)
  };
  var timer;
  var millisec = 300;
  s.getScrollTop = function () {
    return s.overflowContainer === document.body ? document.documentElement.scrollTop : s.overflowContainer.scrollTop;
  };
  s.onScroll = function (e) {
    if (s.params.onScroll) s.params.onScroll(e);
    // 计算scrollEnd事件
    s.scrollTop = s.getScrollTop();
    if (timer) {
      clearTimeout(timer);
    }
    timer = setTimeout(function () {
      if (s.scrollTop === s.getScrollTop()) {
        s.onScrollEnd();
        clearTimeout(timer);
        return;
      }
      timer = null;
    }, millisec);
  };
  s.onScrollEnd = function () {
    console.log('停止滚动');
    s.update();
  };
  /* --------------------
  Init
  -------------------- */
  s.init = function () {
    // 绑定滚动条事件
    s.attach();
    // 绑定图片事件
    s.imgsAttach();
  };
  s.init();
};

var Dragrefresh$1 = function (_Component) {
  inherits(Dragrefresh, _Component);

  function Dragrefresh(props) {
    classCallCheck(this, Dragrefresh);

    var _this = possibleConstructorReturn(this, (Dragrefresh.__proto__ || Object.getPrototypeOf(Dragrefresh)).call(this, props));

    _this.componentDidMount = function () {
      _this.init();
      console.log('dragrefresh:DidMount, hasMore:' + _this.props.hasMore);
      _this.setPagination();
    };

    _this.init = function () {
      var onScroll = _this.props.onScroll;

      var instance = new DragPull({
        container: _this.$el,
        onScroll: onScroll,
        onTopRefresh: _this.props.onTopRefresh ? _this.props.onTopRefresh : null, // 头部刷新,加载第一页
        onTopComplete: _this.props.onTopComplete ? _this.props.onTopComplete : null, // 头部完成
        onBottomRefresh: _this.props.onBottomRefresh ? _this.props.onBottomRefresh : null, // 底部刷新,加载下一页
        onBottomComplete: _this.props.onBottomComplete ? _this.props.onBottomComplete : null // 底部完成
      });
      _this.setState({
        instance: instance
      });
      // 懒人加载
      var imgLazy = null;
      if (_this.props.lazyLoad && !imgLazy) {
        imgLazy = new ImgLazy({
          overflowContainer: _this.$el
        });
      }
    };

    _this.componentDidUpdate = function (prevProps) {
      if (prevProps.hasMore === _this.props.hasMore) return;
      if (_this.props.hasMore === 404) {
        console.log('dragrefresh:解除touch事件，暂无数据');
        _this.state.instance.detach();
      } else if (prevProps.hasMore === 404 && _this.props.hasMore !== 404) {
        /* this.setState({
          noData: false
        }); */
        console.log('dragrefresh:绑定touch事件，有数据');
        _this.state.instance.attach();
      }
      console.log('dragrefresh:DidUpdate, hasMore:' + _this.props.hasMore);
      _this.setPagination();
    };

    _this.setPagination = function () {
      // 如果还没有初始化完成,则会再轮询调用一下
      if (!_this.state.instance) {
        setTimeout(function () {
          _this.setPagination();
        }, 100);
        return;
      }
      if (_this.props.hasMore === 1) {
        // 头部完成
        console.log('dragrefresh:头部完成');
        _this.state.instance.setPagination(false, false);
      } else if (_this.props.hasMore === 2) {
        // 底部完成
        console.log('dragrefresh:底部完成');
        _this.state.instance.setPagination(true, false);
      } else if (_this.props.hasMore === 0) {
        // 没有更多数据
        console.log('dragrefresh:没有更多数据');
        _this.state.instance.setPagination(true, true);
      } else if (_this.props.hasMore === -1) {
        console.log('dragrefresh:网络错误');
        _this.state.instance.setPagination(true, true, true);
      } else if (_this.props.hasMore === 404) {
        // if (this.state.noData === true) return;
        console.log('dragrefresh:没有一条数据');
        _this.state.instance.setPagination(true, true);
        /* this.setState({
          noData: true
        }); */
      }
    };

    _this.state = {
      instance: null
      // noData: false
    };
    return _this;
  }

  createClass(Dragrefresh, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          onTopRefresh = _props.onTopRefresh,
          onBottomRefresh = _props.onBottomRefresh,
          showNoData = _props.showNoData,
          noDataClassName = _props.noDataClassName,
          noDataStyle = _props.noDataStyle,
          noDataCaption = _props.noDataCaption,
          noDataIconSrc = _props.noDataIconSrc,
          noDataIconClassName = _props.noDataIconClassName,
          noDataOnClick = _props.noDataOnClick;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'container' + (className ? ' ' + className : ''), style: style },
        onTopRefresh && React__default.createElement(
          'div',
          { className: 'SID-Dragrefresh-TopContainer df-pull', style: { transitionDuration: '150ms', height: '0px' } },
          React__default.createElement(
            'div',
            { className: 'df-pull-box' },
            React__default.createElement('div', { className: 'df-pull-icon' }),
            React__default.createElement(
              'div',
              { className: 'df-pull-caption' },
              '\u4E0B\u62C9\u53EF\u4EE5\u5237\u65B0'
            )
          )
        ),
        this.props.children,
        onBottomRefresh && React__default.createElement(
          'div',
          { className: 'SID-Dragrefresh-BottomContainer df-pull', style: { height: '50px' } },
          this.props.hasMore !== -3 && React__default.createElement(
            'div',
            { className: 'df-pull-box' },
            React__default.createElement('div', { className: 'df-pull-icon df-pull-icon-loading' }),
            React__default.createElement(
              'div',
              { className: 'df-pull-caption' },
              '\u6B63\u5728\u52A0\u8F7D...'
            )
          )
        ),
        onBottomRefresh && React__default.createElement(
          'div',
          { className: 'SID-Dragrefresh-NoDataContainer df-pull hide', style: { height: '50px' } },
          React__default.createElement(
            'div',
            { className: 'df-pull-box' },
            React__default.createElement(
              'div',
              { className: 'df-pull-caption' },
              '\u6CA1\u6709\u66F4\u591A\u6570\u636E\u4E86'
            )
          )
        ),
        onBottomRefresh && React__default.createElement(
          'div',
          { className: 'SID-Dragrefresh-ErrorContainer df-pull hide', style: { height: '50px' } },
          React__default.createElement(
            'div',
            { className: 'df-pull-box' },
            React__default.createElement(
              'div',
              { className: 'df-pull-caption' },
              '\u52A0\u8F7D\u5931\u8D25\uFF0C\u8BF7\u7A0D\u540E\u518D\u8BD5'
            )
          )
        ),
        this.props.hasMore === 404 && showNoData && React__default.createElement(Notice$1, { className: noDataClassName, style: noDataStyle, caption: noDataCaption || '暂无数据', iconSrc: noDataIconSrc, iconClassName: noDataIconClassName, onClick: noDataOnClick })
      );
    }
  }]);
  return Dragrefresh;
}(React.Component);

Dragrefresh$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  onTopRefresh: propTypes.func,
  onTopComplete: propTypes.func,
  onBottomRefresh: propTypes.func,
  onBottomComplete: propTypes.func,
  children: propTypes.node,
  hasMore: propTypes.number, // 1头部完成 | 2底部完成 | 0没有更多数据 | -1网络错误 | 404找不到数据 | -2空闲但展现底部转圈 | -3空闲但不展现底部转圈

  showNoData: propTypes.bool, // 是否允许暂无数据
  noDataClassName: propTypes.string,
  noDataStyle: propTypes.object,
  noDataCaption: propTypes.string,
  noDataIconSrc: propTypes.string,
  noDataIconClassName: propTypes.string,
  noDataOnClick: propTypes.func, // 点击暂无数据

  lazyLoad: propTypes.bool,

  onScroll: propTypes.func // 滚动事件
};
Dragrefresh$1.defaultProps = {
  noDataIconClassName: 'notice-icon-nodata',
  showNoData: true
};

var Tabbar$1 = function (_Component) {
  inherits(Tabbar, _Component);

  function Tabbar(props) {
    classCallCheck(this, Tabbar);

    var _this = possibleConstructorReturn(this, (Tabbar.__proto__ || Object.getPrototypeOf(Tabbar)).call(this, props));

    _this.onClick = function (e) {
      var target = e.target;
      if (_this.props.exceptOnClickActive && target.classList.contains('active')) return;
      var index = target.getAttribute('data-index');
      if (_this.props.onClick) {
        _this.props.onClick(_this.props.list[index], Number(index));
        e.stopPropagation();
      }
    };

    _this.getLIconDOM = function (item, isActive) {
      // iconStyle | iconClassName
      var iconStyle = {};
      var iconClassName = '';
      if (isActive && (item.iconActiveClassName || item.iconActiveStyle)) {
        if (item.iconActiveClassName) iconClassName = 'tab-icon ' + item.iconActiveClassName;
        if (item.iconActiveStyle) iconStyle = item.iconActiveStyle;
      } else {
        if (item.iconClassName) iconClassName = 'tab-icon ' + item.iconClassName;
        if (item.iconStyle) iconStyle = item.iconStyle;
      }
      // iconBadgeStyle | iconBadgeClassName | iconBadgeCaption
      var iconBadgeStyle = _this.props.iconBadgeStyle;
      if (item.iconBadgeStyle) {
        iconBadgeStyle = item.iconBadgeStyle;
      }
      var iconBadgeClassName = _this.props.iconBadgeClassName;
      if (item.iconBadgeClassName) {
        iconBadgeClassName = item.iconBadgeClassName;
      }
      var iconBadgeCaption = '';
      if (item.iconBadgeCaption) {
        iconBadgeCaption = item.iconBadgeCaption;
      }
      // DOM
      return React__default.createElement(Icon$1, { className: iconClassName, style: iconStyle, badgeCaption: iconBadgeCaption, badgeClassName: iconBadgeClassName, badgeStyle: iconBadgeStyle });
    };

    _this.getRIconDOM = function (item, isActive) {
      // riconStyle | riconClassName
      var riconStyle = {};
      var riconClassName = '';
      if (isActive && (item.iconActiveClassName || item.iconActiveStyle)) {
        if (item.iconActiveClassName) riconClassName = 'tab-icon ' + item.iconActiveClassName;
        if (item.iconActiveStyle) riconStyle = item.iconActiveStyle;
      } else {
        if (item.riconClassName) riconClassName = 'tab-icon ' + item.riconClassName;
        if (item.riconStyle) riconStyle = item.riconStyle;
      }
      // riconBadgeStyle | riconBadgeClassName | riconBadgeCaption
      var riconBadgeStyle = _this.props.riconBadgeStyle;
      if (item.riconBadgeStyle) {
        riconBadgeStyle = item.riconBadgeStyle;
      }
      var riconBadgeClassName = _this.props.riconBadgeClassName;
      if (item.riconBadgeClassName) {
        riconBadgeClassName = item.riconBadgeClassName;
      }
      var riconBadgeCaption = '';
      if (item.riconBadgeCaption) {
        riconBadgeCaption = item.riconBadgeCaption;
      }
      // DOM
      return React__default.createElement(Icon$1, { className: riconClassName, style: riconStyle, badgeCaption: riconBadgeCaption, badgeClassName: riconBadgeClassName, badgeStyle: riconBadgeStyle });
    };

    _this.getTabsDOM = function () {
      var _this$props = _this.props,
          list = _this$props.list,
          style = _this$props.style,
          activeIndex = _this$props.activeIndex;
      // tabStyle高度

      var tabStyle = {};
      if (style && style.height) {
        tabStyle = {
          height: style.height
        };
      }
      // 遍历
      return list.map(function (item, index) {
        var isActive = item.active || activeIndex === index;
        var liconDOM = null;
        if (item.iconClassName) {
          liconDOM = _this.getLIconDOM(item, isActive);
        }
        var riconDOM = null;
        if (item.riconClassName) {
          riconDOM = _this.getRIconDOM(item, isActive);
        }
        return React__default.createElement(
          'li',
          { id: item.id, 'data-index': index, className: 'tab' + (isActive ? ' active' : ''), style: Object.assign(tabStyle, item.style || {}), key: index },
          liconDOM && liconDOM,
          React__default.createElement(
            'div',
            { className: 'tab-content' },
            React__default.createElement(
              'div',
              { className: 'tab-caption' },
              item.caption
            ),
            item.sndcaption && React__default.createElement(
              'div',
              { className: 'tab-sndcaption' },
              item.sndcaption
            )
          ),
          riconDOM && riconDOM
        );
      });
    };

    _this.getTabbarStyle = function () {
      var _this$props2 = _this.props,
          list = _this$props2.list,
          className = _this$props2.className,
          style = _this$props2.style;

      var tabbarStyle = {};
      // 矩形tabbar应当有的总宽度
      if (className.hasClass('tabbar-rect')) {
        switch (list.length) {
          case 1:
            tabbarStyle = { width: '30%' };
            break;
          case 2:
            tabbarStyle = { width: '50%' };
            break;
          case 3:
            tabbarStyle = { width: '50%' };
            break;
          default:
            tabbarStyle = {};
        }
      }
      return Object.assign({}, tabbarStyle, style);
    };

    _this.getTabbarClassName = function () {
      var _this$props3 = _this.props,
          className = _this$props3.className,
          tiled = _this$props3.tiled;

      return 'tabbar animated' + (className ? ' ' + className : ' tabbar-line-width60') + (tiled ? ' tabbar-tiled' : '');
    };

    _this.state = {};
    return _this;
  }

  createClass(Tabbar, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var disabled = this.props.disabled;
      // 获取tabbar样式

      var tabbarStyle = this.getTabbarStyle();
      // 获取tabs的DOM
      var tabsDOM = this.getTabsDOM();
      // 获取tabbar的ClassName
      var tabbarClassName = this.getTabbarClassName();
      return React__default.createElement(
        'ul',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: tabbarClassName, disabled: disabled, style: tabbarStyle, onClick: this.onClick },
        tabsDOM
      );
    }
  }]);
  return Tabbar;
}(React.Component);

Tabbar$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string, // tabbar-line | tabbar-rect | tabbar-lump | tabbar-dropdown | tabbar-footer
  iconBadgeStyle: propTypes.object,
  iconBadgeClassName: propTypes.string,
  riconBadgeStyle: propTypes.object,
  riconBadgeClassName: propTypes.string,
  list: propTypes.array,
  tiled: propTypes.bool, // 宽度等分, 默认宽度弹性伸缩
  disabled: propTypes.bool,
  exceptOnClickActive: propTypes.bool, // 排除点击选中的菜单
  onClick: propTypes.func,
  activeIndex: propTypes.number
};
Tabbar$1.defaultProps = {
  list: [],
  // [
  //   {
  //     iconStyle: object,
  //     iconClassName: string,
  //     iconActiveStyle: object,
  //     iconActiveClassName: string,

  //     iconBadgeClassName: string,
  //     iconBadgeStyle: object,
  //     iconBadgeCaption: string,

  //     riconStyle: object,
  //     riconClassName: string,
  //     riconActiveStyle: object,
  //     riconActiveClassName: string,

  //     riconBadgeClassName: string,
  //     riconBadgeStyle: object,
  //     riconBadgeCaption: string,

  //     caption: string,
  //     sndcaption: string,
  //     active: bool,
  //     id: string
  //   }
  // ]
  exceptOnClickActive: true,
  className: 'tabbar-line tabbar-line-width70 border-b',
  activeIndex: 0
};

// 平铺菜单
var MenuTiled$3 = function MenuTiled(container, params) {
  /* ------------------
  Model
  ------------------ */
  var defaults = {
    // DATA
    data: null,
    slotClass: 'menutiled-slot',
    slotSubClass: 'menutiled-slot-sub',
    tagClass: 'menutiled-tag',
    moreClass: 'menutiled-more',
    activeClass: 'active',
    extandClass: 'extand',

    activeId: '' // 默认选中项的id
    /*
    callbacks
    onClick:function(item, isActived, isExtand) // 点击项的数据,是否是选中状态,是否是展开状态
    */

    /* 参数data: [{
      id: '',
      caption: '',
      active: false,
      children
    }] */
  };params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  // MenuTiled
  var s = this;

  // Params
  s.params = params;
  // Container
  s.container = typeof container === 'string' ? document.querySelector(container) : container;
  if (!s.container) {
    console.log('SeedsUI Error：未找到MenuTiled的DOM对象，请检查传入参数是否正确');
    return;
  }
  s.initData = function (list) {
    var hasSlot = s.container.querySelector('.' + s.params.slotClass);
    var slot = document.createElement('div');
    slot.setAttribute('class', hasSlot ? s.params.slotSubClass : s.params.slotClass);
    var html = '';
    for (var i = 0, option; option = list[i++];) {
      // eslint-disable-line
      html += '<div data-index="' + i + '" data-item=\'' + JSON.stringify(option) + '\' class="' + s.params.tagClass + (option.id === s.params.activeId ? ' active' : '') + '">' + '<p class="menutiled-tag-font">' + option.caption + '</p>' + (option.children && option.children.length > 0 ? '<i class="menutiled-more"></i>' : '<i class="menutiled-select"></i>') + '</div>';
    }
    slot.innerHTML = html;
    s.container.appendChild(slot);
  };
  s.container.innerHTML = '';

  /* ------------------
  Method
  ------------------ */
  // 设置选中项
  s.setActiveId = function (id) {
    s.params.activeId = id;
  };
  // 重新设置数据
  s.setData = function (data) {
    s.params.data = data;
    s.container.innerHTML = '';
    s.initData(data);
  };

  /* ------------------
    Events
    ------------------ */
  // 绑定事件
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    // 树结构
    s.container[action]('click', s.onTap, false);
    // 部分手机touch事件在特殊情况下无效
    // s.container[action]('touchstart', s.onTouchStart, false)
    // s.container[action]('touchend', s.onTouchEnd, false)
    // s.container[action]('touchcancel', s.onTouchEnd, false)
  };
  // attach、dettach事件
  s.attach = function (event) {
    s.events();
  };
  s.detach = function (event) {
    s.events(true);
  };
  /* ------------------
  Event Handler
  ------------------ */
  // Tap
  s.touches = {
    startX: 0,
    startY: 0,
    endX: 0,
    endY: 0,
    diffX: 0,
    diffY: 0
  };
  s.onTouchStart = function (e) {
    s.touches.startX = e.touches[0].clientX;
    s.touches.startY = e.touches[0].clientY;
  };
  s.onTouchEnd = function (e) {
    s.touches.endX = e.changedTouches[0].clientX;
    s.touches.endY = e.changedTouches[0].clientY;
    s.touches.diffX = s.touches.startX - s.touches.endX;
    s.touches.diffY = s.touches.startY - s.touches.endY;
    // 单击事件
    if (Math.abs(s.touches.diffX) < 6 && Math.abs(s.touches.diffY) < 6) {
      s.onTap(e);
    }
  };
  // 点击树
  s.onTap = function (e) {
    var target = e.target;
    if (!target.classList.contains(s.params.tagClass)) return;
    var isActived = target.classList.contains(s.params.activeClass);
    var isExtand = target.classList.contains(s.params.extandClass);
    // 点击行的数据
    var item = target.getAttribute('data-item');
    // 移除下级节点
    var slot = target.parentNode;
    var nextSlot = slot.nextElementSibling;
    if (nextSlot) slot.parentNode.removeChild(nextSlot);
    // 如果已经展开,则收缩
    if (isExtand) {
      target.classList.remove(s.params.extandClass);
      // 如果没有展开,则展开并选中,有下级则新建下级节点
    } else {
      // 移除同级所有的选中项与展开项
      var tags = slot.children;
      for (var i = 0, tag; tag = tags[i++];) {
        // eslint-disable-line
        if (tag) {
          tag.classList.remove(s.params.extandClass);
          tag.classList.remove(s.params.activeClass);
        }
      }
      // 添加当前节点为选中项和展开项
      target.classList.add(s.params.extandClass);
      target.classList.add(s.params.activeClass);
      // 如果有下级则新建下级节点
      var children = item ? JSON.parse(item).children : null;
      if (children && children.length > 0) {
        s.initData(children);
      }
    }
    // 返回item
    var json = item ? JSON.parse(item) : null;
    if (s.params.onClick) s.params.onClick(json, isActived, !isExtand);
  };
  // 主函数
  s.init = function () {
    s.initData(s.params.data, s.container);
    s.attach();
  };
  s.init();
};

var MenuTiled$1 = function (_Component) {
  inherits(MenuTiled, _Component);

  function MenuTiled(props) {
    classCallCheck(this, MenuTiled);

    var _this = possibleConstructorReturn(this, (MenuTiled.__proto__ || Object.getPrototypeOf(MenuTiled)).call(this, props));

    _this.shouldComponentUpdate = function (nextProps) {
      if (_this.props.list.length === nextProps.list.length) {
        return false;
      }
      return true;
    };

    _this.componentDidUpdate = function (prevProps) {
      _this.state.instance.setActiveId(_this.props.activeId);
      _this.state.instance.setData(_this.props.list);
    };

    _this.componentDidMount = function () {
      var _this$props = _this.props,
          list = _this$props.list,
          activeId = _this$props.activeId;

      if (_this.state.instance) return;
      var instance = new MenuTiled$3(_this.$el, {
        data: list,
        activeId: activeId,
        onClick: _this.onClick
      });
      _this.setState({
        instance: instance
      });
    };

    _this.onClick = function (item, isActived, isExtand) {
      if (isExtand && _this.props.onClick) _this.props.onClick(item);
    };

    _this.state = {
      instance: null
    };
    return _this;
  }
  /* list: [{
    id: '',
    caption: '',
    active: false,
    children
  }] */


  createClass(MenuTiled, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return React__default.createElement('div', { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'menutiled' + (className ? ' ' + className : ''), style: style });
    }
  }]);
  return MenuTiled;
}(React.Component);

MenuTiled$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  activeId: propTypes.string, // 默认选中项的id
  onClick: propTypes.func,

  list: propTypes.array };
MenuTiled$1.defaultProps = {};

var Dropdown$1 = function (_Component) {
  inherits(Dropdown, _Component);

  function Dropdown(props) {
    classCallCheck(this, Dropdown);

    var _this = possibleConstructorReturn(this, (Dropdown.__proto__ || Object.getPrototypeOf(Dropdown)).call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      // 如果数据长度不一样,或者上次没有data,此次有data,则刷新
      if (prevProps.list.length !== _this.props.list.length || prevProps.list[0] && !prevProps.list[0].data && _this.props.list[0].data) {
        _this.refresh();
        // 如果选中项有变化也要刷新
      } else if (_this.props.list.some(function (item, i) {
        return item.id !== prevProps.list[i].id;
      })) {
        _this.refresh();
      }
    };

    _this.componentDidMount = function () {
      // 计算距离头部
      var top = _this.props.top;
      if (!top) {
        top = _this.$tabbar.$el.offsetTop + 40;
      }
      _this.setState({
        top: top
      });
      // 更新数据
      _this.refresh();
    };

    _this.refresh = function () {
      // tabbar 和 MenuTiled
      var tabbar = [];
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = _this.props.list[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var item = _step.value;

          tabbar.push({
            id: item.id,
            caption: item.caption,
            riconClassName: 'shape-triangle-down',
            riconActiveStyle: { borderTopColor: '#EB464A' }
          });
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      
      _this.setState({
        tabbar: tabbar
      });
    };

    _this.onClickTab = function (item, index) {
      // 设置弹框的数据
      _this.setState({
        activeMenuId: _this.state.tabbar[index].id,
        menus: _this.props.list[index].data
      });
      if (_this.state.tabbarActiveIndex >= 0) {
        _this.setState({
          tabbarActiveIndex: -1,
          dialogShow: false
        });
      } else {
        _this.setState({
          tabbarActiveIndex: index,
          dialogShow: true
        });
      }
    };

    _this.onClickMask = function () {
      _this.setState({
        tabbarActiveIndex: -1,
        dialogShow: false
      });
    };

    _this.onClickMenu = function (item) {
      if (item.children && item.children.length > 0) return;
      var tabbar = _this.state.tabbar;
      var activeIndex = _this.state.tabbarActiveIndex;
      // 如果选中的标题是全部,则显示原始标题,例如:点击分类,选择全部,则应当显示分类
      if (item.id === _this.props.list[activeIndex].id) {
        tabbar[activeIndex].id = _this.props.list[activeIndex].id;
        tabbar[activeIndex].caption = _this.props.list[activeIndex].caption;
        // 设置选中的标题显示在tabbar上
      } else {
        tabbar[activeIndex].id = item.id;
        tabbar[activeIndex].caption = item.caption;
      }
      _this.setState({
        tabbar: tabbar,
        tabbarActiveIndex: -1,
        dialogShow: false
      });
      // 触发onChange事件
      if (_this.props.onChange) _this.props.onChange(tabbar);
    };

    _this.state = {
      tabbarActiveIndex: -1,
      tabbar: [],
      activeMenuId: '',
      menus: [],
      top: 0,
      dialogShow: false
    };
    return _this;
  }

  createClass(Dropdown, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var DOM = [React__default.createElement(Tabbar$1, { key: 'tabbar', ref: function ref(el) {
          _this2.$tabbar = el;
        }, exceptOnClickActive: false, list: this.state.tabbar, onClick: this.onClickTab, activeIndex: this.state.tabbarActiveIndex, className: 'tabbar-dropdown tabbar-tiled border-b' })];
      if (this.props.portal) {
        DOM.push(React__default.createElement(
          Dialog$1,
          { key: 'dialog', portal: this.props.portal, onClickMask: this.onClickMask, animation: 'slideDown', style: { width: '100%' }, maskStyle: { top: this.state.top + 'px' }, show: this.state.dialogShow },
          React__default.createElement(MenuTiled$1, { list: this.state.menus, activeId: this.state.activeMenuId, onClick: this.onClickMenu })
        ));
      }
      return DOM;
    }
  }]);
  return Dropdown;
}(React.Component);

Dropdown$1.propTypes = {
  portal: propTypes.object, // 传送到DOM
  top: propTypes.number,
  disabled: propTypes.bool,
  onChange: propTypes.func,
  list: propTypes.array // [{caption: '分类', data: [{id: '1',caption: '测试数据1',children:[]}]}]
};
Dropdown$1.defaultProps = {
  list: []
};

var InputText$1 = function (_Component) {
  inherits(InputText, _Component);

  function InputText(props) {
    classCallCheck(this, InputText);

    var _this = possibleConstructorReturn(this, (InputText.__proto__ || Object.getPrototypeOf(InputText)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.disabled) return;
      if (_this.props.onClick) {
        var target = e.currentTarget.querySelector('input');
        var value = target.value;
        _this.props.onClick(value, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.correctPhone = function (value) {
      var val = value;
      // 如果输入的不是一个正整数，则转为正整数
      if (isNaN(value)) {
        var result = value.match(/[0-9]{1,}/);
        if (result) val = result[0];else val = '';
        // callback onError
        if (_this.props.onError) _this.props.onError({ msg: '必须要输入数字哦' });
      }
      return val;
    };

    _this.correctNumber = function (value) {
      if (value === '') return '';
      var num = Number(value);
      if (isNaN(num)) return '';
      // 判断是否超出限制
      var _this$props = _this.props,
          max = _this$props.max,
          min = _this$props.min;

      if (!isNaN(max) && num > max) {
        // callback onError
        if (_this.props.onError) _this.props.onError({ msg: '最大不能超过' + max });
        return '' + max;
      }
      if (!isNaN(min) && num < min) {
        // callback onError
        if (_this.props.onError) _this.props.onError({ msg: '最小不能小于' + min });
        return '' + min;
      }
      var val = value;
      // 截取小数位数
      if (_this.props.digits !== false) {
        if (String(num).indexOf('.') >= 0) val = Math.Calc.toDigits(num, _this.props.digits);
      }
      // 最大长度限制
      if (_this.props.maxLength && val && val.length > _this.props.maxLength) {
        val = val.slice(0, _this.props.maxLength);
      }
      return '' + val;
    };

    _this.preAutoSize = function () {
      _this.$input.style.height = _this.$pre.clientHeight + 'px';
    };

    _this.onChange = function (e) {
      var target = e.target;
      var value = target.value;
      var _this$props2 = _this.props,
          type = _this$props2.type,
          onChange = _this$props2.onChange;
      // 自动扩充功能

      if (_this.props.pre) {
        _this.$pre.children[0].innerText = value;
        _this.preAutoSize();
      }
      // 手机组件
      if (type === 'phone') {
        value = _this.correctPhone(value);
        if (!_this.props.valueBindProp) target.value = value;
        if (onChange) onChange(value, _this.getArgs(e));
        return;
      }
      // 数字组件
      if (type === 'number') {
        // target.validity.badInput
        value = _this.correctNumber(value.toString());
        if (!_this.props.valueBindProp) target.value = value;
        if (onChange) onChange(value, _this.getArgs(e));
      }
      // 文本框组件
      if (onChange) onChange(value, _this.getArgs(e));
    };

    _this.onClickInput = function (e) {
      var target = e.target;
      var value = target.value;
      if (_this.props.onClick) {
        _this.props.onClick(value, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onBlur = function (e) {
      var target = e.target;
      var value = target.value;
      if (_this.props.onBlur) {
        _this.props.onBlur(value, _this.getArgs(e));
      }
    };

    _this.onFocus = function (e) {
      var target = e.target;
      var value = target.value;
      if (_this.props.onFocus) {
        _this.props.onFocus(value, _this.getArgs(e));
        e.stopPropagation();
      }
      if (_this.props.readOnly) {
        target.blur();
      }
    };

    _this.onClear = function (e) {
      _this.$input.focus();
      // 赋值
      if (!_this.props.valueBindProp) _this.$input.value = '';
      if (_this.props.clear && typeof _this.props.clear !== 'boolean') _this.props.clear();
      if (_this.props.onChange) {
        _this.props.onChange('', _this.getArgs(e));
      }
      // 自动扩充功能
      if (_this.props.pre) {
        _this.preAutoSize();
      }
      e.stopPropagation();
    };

    _this.onClickLicon = function (e) {
      if (_this.props.onClickLicon) {
        _this.props.onClickLicon(_this.$input.value, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickRicon = function (e) {
      if (_this.props.onClickRicon) {
        _this.props.onClickRicon(_this.$input.value, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.getInputDOM = function () {
      var _this$props3 = _this.props,
          pre = _this$props3.pre,
          type = _this$props3.type,
          valueBindProp = _this$props3.valueBindProp,
          inputClassName = _this$props3.inputClassName,
          inputStyle = _this$props3.inputStyle,
          maxLength = _this$props3.maxLength,
          value = _this$props3.value,
          placeholder = _this$props3.placeholder,
          name = _this$props3.name,
          readOnly = _this$props3.readOnly,
          disabled = _this$props3.disabled;
      // pre类型

      if (pre) {
        // pre的左右padding
        var preLeft = 0;
        var preRight = 0;
        if (inputStyle) {
          if (inputStyle.padding) {
            var paddingValues = inputStyle.padding.split(' ');
            if (paddingValues.length === 1) {
              preLeft = paddingValues[0];
              preRight = paddingValues[0];
            } else if (paddingValues.length === 2) {
              preLeft = paddingValues[1];
              preRight = paddingValues[1];
            } else if (paddingValues.length === 4) {
              preLeft = paddingValues[1];
              preRight = paddingValues[3];
            }
          } else if (inputStyle.paddingLeft || inputStyle.paddingRight) {
            preLeft = inputStyle.paddingLeft || '0';
            preRight = inputStyle.paddingRight || '0';
          }
        }
        return React__default.createElement(
          'div',
          { className: 'input-pre-space' + (inputClassName ? ' ' + inputClassName : ''), style: inputStyle },
          valueBindProp && React__default.createElement('textarea', { ref: function ref(el) {
              _this.$input = el;
            }, value: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, className: 'input-pre', placeholder: placeholder, name: name, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus }),
          !valueBindProp && React__default.createElement('textarea', { ref: function ref(el) {
              _this.$input = el;
            }, defaultValue: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, className: 'input-pre', placeholder: placeholder, name: name, onChange: _this.onChange, onBlur: _this.onBlur, onFocus: _this.onFocus }),
          React__default.createElement(
            'pre',
            { ref: function ref(el) {
                _this.$pre = el;
              }, style: { left: preLeft, right: preRight } },
            React__default.createElement(
              'span',
              null,
              value
            )
          )
        );
      }
      // textarea类型
      if (type === 'textarea') {
        // 如果值绑定属性,则只有通过父组件的prop来改变值
        if (valueBindProp) {
          return React__default.createElement('textarea', { ref: function ref(el) {
              _this.$input = el;
            }, value: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, name: name, onChange: _this.onChange, onClick: _this.onClickInput, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-area' + (inputClassName ? ' ' + inputClassName : ''), style: inputStyle });
        }
        return React__default.createElement('textarea', { ref: function ref(el) {
            _this.$input = el;
          }, defaultValue: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, name: name, onInput: _this.onChange, onClick: _this.onClickInput, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-area' + (inputClassName ? ' ' + inputClassName : ''), style: inputStyle });
      }
      // 其它类型
      var inputType = type;
      switch (type) {
        case 'phone':
          inputType = 'tel';
          break;
        default:
          inputType = type;
      }
      // 如果值绑定属性,则只有通过父组件的prop来改变值
      if (valueBindProp) {
        return React__default.createElement('input', { ref: function ref(el) {
            _this.$input = el;
          }, type: inputType, value: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, name: name, onChange: _this.onChange, onClick: _this.onClickInput, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-text' + (inputClassName ? ' ' + inputClassName : ''), style: inputStyle });
      }
      return React__default.createElement('input', { ref: function ref(el) {
          _this.$input = el;
        }, type: inputType, defaultValue: value, maxLength: maxLength, readOnly: readOnly, disabled: disabled, placeholder: placeholder, name: name, onInput: _this.onChange, onClick: _this.onClickInput, onBlur: _this.onBlur, onFocus: _this.onFocus, className: 'input-text' + (inputClassName ? ' ' + inputClassName : ''), style: inputStyle });
    };

    _this.state = {};
    return _this;
  }
  // 点击容器

  // 手机号码纠正

  // 数字框纠正

  // 自动扩充功能

  // 文本框事件

  // 点击清除

  // 点击左右图标


  createClass(InputText, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          liconClassName = _props.liconClassName,
          value = _props.value,
          clearClassName = _props.clearClassName,
          clearIconClassName = _props.clearIconClassName,
          clear = _props.clear,
          riconClassName = _props.riconClassName,
          rcaption = _props.rcaption;

      return React__default.createElement(
        'div',
        { className: 'attribute' + (className ? ' ' + className : ''), style: style, onClick: this.onClick },
        liconClassName && React__default.createElement(Icon$1, { className: 'color-placeholder ' + liconClassName, onClick: this.onClickLicon }),
        this.getInputDOM(),
        clear && React__default.createElement(Close$1, { onClick: this.onClear, className: (clearClassName ? clearClassName : '') + ' ' + (value.length === 0 ? 'hide' : ''), iconClassName: clearIconClassName }),
        riconClassName && React__default.createElement(Icon$1, { className: 'color-placeholder ' + riconClassName, onClick: this.onClickRicon }),
        rcaption && rcaption
      );
    }
  }]);
  return InputText;
}(React.Component);

InputText$1.propTypes = {
  type: propTypes.string, // 类型: text, password
  valueBindProp: propTypes.bool, // 值是否绑定属性
  pre: propTypes.bool, // 自动扩充功能
  // 容器
  args: propTypes.any,
  style: propTypes.object,
  className: propTypes.string,
  onClick: propTypes.func,
  // 文本框
  name: propTypes.string,
  maxLength: propTypes.string,
  max: propTypes.oneOfType([// 日期或者数字框
  propTypes.string, propTypes.number]),
  min: propTypes.oneOfType([propTypes.string, propTypes.number]),
  digits: propTypes.oneOfType([propTypes.bool, propTypes.number]),
  readOnly: propTypes.bool,
  disabled: propTypes.bool,

  inputStyle: propTypes.object,
  inputClassName: propTypes.string,
  value: propTypes.string,
  placeholder: propTypes.string,
  onChange: propTypes.func,
  onClickInput: propTypes.func,
  onBlur: propTypes.func,
  onFocus: propTypes.func,
  // 左右图标
  liconClassName: propTypes.string,
  riconClassName: propTypes.string,
  onClickLicon: propTypes.func,
  onClickRicon: propTypes.func,
  // 清除按键
  clearClassName: propTypes.string,
  clearIconClassName: propTypes.string,
  clear: propTypes.oneOfType([propTypes.bool, propTypes.func]),
  // 右侧内容
  rcaption: propTypes.node
};
InputText$1.defaultProps = {
  type: 'text',
  args: null,
  value: '',
  readOnly: false,
  disabled: false,
  digits: false
};

var InputPre$1 = function (_Component) {
  inherits(InputPre, _Component);

  function InputPre(props) {
    classCallCheck(this, InputPre);
    return possibleConstructorReturn(this, (InputPre.__proto__ || Object.getPrototypeOf(InputPre)).call(this, props));
  }

  createClass(InputPre, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputText$1, _extends({ ref: '$ComponentInputText' }, this.props, { pre: true }));
    }
  }]);
  return InputPre;
}(React.Component);

// Emoji 表情管理
var Emoji$2 = {
	// 图标对应表
	icons: {
		'[微笑]': '[weixiao]',
		'[难过]': '[nanguo]',
		'[色]': '[se]',
		'[发呆]': '[fadai]',
		'[酷]': '[cool]',
		'[大哭]': '[daku]',
		'[害羞]': '[haixiu]',

		'[闭嘴]': '[bizui]',
		'[睡觉]': '[shuijiao]',
		'[哭]': '[ku]',
		'[流汗]': '[liuhan]',
		'[发怒]': '[fanu]',
		'[眨眼]': '[zhayan]',
		'[龇牙]': '[ziya]',

		'[惊讶]': '[jingya]',
		'[傲慢]': '[aoman]',
		'[得意]': '[deyi]',
		'[可怜]': '[kelian]',
		'[拜拜]': '[baibai]',
		'[开心]': '[kaixin]',
		'[呕吐]': '[outu]',
		'[奋斗]': '[fendou]',
		'[坏笑]': '[huaixiao]',
		'[尴尬]': '[ganga]',
		'[惊吓]': '[jingxia]',
		'[打哈欠]': '[dahaqian]',
		'[白眼]': '[baiyan]',
		'[鄙视]': '[bishi]',

		'[抽烟]': '[chouyan]',
		'[敲头]': '[qiaotou]',
		'[亲亲]': '[qingqing]',
		'[恭喜]': '[gongxi]',
		'[奸笑]': '[jianxiao]',
		'[骂人]': '[maren]',
		'[糗]': '[qiu]',

		'[伤心]': '[shangxin]',
		'[受委屈]': '[shouweiqu]',
		'[偷笑]': '[touxiao]',
		'[挖鼻孔]': '[wabikong]',
		'[委屈]': '[weiqu]',
		'[问]': '[wen]',
		'[擦汗]': '[cahan]',
		'[左哼哼]': '[zuohengheng]',
		'[右哼哼]': '[youhengheng]',
		'[晕]': '[yun]',
		'[大笑]': '[daxiao]',
		'[吓]': '[xia]',
		'[困]': '[kun]',
		'[嘘]': '[xu]',

		'[加油]': '[jiayou]',
		'[强]': '[qiang]',
		'[我爱你]': '[iloveyou]',
		'[差劲]': '[chajin]',
		'[No]': '[no]',
		'[Ok]': '[ok]',
		'[弱]': '[ruo]',

		'[抱拳]': '[baoquan]',
		'[握手]': '[woshou]',
		'[Yeah]': '[yeah]',
		'[来]': '[lai]',
		'[猪头]': '[zhutou]',
		'[心]': '[xin]',
		'[心碎]': '[xinsui]',
		'[抱抱]': '[baobao]',
		'[红唇]': '[hongchun]',
		'[菜刀]': '[caidao]',
		'[太阳]': '[taiyang]',
		'[夜晚]': '[yewan]',
		'[花谢了]': '[huaxiele]',

		'[蛋糕]': '[dangao]',
		'[咖啡]': '[kafei]',
		'[足球]': '[zuqiu]',
		'[骷髅]': '[kulou]',
		'[西瓜]': '[xigua]',
		'[炸弹]': '[zhadan]',
		'[篮球]': '[lanqiu]',

		'[礼物]': '[liwu]',
		'[大便]': '[dabian]',
		'[玫瑰]': '[meigui]',
		'[米饭]': '[mifan]',
		'[瓢虫]': '[piaochong]',
		'[啤酒]': '[pijiu]',
		'[闪电]': '[shandian]'
	},
	// 将文件转成图片
	parse: function parse(str) {
		var emojiExpr = /(\[[\u4E00-\u9FA5]*\])/gm;
		var parseStr = str;
		while (emojiExpr.exec(str)) {
			if (this.icons[RegExp.$1]) {
				parseStr = parseStr.replace(RegExp.$1, '<span data-emoji=' + this.icons[RegExp.$1] + '></span>');
			}
		}
		return parseStr;
	},
	// 监听位置
	cursorOffset: 0,
	$input: null,
	init: function init(elInput) {
		var _this = this;

		this.$input = elInput;
		document.onselectionchange = function (e) {
			if (Object.prototype.toString.call(e.target.activeElement) === '[object HTMLTextAreaElement]') {
				// 获得光标位置
				_this.cursorOffset = _this.$input.selectionStart;
			}
		};
		this.$input.addEventListener('input', function (e) {
			// 获得光标位置
			_this.cursorOffset = e.target.selectionStart;
		}, false);
	},
	// 插入表情文字
	insertFace: function insertFace(emojiName) {
		// 设置value
		var value = this.$input.value;
		var valueBefore = value.substr(0, this.cursorOffset);
		var valueAfter = value.substr(this.cursorOffset, value.length);
		var valueInsert = emojiName;
		this.cursorOffset = this.cursorOffset + emojiName.length;
		this.$input.value = valueBefore + valueInsert + valueAfter;
		// 设置光杆位置
		this.$input.focus();
		this.setCaretPosition(this.$input, this.cursorOffset);
		return this.$input.value;
	},
	// 设置光标位置
	setCaretPosition: function setCaretPosition(elem, caretPos) {
		if (elem !== null) {
			if (elem.createTextRange) {
				var range = elem.createTextRange();
				range.move('character', caretPos);
				range.select();
			} else {
				if (elem.selectionStart) {
					elem.focus();
					elem.setSelectionRange(caretPos, caretPos);
				} else {
					elem.focus();
				}
			}
		}
	}
};

var Dialog$3 = function (_Component) {
  inherits(Dialog, _Component);

  function Dialog(props) {
    classCallCheck(this, Dialog);

    var _this = possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (prevProps.show !== _this.props.show && _this.props.show === true && _this.$inputPre) {
        _this.$inputPre.$input.focus();
      }
    };

    _this.componentDidMount = function () {
      Emoji$2.init(_this.$inputPre.$input);
    };

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(_this.getArgs(e));
      e.stopPropagation();
    };

    _this.onSubmit = function (e) {
      if (_this.props.onSubmit) _this.props.onSubmit(_this.props.value, _this.getArgs(e));
    };

    _this.onClick = function (e) {
      var target = e.target;
      // 点击表情
      if (target.getAttribute('data-emoji')) {
        var value = Emoji$2.insertFace(target.getAttribute('alt'));
        if (_this.props.onChange) _this.props.onChange(value, _this.getArgs(e));
      }
      e.stopPropagation();
    };

    _this.getFaceDOM = function () {
      // 将icons分页
      var icons = [];
      var page = 0;
      var index = 0;
      for (var name in Emoji$2.icons) {
        if (index !== 0 && index % 21 === 0) {
          page++;
        }
        if (!icons[page]) icons[page] = [];
        icons[page].push({ key: name, value: Emoji$2.icons[name] });
        index++;
      }
      // 生成DOM
      return icons.map(function (icon, i) {
        return React__default.createElement(
          'div',
          { key: 'page' + i },
          icon.map(function (item, index) {
            return React__default.createElement(
              'a',
              { key: 'face' + index, 'data-emoji': item.value, alt: item.key },
              '\xA0'
            );
          })
        );
      });
    };

    _this.state = {
      instance: Emoji$2
    };
    return _this;
  }

  createClass(Dialog, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          value = _props.value,
          show = _props.show,
          placeholder = _props.placeholder,
          maskClassName = _props.maskClassName,
          maskStyle = _props.maskStyle,
          className = _props.className,
          style = _props.style,
          onChange = _props.onChange;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'mask emoji-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: maskStyle, onClick: this.onClickMask },
        React__default.createElement(
          'div',
          { className: 'emoji' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: style, onClick: this.onClick },
          React__default.createElement(
            Carrousel$1,
            { pagination: true, className: 'carrousel-container', style: { height: '186px' } },
            this.getFaceDOM()
          ),
          React__default.createElement(InputPre$1, {
            ref: function ref(el) {
              _this2.$inputPre = el;
            },
            className: 'emoji-input', inputClassName: 'basketline', inputStyle: { padding: '4px 8px' },
            valueBindProp: true,
            value: value,
            onChange: onChange,
            placeholder: placeholder,
            rcaption: React__default.createElement(
              Button$1,
              { className: 'link outline emoji-button', disabled: !value, onClick: this.onSubmit },
              '\u63D0\u4EA4'
            )
          })
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Dialog;
}(React.Component);

Dialog$3.propTypes = {
  portal: propTypes.object,
  args: propTypes.any,
  show: propTypes.bool,

  value: propTypes.string,
  placeholder: propTypes.string,

  isClickMaskHide: propTypes.bool,
  onClickMask: propTypes.func,

  maskClassName: propTypes.string,
  maskStyle: propTypes.object,

  className: propTypes.string,
  style: propTypes.object,

  onChange: propTypes.func,
  onSubmit: propTypes.func
};
Dialog$3.defaultProps = {
  args: null,
  placeholder: '请输入',
  isClickMaskHide: false
};

var Footer$1 = function (_Component) {
  inherits(Footer, _Component);

  function Footer(props) {
    classCallCheck(this, Footer);
    return possibleConstructorReturn(this, (Footer.__proto__ || Object.getPrototypeOf(Footer)).call(this, props));
  }

  createClass(Footer, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className;

      return React__default.createElement(
        'footer',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'footer' + (className ? ' ' + className : ''), style: style },
        this.props.children
      );
    }
  }]);
  return Footer;
}(React.Component);

Footer$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  children: propTypes.node
};

var Grid$1 = function (_Component) {
  inherits(Grid, _Component);

  function Grid(props) {
    classCallCheck(this, Grid);

    var _this = possibleConstructorReturn(this, (Grid.__proto__ || Object.getPrototypeOf(Grid)).call(this, props));

    _this.getSpaceStyle = function () {
      var _this$props = _this.props,
          className = _this$props.className,
          space = _this$props.space,
          wing = _this$props.wing;

      if (!space && !wing) return {
        ulStyle: {},
        cellStyle: {}
      };
      // 有边框的单元格
      if (className && className.hasClass('grid-bordered')) {
        return {
          ulStyle: {
            padding: '0'
          },
          cellStyle: {
            padding: space + 'px ' + wing + 'px'
          }
        };
      }
      // 无边框的单元格
      if (className && className.hasClass('between')) {
        // between对齐模式
        return {
          ulStyle: {
            padding: space / 2 + 'px 0px'
          },
          cellStyle: {
            padding: space / 2 + 'px ' + wing + 'px ' + space / 2 + 'px 0'
          }
        };
      }
      return { // around对齐模式
        ulStyle: {
          padding: space / 2 + 'px ' + wing / 2 + 'px'
        },
        cellStyle: {
          padding: space / 2 + 'px ' + wing / 2 + 'px'
        }
      };
    };

    _this.getLiStyle = function () {
      return _this.getSpaceStyle().cellStyle;
    };

    _this.getUlStyle = function () {
      return _this.getSpaceStyle().ulStyle;
    };

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClickIcon = function (e, item, index) {
      if (_this.props.onClickIcon) {
        _this.props.onClickIcon(item, index, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickContent = function (e, item, index) {
      if (_this.props.onClickContent) {
        _this.props.onClickContent(item, index, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickCell = function (e, item, index) {
      // 如果有src,说明需要预览
      if (item.src && item.preview !== false && _this.props.list) {
        var imgs = _this.props.list.map(function (n) {
          return n.src;
        });
        if (!imgs) return;
        Bridge$1.previewImage({
          urls: imgs,
          current: imgs[index] || imgs[0],
          index: index || 0
        });
        e.stopPropagation();
      }
      if (_this.props.onClickCell) {
        _this.props.onClickCell(item, index, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickDelete = function (e, item, index) {
      if (_this.props.onClickDelete) {
        _this.props.onClickDelete(item, index, _this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickAdd = function (e) {
      if (_this.props.onClickAdd) {
        _this.props.onClickAdd(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.state = {};
    return _this;
  }
  /* list: [{
    iconClassName: '',
    iconStyle: {},
    iconSrc: '',
    preview: true | false, // 是否支持预览,默认true
    thumb: '', // 缩略图
    src: '', // 预览地址
    caption: '',
    onClick: function() {},
    iconBadgeCaption: '',
    showClose: false
  }] */


  createClass(Grid, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          col = _props.col,
          list = _props.list,
          cellClassName = _props.cellClassName,
          cellStyle = _props.cellStyle,
          contentClassName = _props.contentClassName,
          contentStyle = _props.contentStyle,
          iconClassName = _props.iconClassName,
          iconStyle = _props.iconStyle,
          lazyLoad = _props.lazyLoad,
          iconBadgeClassName = _props.iconBadgeClassName,
          closeClassName = _props.closeClassName,
          onClickDelete = _props.onClickDelete,
          captionClassName = _props.captionClassName,
          captionStyle = _props.captionStyle,
          sndcaptionClassName = _props.sndcaptionClassName,
          sndcaptionStyle = _props.sndcaptionStyle,
          showUpload = _props.showUpload;

      var children = React__default.Children.toArray(this.props.children);
      var dom = null;
      dom = React__default.createElement(
        'ul',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'grid' + (className ? ' ' + className : ''), 'data-col': col, style: Object.assign(this.getUlStyle(), style) },
        list.length > 0 && list.map(function (item, index) {
          if (!item) return null;
          return React__default.createElement(
            'li',
            { onClick: function onClick(e) {
                _this2.onClickCell(e, item, index);
              }, key: index, className: 'grid-cell' + (cellClassName ? ' ' + cellClassName : ''), style: Object.assign({}, _this2.getLiStyle(), cellStyle) },
            React__default.createElement(
              'a',
              { onClick: function onClick(e) {
                  _this2.onClickContent(e, item, index);
                }, className: 'grid-iconbox' + (contentClassName ? ' ' + contentClassName : '') + (item.className ? ' ' + item.className : ''), style: Object.assign(contentStyle ? contentStyle : {}, item.style ? item.style : {}) },
              (item.iconSrc || item.iconClassName) && React__default.createElement(Icon$1, { badgeClassName: iconBadgeClassName, badgeCaption: item.iconBadgeCaption, onClick: function onClick(e) {
                  _this2.onClickIcon(e, item, index);
                }, lazyLoad: lazyLoad, className: 'grid-icon' + (iconClassName ? ' ' + iconClassName : '') + (item.iconClassName ? ' ' + item.iconClassName : ''), style: Object.assign(iconStyle, item.iconStyle ? item.iconStyle : {}), src: item.iconSrc ? item.iconSrc : '' }),
              item.thumb && React__default.createElement('img', { alt: '', src: item.thumb, onClick: function onClick(e) {
                  _this2.onClickIcon(e, item, index);
                } }),
              onClickDelete && React__default.createElement(Close$1, { onClick: function onClick(e) {
                  _this2.onClickDelete(e, item, index);
                }, className: 'grid-close' + (closeClassName ? ' ' + closeClassName : ''), iconClassName: 'close-icon-clear color-cancel' })
            ),
            item.caption && React__default.createElement(
              'label',
              { className: 'grid-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
              item.caption
            ),
            item.sndcaption && React__default.createElement(
              'label',
              { className: 'grid-sndcaption' + (sndcaptionClassName ? ' ' + sndcaptionClassName : ''), style: sndcaptionStyle },
              item.sndcaption
            )
          );
        }),
        showUpload === true && React__default.createElement(
          'li',
          { className: 'grid-cell', style: this.getLiStyle() },
          React__default.createElement(
            'a',
            { onClick: function onClick(e) {
                _this2.onClickAdd(e);
              }, className: 'grid-iconbox grid-iconbox-add' + (contentClassName ? ' ' + contentClassName : ''), style: contentStyle },
            React__default.createElement(Icon$1, { className: 'grid-icon-add' })
          )
        ),
        children.length > 0 && children.map(function (item, index) {
          if (!item) return null;
          return React__default.createElement(
            'li',
            { key: index, className: 'grid-cell' + (cellClassName ? ' ' + cellClassName : ''), style: Object.assign({}, _this2.getLiStyle(), cellStyle) },
            item
          );
        })
      );
      return dom;
    }
  }]);
  return Grid;
}(React.Component);

Grid$1.propTypes = {
  args: propTypes.any,
  lazyLoad: propTypes.bool, // 图标是否懒人加载
  style: propTypes.object,
  className: propTypes.string, // grid-album | grid-bordered
  space: propTypes.number, // 上下间距
  wing: propTypes.number, // 左右间距
  col: propTypes.string, // 一行列数
  showUpload: propTypes.bool,
  list: propTypes.array, // 单元格，见下方示例
  children: propTypes.node, // 也可以直接放子元素，grid将自动排列

  cellClassName: propTypes.string, // 单元格Class
  cellStyle: propTypes.object, // 单元格Style

  caption: propTypes.node,
  captionClassName: propTypes.string,
  captionStyle: propTypes.object,

  sndcaption: propTypes.node,
  sndcaptionClassName: propTypes.string,
  sndcaptionStyle: propTypes.object,

  contentClassName: propTypes.string, // 单元格内容Class
  contentStyle: propTypes.object, // 单元格内容Style

  iconClassName: propTypes.string,
  iconStyle: propTypes.object,

  badgeClassName: propTypes.string,

  onClick: propTypes.func,
  onClickCell: propTypes.func,
  onClickContent: propTypes.func,
  onClickIcon: propTypes.func,
  onClickDelete: propTypes.func,
  onClickAdd: propTypes.func };
Grid$1.defaultProps = {
  list: [],
  args: null,
  iconStyle: {},
  space: 0,
  wing: 0,
  col: '3'
};

var Group$1 = function (_Component) {
  inherits(Group, _Component);

  function Group(props) {
    classCallCheck(this, Group);

    var _this = possibleConstructorReturn(this, (Group.__proto__ || Object.getPrototypeOf(Group)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.onClick) _this.props.onClick(_this.getArgs(e));
    };

    _this.state = {};
    return _this;
  }

  createClass(Group, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          children = _props.children,
          style = _props.style,
          className = _props.className;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'group' + (className ? ' ' + className : ''), style: style, onClick: this.onClick },
        children
      );
    }
  }]);
  return Group;
}(React.Component);

Group$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  children: propTypes.node,
  onClick: propTypes.func
};

var Handsign$3 = function Handsign(container, params) {
  /* ----------------------
  Model
  ---------------------- */
  var defaults = {
    strokeStyle: '#000',
    lineWidth: 3,

    suffix: 'image/png',
    quality: 0.92
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  s.container = typeof container === 'string' ? document.querySelector(container) : container;
  if (!s.container) {
    console.log('SeedsUI Error : HandSign container不存在，请检查页面中是否有此元素');
    return;
  }
  s.width = s.container.width;
  s.height = s.container.height;
  s.ctx = s.container.getContext('2d');
  s.stage_info = s.container.getBoundingClientRect();
  s.path = {
    beginX: 0,
    beginY: 0,
    endX: 0,
    endY: 0
    /* ----------------------
    Events
    ---------------------- */
  };s.preventDefault = function (e) {
    e.preventDefault();
  };
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    s.container[action]('touchstart', s.onTouchStart, false);
    s.container[action]('touchmove', s.onTouchMove, false);
    s.container[action]('touchend', s.onTouchEnd, false);
    s.container[action]('touchcancel', s.onTouchEnd, false);
  };
  // attach、detach事件
  s.attach = function () {
    s.events();
  };
  s.detach = function () {
    s.events(true);
  };
  s.onTouchStart = function (e) {
    s.container.addEventListener('touchmove', s.preventDefault, false);
    window.getSelection() ? window.getSelection().removeAllRanges() : document.selection.empty();
    s.ctx.strokeStyle = s.params.strokeStyle;
    s.ctx.lineWidth = s.params.lineWidth;
    s.ctx.beginPath();
    s.ctx.moveTo(e.changedTouches[0].clientX - s.stage_info.left, e.changedTouches[0].clientY - s.stage_info.top);
    s.path.beginX = e.changedTouches[0].clientX - s.stage_info.left;
    s.path.beginY = e.changedTouches[0].clientY - s.stage_info.top;
  };
  s.onTouchMove = function (e) {
    s.ctx.lineTo(e.changedTouches[0].clientX - s.stage_info.left, e.changedTouches[0].clientY - s.stage_info.top);
    s.path.endX = e.changedTouches[0].clientX - s.stage_info.left;
    s.path.endY = e.changedTouches[0].clientY - s.stage_info.top;
    s.ctx.stroke();
  };
  s.onTouchEnd = function (e) {
    s.container.removeEventListener('touchmove', s.preventDefault, false);
  };
  /* ----------------------
  Method
  ---------------------- */
  // 获取设备缩放比率
  s.getPixelRatio = function () {
    var context = s.ctx;
    var backingStore = context.backingStorePixelRatio || context.webkitBackingStorePixelRatio || context.mozBackingStorePixelRatio || context.msBackingStorePixelRatio || context.oBackingStorePixelRatio || context.backingStorePixelRatio || 1;
    return (window.devicePixelRatio || 1) / backingStore;
  };
  // 清除签名
  s.clear = function () {
    s.ctx.clearRect(0, 0, s.width, s.height);
  };
  // 是否画过
  s.isDrew = function () {
    var blank = document.createElement('canvas');
    blank.width = s.container.width;
    blank.height = s.container.height;
    if (s.container.toDataURL() === blank.toDataURL()) return false;
    return true;
  };
  // 保存签名
  s.save = function () {
    // 如果已经画过了,则返回base64,如果没有画过,则返回空
    if (s.isDrew()) {
      return s.container.toDataURL(s.params.suffix, s.params.quality);
    } else {
      return '';
    }
  };
  // 计算top left bottom center的位置
  s.calcPosition = function (w, h, pos) {
    var posArr = pos.split(' ').map(function (item, index) {
      var x = 0;
      var y = 0;
      // 如果是数字
      if (!isNaN(item)) {
        if (index === 0) return { x: item };
        if (index === 1) return { y: item };
      }
      // 如果是字符串
      if (item === 'top') return { y: 0 };
      if (item === 'left') return { x: 0 };
      if (item === 'right') {
        x = s.width < w ? 0 : s.width - w;
        return { x: x };
      }
      if (item === 'bottom') {
        y = s.height < h ? 0 : s.height - h;
        return { y: y };
      }
      if (item === 'center') {
        x = (s.width - w) / 2;
        return { x: x };
      }
      if (item === 'middle') {
        y = (s.height - h) / 2;
        return { y: y };
      }
      return { x: 0, y: 0 };
    });
    var posJson = {
      x: 0,
      y: 0
    };
    posArr.forEach(function (item) {
      if (item.x) {
        posJson.x = item.x;
      } else if (item.y) {
        posJson.y = item.y;
      }
    });
    return {
      x: posJson.x || 0,
      y: posJson.y || 0
    };
  };
  // 绘制图片
  s.drawImg = function (imgSrc, opts) {
    if (!imgSrc) {
      console.log('SeedsUI Error:手写签名drawImg缺少imgSrc');
      return;
    }
    var imgW = opts.width || 100;
    var imgH = opts.height || 100;
    var imgP = opts.position || 'bottom right';

    var img = new Image();
    img.crossOrigin = 'Anonymous';
    img.src = imgSrc;
    img.onload = function () {
      var sx = 0; // 剪切的 x 坐标
      var sy = 0; // 剪切的 y 坐标
      var width = imgW || img.width; // 使用的图像宽度
      var height = imgH || img.height; // 使用的图像高度
      var swidth = img.width; // 剪切图像的宽度
      var sheight = img.height; // 剪切图像的高度
      var pos = s.calcPosition(width, height, imgP); // 画布上放置xy坐标
      s.ctx.drawImage(img, sx, sy, swidth, sheight, pos.x, pos.y, width, height);
      // 成功回调
      if (opts.onSuccess) opts.onSuccess();
    };
  };
  // 绘制文字
  s.drawFont = function (text, opts) {
    if (!text) {
      console.log('SeedsUI Error:手写签名drawFont缺少文字');
      return;
    }
    var fontSize = opts.fontSize || 15;
    var fontFamily = opts.fontFamily || 'microsoft yahei';
    var fontPosition = opts.position || 'bottom center';
    var fontStyle = opts.color || 'rgba(0, 0, 0, 1)';
    if (isNaN(fontSize)) {
      console.log('SeedsUI Error:文字大小请输入数字类型');
      return;
    }
    var height = fontSize;
    var width = text.length * height;
    var pos = s.calcPosition(width, height, fontPosition); // 画布上放置xy坐标
    var calcY = pos.y === 0 ? Number(pos.y) + Number(height) : Number(pos.y) + Number(height) - 5; // 文字垂直位置有整个高度的偏差
    // 写字
    s.ctx.font = fontSize + 'px ' + fontFamily;
    s.ctx.fillStyle = fontStyle;
    s.ctx.fillText(text, pos.x, calcY);
  };
  // 主函数
  s.init = function () {
    s.attach();
  };

  s.init();
};

var Handsign$1 = function (_Component) {
  inherits(Handsign, _Component);

  function Handsign(props) {
    classCallCheck(this, Handsign);

    var _this = possibleConstructorReturn(this, (Handsign.__proto__ || Object.getPrototypeOf(Handsign)).call(this, props));

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(Handsign, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.instance) return;
      var instance = new Handsign$3(this.$el, {
        strokeStyle: this.props.strokeStyle,
        lineWidth: this.props.lineWidth,
        quality: this.props.quality
      });
      this.setState({
        instance: instance
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          width = _props.width,
          height = _props.height,
          style = _props.style,
          className = _props.className;

      return React__default.createElement(
        'canvas',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: className, style: style, width: width, height: height },
        'Canvas\u753B\u677F'
      );
    }
  }]);
  return Handsign;
}(React.Component);

Handsign$1.propTypes = {
  strokeStyle: propTypes.string,
  lineWidth: propTypes.number,
  quality: propTypes.number,
  // 不能使用style制定宽高,canvas用style的width|height会导致绘图位置不正确
  width: propTypes.number, // 宽度
  height: propTypes.number, // 高度
  style: propTypes.object,
  className: propTypes.string
};
Handsign$1.defaultProps = {
  strokeStyle: '#000',
  lineWidth: 3,
  quality: 0.92,
  width: 300,
  height: 300
};

var Header$1 = function (_Component) {
  inherits(Header, _Component);

  function Header(props) {
    classCallCheck(this, Header);

    var _this = possibleConstructorReturn(this, (Header.__proto__ || Object.getPrototypeOf(Header)).call(this, props));

    _this.state = {};
    return _this;
  }

  createClass(Header, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className;

      return React__default.createElement(
        'header',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'header' + (className ? ' ' + className : ''), style: style },
        this.props.children
      );
    }
  }]);
  return Header;
}(React.Component);

Header$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  children: propTypes.node
};

var ImgLazy$2 = function (_Component) {
  inherits(ImgLazy$$1, _Component);

  function ImgLazy$$1(props) {
    classCallCheck(this, ImgLazy$$1);

    var _this = possibleConstructorReturn(this, (ImgLazy$$1.__proto__ || Object.getPrototypeOf(ImgLazy$$1)).call(this, props));

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(ImgLazy$$1, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.state.instance) return;
      var instance = new ImgLazy({
        overflowContainer: this.$el
      });
      this.setState({
        instance: instance
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          children = _props.children;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: className, style: style },
        children
      );
    }
  }]);
  return ImgLazy$$1;
}(React.Component);

ImgLazy$2.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  children: propTypes.node
};

var Count = {
  fontSize: '12px',
  color: '#999',
  verticalAlign: '0',
  marginLeft: '4px'
};

var ImgUploader$1 = function (_Component) {
  inherits(ImgUploader, _Component);

  function ImgUploader(props) {
    classCallCheck(this, ImgUploader);

    var _this = possibleConstructorReturn(this, (ImgUploader.__proto__ || Object.getPrototypeOf(ImgUploader)).call(this, props));

    _this.componentDidMount = function () {
      // 初始化图片组件
      _this.setState({
        instance: new Bridge$1.Image({
          onChooseSuccess: _this.onChooseSuccess,
          onUploadsSuccess: _this.onUploadsSuccess,
          onUploadFail: _this.onUploadFail
        })
      });
    };

    _this.convertList = function (imgMap) {
      var list = [];
      if (Bridge$1.platform === 'waiqin') {
        for (var img in imgMap) {
          list.push({
            id: img, // 外勤客户端中,id就是name
            src: imgMap[img].src,
            thumb: imgMap[img].base64,
            sourceType: imgMap[img].sourceType,
            name: img,
            base64: imgMap[img].path
          });
        }
      } else if (Bridge$1.platform === 'dinghuo') {
        for (var _img in imgMap) {
          list.push({
            id: _img,
            src: 'LocalResource://imageid' + _img,
            thumb: 'LocalResource://imageid' + _img,
            sourceType: imgMap[_img].sourceType
          });
        }
      } else if (Bridge$1.platform === 'weixin') {
        for (var _img2 in imgMap) {
          list.push({
            id: _img2,
            src: _img2,
            thumb: _img2,
            sourceType: imgMap[_img2].sourceType,
            serverId: imgMap[_img2].serverId
          });
        }
      } else {
        // browser测试
        for (var _img3 in imgMap) {
          list.push({
            id: _img3,
            src: _img3,
            thumb: _img3,
            sourceType: imgMap[_img3].sourceType,
            serverId: imgMap[_img3].serverId
          });
        }
      }
      return list;
    };

    _this.onChange = function (imgMap) {
      var currentList = _this.convertList(imgMap);
      // 过滤原有list中和现在list中相同的图片
      var prevList = _this.props.list.filter(function (item) {
        var _iteratorNormalCompletion = true;
        var _didIteratorError = false;
        var _iteratorError = undefined;

        try {
          for (var _iterator = currentList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
            var current = _step.value;

            if (current.id === item.id) return false;
          }
        } catch (err) {
          _didIteratorError = true;
          _iteratorError = err;
        } finally {
          try {
            if (!_iteratorNormalCompletion && _iterator.return) {
              _iterator.return();
            }
          } finally {
            if (_didIteratorError) {
              throw _iteratorError;
            }
          }
        }

        return true;
      });
      var list = currentList.concat(prevList);
      // 显示和隐藏添加按钮
      if (list.length >= _this.props.max) {
        _this.setState({
          showUpload: false
        });
      } else {
        _this.setState({
          showUpload: true
        });
      }
      // 设置数量
      _this.setState({
        count: list.length
      });
      // Callback
      if (_this.props.onChange) _this.props.onChange(list);
    };

    _this.onChooseSuccess = function (imgMap) {
      _this.onChange(imgMap);
    };

    _this.onUploadFail = function (index) {
      // 删除上传错误的一项
      var list = Object.clone(_this.props.list);
      list.splice(index, 1);
      // Callback
      if (_this.props.onChange) _this.props.onChange(list);
      // 上传失败,则重新鉴权
      Bridge$1.config({
        onError: function onError(res) {
          Bridge$1.showToast(res.msg, { mask: false });
        }
      });
    };

    _this.onUploadsSuccess = function (imgMap) {
      _this.onChange(imgMap);
    };

    _this.chooseImg = function () {
      var _this$props = _this.props,
          enableSafe = _this$props.enableSafe,
          max = _this$props.max,
          sourceType = _this$props.sourceType,
          sizeType = _this$props.sizeType,
          watermark = _this$props.watermark;

      _this.state.instance.choose({
        enableSafe: enableSafe, // 安全上传,第次只能传一张
        max: max,
        currentCount: _this.props.list.length,
        sourceType: sourceType,
        sizeType: sizeType,
        watermark: watermark
      });
    };

    _this.deleteImg = function (item) {
      var list = _this.props.list.filter(function (photo) {
        if (photo.id === item.id) return false;
        return true;
      });
      _this.setState({
        count: list.length
      });
      // Callback
      if (_this.props.onChange) _this.props.onChange(list);
    };

    _this.state = {
      instance: null,
      count: 0, // 剩余可上传数量
      showUpload: true
    };
    return _this;
  }

  createClass(ImgUploader, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          list = _props.list,
          className = _props.className,
          style = _props.style,
          caption = _props.caption,
          captionClassName = _props.captionClassName,
          captionStyle = _props.captionStyle,
          max = _props.max,
          showCount = _props.showCount,
          showDelete = _props.showDelete;

      return [caption && React__default.createElement(
        'div',
        { key: 'iuCaption', className: 'grid-title' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
        caption,
        showCount ? React__default.createElement(
          'span',
          { style: Count },
          '(',
          this.state.count,
          '/',
          max,
          ')'
        ) : null
      ), React__default.createElement(Grid$1, { onClickDelete: this.props.showDelete ? this.deleteImg : null, onClickAdd: this.chooseImg, list: list, showUpload: this.state.showUpload && this.props.showUpload, showDelete: showDelete, key: 'iuGrid', className: 'grid-album' + (className ? ' ' + className : ''), wing: 12, space: 12, style: style })];
    }
  }]);
  return ImgUploader;
}(React.Component);

ImgUploader$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,
  caption: propTypes.node,
  captionStyle: propTypes.object,
  captionClassName: propTypes.string,
  list: propTypes.array,

  enableSafe: propTypes.bool,
  max: propTypes.number,
  sourceType: propTypes.array,
  sizeType: propTypes.array,

  showUpload: propTypes.bool, // 显示上传按钮
  showDelete: propTypes.bool, // 显示删除按钮
  readOnly: propTypes.bool,

  showCount: propTypes.bool, // 标题显示图片张字
  watermark: propTypes.object, // 增加水印

  onChange: propTypes.func // 照片发生变化
};
ImgUploader$1.defaultProps = {
  enableSafe: false, // 安全上传,第次只能传一张
  max: 5,
  sourceType: ['album', 'camera'],
  sizeType: ['compressed'], // ['original', 'compressed']
  list: [], // 格式[{id: '用于删除标识,订货和微信上传的值', src: '预览地址,外勤客户端上传的地址', thumb: '缩略图'}]
  showUpload: false,
  showDelete: false
};

var InputArea$1 = function (_Component) {
  inherits(InputArea, _Component);

  function InputArea(props) {
    classCallCheck(this, InputArea);
    return possibleConstructorReturn(this, (InputArea.__proto__ || Object.getPrototypeOf(InputArea)).call(this, props));
  }

  createClass(InputArea, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputText$1, _extends({ ref: '$ComponentInputText' }, this.props, { type: 'textarea' }));
    }
  }]);
  return InputArea;
}(React.Component);

var citys = [{
  "value": "北京",
  "children": [{
    "value": "东城区",
    "key": "110101"
  }, {
    "value": "西城区",
    "key": "110102"
  }, {
    "value": "崇文区",
    "key": "110103"
  }, {
    "value": "宣武区",
    "key": "110104"
  }, {
    "value": "朝阳区",
    "key": "110105"
  }, {
    "value": "丰台区",
    "key": "110106"
  }, {
    "value": "石景山区",
    "key": "110107"
  }, {
    "value": "海淀区",
    "key": "110108"
  }, {
    "value": "门头沟区",
    "key": "110109"
  }, {
    "value": "房山区",
    "key": "110111"
  }, {
    "value": "通州区",
    "key": "110112"
  }, {
    "value": "顺义区",
    "key": "110113"
  }, {
    "value": "昌平区",
    "key": "110114"
  }, {
    "value": "大兴区",
    "key": "110115"
  }, {
    "value": "怀柔区",
    "key": "110116"
  }, {
    "value": "平谷区",
    "key": "110117"
  }, {
    "value": "密云县",
    "key": "110228"
  }, {
    "value": "延庆县",
    "key": "110229"
  }],
  "key": "110000"
}, {
  "value": "天津",
  "children": [{
    "value": "和平区",
    "key": "120101"
  }, {
    "value": "河东区",
    "key": "120102"
  }, {
    "value": "河西区",
    "key": "120103"
  }, {
    "value": "南开区",
    "key": "120104"
  }, {
    "value": "河北区",
    "key": "120105"
  }, {
    "value": "红桥区",
    "key": "120106"
  }, {
    "value": "塘沽区",
    "key": "120107"
  }, {
    "value": "汉沽区",
    "key": "120108"
  }, {
    "value": "大港区",
    "key": "120109"
  }, {
    "value": "东丽区",
    "key": "120110"
  }, {
    "value": "西青区",
    "key": "120111"
  }, {
    "value": "津南区",
    "key": "120112"
  }, {
    "value": "北辰区",
    "key": "120113"
  }, {
    "value": "武清区",
    "key": "120114"
  }, {
    "value": "宝坻区",
    "key": "120115"
  }, {
    "value": "滨海新区",
    "key": "120116"
  }, {
    "value": "宁河县",
    "key": "120221"
  }, {
    "value": "静海县",
    "key": "120223"
  }, {
    "value": "蓟县",
    "key": "120225"
  }],
  "key": "120000"
}, {
  "value": "河北",
  "children": [{
    "value": "石家庄市",
    "children": [{
      "value": "长安区",
      "key": "130102"
    }, {
      "value": "桥东区",
      "key": "130103"
    }, {
      "value": "桥西区",
      "key": "130104"
    }, {
      "value": "新华区",
      "key": "130105"
    }, {
      "value": "井陉矿区",
      "key": "130107"
    }, {
      "value": "裕华区",
      "key": "130108"
    }, {
      "value": "井陉县",
      "key": "130121"
    }, {
      "value": "正定县",
      "key": "130123"
    }, {
      "value": "栾城县",
      "key": "130124"
    }, {
      "value": "行唐县",
      "key": "130125"
    }, {
      "value": "灵寿县",
      "key": "130126"
    }, {
      "value": "高邑县",
      "key": "130127"
    }, {
      "value": "深泽县",
      "key": "130128"
    }, {
      "value": "赞皇县",
      "key": "130129"
    }, {
      "value": "无极县",
      "key": "130130"
    }, {
      "value": "平山县",
      "key": "130131"
    }, {
      "value": "元氏县",
      "key": "130132"
    }, {
      "value": "赵县",
      "key": "130133"
    }, {
      "value": "辛集市",
      "key": "130181"
    }, {
      "value": "藁城市",
      "key": "130182"
    }, {
      "value": "晋州市",
      "key": "130183"
    }, {
      "value": "新乐市",
      "key": "130184"
    }, {
      "value": "鹿泉市",
      "key": "130185"
    }],
    "key": "130100"
  }, {
    "value": "唐山市",
    "children": [{
      "value": "路南区",
      "key": "130202"
    }, {
      "value": "路北区",
      "key": "130203"
    }, {
      "value": "古冶区",
      "key": "130204"
    }, {
      "value": "开平区",
      "key": "130205"
    }, {
      "value": "丰南区",
      "key": "130207"
    }, {
      "value": "丰润区",
      "key": "130208"
    }, {
      "value": "曹妃甸区",
      "key": "130209"
    }, {
      "value": "滦县",
      "key": "130223"
    }, {
      "value": "滦南县",
      "key": "130224"
    }, {
      "value": "乐亭县",
      "key": "130225"
    }, {
      "value": "迁西县",
      "key": "130227"
    }, {
      "value": "玉田县",
      "key": "130229"
    }, {
      "value": "遵化市",
      "key": "130281"
    }, {
      "value": "迁安市",
      "key": "130283"
    }],
    "key": "130200"
  }, {
    "value": "秦皇岛市",
    "children": [{
      "value": "海港区",
      "key": "130302"
    }, {
      "value": "山海关区",
      "key": "130303"
    }, {
      "value": "北戴河区",
      "key": "130304"
    }, {
      "value": "青龙满族自治县",
      "key": "130321"
    }, {
      "value": "昌黎县",
      "key": "130322"
    }, {
      "value": "抚宁县",
      "key": "130323"
    }, {
      "value": "卢龙县",
      "key": "130324"
    }],
    "key": "130300"
  }, {
    "value": "邯郸市",
    "children": [{
      "value": "邯山区",
      "key": "130402"
    }, {
      "value": "丛台区",
      "key": "130403"
    }, {
      "value": "复兴区",
      "key": "130404"
    }, {
      "value": "峰峰矿区",
      "key": "130406"
    }, {
      "value": "邯郸县",
      "key": "130421"
    }, {
      "value": "临漳县",
      "key": "130423"
    }, {
      "value": "成安县",
      "key": "130424"
    }, {
      "value": "大名县",
      "key": "130425"
    }, {
      "value": "涉县",
      "key": "130426"
    }, {
      "value": "磁县",
      "key": "130427"
    }, {
      "value": "肥乡县",
      "key": "130428"
    }, {
      "value": "永年县",
      "key": "130429"
    }, {
      "value": "邱县",
      "key": "130430"
    }, {
      "value": "鸡泽县",
      "key": "130431"
    }, {
      "value": "广平县",
      "key": "130432"
    }, {
      "value": "馆陶县",
      "key": "130433"
    }, {
      "value": "魏县",
      "key": "130434"
    }, {
      "value": "曲周县",
      "key": "130435"
    }, {
      "value": "武安市",
      "key": "130481"
    }],
    "key": "130400"
  }, {
    "value": "邢台市",
    "children": [{
      "value": "桥东区",
      "key": "130502"
    }, {
      "value": "桥西区",
      "key": "130503"
    }, {
      "value": "邢台县",
      "key": "130521"
    }, {
      "value": "临城县",
      "key": "130522"
    }, {
      "value": "内丘县",
      "key": "130523"
    }, {
      "value": "柏乡县",
      "key": "130524"
    }, {
      "value": "隆尧县",
      "key": "130525"
    }, {
      "value": "任县",
      "key": "130526"
    }, {
      "value": "南和县",
      "key": "130527"
    }, {
      "value": "宁晋县",
      "key": "130528"
    }, {
      "value": "巨鹿县",
      "key": "130529"
    }, {
      "value": "新河县",
      "key": "130530"
    }, {
      "value": "广宗县",
      "key": "130531"
    }, {
      "value": "平乡县",
      "key": "130532"
    }, {
      "value": "威县",
      "key": "130533"
    }, {
      "value": "清河县",
      "key": "130534"
    }, {
      "value": "临西县",
      "key": "130535"
    }, {
      "value": "南宫市",
      "key": "130581"
    }, {
      "value": "沙河市",
      "key": "130582"
    }],
    "key": "130500"
  }, {
    "value": "保定市",
    "children": [{
      "value": "新市区",
      "key": "130602"
    }, {
      "value": "北市区",
      "key": "130603"
    }, {
      "value": "南市区",
      "key": "130604"
    }, {
      "value": "满城县",
      "key": "130621"
    }, {
      "value": "清苑县",
      "key": "130622"
    }, {
      "value": "涞水县",
      "key": "130623"
    }, {
      "value": "阜平县",
      "key": "130624"
    }, {
      "value": "徐水县",
      "key": "130625"
    }, {
      "value": "定兴县",
      "key": "130626"
    }, {
      "value": "唐县",
      "key": "130627"
    }, {
      "value": "高阳县",
      "key": "130628"
    }, {
      "value": "容城县",
      "key": "130629"
    }, {
      "value": "涞源县",
      "key": "130630"
    }, {
      "value": "望都县",
      "key": "130631"
    }, {
      "value": "安新县",
      "key": "130632"
    }, {
      "value": "易县",
      "key": "130633"
    }, {
      "value": "曲阳县",
      "key": "130634"
    }, {
      "value": "蠡县",
      "key": "130635"
    }, {
      "value": "顺平县",
      "key": "130636"
    }, {
      "value": "博野县",
      "key": "130637"
    }, {
      "value": "雄县",
      "key": "130638"
    }, {
      "value": "涿州市",
      "key": "130681"
    }, {
      "value": "定州市",
      "key": "130682"
    }, {
      "value": "安国市",
      "key": "130683"
    }, {
      "value": "高碑店市",
      "key": "130684"
    }],
    "key": "130600"
  }, {
    "value": "张家口市",
    "children": [{
      "value": "桥东区",
      "key": "130702"
    }, {
      "value": "桥西区",
      "key": "130703"
    }, {
      "value": "宣化区",
      "key": "130705"
    }, {
      "value": "下花园区",
      "key": "130706"
    }, {
      "value": "宣化县",
      "key": "130721"
    }, {
      "value": "张北县",
      "key": "130722"
    }, {
      "value": "康保县",
      "key": "130723"
    }, {
      "value": "沽源县",
      "key": "130724"
    }, {
      "value": "尚义县",
      "key": "130725"
    }, {
      "value": "蔚县",
      "key": "130726"
    }, {
      "value": "阳原县",
      "key": "130727"
    }, {
      "value": "怀安县",
      "key": "130728"
    }, {
      "value": "万全县",
      "key": "130729"
    }, {
      "value": "怀来县",
      "key": "130730"
    }, {
      "value": "涿鹿县",
      "key": "130731"
    }, {
      "value": "赤城县",
      "key": "130732"
    }, {
      "value": "崇礼县",
      "key": "130733"
    }],
    "key": "130700"
  }, {
    "value": "承德市",
    "children": [{
      "value": "双桥区",
      "key": "130802"
    }, {
      "value": "双滦区",
      "key": "130803"
    }, {
      "value": "鹰手营子矿区",
      "key": "130804"
    }, {
      "value": "承德县",
      "key": "130821"
    }, {
      "value": "兴隆县",
      "key": "130822"
    }, {
      "value": "平泉县",
      "key": "130823"
    }, {
      "value": "滦平县",
      "key": "130824"
    }, {
      "value": "隆化县",
      "key": "130825"
    }, {
      "value": "丰宁满族自治县",
      "key": "130826"
    }, {
      "value": "宽城满族自治县",
      "key": "130827"
    }, {
      "value": "围场满族蒙古族自治县",
      "key": "130828"
    }],
    "key": "130800"
  }, {
    "value": "沧州市",
    "children": [{
      "value": "新华区",
      "key": "130902"
    }, {
      "value": "运河区",
      "key": "130903"
    }, {
      "value": "沧县",
      "key": "130921"
    }, {
      "value": "青县",
      "key": "130922"
    }, {
      "value": "东光县",
      "key": "130923"
    }, {
      "value": "海兴县",
      "key": "130924"
    }, {
      "value": "盐山县",
      "key": "130925"
    }, {
      "value": "肃宁县",
      "key": "130926"
    }, {
      "value": "南皮县",
      "key": "130927"
    }, {
      "value": "吴桥县",
      "key": "130928"
    }, {
      "value": "献县",
      "key": "130929"
    }, {
      "value": "孟村回族自治县",
      "key": "130930"
    }, {
      "value": "泊头市",
      "key": "130981"
    }, {
      "value": "任丘市",
      "key": "130982"
    }, {
      "value": "黄骅市",
      "key": "130983"
    }, {
      "value": "河间市",
      "key": "130984"
    }],
    "key": "130900"
  }, {
    "value": "廊坊市",
    "children": [{
      "value": "安次区",
      "key": "131002"
    }, {
      "value": "广阳区",
      "key": "131003"
    }, {
      "value": "固安县",
      "key": "131022"
    }, {
      "value": "永清县",
      "key": "131023"
    }, {
      "value": "香河县",
      "key": "131024"
    }, {
      "value": "大城县",
      "key": "131025"
    }, {
      "value": "文安县",
      "key": "131026"
    }, {
      "value": "大厂回族自治县",
      "key": "131028"
    }, {
      "value": "霸州市",
      "key": "131081"
    }, {
      "value": "三河市",
      "key": "131082"
    }],
    "key": "131000"
  }, {
    "value": "衡水市",
    "children": [{
      "value": "桃城区",
      "key": "131102"
    }, {
      "value": "枣强县",
      "key": "131121"
    }, {
      "value": "武邑县",
      "key": "131122"
    }, {
      "value": "武强县",
      "key": "131123"
    }, {
      "value": "饶阳县",
      "key": "131124"
    }, {
      "value": "安平县",
      "key": "131125"
    }, {
      "value": "故城县",
      "key": "131126"
    }, {
      "value": "景县",
      "key": "131127"
    }, {
      "value": "阜城县",
      "key": "131128"
    }, {
      "value": "冀州市",
      "key": "131181"
    }, {
      "value": "深州市",
      "key": "131182"
    }],
    "key": "131100"
  }],
  "key": "130000"
}, {
  "value": "山西",
  "children": [{
    "value": "太原市",
    "children": [{
      "value": "小店区",
      "key": "140105"
    }, {
      "value": "迎泽区",
      "key": "140106"
    }, {
      "value": "杏花岭区",
      "key": "140107"
    }, {
      "value": "尖草坪区",
      "key": "140108"
    }, {
      "value": "万柏林区",
      "key": "140109"
    }, {
      "value": "晋源区",
      "key": "140110"
    }, {
      "value": "清徐县",
      "key": "140121"
    }, {
      "value": "阳曲县",
      "key": "140122"
    }, {
      "value": "娄烦县",
      "key": "140123"
    }, {
      "value": "古交市",
      "key": "140181"
    }],
    "key": "140100"
  }, {
    "value": "大同市",
    "children": [{
      "value": "城区",
      "key": "140202"
    }, {
      "value": "矿区",
      "key": "140203"
    }, {
      "value": "南郊区",
      "key": "140211"
    }, {
      "value": "新荣区",
      "key": "140212"
    }, {
      "value": "阳高县",
      "key": "140221"
    }, {
      "value": "天镇县",
      "key": "140222"
    }, {
      "value": "广灵县",
      "key": "140223"
    }, {
      "value": "灵丘县",
      "key": "140224"
    }, {
      "value": "浑源县",
      "key": "140225"
    }, {
      "value": "左云县",
      "key": "140226"
    }, {
      "value": "大同县",
      "key": "140227"
    }],
    "key": "140200"
  }, {
    "value": "阳泉市",
    "children": [{
      "value": "城区",
      "key": "140302"
    }, {
      "value": "矿区",
      "key": "140303"
    }, {
      "value": "郊区",
      "key": "140311"
    }, {
      "value": "平定县",
      "key": "140321"
    }, {
      "value": "盂县",
      "key": "140322"
    }],
    "key": "140300"
  }, {
    "value": "长治市",
    "children": [{
      "value": "城区",
      "key": "140402"
    }, {
      "value": "郊区",
      "key": "140411"
    }, {
      "value": "长治县",
      "key": "140421"
    }, {
      "value": "襄垣县",
      "key": "140423"
    }, {
      "value": "屯留县",
      "key": "140424"
    }, {
      "value": "平顺县",
      "key": "140425"
    }, {
      "value": "黎城县",
      "key": "140426"
    }, {
      "value": "壶关县",
      "key": "140427"
    }, {
      "value": "长子县",
      "key": "140428"
    }, {
      "value": "武乡县",
      "key": "140429"
    }, {
      "value": "沁县",
      "key": "140430"
    }, {
      "value": "沁源县",
      "key": "140431"
    }, {
      "value": "潞城市",
      "key": "140481"
    }],
    "key": "140400"
  }, {
    "value": "晋城市",
    "children": [{
      "value": "城区",
      "key": "140502"
    }, {
      "value": "沁水县",
      "key": "140521"
    }, {
      "value": "阳城县",
      "key": "140522"
    }, {
      "value": "陵川县",
      "key": "140524"
    }, {
      "value": "泽州县",
      "key": "140525"
    }, {
      "value": "高平市",
      "key": "140581"
    }],
    "key": "140500"
  }, {
    "value": "朔州市",
    "children": [{
      "value": "朔城区",
      "key": "140602"
    }, {
      "value": "平鲁区",
      "key": "140603"
    }, {
      "value": "山阴县",
      "key": "140621"
    }, {
      "value": "应县",
      "key": "140622"
    }, {
      "value": "右玉县",
      "key": "140623"
    }, {
      "value": "怀仁县",
      "key": "140624"
    }],
    "key": "140600"
  }, {
    "value": "晋中市",
    "children": [{
      "value": "榆次区",
      "key": "140702"
    }, {
      "value": "榆社县",
      "key": "140721"
    }, {
      "value": "左权县",
      "key": "140722"
    }, {
      "value": "和顺县",
      "key": "140723"
    }, {
      "value": "昔阳县",
      "key": "140724"
    }, {
      "value": "寿阳县",
      "key": "140725"
    }, {
      "value": "太谷县",
      "key": "140726"
    }, {
      "value": "祁县",
      "key": "140727"
    }, {
      "value": "平遥县",
      "key": "140728"
    }, {
      "value": "灵石县",
      "key": "140729"
    }, {
      "value": "介休市",
      "key": "140781"
    }],
    "key": "140700"
  }, {
    "value": "运城市",
    "children": [{
      "value": "盐湖区",
      "key": "140802"
    }, {
      "value": "临猗县",
      "key": "140821"
    }, {
      "value": "万荣县",
      "key": "140822"
    }, {
      "value": "闻喜县",
      "key": "140823"
    }, {
      "value": "稷山县",
      "key": "140824"
    }, {
      "value": "新绛县",
      "key": "140825"
    }, {
      "value": "绛县",
      "key": "140826"
    }, {
      "value": "垣曲县",
      "key": "140827"
    }, {
      "value": "夏县",
      "key": "140828"
    }, {
      "value": "平陆县",
      "key": "140829"
    }, {
      "value": "芮城县",
      "key": "140830"
    }, {
      "value": "永济市",
      "key": "140881"
    }, {
      "value": "河津市",
      "key": "140882"
    }],
    "key": "140800"
  }, {
    "value": "忻州市",
    "children": [{
      "value": "忻府区",
      "key": "140902"
    }, {
      "value": "定襄县",
      "key": "140921"
    }, {
      "value": "五台县",
      "key": "140922"
    }, {
      "value": "代县",
      "key": "140923"
    }, {
      "value": "繁峙县",
      "key": "140924"
    }, {
      "value": "宁武县",
      "key": "140925"
    }, {
      "value": "静乐县",
      "key": "140926"
    }, {
      "value": "神池县",
      "key": "140927"
    }, {
      "value": "五寨县",
      "key": "140928"
    }, {
      "value": "岢岚县",
      "key": "140929"
    }, {
      "value": "河曲县",
      "key": "140930"
    }, {
      "value": "保德县",
      "key": "140931"
    }, {
      "value": "偏关县",
      "key": "140932"
    }, {
      "value": "原平市",
      "key": "140981"
    }],
    "key": "140900"
  }, {
    "value": "临汾市",
    "children": [{
      "value": "尧都区",
      "key": "141002"
    }, {
      "value": "曲沃县",
      "key": "141021"
    }, {
      "value": "翼城县",
      "key": "141022"
    }, {
      "value": "襄汾县",
      "key": "141023"
    }, {
      "value": "洪洞县",
      "key": "141024"
    }, {
      "value": "古县",
      "key": "141025"
    }, {
      "value": "安泽县",
      "key": "141026"
    }, {
      "value": "浮山县",
      "key": "141027"
    }, {
      "value": "吉县",
      "key": "141028"
    }, {
      "value": "乡宁县",
      "key": "141029"
    }, {
      "value": "大宁县",
      "key": "141030"
    }, {
      "value": "隰县",
      "key": "141031"
    }, {
      "value": "永和县",
      "key": "141032"
    }, {
      "value": "蒲县",
      "key": "141033"
    }, {
      "value": "汾西县",
      "key": "141034"
    }, {
      "value": "侯马市",
      "key": "141081"
    }, {
      "value": "霍州市",
      "key": "141082"
    }],
    "key": "141000"
  }, {
    "value": "吕梁市",
    "children": [{
      "value": "离石区",
      "key": "141102"
    }, {
      "value": "文水县",
      "key": "141121"
    }, {
      "value": "交城县",
      "key": "141122"
    }, {
      "value": "兴县",
      "key": "141123"
    }, {
      "value": "临县",
      "key": "141124"
    }, {
      "value": "柳林县",
      "key": "141125"
    }, {
      "value": "石楼县",
      "key": "141126"
    }, {
      "value": "岚县",
      "key": "141127"
    }, {
      "value": "方山县",
      "key": "141128"
    }, {
      "value": "中阳县",
      "key": "141129"
    }, {
      "value": "交口县",
      "key": "141130"
    }, {
      "value": "孝义市",
      "key": "141181"
    }, {
      "value": "汾阳市",
      "key": "141182"
    }],
    "key": "141100"
  }],
  "key": "140000"
}, {
  "value": "内蒙古",
  "children": [{
    "value": "呼和浩特市",
    "children": [{
      "value": "新城区",
      "key": "150102"
    }, {
      "value": "回民区",
      "key": "150103"
    }, {
      "value": "玉泉区",
      "key": "150104"
    }, {
      "value": "赛罕区",
      "key": "150105"
    }, {
      "value": "土默特左旗",
      "key": "150121"
    }, {
      "value": "托克托县",
      "key": "150122"
    }, {
      "value": "和林格尔县",
      "key": "150123"
    }, {
      "value": "清水河县",
      "key": "150124"
    }, {
      "value": "武川县",
      "key": "150125"
    }],
    "key": "150100"
  }, {
    "value": "包头市",
    "children": [{
      "value": "东河区",
      "key": "150202"
    }, {
      "value": "昆都仑区",
      "key": "150203"
    }, {
      "value": "青山区",
      "key": "150204"
    }, {
      "value": "石拐区",
      "key": "150205"
    }, {
      "value": "白云鄂博矿区",
      "key": "150206"
    }, {
      "value": "九原区",
      "key": "150207"
    }, {
      "value": "土默特右旗",
      "key": "150221"
    }, {
      "value": "固阳县",
      "key": "150222"
    }, {
      "value": "达尔罕茂明安联合旗",
      "key": "150223"
    }],
    "key": "150200"
  }, {
    "value": "乌海市",
    "children": [{
      "value": "海勃湾区",
      "key": "150302"
    }, {
      "value": "海南区",
      "key": "150303"
    }, {
      "value": "乌达区",
      "key": "150304"
    }],
    "key": "150300"
  }, {
    "value": "赤峰市",
    "children": [{
      "value": "红山区",
      "key": "150402"
    }, {
      "value": "元宝山区",
      "key": "150403"
    }, {
      "value": "松山区",
      "key": "150404"
    }, {
      "value": "阿鲁科尔沁旗",
      "key": "150421"
    }, {
      "value": "巴林左旗",
      "key": "150422"
    }, {
      "value": "巴林右旗",
      "key": "150423"
    }, {
      "value": "林西县",
      "key": "150424"
    }, {
      "value": "克什克腾旗",
      "key": "150425"
    }, {
      "value": "翁牛特旗",
      "key": "150426"
    }, {
      "value": "喀喇沁旗",
      "key": "150428"
    }, {
      "value": "宁城县",
      "key": "150429"
    }, {
      "value": "敖汉旗",
      "key": "150430"
    }],
    "key": "150400"
  }, {
    "value": "通辽市",
    "children": [{
      "value": "科尔沁区",
      "key": "150502"
    }, {
      "value": "科尔沁左翼中旗",
      "key": "150521"
    }, {
      "value": "科尔沁左翼后旗",
      "key": "150522"
    }, {
      "value": "开鲁县",
      "key": "150523"
    }, {
      "value": "库伦旗",
      "key": "150524"
    }, {
      "value": "奈曼旗",
      "key": "150525"
    }, {
      "value": "扎鲁特旗",
      "key": "150526"
    }, {
      "value": "霍林郭勒市",
      "key": "150581"
    }],
    "key": "150500"
  }, {
    "value": "鄂尔多斯市",
    "children": [{
      "value": "东胜区",
      "key": "150602"
    }, {
      "value": "达拉特旗",
      "key": "150621"
    }, {
      "value": "准格尔旗",
      "key": "150622"
    }, {
      "value": "鄂托克前旗",
      "key": "150623"
    }, {
      "value": "鄂托克旗",
      "key": "150624"
    }, {
      "value": "杭锦旗",
      "key": "150625"
    }, {
      "value": "乌审旗",
      "key": "150626"
    }, {
      "value": "伊金霍洛旗",
      "key": "150627"
    }],
    "key": "150600"
  }, {
    "value": "呼伦贝尔市",
    "children": [{
      "value": "海拉尔区",
      "key": "150702"
    }, {
      "value": "阿荣旗",
      "key": "150721"
    }, {
      "value": "莫力达瓦达斡尔族自治旗",
      "key": "150722"
    }, {
      "value": "鄂伦春自治旗",
      "key": "150723"
    }, {
      "value": "鄂温克族自治旗",
      "key": "150724"
    }, {
      "value": "陈巴尔虎旗",
      "key": "150725"
    }, {
      "value": "新巴尔虎左旗",
      "key": "150726"
    }, {
      "value": "新巴尔虎右旗",
      "key": "150727"
    }, {
      "value": "满洲里市",
      "key": "150781"
    }, {
      "value": "牙克石市",
      "key": "150782"
    }, {
      "value": "扎兰屯市",
      "key": "150783"
    }, {
      "value": "额尔古纳市",
      "key": "150784"
    }, {
      "value": "根河市",
      "key": "150785"
    }],
    "key": "150700"
  }, {
    "value": "巴彦淖尔市",
    "children": [{
      "value": "临河区",
      "key": "150802"
    }, {
      "value": "五原县",
      "key": "150821"
    }, {
      "value": "磴口县",
      "key": "150822"
    }, {
      "value": "乌拉特前旗",
      "key": "150823"
    }, {
      "value": "乌拉特中旗",
      "key": "150824"
    }, {
      "value": "乌拉特后旗",
      "key": "150825"
    }, {
      "value": "杭锦后旗",
      "key": "150826"
    }],
    "key": "150800"
  }, {
    "value": "乌兰察布市",
    "children": [{
      "value": "集宁区",
      "key": "150902"
    }, {
      "value": "卓资县",
      "key": "150921"
    }, {
      "value": "化德县",
      "key": "150922"
    }, {
      "value": "商都县",
      "key": "150923"
    }, {
      "value": "兴和县",
      "key": "150924"
    }, {
      "value": "凉城县",
      "key": "150925"
    }, {
      "value": "察哈尔右翼前旗",
      "key": "150926"
    }, {
      "value": "察哈尔右翼中旗",
      "key": "150927"
    }, {
      "value": "察哈尔右翼后旗",
      "key": "150928"
    }, {
      "value": "四子王旗",
      "key": "150929"
    }, {
      "value": "丰镇市",
      "key": "150981"
    }],
    "key": "150900"
  }, {
    "value": "兴安盟",
    "children": [{
      "value": "乌兰浩特市",
      "key": "152201"
    }, {
      "value": "阿尔山市",
      "key": "152202"
    }, {
      "value": "科尔沁右翼前旗",
      "key": "152221"
    }, {
      "value": "科尔沁右翼中旗",
      "key": "152222"
    }, {
      "value": "扎赉特旗",
      "key": "152223"
    }, {
      "value": "突泉县",
      "key": "152224"
    }],
    "key": "152200"
  }, {
    "value": "锡林郭勒盟",
    "children": [{
      "value": "二连浩特市",
      "key": "152501"
    }, {
      "value": "锡林浩特市",
      "key": "152502"
    }, {
      "value": "阿巴嘎旗",
      "key": "152522"
    }, {
      "value": "苏尼特左旗",
      "key": "152523"
    }, {
      "value": "苏尼特右旗",
      "key": "152524"
    }, {
      "value": "东乌珠穆沁旗",
      "key": "152525"
    }, {
      "value": "西乌珠穆沁旗",
      "key": "152526"
    }, {
      "value": "太仆寺旗",
      "key": "152527"
    }, {
      "value": "镶黄旗",
      "key": "152528"
    }, {
      "value": "正镶白旗",
      "key": "152529"
    }, {
      "value": "正蓝旗",
      "key": "152530"
    }, {
      "value": "多伦县",
      "key": "152531"
    }],
    "key": "152500"
  }, {
    "value": "阿拉善盟",
    "children": [{
      "value": "阿拉善左旗",
      "key": "152921"
    }, {
      "value": "阿拉善右旗",
      "key": "152922"
    }, {
      "value": "额济纳旗",
      "key": "152923"
    }],
    "key": "152900"
  }],
  "key": "150000"
}, {
  "value": "辽宁",
  "children": [{
    "value": "沈阳市",
    "children": [{
      "value": "和平区",
      "key": "210102"
    }, {
      "value": "沈河区",
      "key": "210103"
    }, {
      "value": "大东区",
      "key": "210104"
    }, {
      "value": "皇姑区",
      "key": "210105"
    }, {
      "value": "铁西区",
      "key": "210106"
    }, {
      "value": "苏家屯区",
      "key": "210111"
    }, {
      "value": "东陵区",
      "key": "210112"
    }, {
      "value": "沈北新区",
      "key": "210113"
    }, {
      "value": "于洪区",
      "key": "210114"
    }, {
      "value": "辽中县",
      "key": "210122"
    }, {
      "value": "康平县",
      "key": "210123"
    }, {
      "value": "法库县",
      "key": "210124"
    }, {
      "value": "新民市",
      "key": "210181"
    }],
    "key": "210100"
  }, {
    "value": "大连市",
    "children": [{
      "value": "中山区",
      "key": "210202"
    }, {
      "value": "西岗区",
      "key": "210203"
    }, {
      "value": "沙河口区",
      "key": "210204"
    }, {
      "value": "甘井子区",
      "key": "210211"
    }, {
      "value": "旅顺口区",
      "key": "210212"
    }, {
      "value": "金州区",
      "key": "210213"
    }, {
      "value": "长海县",
      "key": "210224"
    }, {
      "value": "瓦房店市",
      "key": "210281"
    }, {
      "value": "普兰店市",
      "key": "210282"
    }, {
      "value": "庄河市",
      "key": "210283"
    }],
    "key": "210200"
  }, {
    "value": "鞍山市",
    "children": [{
      "value": "铁东区",
      "key": "210302"
    }, {
      "value": "铁西区",
      "key": "210303"
    }, {
      "value": "立山区",
      "key": "210304"
    }, {
      "value": "千山区",
      "key": "210311"
    }, {
      "value": "台安县",
      "key": "210321"
    }, {
      "value": "岫岩满族自治县",
      "key": "210323"
    }, {
      "value": "海城市",
      "key": "210381"
    }],
    "key": "210300"
  }, {
    "value": "抚顺市",
    "children": [{
      "value": "新抚区",
      "key": "210402"
    }, {
      "value": "东洲区",
      "key": "210403"
    }, {
      "value": "望花区",
      "key": "210404"
    }, {
      "value": "顺城区",
      "key": "210411"
    }, {
      "value": "抚顺县",
      "key": "210421"
    }, {
      "value": "新宾满族自治县",
      "key": "210422"
    }, {
      "value": "清原满族自治县",
      "key": "210423"
    }],
    "key": "210400"
  }, {
    "value": "本溪市",
    "children": [{
      "value": "平山区",
      "key": "210502"
    }, {
      "value": "溪湖区",
      "key": "210503"
    }, {
      "value": "明山区",
      "key": "210504"
    }, {
      "value": "南芬区",
      "key": "210505"
    }, {
      "value": "本溪满族自治县",
      "key": "210521"
    }, {
      "value": "桓仁满族自治县",
      "key": "210522"
    }],
    "key": "210500"
  }, {
    "value": "丹东市",
    "children": [{
      "value": "元宝区",
      "key": "210602"
    }, {
      "value": "振兴区",
      "key": "210603"
    }, {
      "value": "振安区",
      "key": "210604"
    }, {
      "value": "宽甸满族自治县",
      "key": "210624"
    }, {
      "value": "东港市",
      "key": "210681"
    }, {
      "value": "凤城市",
      "key": "210682"
    }],
    "key": "210600"
  }, {
    "value": "锦州市",
    "children": [{
      "value": "古塔区",
      "key": "210702"
    }, {
      "value": "凌河区",
      "key": "210703"
    }, {
      "value": "太和区",
      "key": "210711"
    }, {
      "value": "黑山县",
      "key": "210726"
    }, {
      "value": "义县",
      "key": "210727"
    }, {
      "value": "凌海市",
      "key": "210781"
    }, {
      "value": "北镇市",
      "key": "210782"
    }],
    "key": "210700"
  }, {
    "value": "营口市",
    "children": [{
      "value": "站前区",
      "key": "210802"
    }, {
      "value": "西市区",
      "key": "210803"
    }, {
      "value": "鲅鱼圈区",
      "key": "210804"
    }, {
      "value": "老边区",
      "key": "210811"
    }, {
      "value": "盖州市",
      "key": "210881"
    }, {
      "value": "大石桥市",
      "key": "210882"
    }],
    "key": "210800"
  }, {
    "value": "阜新市",
    "children": [{
      "value": "海州区",
      "key": "210902"
    }, {
      "value": "新邱区",
      "key": "210903"
    }, {
      "value": "太平区",
      "key": "210904"
    }, {
      "value": "清河门区",
      "key": "210905"
    }, {
      "value": "细河区",
      "key": "210911"
    }, {
      "value": "阜新蒙古族自治县",
      "key": "210921"
    }, {
      "value": "彰武县",
      "key": "210922"
    }],
    "key": "210900"
  }, {
    "value": "辽阳市",
    "children": [{
      "value": "白塔区",
      "key": "211002"
    }, {
      "value": "文圣区",
      "key": "211003"
    }, {
      "value": "宏伟区",
      "key": "211004"
    }, {
      "value": "弓长岭区",
      "key": "211005"
    }, {
      "value": "太子河区",
      "key": "211011"
    }, {
      "value": "辽阳县",
      "key": "211021"
    }, {
      "value": "灯塔市",
      "key": "211081"
    }],
    "key": "211000"
  }, {
    "value": "盘锦市",
    "children": [{
      "value": "双台子区",
      "key": "211102"
    }, {
      "value": "兴隆台区",
      "key": "211103"
    }, {
      "value": "大洼县",
      "key": "211121"
    }, {
      "value": "盘山县",
      "key": "211122"
    }],
    "key": "211100"
  }, {
    "value": "铁岭市",
    "children": [{
      "value": "银州区",
      "key": "211202"
    }, {
      "value": "清河区",
      "key": "211204"
    }, {
      "value": "铁岭县",
      "key": "211221"
    }, {
      "value": "西丰县",
      "key": "211223"
    }, {
      "value": "昌图县",
      "key": "211224"
    }, {
      "value": "调兵山市",
      "key": "211281"
    }, {
      "value": "开原市",
      "key": "211282"
    }],
    "key": "211200"
  }, {
    "value": "朝阳市",
    "children": [{
      "value": "双塔区",
      "key": "211302"
    }, {
      "value": "龙城区",
      "key": "211303"
    }, {
      "value": "朝阳县",
      "key": "211321"
    }, {
      "value": "建平县",
      "key": "211322"
    }, {
      "value": "喀喇沁左翼蒙古族自治县",
      "key": "211324"
    }, {
      "value": "北票市",
      "key": "211381"
    }, {
      "value": "凌源市",
      "key": "211382"
    }],
    "key": "211300"
  }, {
    "value": "葫芦岛市",
    "children": [{
      "value": "连山区",
      "key": "211402"
    }, {
      "value": "龙港区",
      "key": "211403"
    }, {
      "value": "南票区",
      "key": "211404"
    }, {
      "value": "绥中县",
      "key": "211421"
    }, {
      "value": "建昌县",
      "key": "211422"
    }, {
      "value": "兴城市",
      "key": "211481"
    }],
    "key": "211400"
  }],
  "key": "210000"
}, {
  "value": "吉林",
  "children": [{
    "value": "长春市",
    "children": [{
      "value": "南关区",
      "key": "220102"
    }, {
      "value": "宽城区",
      "key": "220103"
    }, {
      "value": "朝阳区",
      "key": "220104"
    }, {
      "value": "二道区",
      "key": "220105"
    }, {
      "value": "绿园区",
      "key": "220106"
    }, {
      "value": "双阳区",
      "key": "220112"
    }, {
      "value": "农安县",
      "key": "220122"
    }, {
      "value": "九台市",
      "key": "220181"
    }, {
      "value": "榆树市",
      "key": "220182"
    }, {
      "value": "德惠市",
      "key": "220183"
    }],
    "key": "220100"
  }, {
    "value": "吉林市",
    "children": [{
      "value": "昌邑区",
      "key": "220202"
    }, {
      "value": "龙潭区",
      "key": "220203"
    }, {
      "value": "船营区",
      "key": "220204"
    }, {
      "value": "丰满区",
      "key": "220211"
    }, {
      "value": "永吉县",
      "key": "220221"
    }, {
      "value": "蛟河市",
      "key": "220281"
    }, {
      "value": "桦甸市",
      "key": "220282"
    }, {
      "value": "舒兰市",
      "key": "220283"
    }, {
      "value": "磐石市",
      "key": "220284"
    }],
    "key": "220200"
  }, {
    "value": "四平市",
    "children": [{
      "value": "铁西区",
      "key": "220302"
    }, {
      "value": "铁东区",
      "key": "220303"
    }, {
      "value": "梨树县",
      "key": "220322"
    }, {
      "value": "伊通满族自治县",
      "key": "220323"
    }, {
      "value": "公主岭市",
      "key": "220381"
    }, {
      "value": "双辽市",
      "key": "220382"
    }],
    "key": "220300"
  }, {
    "value": "辽源市",
    "children": [{
      "value": "龙山区",
      "key": "220402"
    }, {
      "value": "西安区",
      "key": "220403"
    }, {
      "value": "东丰县",
      "key": "220421"
    }, {
      "value": "东辽县",
      "key": "220422"
    }],
    "key": "220400"
  }, {
    "value": "通化市",
    "children": [{
      "value": "东昌区",
      "key": "220502"
    }, {
      "value": "二道江区",
      "key": "220503"
    }, {
      "value": "通化县",
      "key": "220521"
    }, {
      "value": "辉南县",
      "key": "220523"
    }, {
      "value": "柳河县",
      "key": "220524"
    }, {
      "value": "梅河口市",
      "key": "220581"
    }, {
      "value": "集安市",
      "key": "220582"
    }],
    "key": "220500"
  }, {
    "value": "白山市",
    "children": [{
      "value": "浑江区",
      "key": "220602"
    }, {
      "value": "江源区",
      "key": "220605"
    }, {
      "value": "抚松县",
      "key": "220621"
    }, {
      "value": "靖宇县",
      "key": "220622"
    }, {
      "value": "长白朝鲜族自治县",
      "key": "220623"
    }, {
      "value": "江源县",
      "key": "220625"
    }, {
      "value": "临江市",
      "key": "220681"
    }],
    "key": "220600"
  }, {
    "value": "松原市",
    "children": [{
      "value": "宁江区",
      "key": "220702"
    }, {
      "value": "前郭尔罗斯蒙古族自治县",
      "key": "220721"
    }, {
      "value": "长岭县",
      "key": "220722"
    }, {
      "value": "乾安县",
      "key": "220723"
    }, {
      "value": "扶余市",
      "key": "220724"
    }],
    "key": "220700"
  }, {
    "value": "白城市",
    "children": [{
      "value": "洮北区",
      "key": "220802"
    }, {
      "value": "镇赉县",
      "key": "220821"
    }, {
      "value": "通榆县",
      "key": "220822"
    }, {
      "value": "洮南市",
      "key": "220881"
    }, {
      "value": "大安市",
      "key": "220882"
    }],
    "key": "220800"
  }, {
    "value": "延边朝鲜族自治州",
    "children": [{
      "value": "延吉市",
      "key": "222401"
    }, {
      "value": "图们市",
      "key": "222402"
    }, {
      "value": "敦化市",
      "key": "222403"
    }, {
      "value": "珲春市",
      "key": "222404"
    }, {
      "value": "龙井市",
      "key": "222405"
    }, {
      "value": "和龙市",
      "key": "222406"
    }, {
      "value": "汪清县",
      "key": "222424"
    }, {
      "value": "安图县",
      "key": "222426"
    }],
    "key": "222400"
  }],
  "key": "220000"
}, {
  "value": "黑龙江",
  "children": [{
    "value": "哈尔滨市",
    "children": [{
      "value": "道里区",
      "key": "230102"
    }, {
      "value": "南岗区",
      "key": "230103"
    }, {
      "value": "道外区",
      "key": "230104"
    }, {
      "value": "香坊区",
      "key": "230106"
    }, {
      "value": "动力区",
      "key": "230107"
    }, {
      "value": "平房区",
      "key": "230108"
    }, {
      "value": "松北区",
      "key": "230109"
    }, {
      "value": "呼兰区",
      "key": "230111"
    }, {
      "value": "阿城区",
      "key": "230112"
    }, {
      "value": "依兰县",
      "key": "230123"
    }, {
      "value": "方正县",
      "key": "230124"
    }, {
      "value": "宾县",
      "key": "230125"
    }, {
      "value": "巴彦县",
      "key": "230126"
    }, {
      "value": "木兰县",
      "key": "230127"
    }, {
      "value": "通河县",
      "key": "230128"
    }, {
      "value": "延寿县",
      "key": "230129"
    }, {
      "value": "双城市",
      "key": "230182"
    }, {
      "value": "尚志市",
      "key": "230183"
    }, {
      "value": "五常市",
      "key": "230184"
    }],
    "key": "230100"
  }, {
    "value": "齐齐哈尔市",
    "children": [{
      "value": "龙沙区",
      "key": "230202"
    }, {
      "value": "建华区",
      "key": "230203"
    }, {
      "value": "铁锋区",
      "key": "230204"
    }, {
      "value": "昂昂溪区",
      "key": "230205"
    }, {
      "value": "富拉尔基区",
      "key": "230206"
    }, {
      "value": "碾子山区",
      "key": "230207"
    }, {
      "value": "梅里斯达斡尔族区",
      "key": "230208"
    }, {
      "value": "龙江县",
      "key": "230221"
    }, {
      "value": "依安县",
      "key": "230223"
    }, {
      "value": "泰来县",
      "key": "230224"
    }, {
      "value": "甘南县",
      "key": "230225"
    }, {
      "value": "富裕县",
      "key": "230227"
    }, {
      "value": "克山县",
      "key": "230229"
    }, {
      "value": "克东县",
      "key": "230230"
    }, {
      "value": "拜泉县",
      "key": "230231"
    }, {
      "value": "讷河市",
      "key": "230281"
    }],
    "key": "230200"
  }, {
    "value": "鸡西市",
    "children": [{
      "value": "鸡冠区",
      "key": "230302"
    }, {
      "value": "恒山区",
      "key": "230303"
    }, {
      "value": "滴道区",
      "key": "230304"
    }, {
      "value": "梨树区",
      "key": "230305"
    }, {
      "value": "城子河区",
      "key": "230306"
    }, {
      "value": "麻山区",
      "key": "230307"
    }, {
      "value": "鸡东县",
      "key": "230321"
    }, {
      "value": "虎林市",
      "key": "230381"
    }, {
      "value": "密山市",
      "key": "230382"
    }],
    "key": "230300"
  }, {
    "value": "鹤岗市",
    "children": [{
      "value": "向阳区",
      "key": "230402"
    }, {
      "value": "工农区",
      "key": "230403"
    }, {
      "value": "南山区",
      "key": "230404"
    }, {
      "value": "兴安区",
      "key": "230405"
    }, {
      "value": "东山区",
      "key": "230406"
    }, {
      "value": "兴山区",
      "key": "230407"
    }, {
      "value": "萝北县",
      "key": "230421"
    }, {
      "value": "绥滨县",
      "key": "230422"
    }],
    "key": "230400"
  }, {
    "value": "双鸭山市",
    "children": [{
      "value": "尖山区",
      "key": "230502"
    }, {
      "value": "岭东区",
      "key": "230503"
    }, {
      "value": "四方台区",
      "key": "230505"
    }, {
      "value": "宝山区",
      "key": "230506"
    }, {
      "value": "集贤县",
      "key": "230521"
    }, {
      "value": "友谊县",
      "key": "230522"
    }, {
      "value": "宝清县",
      "key": "230523"
    }, {
      "value": "饶河县",
      "key": "230524"
    }],
    "key": "230500"
  }, {
    "value": "大庆市",
    "children": [{
      "value": "萨尔图区",
      "key": "230602"
    }, {
      "value": "龙凤区",
      "key": "230603"
    }, {
      "value": "让胡路区",
      "key": "230604"
    }, {
      "value": "红岗区",
      "key": "230605"
    }, {
      "value": "大同区",
      "key": "230606"
    }, {
      "value": "肇州县",
      "key": "230621"
    }, {
      "value": "肇源县",
      "key": "230622"
    }, {
      "value": "林甸县",
      "key": "230623"
    }, {
      "value": "杜尔伯特蒙古族自治县",
      "key": "230624"
    }],
    "key": "230600"
  }, {
    "value": "伊春市",
    "children": [{
      "value": "伊春区",
      "key": "230702"
    }, {
      "value": "南岔区",
      "key": "230703"
    }, {
      "value": "友好区",
      "key": "230704"
    }, {
      "value": "西林区",
      "key": "230705"
    }, {
      "value": "翠峦区",
      "key": "230706"
    }, {
      "value": "新青区",
      "key": "230707"
    }, {
      "value": "美溪区",
      "key": "230708"
    }, {
      "value": "金山屯区",
      "key": "230709"
    }, {
      "value": "五营区",
      "key": "230710"
    }, {
      "value": "乌马河区",
      "key": "230711"
    }, {
      "value": "汤旺河区",
      "key": "230712"
    }, {
      "value": "带岭区",
      "key": "230713"
    }, {
      "value": "乌伊岭区",
      "key": "230714"
    }, {
      "value": "红星区",
      "key": "230715"
    }, {
      "value": "上甘岭区",
      "key": "230716"
    }, {
      "value": "嘉荫县",
      "key": "230722"
    }, {
      "value": "铁力市",
      "key": "230781"
    }],
    "key": "230700"
  }, {
    "value": "佳木斯市",
    "children": [{
      "value": "永红区",
      "key": "230802"
    }, {
      "value": "向阳区",
      "key": "230803"
    }, {
      "value": "前进区",
      "key": "230804"
    }, {
      "value": "东风区",
      "key": "230805"
    }, {
      "value": "郊区",
      "key": "230811"
    }, {
      "value": "桦南县",
      "key": "230822"
    }, {
      "value": "桦川县",
      "key": "230826"
    }, {
      "value": "汤原县",
      "key": "230828"
    }, {
      "value": "抚远县",
      "key": "230833"
    }, {
      "value": "同江市",
      "key": "230881"
    }, {
      "value": "富锦市",
      "key": "230882"
    }],
    "key": "230800"
  }, {
    "value": "七台河市",
    "children": [{
      "value": "新兴区",
      "key": "230902"
    }, {
      "value": "桃山区",
      "key": "230903"
    }, {
      "value": "茄子河区",
      "key": "230904"
    }, {
      "value": "勃利县",
      "key": "230921"
    }],
    "key": "230900"
  }, {
    "value": "牡丹江市",
    "children": [{
      "value": "东安区",
      "key": "231002"
    }, {
      "value": "阳明区",
      "key": "231003"
    }, {
      "value": "爱民区",
      "key": "231004"
    }, {
      "value": "西安区",
      "key": "231005"
    }, {
      "value": "东宁县",
      "key": "231024"
    }, {
      "value": "林口县",
      "key": "231025"
    }, {
      "value": "绥芬河市",
      "key": "231081"
    }, {
      "value": "海林市",
      "key": "231083"
    }, {
      "value": "宁安市",
      "key": "231084"
    }, {
      "value": "穆棱市",
      "key": "231085"
    }],
    "key": "231000"
  }, {
    "value": "黑河市",
    "children": [{
      "value": "爱辉区",
      "key": "231102"
    }, {
      "value": "嫩江县",
      "key": "231121"
    }, {
      "value": "逊克县",
      "key": "231123"
    }, {
      "value": "孙吴县",
      "key": "231124"
    }, {
      "value": "北安市",
      "key": "231181"
    }, {
      "value": "五大连池市",
      "key": "231182"
    }],
    "key": "231100"
  }, {
    "value": "绥化市",
    "children": [{
      "value": "北林区",
      "key": "231202"
    }, {
      "value": "望奎县",
      "key": "231221"
    }, {
      "value": "兰西县",
      "key": "231222"
    }, {
      "value": "青冈县",
      "key": "231223"
    }, {
      "value": "庆安县",
      "key": "231224"
    }, {
      "value": "明水县",
      "key": "231225"
    }, {
      "value": "绥棱县",
      "key": "231226"
    }, {
      "value": "安达市",
      "key": "231281"
    }, {
      "value": "肇东市",
      "key": "231282"
    }, {
      "value": "海伦市",
      "key": "231283"
    }],
    "key": "231200"
  }, {
    "value": "大兴安岭地区",
    "children": [{
      "value": "加格达奇区",
      "key": "232701"
    }, {
      "value": "松岭区",
      "key": "232702"
    }, {
      "value": "新林区",
      "key": "232703"
    }, {
      "value": "呼中区",
      "key": "232704"
    }, {
      "value": "呼玛县",
      "key": "232721"
    }, {
      "value": "塔河县",
      "key": "232722"
    }, {
      "value": "漠河县",
      "key": "232723"
    }],
    "key": "232700"
  }],
  "key": "230000"
}, {
  "value": "上海",
  "children": [{
    "value": "黄浦区",
    "key": "310101"
  }, {
    "value": "卢湾区",
    "key": "310103"
  }, {
    "value": "徐汇区",
    "key": "310104"
  }, {
    "value": "长宁区",
    "key": "310105"
  }, {
    "value": "静安区",
    "key": "310106"
  }, {
    "value": "普陀区",
    "key": "310107"
  }, {
    "value": "闸北区",
    "key": "310108"
  }, {
    "value": "虹口区",
    "key": "310109"
  }, {
    "value": "杨浦区",
    "key": "310110"
  }, {
    "value": "闵行区",
    "key": "310112"
  }, {
    "value": "宝山区",
    "key": "310113"
  }, {
    "value": "嘉定区",
    "key": "310114"
  }, {
    "value": "浦东新区",
    "key": "310115"
  }, {
    "value": "金山区",
    "key": "310116"
  }, {
    "value": "松江区",
    "key": "310117"
  }, {
    "value": "青浦区",
    "key": "310118"
  }, {
    "value": "南汇区",
    "key": "310119"
  }, {
    "value": "奉贤区",
    "key": "310120"
  }, {
    "value": "崇明县",
    "key": "310230"
  }],
  "key": "310000"
}, {
  "value": "江苏",
  "children": [{
    "value": "南京市",
    "children": [{
      "value": "玄武区",
      "key": "320102"
    }, {
      "value": "白下区",
      "key": "320103"
    }, {
      "value": "秦淮区",
      "key": "320104"
    }, {
      "value": "建邺区",
      "key": "320105"
    }, {
      "value": "鼓楼区",
      "key": "320106"
    }, {
      "value": "下关区",
      "key": "320107"
    }, {
      "value": "浦口区",
      "key": "320111"
    }, {
      "value": "栖霞区",
      "key": "320113"
    }, {
      "value": "雨花台区",
      "key": "320114"
    }, {
      "value": "江宁区",
      "key": "320115"
    }, {
      "value": "六合区",
      "key": "320116"
    }, {
      "value": "溧水县",
      "key": "320124"
    }, {
      "value": "高淳县",
      "key": "320125"
    }],
    "key": "320100"
  }, {
    "value": "无锡市",
    "children": [{
      "value": "崇安区",
      "key": "320202"
    }, {
      "value": "南长区",
      "key": "320203"
    }, {
      "value": "北塘区",
      "key": "320204"
    }, {
      "value": "锡山区",
      "key": "320205"
    }, {
      "value": "惠山区",
      "key": "320206"
    }, {
      "value": "滨湖区",
      "key": "320211"
    }, {
      "value": "梁溪区",
      "key": "320213"
    }, {
      "value": "新吴区",
      "key": "320214"
    }, {
      "value": "江阴市",
      "key": "320281"
    }, {
      "value": "宜兴市",
      "key": "320282"
    }],
    "key": "320200"
  }, {
    "value": "徐州市",
    "children": [{
      "value": "鼓楼区",
      "key": "320302"
    }, {
      "value": "云龙区",
      "key": "320303"
    }, {
      "value": "九里区",
      "key": "320304"
    }, {
      "value": "贾汪区",
      "key": "320305"
    }, {
      "value": "泉山区",
      "key": "320311"
    }, {
      "value": "铜山区",
      "key": "320312"
    }, {
      "value": "丰县",
      "key": "320321"
    }, {
      "value": "沛县",
      "key": "320322"
    }, {
      "value": "铜山县",
      "key": "320323"
    }, {
      "value": "睢宁县",
      "key": "320324"
    }, {
      "value": "新沂市",
      "key": "320381"
    }, {
      "value": "邳州市",
      "key": "320382"
    }],
    "key": "320300"
  }, {
    "value": "常州市",
    "children": [{
      "value": "天宁区",
      "key": "320402"
    }, {
      "value": "钟楼区",
      "key": "320404"
    }, {
      "value": "戚墅堰区",
      "key": "320405"
    }, {
      "value": "新北区",
      "key": "320411"
    }, {
      "value": "武进区",
      "key": "320412"
    }, {
      "value": "溧阳市",
      "key": "320481"
    }, {
      "value": "金坛市",
      "key": "320482"
    }],
    "key": "320400"
  }, {
    "value": "苏州市",
    "children": [{
      "value": "沧浪区",
      "key": "320502"
    }, {
      "value": "平江区",
      "key": "320503"
    }, {
      "value": "金阊区",
      "key": "320504"
    }, {
      "value": "虎丘区",
      "key": "320505"
    }, {
      "value": "吴中区",
      "key": "320506"
    }, {
      "value": "相城区",
      "key": "320507"
    }, {
      "value": "姑苏区",
      "key": "320508"
    }, {
      "value": "吴江区",
      "key": "320509"
    }, {
      "value": "常熟市",
      "key": "320581"
    }, {
      "value": "张家港市",
      "key": "320582"
    }, {
      "value": "昆山市",
      "key": "320583"
    }, {
      "value": "吴江市",
      "key": "320584"
    }, {
      "value": "太仓市",
      "key": "320585"
    }],
    "key": "320500"
  }, {
    "value": "南通市",
    "children": [{
      "value": "崇川区",
      "key": "320602"
    }, {
      "value": "港闸区",
      "key": "320611"
    }, {
      "value": "通州区",
      "key": "320612"
    }, {
      "value": "海安县",
      "key": "320621"
    }, {
      "value": "如东县",
      "key": "320623"
    }, {
      "value": "启东市",
      "key": "320681"
    }, {
      "value": "如皋市",
      "key": "320682"
    }, {
      "value": "通州市",
      "key": "320683"
    }, {
      "value": "海门市",
      "key": "320684"
    }],
    "key": "320600"
  }, {
    "value": "连云港市",
    "children": [{
      "value": "连云区",
      "key": "320703"
    }, {
      "value": "新浦区",
      "key": "320705"
    }, {
      "value": "海州区",
      "key": "320706"
    }, {
      "value": "赣榆县",
      "key": "320721"
    }, {
      "value": "东海县",
      "key": "320722"
    }, {
      "value": "灌云县",
      "key": "320723"
    }, {
      "value": "灌南县",
      "key": "320724"
    }],
    "key": "320700"
  }, {
    "value": "淮安市",
    "children": [{
      "value": "清河区",
      "key": "320802"
    }, {
      "value": "淮安区",
      "key": "320803"
    }, {
      "value": "淮阴区",
      "key": "320804"
    }, {
      "value": "清浦区",
      "key": "320811"
    }, {
      "value": "涟水县",
      "key": "320826"
    }, {
      "value": "洪泽县",
      "key": "320829"
    }, {
      "value": "盱眙县",
      "key": "320830"
    }, {
      "value": "金湖县",
      "key": "320831"
    }],
    "key": "320800"
  }, {
    "value": "盐城市",
    "children": [{
      "value": "亭湖区",
      "key": "320902"
    }, {
      "value": "盐都区",
      "key": "320903"
    }, {
      "value": "响水县",
      "key": "320921"
    }, {
      "value": "滨海县",
      "key": "320922"
    }, {
      "value": "阜宁县",
      "key": "320923"
    }, {
      "value": "射阳县",
      "key": "320924"
    }, {
      "value": "建湖县",
      "key": "320925"
    }, {
      "value": "东台市",
      "key": "320981"
    }, {
      "value": "大丰市",
      "key": "320982"
    }],
    "key": "320900"
  }, {
    "value": "扬州市",
    "children": [{
      "value": "广陵区",
      "key": "321002"
    }, {
      "value": "邗江区",
      "key": "321003"
    }, {
      "value": "维扬区",
      "key": "321011"
    }, {
      "value": "江都区",
      "key": "321012"
    }, {
      "value": "宝应县",
      "key": "321023"
    }, {
      "value": "仪征市",
      "key": "321081"
    }, {
      "value": "高邮市",
      "key": "321084"
    }, {
      "value": "江都市",
      "key": "321088"
    }],
    "key": "321000"
  }, {
    "value": "镇江市",
    "children": [{
      "value": "京口区",
      "key": "321102"
    }, {
      "value": "润州区",
      "key": "321111"
    }, {
      "value": "丹徒区",
      "key": "321112"
    }, {
      "value": "丹阳市",
      "key": "321181"
    }, {
      "value": "扬中市",
      "key": "321182"
    }, {
      "value": "句容市",
      "key": "321183"
    }],
    "key": "321100"
  }, {
    "value": "泰州市",
    "children": [{
      "value": "海陵区",
      "key": "321202"
    }, {
      "value": "高港区",
      "key": "321203"
    }, {
      "value": "兴化市",
      "key": "321281"
    }, {
      "value": "靖江市",
      "key": "321282"
    }, {
      "value": "泰兴市",
      "key": "321283"
    }, {
      "value": "姜堰区",
      "key": "321284"
    }],
    "key": "321200"
  }, {
    "value": "宿迁市",
    "children": [{
      "value": "宿城区",
      "key": "321302"
    }, {
      "value": "宿豫区",
      "key": "321311"
    }, {
      "value": "沭阳县",
      "key": "321322"
    }, {
      "value": "泗阳县",
      "key": "321323"
    }, {
      "value": "泗洪县",
      "key": "321324"
    }],
    "key": "321300"
  }],
  "key": "320000"
}, {
  "value": "浙江",
  "children": [{
    "value": "杭州市",
    "children": [{
      "value": "上城区",
      "key": "330102"
    }, {
      "value": "下城区",
      "key": "330103"
    }, {
      "value": "江干区",
      "key": "330104"
    }, {
      "value": "拱墅区",
      "key": "330105"
    }, {
      "value": "西湖区",
      "key": "330106"
    }, {
      "value": "滨江区",
      "key": "330108"
    }, {
      "value": "萧山区",
      "key": "330109"
    }, {
      "value": "余杭区",
      "key": "330110"
    }, {
      "value": "桐庐县",
      "key": "330122"
    }, {
      "value": "淳安县",
      "key": "330127"
    }, {
      "value": "建德市",
      "key": "330182"
    }, {
      "value": "富阳市",
      "key": "330183"
    }, {
      "value": "临安市",
      "key": "330185"
    }],
    "key": "330100"
  }, {
    "value": "宁波市",
    "children": [{
      "value": "海曙区",
      "key": "330203"
    }, {
      "value": "江东区",
      "key": "330204"
    }, {
      "value": "江北区",
      "key": "330205"
    }, {
      "value": "北仑区",
      "key": "330206"
    }, {
      "value": "镇海区",
      "key": "330211"
    }, {
      "value": "鄞州区",
      "key": "330212"
    }, {
      "value": "象山县",
      "key": "330225"
    }, {
      "value": "宁海县",
      "key": "330226"
    }, {
      "value": "余姚市",
      "key": "330281"
    }, {
      "value": "慈溪市",
      "key": "330282"
    }, {
      "value": "奉化市",
      "key": "330283"
    }],
    "key": "330200"
  }, {
    "value": "温州市",
    "children": [{
      "value": "鹿城区",
      "key": "330302"
    }, {
      "value": "龙湾区",
      "key": "330303"
    }, {
      "value": "瓯海区",
      "key": "330304"
    }, {
      "value": "洞头县",
      "key": "330322"
    }, {
      "value": "永嘉县",
      "key": "330324"
    }, {
      "value": "平阳县",
      "key": "330326"
    }, {
      "value": "苍南县",
      "key": "330327"
    }, {
      "value": "文成县",
      "key": "330328"
    }, {
      "value": "泰顺县",
      "key": "330329"
    }, {
      "value": "瑞安市",
      "key": "330381"
    }, {
      "value": "乐清市",
      "key": "330382"
    }],
    "key": "330300"
  }, {
    "value": "嘉兴市",
    "children": [{
      "value": "南湖区",
      "key": "330402"
    }, {
      "value": "秀洲区",
      "key": "330411"
    }, {
      "value": "嘉善县",
      "key": "330421"
    }, {
      "value": "海盐县",
      "key": "330424"
    }, {
      "value": "海宁市",
      "key": "330481"
    }, {
      "value": "平湖市",
      "key": "330482"
    }, {
      "value": "桐乡市",
      "key": "330483"
    }],
    "key": "330400"
  }, {
    "value": "湖州市",
    "children": [{
      "value": "吴兴区",
      "key": "330502"
    }, {
      "value": "南浔区",
      "key": "330503"
    }, {
      "value": "德清县",
      "key": "330521"
    }, {
      "value": "长兴县",
      "key": "330522"
    }, {
      "value": "安吉县",
      "key": "330523"
    }],
    "key": "330500"
  }, {
    "value": "绍兴市",
    "children": [{
      "value": "越城区",
      "key": "330602"
    }, {
      "value": "绍兴县",
      "key": "330621"
    }, {
      "value": "新昌县",
      "key": "330624"
    }, {
      "value": "诸暨市",
      "key": "330681"
    }, {
      "value": "上虞市",
      "key": "330682"
    }, {
      "value": "嵊州市",
      "key": "330683"
    }],
    "key": "330600"
  }, {
    "value": "金华市",
    "children": [{
      "value": "婺城区",
      "key": "330702"
    }, {
      "value": "金东区",
      "key": "330703"
    }, {
      "value": "武义县",
      "key": "330723"
    }, {
      "value": "浦江县",
      "key": "330726"
    }, {
      "value": "磐安县",
      "key": "330727"
    }, {
      "value": "兰溪市",
      "key": "330781"
    }, {
      "value": "义乌市",
      "key": "330782"
    }, {
      "value": "东阳市",
      "key": "330783"
    }, {
      "value": "永康市",
      "key": "330784"
    }],
    "key": "330700"
  }, {
    "value": "衢州市",
    "children": [{
      "value": "柯城区",
      "key": "330802"
    }, {
      "value": "衢江区",
      "key": "330803"
    }, {
      "value": "常山县",
      "key": "330822"
    }, {
      "value": "开化县",
      "key": "330824"
    }, {
      "value": "龙游县",
      "key": "330825"
    }, {
      "value": "江山市",
      "key": "330881"
    }],
    "key": "330800"
  }, {
    "value": "舟山市",
    "children": [{
      "value": "定海区",
      "key": "330902"
    }, {
      "value": "普陀区",
      "key": "330903"
    }, {
      "value": "岱山县",
      "key": "330921"
    }, {
      "value": "嵊泗县",
      "key": "330922"
    }],
    "key": "330900"
  }, {
    "value": "台州市",
    "children": [{
      "value": "椒江区",
      "key": "331002"
    }, {
      "value": "黄岩区",
      "key": "331003"
    }, {
      "value": "路桥区",
      "key": "331004"
    }, {
      "value": "玉环县",
      "key": "331021"
    }, {
      "value": "三门县",
      "key": "331022"
    }, {
      "value": "天台县",
      "key": "331023"
    }, {
      "value": "仙居县",
      "key": "331024"
    }, {
      "value": "温岭市",
      "key": "331081"
    }, {
      "value": "临海市",
      "key": "331082"
    }],
    "key": "331000"
  }, {
    "value": "丽水市",
    "children": [{
      "value": "莲都区",
      "key": "331102"
    }, {
      "value": "青田县",
      "key": "331121"
    }, {
      "value": "缙云县",
      "key": "331122"
    }, {
      "value": "遂昌县",
      "key": "331123"
    }, {
      "value": "松阳县",
      "key": "331124"
    }, {
      "value": "云和县",
      "key": "331125"
    }, {
      "value": "庆元县",
      "key": "331126"
    }, {
      "value": "景宁畲族自治县",
      "key": "331127"
    }, {
      "value": "龙泉市",
      "key": "331181"
    }],
    "key": "331100"
  }],
  "key": "330000"
}, {
  "value": "安徽",
  "children": [{
    "value": "合肥市",
    "children": [{
      "value": "瑶海区",
      "key": "340102"
    }, {
      "value": "庐阳区",
      "key": "340103"
    }, {
      "value": "蜀山区",
      "key": "340104"
    }, {
      "value": "包河区",
      "key": "340111"
    }, {
      "value": "长丰县",
      "key": "340121"
    }, {
      "value": "肥东县",
      "key": "340122"
    }, {
      "value": "肥西县",
      "key": "340123"
    }, {
      "value": "庐江县",
      "key": "340124"
    }, {
      "value": "巢湖市",
      "key": "340181"
    }],
    "key": "340100"
  }, {
    "value": "芜湖市",
    "children": [{
      "value": "镜湖区",
      "key": "340202"
    }, {
      "value": "弋江区",
      "key": "340203"
    }, {
      "value": "新芜区",
      "key": "340204"
    }, {
      "value": "鸠江区",
      "key": "340207"
    }, {
      "value": "三山区",
      "key": "340208"
    }, {
      "value": "芜湖县",
      "key": "340221"
    }, {
      "value": "繁昌县",
      "key": "340222"
    }, {
      "value": "南陵县",
      "key": "340223"
    }, {
      "value": "无为县",
      "key": "340225"
    }],
    "key": "340200"
  }, {
    "value": "蚌埠市",
    "children": [{
      "value": "龙子湖区",
      "key": "340302"
    }, {
      "value": "蚌山区",
      "key": "340303"
    }, {
      "value": "禹会区",
      "key": "340304"
    }, {
      "value": "淮上区",
      "key": "340311"
    }, {
      "value": "怀远县",
      "key": "340321"
    }, {
      "value": "五河县",
      "key": "340322"
    }, {
      "value": "固镇县",
      "key": "340323"
    }],
    "key": "340300"
  }, {
    "value": "淮南市",
    "children": [{
      "value": "大通区",
      "key": "340402"
    }, {
      "value": "田家庵区",
      "key": "340403"
    }, {
      "value": "谢家集区",
      "key": "340404"
    }, {
      "value": "八公山区",
      "key": "340405"
    }, {
      "value": "潘集区",
      "key": "340406"
    }, {
      "value": "凤台县",
      "key": "340421"
    }],
    "key": "340400"
  }, {
    "value": "马鞍山市",
    "children": [{
      "value": "金家庄区",
      "key": "340502"
    }, {
      "value": "花山区",
      "key": "340503"
    }, {
      "value": "雨山区",
      "key": "340504"
    }, {
      "value": "当涂县",
      "key": "340521"
    }, {
      "value": "含山县",
      "key": "340522"
    }, {
      "value": "和县",
      "key": "340523"
    }],
    "key": "340500"
  }, {
    "value": "淮北市",
    "children": [{
      "value": "杜集区",
      "key": "340602"
    }, {
      "value": "相山区",
      "key": "340603"
    }, {
      "value": "烈山区",
      "key": "340604"
    }, {
      "value": "濉溪县",
      "key": "340621"
    }],
    "key": "340600"
  }, {
    "value": "铜陵市",
    "children": [{
      "value": "铜官山区",
      "key": "340702"
    }, {
      "value": "狮子山区",
      "key": "340703"
    }, {
      "value": "郊区",
      "key": "340711"
    }, {
      "value": "铜陵县",
      "key": "340721"
    }],
    "key": "340700"
  }, {
    "value": "安庆市",
    "children": [{
      "value": "迎江区",
      "key": "340802"
    }, {
      "value": "大观区",
      "key": "340803"
    }, {
      "value": "宜秀区",
      "key": "340811"
    }, {
      "value": "怀宁县",
      "key": "340822"
    }, {
      "value": "枞阳县",
      "key": "340823"
    }, {
      "value": "潜山县",
      "key": "340824"
    }, {
      "value": "太湖县",
      "key": "340825"
    }, {
      "value": "宿松县",
      "key": "340826"
    }, {
      "value": "望江县",
      "key": "340827"
    }, {
      "value": "岳西县",
      "key": "340828"
    }, {
      "value": "桐城市",
      "key": "340881"
    }],
    "key": "340800"
  }, {
    "value": "黄山市",
    "children": [{
      "value": "屯溪区",
      "key": "341002"
    }, {
      "value": "黄山区",
      "key": "341003"
    }, {
      "value": "徽州区",
      "key": "341004"
    }, {
      "value": "歙县",
      "key": "341021"
    }, {
      "value": "休宁县",
      "key": "341022"
    }, {
      "value": "黟县",
      "key": "341023"
    }, {
      "value": "祁门县",
      "key": "341024"
    }],
    "key": "341000"
  }, {
    "value": "滁州市",
    "children": [{
      "value": "琅琊区",
      "key": "341102"
    }, {
      "value": "南谯区",
      "key": "341103"
    }, {
      "value": "来安县",
      "key": "341122"
    }, {
      "value": "全椒县",
      "key": "341124"
    }, {
      "value": "定远县",
      "key": "341125"
    }, {
      "value": "凤阳县",
      "key": "341126"
    }, {
      "value": "天长市",
      "key": "341181"
    }, {
      "value": "明光市",
      "key": "341182"
    }],
    "key": "341100"
  }, {
    "value": "阜阳市",
    "children": [{
      "value": "颍州区",
      "key": "341202"
    }, {
      "value": "颍东区",
      "key": "341203"
    }, {
      "value": "颍泉区",
      "key": "341204"
    }, {
      "value": "临泉县",
      "key": "341221"
    }, {
      "value": "太和县",
      "key": "341222"
    }, {
      "value": "阜南县",
      "key": "341225"
    }, {
      "value": "颍上县",
      "key": "341226"
    }, {
      "value": "界首市",
      "key": "341282"
    }],
    "key": "341200"
  }, {
    "value": "宿州市",
    "children": [{
      "value": "墉桥区",
      "key": "341302"
    }, {
      "value": "砀山县",
      "key": "341321"
    }, {
      "value": "萧县",
      "key": "341322"
    }, {
      "value": "灵璧县",
      "key": "341323"
    }, {
      "value": "泗县",
      "key": "341324"
    }],
    "key": "341300"
  }, {
    "value": "巢湖市",
    "children": [{
      "value": "居巢区",
      "key": "341402"
    }, {
      "value": "庐江县",
      "key": "341421"
    }, {
      "value": "无为县",
      "key": "341422"
    }, {
      "value": "含山县",
      "key": "341423"
    }, {
      "value": "和县",
      "key": "341424"
    }],
    "key": "341400"
  }, {
    "value": "六安市",
    "children": [{
      "value": "金安区",
      "key": "341502"
    }, {
      "value": "裕安区",
      "key": "341503"
    }, {
      "value": "寿县",
      "key": "341521"
    }, {
      "value": "霍邱县",
      "key": "341522"
    }, {
      "value": "舒城县",
      "key": "341523"
    }, {
      "value": "金寨县",
      "key": "341524"
    }, {
      "value": "霍山县",
      "key": "341525"
    }],
    "key": "341500"
  }, {
    "value": "亳州市",
    "children": [{
      "value": "谯城区",
      "key": "341602"
    }, {
      "value": "涡阳县",
      "key": "341621"
    }, {
      "value": "蒙城县",
      "key": "341622"
    }, {
      "value": "利辛县",
      "key": "341623"
    }],
    "key": "341600"
  }, {
    "value": "池州市",
    "children": [{
      "value": "贵池区",
      "key": "341702"
    }, {
      "value": "东至县",
      "key": "341721"
    }, {
      "value": "石台县",
      "key": "341722"
    }, {
      "value": "青阳县",
      "key": "341723"
    }],
    "key": "341700"
  }, {
    "value": "宣城市",
    "children": [{
      "value": "宣州区",
      "key": "341802"
    }, {
      "value": "郎溪县",
      "key": "341821"
    }, {
      "value": "广德县",
      "key": "341822"
    }, {
      "value": "泾县",
      "key": "341823"
    }, {
      "value": "绩溪县",
      "key": "341824"
    }, {
      "value": "旌德县",
      "key": "341825"
    }, {
      "value": "宁国市",
      "key": "341881"
    }],
    "key": "341800"
  }],
  "key": "340000"
}, {
  "value": "福建",
  "children": [{
    "value": "福州市",
    "children": [{
      "value": "鼓楼区",
      "key": "350102"
    }, {
      "value": "台江区",
      "key": "350103"
    }, {
      "value": "仓山区",
      "key": "350104"
    }, {
      "value": "马尾区",
      "key": "350105"
    }, {
      "value": "晋安区",
      "key": "350111"
    }, {
      "value": "闽侯县",
      "key": "350121"
    }, {
      "value": "连江县",
      "key": "350122"
    }, {
      "value": "罗源县",
      "key": "350123"
    }, {
      "value": "闽清县",
      "key": "350124"
    }, {
      "value": "永泰县",
      "key": "350125"
    }, {
      "value": "平潭县",
      "key": "350128"
    }, {
      "value": "福清市",
      "key": "350181"
    }, {
      "value": "长乐市",
      "key": "350182"
    }],
    "key": "350100"
  }, {
    "value": "厦门市",
    "children": [{
      "value": "思明区",
      "key": "350203"
    }, {
      "value": "海沧区",
      "key": "350205"
    }, {
      "value": "湖里区",
      "key": "350206"
    }, {
      "value": "集美区",
      "key": "350211"
    }, {
      "value": "同安区",
      "key": "350212"
    }, {
      "value": "翔安区",
      "key": "350213"
    }],
    "key": "350200"
  }, {
    "value": "莆田市",
    "children": [{
      "value": "城厢区",
      "key": "350302"
    }, {
      "value": "涵江区",
      "key": "350303"
    }, {
      "value": "荔城区",
      "key": "350304"
    }, {
      "value": "秀屿区",
      "key": "350305"
    }, {
      "value": "仙游县",
      "key": "350322"
    }],
    "key": "350300"
  }, {
    "value": "三明市",
    "children": [{
      "value": "梅列区",
      "key": "350402"
    }, {
      "value": "三元区",
      "key": "350403"
    }, {
      "value": "明溪县",
      "key": "350421"
    }, {
      "value": "清流县",
      "key": "350423"
    }, {
      "value": "宁化县",
      "key": "350424"
    }, {
      "value": "大田县",
      "key": "350425"
    }, {
      "value": "尤溪县",
      "key": "350426"
    }, {
      "value": "沙县",
      "key": "350427"
    }, {
      "value": "将乐县",
      "key": "350428"
    }, {
      "value": "泰宁县",
      "key": "350429"
    }, {
      "value": "建宁县",
      "key": "350430"
    }, {
      "value": "永安市",
      "key": "350481"
    }],
    "key": "350400"
  }, {
    "value": "泉州市",
    "children": [{
      "value": "鲤城区",
      "key": "350502"
    }, {
      "value": "丰泽区",
      "key": "350503"
    }, {
      "value": "洛江区",
      "key": "350504"
    }, {
      "value": "泉港区",
      "key": "350505"
    }, {
      "value": "惠安县",
      "key": "350521"
    }, {
      "value": "安溪县",
      "key": "350524"
    }, {
      "value": "永春县",
      "key": "350525"
    }, {
      "value": "德化县",
      "key": "350526"
    }, {
      "value": "金门县",
      "key": "350527"
    }, {
      "value": "石狮市",
      "key": "350581"
    }, {
      "value": "晋江市",
      "key": "350582"
    }, {
      "value": "南安市",
      "key": "350583"
    }],
    "key": "350500"
  }, {
    "value": "漳州市",
    "children": [{
      "value": "芗城区",
      "key": "350602"
    }, {
      "value": "龙文区",
      "key": "350603"
    }, {
      "value": "云霄县",
      "key": "350622"
    }, {
      "value": "漳浦县",
      "key": "350623"
    }, {
      "value": "诏安县",
      "key": "350624"
    }, {
      "value": "长泰县",
      "key": "350625"
    }, {
      "value": "东山县",
      "key": "350626"
    }, {
      "value": "南靖县",
      "key": "350627"
    }, {
      "value": "平和县",
      "key": "350628"
    }, {
      "value": "华安县",
      "key": "350629"
    }, {
      "value": "龙海市",
      "key": "350681"
    }],
    "key": "350600"
  }, {
    "value": "南平市",
    "children": [{
      "value": "延平区",
      "key": "350702"
    }, {
      "value": "顺昌县",
      "key": "350721"
    }, {
      "value": "浦城县",
      "key": "350722"
    }, {
      "value": "光泽县",
      "key": "350723"
    }, {
      "value": "松溪县",
      "key": "350724"
    }, {
      "value": "政和县",
      "key": "350725"
    }, {
      "value": "邵武市",
      "key": "350781"
    }, {
      "value": "武夷山市",
      "key": "350782"
    }, {
      "value": "建瓯市",
      "key": "350783"
    }, {
      "value": "建阳市",
      "key": "350784"
    }],
    "key": "350700"
  }, {
    "value": "龙岩市",
    "children": [{
      "value": "新罗区",
      "key": "350802"
    }, {
      "value": "长汀县",
      "key": "350821"
    }, {
      "value": "永定县",
      "key": "350822"
    }, {
      "value": "上杭县",
      "key": "350823"
    }, {
      "value": "武平县",
      "key": "350824"
    }, {
      "value": "连城县",
      "key": "350825"
    }, {
      "value": "漳平市",
      "key": "350881"
    }],
    "key": "350800"
  }, {
    "value": "宁德市",
    "children": [{
      "value": "蕉城区",
      "key": "350902"
    }, {
      "value": "霞浦县",
      "key": "350921"
    }, {
      "value": "古田县",
      "key": "350922"
    }, {
      "value": "屏南县",
      "key": "350923"
    }, {
      "value": "寿宁县",
      "key": "350924"
    }, {
      "value": "周宁县",
      "key": "350925"
    }, {
      "value": "柘荣县",
      "key": "350926"
    }, {
      "value": "福安市",
      "key": "350981"
    }, {
      "value": "福鼎市",
      "key": "350982"
    }],
    "key": "350900"
  }],
  "key": "350000"
}, {
  "value": "江西",
  "children": [{
    "value": "南昌市",
    "children": [{
      "value": "东湖区",
      "key": "360102"
    }, {
      "value": "西湖区",
      "key": "360103"
    }, {
      "value": "青云谱区",
      "key": "360104"
    }, {
      "value": "湾里区",
      "key": "360105"
    }, {
      "value": "青山湖区",
      "key": "360111"
    }, {
      "value": "南昌县",
      "key": "360121"
    }, {
      "value": "新建县",
      "key": "360122"
    }, {
      "value": "安义县",
      "key": "360123"
    }, {
      "value": "进贤县",
      "key": "360124"
    }],
    "key": "360100"
  }, {
    "value": "景德镇市",
    "children": [{
      "value": "昌江区",
      "key": "360202"
    }, {
      "value": "珠山区",
      "key": "360203"
    }, {
      "value": "浮梁县",
      "key": "360222"
    }, {
      "value": "乐平市",
      "key": "360281"
    }],
    "key": "360200"
  }, {
    "value": "萍乡市",
    "children": [{
      "value": "安源区",
      "key": "360302"
    }, {
      "value": "湘东区",
      "key": "360313"
    }, {
      "value": "莲花县",
      "key": "360321"
    }, {
      "value": "上栗县",
      "key": "360322"
    }, {
      "value": "芦溪县",
      "key": "360323"
    }],
    "key": "360300"
  }, {
    "value": "九江市",
    "children": [{
      "value": "庐山区",
      "key": "360402"
    }, {
      "value": "浔阳区",
      "key": "360403"
    }, {
      "value": "九江县",
      "key": "360421"
    }, {
      "value": "武宁县",
      "key": "360423"
    }, {
      "value": "修水县",
      "key": "360424"
    }, {
      "value": "永修县",
      "key": "360425"
    }, {
      "value": "德安县",
      "key": "360426"
    }, {
      "value": "星子县",
      "key": "360427"
    }, {
      "value": "都昌县",
      "key": "360428"
    }, {
      "value": "湖口县",
      "key": "360429"
    }, {
      "value": "彭泽县",
      "key": "360430"
    }, {
      "value": "瑞昌市",
      "key": "360481"
    }, {
      "value": "共青城市",
      "key": "360482"
    }],
    "key": "360400"
  }, {
    "value": "新余市",
    "children": [{
      "value": "渝水区",
      "key": "360502"
    }, {
      "value": "分宜县",
      "key": "360521"
    }],
    "key": "360500"
  }, {
    "value": "鹰潭市",
    "children": [{
      "value": "月湖区",
      "key": "360602"
    }, {
      "value": "余江县",
      "key": "360622"
    }, {
      "value": "贵溪市",
      "key": "360681"
    }],
    "key": "360600"
  }, {
    "value": "赣州市",
    "children": [{
      "value": "章贡区",
      "key": "360702"
    }, {
      "value": "赣县",
      "key": "360721"
    }, {
      "value": "信丰县",
      "key": "360722"
    }, {
      "value": "大余县",
      "key": "360723"
    }, {
      "value": "上犹县",
      "key": "360724"
    }, {
      "value": "崇义县",
      "key": "360725"
    }, {
      "value": "安远县",
      "key": "360726"
    }, {
      "value": "龙南县",
      "key": "360727"
    }, {
      "value": "定南县",
      "key": "360728"
    }, {
      "value": "全南县",
      "key": "360729"
    }, {
      "value": "宁都县",
      "key": "360730"
    }, {
      "value": "于都县",
      "key": "360731"
    }, {
      "value": "兴国县",
      "key": "360732"
    }, {
      "value": "会昌县",
      "key": "360733"
    }, {
      "value": "寻乌县",
      "key": "360734"
    }, {
      "value": "石城县",
      "key": "360735"
    }, {
      "value": "瑞金市",
      "key": "360781"
    }, {
      "value": "南康市",
      "key": "360782"
    }],
    "key": "360700"
  }, {
    "value": "吉安市",
    "children": [{
      "value": "吉州区",
      "key": "360802"
    }, {
      "value": "青原区",
      "key": "360803"
    }, {
      "value": "吉安县",
      "key": "360821"
    }, {
      "value": "吉水县",
      "key": "360822"
    }, {
      "value": "峡江县",
      "key": "360823"
    }, {
      "value": "新干县",
      "key": "360824"
    }, {
      "value": "永丰县",
      "key": "360825"
    }, {
      "value": "泰和县",
      "key": "360826"
    }, {
      "value": "遂川县",
      "key": "360827"
    }, {
      "value": "万安县",
      "key": "360828"
    }, {
      "value": "安福县",
      "key": "360829"
    }, {
      "value": "永新县",
      "key": "360830"
    }, {
      "value": "井冈山市",
      "key": "360881"
    }],
    "key": "360800"
  }, {
    "value": "宜春市",
    "children": [{
      "value": "袁州区",
      "key": "360902"
    }, {
      "value": "奉新县",
      "key": "360921"
    }, {
      "value": "万载县",
      "key": "360922"
    }, {
      "value": "上高县",
      "key": "360923"
    }, {
      "value": "宜丰县",
      "key": "360924"
    }, {
      "value": "靖安县",
      "key": "360925"
    }, {
      "value": "铜鼓县",
      "key": "360926"
    }, {
      "value": "丰城市",
      "key": "360981"
    }, {
      "value": "樟树市",
      "key": "360982"
    }, {
      "value": "高安市",
      "key": "360983"
    }],
    "key": "360900"
  }, {
    "value": "抚州市",
    "children": [{
      "value": "临川区",
      "key": "361002"
    }, {
      "value": "南城县",
      "key": "361021"
    }, {
      "value": "黎川县",
      "key": "361022"
    }, {
      "value": "南丰县",
      "key": "361023"
    }, {
      "value": "崇仁县",
      "key": "361024"
    }, {
      "value": "乐安县",
      "key": "361025"
    }, {
      "value": "宜黄县",
      "key": "361026"
    }, {
      "value": "金溪县",
      "key": "361027"
    }, {
      "value": "资溪县",
      "key": "361028"
    }, {
      "value": "东乡县",
      "key": "361029"
    }, {
      "value": "广昌县",
      "key": "361030"
    }],
    "key": "361000"
  }, {
    "value": "上饶市",
    "children": [{
      "value": "信州区",
      "key": "361102"
    }, {
      "value": "上饶县",
      "key": "361121"
    }, {
      "value": "广丰县",
      "key": "361122"
    }, {
      "value": "玉山县",
      "key": "361123"
    }, {
      "value": "铅山县",
      "key": "361124"
    }, {
      "value": "横峰县",
      "key": "361125"
    }, {
      "value": "弋阳县",
      "key": "361126"
    }, {
      "value": "余干县",
      "key": "361127"
    }, {
      "value": "鄱阳县",
      "key": "361128"
    }, {
      "value": "万年县",
      "key": "361129"
    }, {
      "value": "婺源县",
      "key": "361130"
    }, {
      "value": "德兴市",
      "key": "361181"
    }],
    "key": "361100"
  }],
  "key": "360000"
}, {
  "value": "山东",
  "children": [{
    "value": "济南市",
    "children": [{
      "value": "历下区",
      "key": "370102"
    }, {
      "value": "市中区",
      "key": "370103"
    }, {
      "value": "槐荫区",
      "key": "370104"
    }, {
      "value": "天桥区",
      "key": "370105"
    }, {
      "value": "历城区",
      "key": "370112"
    }, {
      "value": "长清区",
      "key": "370113"
    }, {
      "value": "平阴县",
      "key": "370124"
    }, {
      "value": "济阳县",
      "key": "370125"
    }, {
      "value": "商河县",
      "key": "370126"
    }, {
      "value": "章丘市",
      "key": "370181"
    }],
    "key": "370100"
  }, {
    "value": "青岛市",
    "children": [{
      "value": "市南区",
      "key": "370202"
    }, {
      "value": "市北区",
      "key": "370203"
    }, {
      "value": "四方区",
      "key": "370205"
    }, {
      "value": "黄岛区",
      "key": "370211"
    }, {
      "value": "崂山区",
      "key": "370212"
    }, {
      "value": "李沧区",
      "key": "370213"
    }, {
      "value": "城阳区",
      "key": "370214"
    }, {
      "value": "胶州市",
      "key": "370281"
    }, {
      "value": "即墨市",
      "key": "370282"
    }, {
      "value": "平度市",
      "key": "370283"
    }, {
      "value": "胶南市",
      "key": "370284"
    }, {
      "value": "莱西市",
      "key": "370285"
    }],
    "key": "370200"
  }, {
    "value": "淄博市",
    "children": [{
      "value": "淄川区",
      "key": "370302"
    }, {
      "value": "张店区",
      "key": "370303"
    }, {
      "value": "博山区",
      "key": "370304"
    }, {
      "value": "临淄区",
      "key": "370305"
    }, {
      "value": "周村区",
      "key": "370306"
    }, {
      "value": "桓台县",
      "key": "370321"
    }, {
      "value": "高青县",
      "key": "370322"
    }, {
      "value": "沂源县",
      "key": "370323"
    }],
    "key": "370300"
  }, {
    "value": "枣庄市",
    "children": [{
      "value": "市中区",
      "key": "370402"
    }, {
      "value": "薛城区",
      "key": "370403"
    }, {
      "value": "峄城区",
      "key": "370404"
    }, {
      "value": "台儿庄区",
      "key": "370405"
    }, {
      "value": "山亭区",
      "key": "370406"
    }, {
      "value": "滕州市",
      "key": "370481"
    }],
    "key": "370400"
  }, {
    "value": "东营市",
    "children": [{
      "value": "东营区",
      "key": "370502"
    }, {
      "value": "河口区",
      "key": "370503"
    }, {
      "value": "垦利县",
      "key": "370521"
    }, {
      "value": "利津县",
      "key": "370522"
    }, {
      "value": "广饶县",
      "key": "370523"
    }],
    "key": "370500"
  }, {
    "value": "烟台市",
    "children": [{
      "value": "烟台市辖区",
      "key": "370601"
    }, {
      "value": "芝罘区",
      "key": "370602"
    }, {
      "value": "福山区",
      "key": "370611"
    }, {
      "value": "牟平区",
      "key": "370612"
    }, {
      "value": "莱山区",
      "key": "370613"
    }, {
      "value": "长岛县",
      "key": "370634"
    }, {
      "value": "龙口市",
      "key": "370681"
    }, {
      "value": "莱阳市",
      "key": "370682"
    }, {
      "value": "莱州市",
      "key": "370683"
    }, {
      "value": "蓬莱市",
      "key": "370684"
    }, {
      "value": "招远市",
      "key": "370685"
    }, {
      "value": "栖霞市",
      "key": "370686"
    }, {
      "value": "海阳市",
      "key": "370687"
    }, {
      "value": "开发区",
      "key": "370693"
    }],
    "key": "370600"
  }, {
    "value": "潍坊市",
    "children": [{
      "value": "潍城区",
      "key": "370702"
    }, {
      "value": "寒亭区",
      "key": "370703"
    }, {
      "value": "坊子区",
      "key": "370704"
    }, {
      "value": "奎文区",
      "key": "370705"
    }, {
      "value": "临朐县",
      "key": "370724"
    }, {
      "value": "昌乐县",
      "key": "370725"
    }, {
      "value": "青州市",
      "key": "370781"
    }, {
      "value": "诸城市",
      "key": "370782"
    }, {
      "value": "寿光市",
      "key": "370783"
    }, {
      "value": "安丘市",
      "key": "370784"
    }, {
      "value": "高密市",
      "key": "370785"
    }, {
      "value": "昌邑市",
      "key": "370786"
    }],
    "key": "370700"
  }, {
    "value": "济宁市",
    "children": [{
      "value": "市中区",
      "key": "370802"
    }, {
      "value": "任城区",
      "key": "370811"
    }, {
      "value": "微山县",
      "key": "370826"
    }, {
      "value": "鱼台县",
      "key": "370827"
    }, {
      "value": "金乡县",
      "key": "370828"
    }, {
      "value": "嘉祥县",
      "key": "370829"
    }, {
      "value": "汶上县",
      "key": "370830"
    }, {
      "value": "泗水县",
      "key": "370831"
    }, {
      "value": "梁山县",
      "key": "370832"
    }, {
      "value": "曲阜市",
      "key": "370881"
    }, {
      "value": "兖州市",
      "key": "370882"
    }, {
      "value": "邹城市",
      "key": "370883"
    }],
    "key": "370800"
  }, {
    "value": "泰安市",
    "children": [{
      "value": "泰山区",
      "key": "370902"
    }, {
      "value": "岱岳区",
      "key": "370903"
    }, {
      "value": "宁阳县",
      "key": "370921"
    }, {
      "value": "东平县",
      "key": "370923"
    }, {
      "value": "新泰市",
      "key": "370982"
    }, {
      "value": "肥城市",
      "key": "370983"
    }],
    "key": "370900"
  }, {
    "value": "威海市",
    "children": [{
      "value": "环翠区",
      "key": "371002"
    }, {
      "value": "文登市",
      "key": "371081"
    }, {
      "value": "荣成市",
      "key": "371082"
    }, {
      "value": "乳山市",
      "key": "371083"
    }],
    "key": "371000"
  }, {
    "value": "日照市",
    "children": [{
      "value": "东港区",
      "key": "371102"
    }, {
      "value": "岚山区",
      "key": "371103"
    }, {
      "value": "五莲县",
      "key": "371121"
    }, {
      "value": "莒县",
      "key": "371122"
    }],
    "key": "371100"
  }, {
    "value": "莱芜市",
    "children": [{
      "value": "莱城区",
      "key": "371202"
    }, {
      "value": "钢城区",
      "key": "371203"
    }],
    "key": "371200"
  }, {
    "value": "临沂市",
    "children": [{
      "value": "兰山区",
      "key": "371302"
    }, {
      "value": "罗庄区",
      "key": "371311"
    }, {
      "value": "河东区",
      "key": "371312"
    }, {
      "value": "沂南县",
      "key": "371321"
    }, {
      "value": "郯城县",
      "key": "371322"
    }, {
      "value": "沂水县",
      "key": "371323"
    }, {
      "value": "苍山县",
      "key": "371324"
    }, {
      "value": "费县",
      "key": "371325"
    }, {
      "value": "平邑县",
      "key": "371326"
    }, {
      "value": "莒南县",
      "key": "371327"
    }, {
      "value": "蒙阴县",
      "key": "371328"
    }, {
      "value": "临沭县",
      "key": "371329"
    }],
    "key": "371300"
  }, {
    "value": "德州市",
    "children": [{
      "value": "德城区",
      "key": "371402"
    }, {
      "value": "陵县",
      "key": "371421"
    }, {
      "value": "宁津县",
      "key": "371422"
    }, {
      "value": "庆云县",
      "key": "371423"
    }, {
      "value": "临邑县",
      "key": "371424"
    }, {
      "value": "齐河县",
      "key": "371425"
    }, {
      "value": "平原县",
      "key": "371426"
    }, {
      "value": "夏津县",
      "key": "371427"
    }, {
      "value": "武城县",
      "key": "371428"
    }, {
      "value": "乐陵市",
      "key": "371481"
    }, {
      "value": "禹城市",
      "key": "371482"
    }],
    "key": "371400"
  }, {
    "value": "聊城市",
    "children": [{
      "value": "东昌府区",
      "key": "371502"
    }, {
      "value": "阳谷县",
      "key": "371521"
    }, {
      "value": "莘县",
      "key": "371522"
    }, {
      "value": "茌平县",
      "key": "371523"
    }, {
      "value": "东阿县",
      "key": "371524"
    }, {
      "value": "冠县",
      "key": "371525"
    }, {
      "value": "高唐县",
      "key": "371526"
    }, {
      "value": "临清市",
      "key": "371581"
    }],
    "key": "371500"
  }, {
    "value": "滨州市",
    "children": [{
      "value": "滨城区",
      "key": "371602"
    }, {
      "value": "惠民县",
      "key": "371621"
    }, {
      "value": "阳信县",
      "key": "371622"
    }, {
      "value": "无棣县",
      "key": "371623"
    }, {
      "value": "沾化县",
      "key": "371624"
    }, {
      "value": "博兴县",
      "key": "371625"
    }, {
      "value": "邹平县",
      "key": "371626"
    }],
    "key": "371600"
  }, {
    "value": "菏泽市",
    "children": [{
      "value": "牡丹区",
      "key": "371702"
    }, {
      "value": "曹县",
      "key": "371721"
    }, {
      "value": "单县",
      "key": "371722"
    }, {
      "value": "成武县",
      "key": "371723"
    }, {
      "value": "巨野县",
      "key": "371724"
    }, {
      "value": "郓城县",
      "key": "371725"
    }, {
      "value": "鄄城县",
      "key": "371726"
    }, {
      "value": "定陶县",
      "key": "371727"
    }, {
      "value": "东明县",
      "key": "371728"
    }],
    "key": "371700"
  }],
  "key": "370000"
}, {
  "value": "河南",
  "children": [{
    "value": "郑州市",
    "children": [{
      "value": "中原区",
      "key": "410102"
    }, {
      "value": "二七区",
      "key": "410103"
    }, {
      "value": "管城回族区",
      "key": "410104"
    }, {
      "value": "金水区",
      "key": "410105"
    }, {
      "value": "上街区",
      "key": "410106"
    }, {
      "value": "惠济区",
      "key": "410108"
    }, {
      "value": "中牟县",
      "key": "410122"
    }, {
      "value": "巩义市",
      "key": "410181"
    }, {
      "value": "荥阳市",
      "key": "410182"
    }, {
      "value": "新密市",
      "key": "410183"
    }, {
      "value": "新郑市",
      "key": "410184"
    }, {
      "value": "登封市",
      "key": "410185"
    }],
    "key": "410100"
  }, {
    "value": "开封市",
    "children": [{
      "value": "龙亭区",
      "key": "410202"
    }, {
      "value": "顺河回族区",
      "key": "410203"
    }, {
      "value": "鼓楼区",
      "key": "410204"
    }, {
      "value": "禹王台区",
      "key": "410205"
    }, {
      "value": "金明区",
      "key": "410211"
    }, {
      "value": "杞县",
      "key": "410221"
    }, {
      "value": "通许县",
      "key": "410222"
    }, {
      "value": "尉氏县",
      "key": "410223"
    }, {
      "value": "开封县",
      "key": "410224"
    }, {
      "value": "兰考县",
      "key": "410225"
    }],
    "key": "410200"
  }, {
    "value": "洛阳市",
    "children": [{
      "value": "老城区",
      "key": "410302"
    }, {
      "value": "西工区",
      "key": "410303"
    }, {
      "value": "瀍河回族区",
      "key": "410304"
    }, {
      "value": "涧西区",
      "key": "410305"
    }, {
      "value": "吉利区",
      "key": "410306"
    }, {
      "value": "洛龙区",
      "key": "410307"
    }, {
      "value": "孟津县",
      "key": "410322"
    }, {
      "value": "新安县",
      "key": "410323"
    }, {
      "value": "栾川县",
      "key": "410324"
    }, {
      "value": "嵩县",
      "key": "410325"
    }, {
      "value": "汝阳县",
      "key": "410326"
    }, {
      "value": "宜阳县",
      "key": "410327"
    }, {
      "value": "洛宁县",
      "key": "410328"
    }, {
      "value": "伊川县",
      "key": "410329"
    }, {
      "value": "偃师市",
      "key": "410381"
    }],
    "key": "410300"
  }, {
    "value": "平顶山市",
    "children": [{
      "value": "新华区",
      "key": "410402"
    }, {
      "value": "卫东区",
      "key": "410403"
    }, {
      "value": "石龙区",
      "key": "410404"
    }, {
      "value": "湛河区",
      "key": "410411"
    }, {
      "value": "宝丰县",
      "key": "410421"
    }, {
      "value": "叶县",
      "key": "410422"
    }, {
      "value": "鲁山县",
      "key": "410423"
    }, {
      "value": "郏县",
      "key": "410425"
    }, {
      "value": "舞钢市",
      "key": "410481"
    }, {
      "value": "汝州市",
      "key": "410482"
    }],
    "key": "410400"
  }, {
    "value": "安阳市",
    "children": [{
      "value": "文峰区",
      "key": "410502"
    }, {
      "value": "北关区",
      "key": "410503"
    }, {
      "value": "殷都区",
      "key": "410505"
    }, {
      "value": "龙安区",
      "key": "410506"
    }, {
      "value": "安阳县",
      "key": "410522"
    }, {
      "value": "汤阴县",
      "key": "410523"
    }, {
      "value": "滑县",
      "key": "410526"
    }, {
      "value": "内黄县",
      "key": "410527"
    }, {
      "value": "林州市",
      "key": "410581"
    }],
    "key": "410500"
  }, {
    "value": "鹤壁市",
    "children": [{
      "value": "鹤山区",
      "key": "410602"
    }, {
      "value": "山城区",
      "key": "410603"
    }, {
      "value": "淇滨区",
      "key": "410611"
    }, {
      "value": "浚县",
      "key": "410621"
    }, {
      "value": "淇县",
      "key": "410622"
    }],
    "key": "410600"
  }, {
    "value": "新乡市",
    "children": [{
      "value": "红旗区",
      "key": "410702"
    }, {
      "value": "卫滨区",
      "key": "410703"
    }, {
      "value": "凤泉区",
      "key": "410704"
    }, {
      "value": "牧野区",
      "key": "410711"
    }, {
      "value": "新乡县",
      "key": "410721"
    }, {
      "value": "获嘉县",
      "key": "410724"
    }, {
      "value": "原阳县",
      "key": "410725"
    }, {
      "value": "延津县",
      "key": "410726"
    }, {
      "value": "封丘县",
      "key": "410727"
    }, {
      "value": "长垣县",
      "key": "410728"
    }, {
      "value": "卫辉市",
      "key": "410781"
    }, {
      "value": "辉县市",
      "key": "410782"
    }],
    "key": "410700"
  }, {
    "value": "焦作市",
    "children": [{
      "value": "解放区",
      "key": "410802"
    }, {
      "value": "中站区",
      "key": "410803"
    }, {
      "value": "马村区",
      "key": "410804"
    }, {
      "value": "山阳区",
      "key": "410811"
    }, {
      "value": "修武县",
      "key": "410821"
    }, {
      "value": "博爱县",
      "key": "410822"
    }, {
      "value": "武陟县",
      "key": "410823"
    }, {
      "value": "温县",
      "key": "410825"
    }, {
      "value": "济源市",
      "key": "410881"
    }, {
      "value": "沁阳市",
      "key": "410882"
    }, {
      "value": "孟州市",
      "key": "410883"
    }],
    "key": "410800"
  }, {
    "value": "濮阳市",
    "children": [{
      "value": "华龙区",
      "key": "410902"
    }, {
      "value": "清丰县",
      "key": "410922"
    }, {
      "value": "南乐县",
      "key": "410923"
    }, {
      "value": "范县",
      "key": "410926"
    }, {
      "value": "台前县",
      "key": "410927"
    }, {
      "value": "濮阳县",
      "key": "410928"
    }],
    "key": "410900"
  }, {
    "value": "许昌市",
    "children": [{
      "value": "魏都区",
      "key": "411002"
    }, {
      "value": "许昌县",
      "key": "411023"
    }, {
      "value": "鄢陵县",
      "key": "411024"
    }, {
      "value": "襄城县",
      "key": "411025"
    }, {
      "value": "禹州市",
      "key": "411081"
    }, {
      "value": "长葛市",
      "key": "411082"
    }],
    "key": "411000"
  }, {
    "value": "漯河市",
    "children": [{
      "value": "源汇区",
      "key": "411102"
    }, {
      "value": "郾城区",
      "key": "411103"
    }, {
      "value": "召陵区",
      "key": "411104"
    }, {
      "value": "舞阳县",
      "key": "411121"
    }, {
      "value": "临颍县",
      "key": "411122"
    }],
    "key": "411100"
  }, {
    "value": "三门峡市",
    "children": [{
      "value": "湖滨区",
      "key": "411202"
    }, {
      "value": "渑池县",
      "key": "411221"
    }, {
      "value": "陕县",
      "key": "411222"
    }, {
      "value": "卢氏县",
      "key": "411224"
    }, {
      "value": "义马市",
      "key": "411281"
    }, {
      "value": "灵宝市",
      "key": "411282"
    }],
    "key": "411200"
  }, {
    "value": "南阳市",
    "children": [{
      "value": "宛城区",
      "key": "411302"
    }, {
      "value": "卧龙区",
      "key": "411303"
    }, {
      "value": "南召县",
      "key": "411321"
    }, {
      "value": "方城县",
      "key": "411322"
    }, {
      "value": "西峡县",
      "key": "411323"
    }, {
      "value": "镇平县",
      "key": "411324"
    }, {
      "value": "内乡县",
      "key": "411325"
    }, {
      "value": "淅川县",
      "key": "411326"
    }, {
      "value": "社旗县",
      "key": "411327"
    }, {
      "value": "唐河县",
      "key": "411328"
    }, {
      "value": "新野县",
      "key": "411329"
    }, {
      "value": "桐柏县",
      "key": "411330"
    }, {
      "value": "邓州市",
      "key": "411381"
    }],
    "key": "411300"
  }, {
    "value": "商丘市",
    "children": [{
      "value": "梁园区",
      "key": "411402"
    }, {
      "value": "睢阳区",
      "key": "411403"
    }, {
      "value": "民权县",
      "key": "411421"
    }, {
      "value": "睢县",
      "key": "411422"
    }, {
      "value": "宁陵县",
      "key": "411423"
    }, {
      "value": "柘城县",
      "key": "411424"
    }, {
      "value": "虞城县",
      "key": "411425"
    }, {
      "value": "夏邑县",
      "key": "411426"
    }, {
      "value": "永城市",
      "key": "411481"
    }],
    "key": "411400"
  }, {
    "value": "信阳市",
    "children": [{
      "value": "浉河区",
      "key": "411502"
    }, {
      "value": "平桥区",
      "key": "411503"
    }, {
      "value": "罗山县",
      "key": "411521"
    }, {
      "value": "光山县",
      "key": "411522"
    }, {
      "value": "新县",
      "key": "411523"
    }, {
      "value": "商城县",
      "key": "411524"
    }, {
      "value": "固始县",
      "key": "411525"
    }, {
      "value": "潢川县",
      "key": "411526"
    }, {
      "value": "淮滨县",
      "key": "411527"
    }, {
      "value": "息县",
      "key": "411528"
    }],
    "key": "411500"
  }, {
    "value": "周口市",
    "children": [{
      "value": "川汇区",
      "key": "411602"
    }, {
      "value": "扶沟县",
      "key": "411621"
    }, {
      "value": "西华县",
      "key": "411622"
    }, {
      "value": "商水县",
      "key": "411623"
    }, {
      "value": "沈丘县",
      "key": "411624"
    }, {
      "value": "郸城县",
      "key": "411625"
    }, {
      "value": "淮阳县",
      "key": "411626"
    }, {
      "value": "太康县",
      "key": "411627"
    }, {
      "value": "鹿邑县",
      "key": "411628"
    }, {
      "value": "项城市",
      "key": "411681"
    }],
    "key": "411600"
  }, {
    "value": "驻马店市",
    "children": [{
      "value": "驿城区",
      "key": "411702"
    }, {
      "value": "西平县",
      "key": "411721"
    }, {
      "value": "上蔡县",
      "key": "411722"
    }, {
      "value": "平舆县",
      "key": "411723"
    }, {
      "value": "正阳县",
      "key": "411724"
    }, {
      "value": "确山县",
      "key": "411725"
    }, {
      "value": "泌阳县",
      "key": "411726"
    }, {
      "value": "汝南县",
      "key": "411727"
    }, {
      "value": "遂平县",
      "key": "411728"
    }, {
      "value": "新蔡县",
      "key": "411729"
    }],
    "key": "411700"
  }, {
    "value": "济源市",
    "key": "419001"
  }],
  "key": "410000"
}, {
  "value": "湖北",
  "children": [{
    "value": "武汉市",
    "children": [{
      "value": "江岸区",
      "key": "420102"
    }, {
      "value": "江汉区",
      "key": "420103"
    }, {
      "value": "硚口区",
      "key": "420104"
    }, {
      "value": "汉阳区",
      "key": "420105"
    }, {
      "value": "武昌区",
      "key": "420106"
    }, {
      "value": "青山区",
      "key": "420107"
    }, {
      "value": "洪山区",
      "key": "420111"
    }, {
      "value": "东西湖区",
      "key": "420112"
    }, {
      "value": "汉南区",
      "key": "420113"
    }, {
      "value": "蔡甸区",
      "key": "420114"
    }, {
      "value": "江夏区",
      "key": "420115"
    }, {
      "value": "黄陂区",
      "key": "420116"
    }, {
      "value": "新洲区",
      "key": "420117"
    }],
    "key": "420100"
  }, {
    "value": "黄石市",
    "children": [{
      "value": "黄石港区",
      "key": "420202"
    }, {
      "value": "西塞山区",
      "key": "420203"
    }, {
      "value": "下陆区",
      "key": "420204"
    }, {
      "value": "铁山区",
      "key": "420205"
    }, {
      "value": "阳新县",
      "key": "420222"
    }, {
      "value": "大冶市",
      "key": "420281"
    }],
    "key": "420200"
  }, {
    "value": "十堰市",
    "children": [{
      "value": "茅箭区",
      "key": "420302"
    }, {
      "value": "张湾区",
      "key": "420303"
    }, {
      "value": "郧县",
      "key": "420321"
    }, {
      "value": "郧西县",
      "key": "420322"
    }, {
      "value": "竹山县",
      "key": "420323"
    }, {
      "value": "竹溪县",
      "key": "420324"
    }, {
      "value": "房县",
      "key": "420325"
    }, {
      "value": "丹江口市",
      "key": "420381"
    }],
    "key": "420300"
  }, {
    "value": "宜昌市",
    "children": [{
      "value": "西陵区",
      "key": "420502"
    }, {
      "value": "伍家岗区",
      "key": "420503"
    }, {
      "value": "点军区",
      "key": "420504"
    }, {
      "value": "猇亭区",
      "key": "420505"
    }, {
      "value": "夷陵区",
      "key": "420506"
    }, {
      "value": "远安县",
      "key": "420525"
    }, {
      "value": "兴山县",
      "key": "420526"
    }, {
      "value": "秭归县",
      "key": "420527"
    }, {
      "value": "长阳土家族自治县",
      "key": "420528"
    }, {
      "value": "五峰土家族自治县",
      "key": "420529"
    }, {
      "value": "宜都市",
      "key": "420581"
    }, {
      "value": "当阳市",
      "key": "420582"
    }, {
      "value": "枝江市",
      "key": "420583"
    }],
    "key": "420500"
  }, {
    "value": "襄阳市",
    "children": [{
      "value": "襄城区",
      "key": "420602"
    }, {
      "value": "樊城区",
      "key": "420606"
    }, {
      "value": "襄州区",
      "key": "420607"
    }, {
      "value": "南漳县",
      "key": "420624"
    }, {
      "value": "谷城县",
      "key": "420625"
    }, {
      "value": "保康县",
      "key": "420626"
    }, {
      "value": "老河口市",
      "key": "420682"
    }, {
      "value": "枣阳市",
      "key": "420683"
    }, {
      "value": "宜城市",
      "key": "420684"
    }],
    "key": "420600"
  }, {
    "value": "鄂州市",
    "children": [{
      "value": "梁子湖区",
      "key": "420702"
    }, {
      "value": "华容区",
      "key": "420703"
    }, {
      "value": "鄂城区",
      "key": "420704"
    }],
    "key": "420700"
  }, {
    "value": "荆门市",
    "children": [{
      "value": "东宝区",
      "key": "420802"
    }, {
      "value": "掇刀区",
      "key": "420804"
    }, {
      "value": "京山县",
      "key": "420821"
    }, {
      "value": "沙洋县",
      "key": "420822"
    }, {
      "value": "钟祥市",
      "key": "420881"
    }],
    "key": "420800"
  }, {
    "value": "孝感市",
    "children": [{
      "value": "孝南区",
      "key": "420902"
    }, {
      "value": "孝昌县",
      "key": "420921"
    }, {
      "value": "大悟县",
      "key": "420922"
    }, {
      "value": "云梦县",
      "key": "420923"
    }, {
      "value": "应城市",
      "key": "420981"
    }, {
      "value": "安陆市",
      "key": "420982"
    }, {
      "value": "汉川市",
      "key": "420984"
    }],
    "key": "420900"
  }, {
    "value": "荆州市",
    "children": [{
      "value": "沙市区",
      "key": "421002"
    }, {
      "value": "荆州区",
      "key": "421003"
    }, {
      "value": "公安县",
      "key": "421022"
    }, {
      "value": "监利县",
      "key": "421023"
    }, {
      "value": "江陵县",
      "key": "421024"
    }, {
      "value": "石首市",
      "key": "421081"
    }, {
      "value": "洪湖市",
      "key": "421083"
    }, {
      "value": "松滋市",
      "key": "421087"
    }],
    "key": "421000"
  }, {
    "value": "黄冈市",
    "children": [{
      "value": "黄州区",
      "key": "421102"
    }, {
      "value": "团风县",
      "key": "421121"
    }, {
      "value": "红安县",
      "key": "421122"
    }, {
      "value": "罗田县",
      "key": "421123"
    }, {
      "value": "英山县",
      "key": "421124"
    }, {
      "value": "浠水县",
      "key": "421125"
    }, {
      "value": "蕲春县",
      "key": "421126"
    }, {
      "value": "黄梅县",
      "key": "421127"
    }, {
      "value": "麻城市",
      "key": "421181"
    }, {
      "value": "武穴市",
      "key": "421182"
    }],
    "key": "421100"
  }, {
    "value": "咸宁市",
    "children": [{
      "value": "咸安区",
      "key": "421202"
    }, {
      "value": "嘉鱼县",
      "key": "421221"
    }, {
      "value": "通城县",
      "key": "421222"
    }, {
      "value": "崇阳县",
      "key": "421223"
    }, {
      "value": "通山县",
      "key": "421224"
    }, {
      "value": "赤壁市",
      "key": "421281"
    }],
    "key": "421200"
  }, {
    "value": "随州市",
    "children": [{
      "value": "曾都区",
      "key": "421302"
    }, {
      "value": "曾都区",
      "key": "421303"
    }, {
      "value": "随县",
      "key": "421321"
    }, {
      "value": "广水市",
      "key": "421381"
    }],
    "key": "421300"
  }, {
    "value": "恩施土家族苗族自治州",
    "children": [{
      "value": "恩施市",
      "key": "422801"
    }, {
      "value": "利川市",
      "key": "422802"
    }, {
      "value": "建始县",
      "key": "422822"
    }, {
      "value": "巴东县",
      "key": "422823"
    }, {
      "value": "宣恩县",
      "key": "422825"
    }, {
      "value": "咸丰县",
      "key": "422826"
    }, {
      "value": "来凤县",
      "key": "422827"
    }, {
      "value": "鹤峰县",
      "key": "422828"
    }],
    "key": "422800"
  }, {
    "value": "仙桃市",
    "key": "429004"
  }, {
    "value": "潜江市",
    "key": "429005"
  }, {
    "value": "天门市",
    "key": "429006"
  }, {
    "value": "神农架林区",
    "key": "429021"
  }],
  "key": "420000"
}, {
  "value": "湖南",
  "children": [{
    "value": "长沙市",
    "children": [{
      "value": "芙蓉区",
      "key": "430102"
    }, {
      "value": "天心区",
      "key": "430103"
    }, {
      "value": "岳麓区",
      "key": "430104"
    }, {
      "value": "开福区",
      "key": "430105"
    }, {
      "value": "雨花区",
      "key": "430111"
    }, {
      "value": "望城区",
      "key": "430112"
    }, {
      "value": "长沙县",
      "key": "430121"
    }, {
      "value": "望城县",
      "key": "430122"
    }, {
      "value": "宁乡县",
      "key": "430124"
    }, {
      "value": "浏阳市",
      "key": "430181"
    }],
    "key": "430100"
  }, {
    "value": "株洲市",
    "children": [{
      "value": "荷塘区",
      "key": "430202"
    }, {
      "value": "芦淞区",
      "key": "430203"
    }, {
      "value": "石峰区",
      "key": "430204"
    }, {
      "value": "天元区",
      "key": "430211"
    }, {
      "value": "株洲县",
      "key": "430221"
    }, {
      "value": "攸县",
      "key": "430223"
    }, {
      "value": "茶陵县",
      "key": "430224"
    }, {
      "value": "炎陵县",
      "key": "430225"
    }, {
      "value": "醴陵市",
      "key": "430281"
    }],
    "key": "430200"
  }, {
    "value": "湘潭市",
    "children": [{
      "value": "雨湖区",
      "key": "430302"
    }, {
      "value": "岳塘区",
      "key": "430304"
    }, {
      "value": "湘潭县",
      "key": "430321"
    }, {
      "value": "湘乡市",
      "key": "430381"
    }, {
      "value": "韶山市",
      "key": "430382"
    }],
    "key": "430300"
  }, {
    "value": "衡阳市",
    "children": [{
      "value": "珠晖区",
      "key": "430405"
    }, {
      "value": "雁峰区",
      "key": "430406"
    }, {
      "value": "石鼓区",
      "key": "430407"
    }, {
      "value": "蒸湘区",
      "key": "430408"
    }, {
      "value": "南岳区",
      "key": "430412"
    }, {
      "value": "衡阳县",
      "key": "430421"
    }, {
      "value": "衡南县",
      "key": "430422"
    }, {
      "value": "衡山县",
      "key": "430423"
    }, {
      "value": "衡东县",
      "key": "430424"
    }, {
      "value": "祁东县",
      "key": "430426"
    }, {
      "value": "耒阳市",
      "key": "430481"
    }, {
      "value": "常宁市",
      "key": "430482"
    }],
    "key": "430400"
  }, {
    "value": "邵阳市",
    "children": [{
      "value": "双清区",
      "key": "430502"
    }, {
      "value": "大祥区",
      "key": "430503"
    }, {
      "value": "北塔区",
      "key": "430511"
    }, {
      "value": "邵东县",
      "key": "430521"
    }, {
      "value": "新邵县",
      "key": "430522"
    }, {
      "value": "邵阳县",
      "key": "430523"
    }, {
      "value": "隆回县",
      "key": "430524"
    }, {
      "value": "洞口县",
      "key": "430525"
    }, {
      "value": "绥宁县",
      "key": "430527"
    }, {
      "value": "新宁县",
      "key": "430528"
    }, {
      "value": "城步苗族自治县",
      "key": "430529"
    }, {
      "value": "武冈市",
      "key": "430581"
    }],
    "key": "430500"
  }, {
    "value": "岳阳市",
    "children": [{
      "value": "岳阳楼区",
      "key": "430602"
    }, {
      "value": "云溪区",
      "key": "430603"
    }, {
      "value": "君山区",
      "key": "430611"
    }, {
      "value": "岳阳县",
      "key": "430621"
    }, {
      "value": "华容县",
      "key": "430623"
    }, {
      "value": "湘阴县",
      "key": "430624"
    }, {
      "value": "平江县",
      "key": "430626"
    }, {
      "value": "汨罗市",
      "key": "430681"
    }, {
      "value": "临湘市",
      "key": "430682"
    }],
    "key": "430600"
  }, {
    "value": "常德市",
    "children": [{
      "value": "武陵区",
      "key": "430702"
    }, {
      "value": "鼎城区",
      "key": "430703"
    }, {
      "value": "安乡县",
      "key": "430721"
    }, {
      "value": "汉寿县",
      "key": "430722"
    }, {
      "value": "澧县",
      "key": "430723"
    }, {
      "value": "临澧县",
      "key": "430724"
    }, {
      "value": "桃源县",
      "key": "430725"
    }, {
      "value": "石门县",
      "key": "430726"
    }, {
      "value": "津市市",
      "key": "430781"
    }],
    "key": "430700"
  }, {
    "value": "张家界市",
    "children": [{
      "value": "永定区",
      "key": "430802"
    }, {
      "value": "武陵源区",
      "key": "430811"
    }, {
      "value": "慈利县",
      "key": "430821"
    }, {
      "value": "桑植县",
      "key": "430822"
    }],
    "key": "430800"
  }, {
    "value": "益阳市",
    "children": [{
      "value": "资阳区",
      "key": "430902"
    }, {
      "value": "赫山区",
      "key": "430903"
    }, {
      "value": "南县",
      "key": "430921"
    }, {
      "value": "桃江县",
      "key": "430922"
    }, {
      "value": "安化县",
      "key": "430923"
    }, {
      "value": "沅江市",
      "key": "430981"
    }],
    "key": "430900"
  }, {
    "value": "郴州市",
    "children": [{
      "value": "北湖区",
      "key": "431002"
    }, {
      "value": "苏仙区",
      "key": "431003"
    }, {
      "value": "桂阳县",
      "key": "431021"
    }, {
      "value": "宜章县",
      "key": "431022"
    }, {
      "value": "永兴县",
      "key": "431023"
    }, {
      "value": "嘉禾县",
      "key": "431024"
    }, {
      "value": "临武县",
      "key": "431025"
    }, {
      "value": "汝城县",
      "key": "431026"
    }, {
      "value": "桂东县",
      "key": "431027"
    }, {
      "value": "安仁县",
      "key": "431028"
    }, {
      "value": "资兴市",
      "key": "431081"
    }],
    "key": "431000"
  }, {
    "value": "永州市",
    "children": [{
      "value": "零陵区",
      "key": "431102"
    }, {
      "value": "冷水滩区",
      "key": "431103"
    }, {
      "value": "祁阳县",
      "key": "431121"
    }, {
      "value": "东安县",
      "key": "431122"
    }, {
      "value": "双牌县",
      "key": "431123"
    }, {
      "value": "道县",
      "key": "431124"
    }, {
      "value": "江永县",
      "key": "431125"
    }, {
      "value": "宁远县",
      "key": "431126"
    }, {
      "value": "蓝山县",
      "key": "431127"
    }, {
      "value": "新田县",
      "key": "431128"
    }, {
      "value": "江华瑶族自治县",
      "key": "431129"
    }],
    "key": "431100"
  }, {
    "value": "怀化市",
    "children": [{
      "value": "鹤城区",
      "key": "431202"
    }, {
      "value": "中方县",
      "key": "431221"
    }, {
      "value": "沅陵县",
      "key": "431222"
    }, {
      "value": "辰溪县",
      "key": "431223"
    }, {
      "value": "溆浦县",
      "key": "431224"
    }, {
      "value": "会同县",
      "key": "431225"
    }, {
      "value": "麻阳苗族自治县",
      "key": "431226"
    }, {
      "value": "新晃侗族自治县",
      "key": "431227"
    }, {
      "value": "芷江侗族自治县",
      "key": "431228"
    }, {
      "value": "靖州苗族侗族自治县",
      "key": "431229"
    }, {
      "value": "通道侗族自治县",
      "key": "431230"
    }, {
      "value": "洪江市",
      "key": "431281"
    }],
    "key": "431200"
  }, {
    "value": "娄底市",
    "children": [{
      "value": "娄星区",
      "key": "431302"
    }, {
      "value": "双峰县",
      "key": "431321"
    }, {
      "value": "新化县",
      "key": "431322"
    }, {
      "value": "冷水江市",
      "key": "431381"
    }, {
      "value": "涟源市",
      "key": "431382"
    }],
    "key": "431300"
  }, {
    "value": "湘西土家族苗族自治州",
    "children": [{
      "value": "吉首市",
      "key": "433101"
    }, {
      "value": "泸溪县",
      "key": "433122"
    }, {
      "value": "凤凰县",
      "key": "433123"
    }, {
      "value": "花垣县",
      "key": "433124"
    }, {
      "value": "保靖县",
      "key": "433125"
    }, {
      "value": "古丈县",
      "key": "433126"
    }, {
      "value": "永顺县",
      "key": "433127"
    }, {
      "value": "龙山县",
      "key": "433130"
    }],
    "key": "433100"
  }],
  "key": "430000"
}, {
  "value": "广东",
  "children": [{
    "value": "广州市",
    "children": [{
      "value": "东山区",
      "key": "440102"
    }, {
      "value": "荔湾区",
      "key": "440103"
    }, {
      "value": "越秀区",
      "key": "440104"
    }, {
      "value": "海珠区",
      "key": "440105"
    }, {
      "value": "天河区",
      "key": "440106"
    }, {
      "value": "芳村区",
      "key": "440107"
    }, {
      "value": "白云区",
      "key": "440111"
    }, {
      "value": "黄埔区",
      "key": "440112"
    }, {
      "value": "番禺区",
      "key": "440113"
    }, {
      "value": "花都区",
      "key": "440114"
    }, {
      "value": "南沙区",
      "key": "440115"
    }, {
      "value": "萝岗区",
      "key": "440116"
    }, {
      "value": "增城市",
      "key": "440183"
    }, {
      "value": "从化市",
      "key": "440184"
    }],
    "key": "440100"
  }, {
    "value": "韶关市",
    "children": [{
      "value": "武江区",
      "key": "440203"
    }, {
      "value": "浈江区",
      "key": "440204"
    }, {
      "value": "曲江区",
      "key": "440205"
    }, {
      "value": "始兴县",
      "key": "440222"
    }, {
      "value": "仁化县",
      "key": "440224"
    }, {
      "value": "翁源县",
      "key": "440229"
    }, {
      "value": "乳源瑶族自治县",
      "key": "440232"
    }, {
      "value": "新丰县",
      "key": "440233"
    }, {
      "value": "乐昌市",
      "key": "440281"
    }, {
      "value": "南雄市",
      "key": "440282"
    }],
    "key": "440200"
  }, {
    "value": "深圳市",
    "children": [{
      "value": "罗湖区",
      "key": "440303"
    }, {
      "value": "福田区",
      "key": "440304"
    }, {
      "value": "南山区",
      "key": "440305"
    }, {
      "value": "宝安区",
      "key": "440306"
    }, {
      "value": "龙岗区",
      "key": "440307"
    }, {
      "value": "盐田区",
      "key": "440308"
    }],
    "key": "440300"
  }, {
    "value": "珠海市",
    "children": [{
      "value": "香洲区",
      "key": "440402"
    }, {
      "value": "斗门区",
      "key": "440403"
    }, {
      "value": "金湾区",
      "key": "440404"
    }],
    "key": "440400"
  }, {
    "value": "汕头市",
    "children": [{
      "value": "龙湖区",
      "key": "440507"
    }, {
      "value": "金平区",
      "key": "440511"
    }, {
      "value": "濠江区",
      "key": "440512"
    }, {
      "value": "潮阳区",
      "key": "440513"
    }, {
      "value": "潮南区",
      "key": "440514"
    }, {
      "value": "澄海区",
      "key": "440515"
    }, {
      "value": "南澳县",
      "key": "440523"
    }],
    "key": "440500"
  }, {
    "value": "佛山市",
    "children": [{
      "value": "禅城区",
      "key": "440604"
    }, {
      "value": "南海区",
      "key": "440605"
    }, {
      "value": "顺德区",
      "key": "440606"
    }, {
      "value": "三水区",
      "key": "440607"
    }, {
      "value": "高明区",
      "key": "440608"
    }],
    "key": "440600"
  }, {
    "value": "江门市",
    "children": [{
      "value": "蓬江区",
      "key": "440703"
    }, {
      "value": "江海区",
      "key": "440704"
    }, {
      "value": "新会区",
      "key": "440705"
    }, {
      "value": "台山市",
      "key": "440781"
    }, {
      "value": "开平市",
      "key": "440783"
    }, {
      "value": "鹤山市",
      "key": "440784"
    }, {
      "value": "恩平市",
      "key": "440785"
    }],
    "key": "440700"
  }, {
    "value": "湛江市",
    "children": [{
      "value": "赤坎区",
      "key": "440802"
    }, {
      "value": "霞山区",
      "key": "440803"
    }, {
      "value": "坡头区",
      "key": "440804"
    }, {
      "value": "麻章区",
      "key": "440811"
    }, {
      "value": "遂溪县",
      "key": "440823"
    }, {
      "value": "徐闻县",
      "key": "440825"
    }, {
      "value": "廉江市",
      "key": "440881"
    }, {
      "value": "雷州市",
      "key": "440882"
    }, {
      "value": "吴川市",
      "key": "440883"
    }],
    "key": "440800"
  }, {
    "value": "茂名市",
    "children": [{
      "value": "茂南区",
      "key": "440902"
    }, {
      "value": "茂港区",
      "key": "440903"
    }, {
      "value": "电白县",
      "key": "440923"
    }, {
      "value": "高州市",
      "key": "440981"
    }, {
      "value": "化州市",
      "key": "440982"
    }, {
      "value": "信宜市",
      "key": "440983"
    }],
    "key": "440900"
  }, {
    "value": "肇庆市",
    "children": [{
      "value": "端州区",
      "key": "441202"
    }, {
      "value": "鼎湖区",
      "key": "441203"
    }, {
      "value": "广宁县",
      "key": "441223"
    }, {
      "value": "怀集县",
      "key": "441224"
    }, {
      "value": "封开县",
      "key": "441225"
    }, {
      "value": "德庆县",
      "key": "441226"
    }, {
      "value": "高要市",
      "key": "441283"
    }, {
      "value": "四会市",
      "key": "441284"
    }],
    "key": "441200"
  }, {
    "value": "惠州市",
    "children": [{
      "value": "惠城区",
      "key": "441302"
    }, {
      "value": "惠阳区",
      "key": "441303"
    }, {
      "value": "博罗县",
      "key": "441322"
    }, {
      "value": "惠东县",
      "key": "441323"
    }, {
      "value": "龙门县",
      "key": "441324"
    }],
    "key": "441300"
  }, {
    "value": "梅州市",
    "children": [{
      "value": "梅江区",
      "key": "441402"
    }, {
      "value": "梅县",
      "key": "441421"
    }, {
      "value": "大埔县",
      "key": "441422"
    }, {
      "value": "丰顺县",
      "key": "441423"
    }, {
      "value": "五华县",
      "key": "441424"
    }, {
      "value": "平远县",
      "key": "441426"
    }, {
      "value": "蕉岭县",
      "key": "441427"
    }, {
      "value": "兴宁市",
      "key": "441481"
    }],
    "key": "441400"
  }, {
    "value": "汕尾市",
    "children": [{
      "value": "城区",
      "key": "441502"
    }, {
      "value": "海丰县",
      "key": "441521"
    }, {
      "value": "陆河县",
      "key": "441523"
    }, {
      "value": "陆丰市",
      "key": "441581"
    }],
    "key": "441500"
  }, {
    "value": "河源市",
    "children": [{
      "value": "源城区",
      "key": "441602"
    }, {
      "value": "紫金县",
      "key": "441621"
    }, {
      "value": "龙川县",
      "key": "441622"
    }, {
      "value": "连平县",
      "key": "441623"
    }, {
      "value": "和平县",
      "key": "441624"
    }, {
      "value": "东源县",
      "key": "441625"
    }],
    "key": "441600"
  }, {
    "value": "阳江市",
    "children": [{
      "value": "江城区",
      "key": "441702"
    }, {
      "value": "阳西县",
      "key": "441721"
    }, {
      "value": "阳东县",
      "key": "441723"
    }, {
      "value": "阳春市",
      "key": "441781"
    }],
    "key": "441700"
  }, {
    "value": "清远市",
    "children": [{
      "value": "清城区",
      "key": "441802"
    }, {
      "value": "佛冈县",
      "key": "441821"
    }, {
      "value": "阳山县",
      "key": "441823"
    }, {
      "value": "连山壮族瑶族自治县",
      "key": "441825"
    }, {
      "value": "连南瑶族自治县",
      "key": "441826"
    }, {
      "value": "清新县",
      "key": "441827"
    }, {
      "value": "英德市",
      "key": "441881"
    }, {
      "value": "连州市",
      "key": "441882"
    }],
    "key": "441800"
  }, {
    "value": "东莞市",
    "key": "441900"
  }, {
    "value": "中山市",
    "key": "442000"
  }, {
    "value": "潮州市",
    "children": [{
      "value": "湘桥区",
      "key": "445102"
    }, {
      "value": "潮安县",
      "key": "445121"
    }, {
      "value": "饶平县",
      "key": "445122"
    }],
    "key": "445100"
  }, {
    "value": "揭阳市",
    "children": [{
      "value": "榕城区",
      "key": "445202"
    }, {
      "value": "揭东县",
      "key": "445221"
    }, {
      "value": "揭西县",
      "key": "445222"
    }, {
      "value": "惠来县",
      "key": "445224"
    }, {
      "value": "普宁市",
      "key": "445281"
    }],
    "key": "445200"
  }, {
    "value": "云浮市",
    "children": [{
      "value": "云城区",
      "key": "445302"
    }, {
      "value": "新兴县",
      "key": "445321"
    }, {
      "value": "郁南县",
      "key": "445322"
    }, {
      "value": "云安县",
      "key": "445323"
    }, {
      "value": "罗定市",
      "key": "445381"
    }],
    "key": "445300"
  }],
  "key": "440000"
}, {
  "value": "广西",
  "children": [{
    "value": "南宁市",
    "children": [{
      "value": "兴宁区",
      "key": "450102"
    }, {
      "value": "青秀区",
      "key": "450103"
    }, {
      "value": "江南区",
      "key": "450105"
    }, {
      "value": "西乡塘区",
      "key": "450107"
    }, {
      "value": "良庆区",
      "key": "450108"
    }, {
      "value": "邕宁区",
      "key": "450109"
    }, {
      "value": "武鸣县",
      "key": "450122"
    }, {
      "value": "隆安县",
      "key": "450123"
    }, {
      "value": "马山县",
      "key": "450124"
    }, {
      "value": "上林县",
      "key": "450125"
    }, {
      "value": "宾阳县",
      "key": "450126"
    }, {
      "value": "横县",
      "key": "450127"
    }],
    "key": "450100"
  }, {
    "value": "柳州市",
    "children": [{
      "value": "城中区",
      "key": "450202"
    }, {
      "value": "鱼峰区",
      "key": "450203"
    }, {
      "value": "柳南区",
      "key": "450204"
    }, {
      "value": "柳北区",
      "key": "450205"
    }, {
      "value": "柳江县",
      "key": "450221"
    }, {
      "value": "柳城县",
      "key": "450222"
    }, {
      "value": "鹿寨县",
      "key": "450223"
    }, {
      "value": "融安县",
      "key": "450224"
    }, {
      "value": "融水苗族自治县",
      "key": "450225"
    }, {
      "value": "三江侗族自治县",
      "key": "450226"
    }],
    "key": "450200"
  }, {
    "value": "桂林市",
    "children": [{
      "value": "秀峰区",
      "key": "450302"
    }, {
      "value": "叠彩区",
      "key": "450303"
    }, {
      "value": "象山区",
      "key": "450304"
    }, {
      "value": "七星区",
      "key": "450305"
    }, {
      "value": "雁山区",
      "key": "450311"
    }, {
      "value": "阳朔县",
      "key": "450321"
    }, {
      "value": "临桂县",
      "key": "450322"
    }, {
      "value": "灵川县",
      "key": "450323"
    }, {
      "value": "全州县",
      "key": "450324"
    }, {
      "value": "兴安县",
      "key": "450325"
    }, {
      "value": "永福县",
      "key": "450326"
    }, {
      "value": "灌阳县",
      "key": "450327"
    }, {
      "value": "龙胜各族自治县",
      "key": "450328"
    }, {
      "value": "资源县",
      "key": "450329"
    }, {
      "value": "平乐县",
      "key": "450330"
    }, {
      "value": "荔蒲县",
      "key": "450331"
    }, {
      "value": "恭城瑶族自治县",
      "key": "450332"
    }],
    "key": "450300"
  }, {
    "value": "梧州市",
    "children": [{
      "value": "万秀区",
      "key": "450403"
    }, {
      "value": "蝶山区",
      "key": "450404"
    }, {
      "value": "长洲区",
      "key": "450405"
    }, {
      "value": "龙圩区",
      "key": "450406"
    }, {
      "value": "苍梧县",
      "key": "450421"
    }, {
      "value": "藤县",
      "key": "450422"
    }, {
      "value": "蒙山县",
      "key": "450423"
    }, {
      "value": "岑溪市",
      "key": "450481"
    }],
    "key": "450400"
  }, {
    "value": "北海市",
    "children": [{
      "value": "海城区",
      "key": "450502"
    }, {
      "value": "银海区",
      "key": "450503"
    }, {
      "value": "铁山港区",
      "key": "450512"
    }, {
      "value": "合浦县",
      "key": "450521"
    }],
    "key": "450500"
  }, {
    "value": "防城港市",
    "children": [{
      "value": "港口区",
      "key": "450602"
    }, {
      "value": "防城区",
      "key": "450603"
    }, {
      "value": "上思县",
      "key": "450621"
    }, {
      "value": "东兴市",
      "key": "450681"
    }],
    "key": "450600"
  }, {
    "value": "钦州市",
    "children": [{
      "value": "钦南区",
      "key": "450702"
    }, {
      "value": "钦北区",
      "key": "450703"
    }, {
      "value": "灵山县",
      "key": "450721"
    }, {
      "value": "浦北县",
      "key": "450722"
    }],
    "key": "450700"
  }, {
    "value": "贵港市",
    "children": [{
      "value": "港北区",
      "key": "450802"
    }, {
      "value": "港南区",
      "key": "450803"
    }, {
      "value": "覃塘区",
      "key": "450804"
    }, {
      "value": "平南县",
      "key": "450821"
    }, {
      "value": "桂平市",
      "key": "450881"
    }],
    "key": "450800"
  }, {
    "value": "玉林市",
    "children": [{
      "value": "玉州区",
      "key": "450902"
    }, {
      "value": "容县",
      "key": "450921"
    }, {
      "value": "陆川县",
      "key": "450922"
    }, {
      "value": "博白县",
      "key": "450923"
    }, {
      "value": "兴业县",
      "key": "450924"
    }, {
      "value": "北流市",
      "key": "450981"
    }],
    "key": "450900"
  }, {
    "value": "百色市",
    "children": [{
      "value": "右江区",
      "key": "451002"
    }, {
      "value": "田阳县",
      "key": "451021"
    }, {
      "value": "田东县",
      "key": "451022"
    }, {
      "value": "平果县",
      "key": "451023"
    }, {
      "value": "德保县",
      "key": "451024"
    }, {
      "value": "靖西县",
      "key": "451025"
    }, {
      "value": "那坡县",
      "key": "451026"
    }, {
      "value": "凌云县",
      "key": "451027"
    }, {
      "value": "乐业县",
      "key": "451028"
    }, {
      "value": "田林县",
      "key": "451029"
    }, {
      "value": "西林县",
      "key": "451030"
    }, {
      "value": "隆林各族自治县",
      "key": "451031"
    }],
    "key": "451000"
  }, {
    "value": "贺州市",
    "children": [{
      "value": "八步区",
      "key": "451102"
    }, {
      "value": "昭平县",
      "key": "451121"
    }, {
      "value": "钟山县",
      "key": "451122"
    }, {
      "value": "富川瑶族自治县",
      "key": "451123"
    }],
    "key": "451100"
  }, {
    "value": "河池市",
    "children": [{
      "value": "金城江区",
      "key": "451202"
    }, {
      "value": "南丹县",
      "key": "451221"
    }, {
      "value": "天峨县",
      "key": "451222"
    }, {
      "value": "凤山县",
      "key": "451223"
    }, {
      "value": "东兰县",
      "key": "451224"
    }, {
      "value": "罗城仫佬族自治县",
      "key": "451225"
    }, {
      "value": "环江毛南族自治县",
      "key": "451226"
    }, {
      "value": "巴马瑶族自治县",
      "key": "451227"
    }, {
      "value": "都安瑶族自治县",
      "key": "451228"
    }, {
      "value": "大化瑶族自治县",
      "key": "451229"
    }, {
      "value": "宜州市",
      "key": "451281"
    }],
    "key": "451200"
  }, {
    "value": "来宾市",
    "children": [{
      "value": "兴宾区",
      "key": "451302"
    }, {
      "value": "忻城县",
      "key": "451321"
    }, {
      "value": "象州县",
      "key": "451322"
    }, {
      "value": "武宣县",
      "key": "451323"
    }, {
      "value": "金秀瑶族自治县",
      "key": "451324"
    }, {
      "value": "合山市",
      "key": "451381"
    }],
    "key": "451300"
  }, {
    "value": "崇左市",
    "children": [{
      "value": "江州区",
      "key": "451402"
    }, {
      "value": "扶绥县",
      "key": "451421"
    }, {
      "value": "宁明县",
      "key": "451422"
    }, {
      "value": "龙州县",
      "key": "451423"
    }, {
      "value": "大新县",
      "key": "451424"
    }, {
      "value": "天等县",
      "key": "451425"
    }, {
      "value": "凭祥市",
      "key": "451481"
    }],
    "key": "451400"
  }],
  "key": "450000"
}, {
  "value": "海南",
  "children": [{
    "value": "海口市",
    "children": [{
      "value": "秀英区",
      "key": "460105"
    }, {
      "value": "龙华区",
      "key": "460106"
    }, {
      "value": "琼山区",
      "key": "460107"
    }, {
      "value": "美兰区",
      "key": "460108"
    }],
    "key": "460100"
  }, {
    "value": "三亚市",
    "children": [{
      "value": "国营农场",
      "key": "460201"
    }, {
      "value": "海棠湾镇",
      "key": "460202"
    }, {
      "value": "吉阳镇",
      "key": "460203"
    }, {
      "value": "凤凰镇",
      "key": "460204"
    }, {
      "value": "河西区",
      "key": "460205"
    }, {
      "value": "河东区",
      "key": "460206"
    }, {
      "value": "崖城镇",
      "key": "460207"
    }, {
      "value": "天涯镇",
      "key": "460208"
    }, {
      "value": "育才镇",
      "key": "460209"
    }],
    "key": "460200"
  }, {
    "value": "五指山市",
    "key": "469001"
  }, {
    "value": "琼海市",
    "key": "469002"
  }, {
    "value": "儋州市",
    "key": "469003"
  }, {
    "value": "文昌市",
    "key": "469005"
  }, {
    "value": "万宁市",
    "key": "469006"
  }, {
    "value": "东方市",
    "key": "469007"
  }, {
    "value": "定安县",
    "key": "469025"
  }, {
    "value": "屯昌县",
    "key": "469026"
  }, {
    "value": "澄迈县",
    "key": "469027"
  }, {
    "value": "临高县",
    "key": "469028"
  }, {
    "value": "白沙黎族自治县",
    "key": "469030"
  }, {
    "value": "昌江黎族自治县",
    "key": "469031"
  }, {
    "value": "乐东黎族自治县",
    "key": "469033"
  }, {
    "value": "陵水黎族自治县",
    "key": "469034"
  }, {
    "value": "保亭黎族苗族自治县",
    "key": "469035"
  }, {
    "value": "琼中黎族苗族自治县",
    "key": "469036"
  }, {
    "value": "西沙群岛",
    "key": "469037"
  }, {
    "value": "南沙群岛",
    "key": "469038"
  }, {
    "value": "中沙群岛的岛礁及其海域",
    "key": "469039"
  }],
  "key": "460000"
}, {
  "value": "重庆",
  "children": [{
    "value": "万州区",
    "key": "500101"
  }, {
    "value": "涪陵区",
    "key": "500102"
  }, {
    "value": "渝中区",
    "key": "500103"
  }, {
    "value": "大渡口区",
    "key": "500104"
  }, {
    "value": "江北区",
    "key": "500105"
  }, {
    "value": "沙坪坝区",
    "key": "500106"
  }, {
    "value": "九龙坡区",
    "key": "500107"
  }, {
    "value": "南岸区",
    "key": "500108"
  }, {
    "value": "北碚区",
    "key": "500109"
  }, {
    "value": "万盛区",
    "key": "500110"
  }, {
    "value": "双桥区",
    "key": "500111"
  }, {
    "value": "渝北区",
    "key": "500112"
  }, {
    "value": "巴南区",
    "key": "500113"
  }, {
    "value": "黔江区",
    "key": "500114"
  }, {
    "value": "长寿区",
    "key": "500115"
  }, {
    "value": "綦江县",
    "key": "500222"
  }, {
    "value": "潼南县",
    "key": "500223"
  }, {
    "value": "铜梁县",
    "key": "500224"
  }, {
    "value": "大足县",
    "key": "500225"
  }, {
    "value": "荣昌县",
    "key": "500226"
  }, {
    "value": "璧山县",
    "key": "500227"
  }, {
    "value": "梁平县",
    "key": "500228"
  }, {
    "value": "城口县",
    "key": "500229"
  }, {
    "value": "丰都县",
    "key": "500230"
  }, {
    "value": "垫江县",
    "key": "500231"
  }, {
    "value": "武隆县",
    "key": "500232"
  }, {
    "value": "忠县",
    "key": "500233"
  }, {
    "value": "开县",
    "key": "500234"
  }, {
    "value": "云阳县",
    "key": "500235"
  }, {
    "value": "奉节县",
    "key": "500236"
  }, {
    "value": "巫山县",
    "key": "500237"
  }, {
    "value": "巫溪县",
    "key": "500238"
  }, {
    "value": "石柱土家族自治县",
    "key": "500240"
  }, {
    "value": "秀山土家族苗族自治县",
    "key": "500241"
  }, {
    "value": "酉阳土家族苗族自治县",
    "key": "500242"
  }, {
    "value": "彭水苗族土家族自治县",
    "key": "500243"
  }, {
    "value": "市区",
    "key": "500300"
  }, {
    "value": "江津区",
    "key": "500381"
  }, {
    "value": "合川区",
    "key": "500382"
  }, {
    "value": "永川区",
    "key": "500383"
  }, {
    "value": "南川区",
    "key": "500384"
  }],
  "key": "500000"
}, {
  "value": "四川",
  "children": [{
    "value": "成都市",
    "children": [{
      "value": "锦江区",
      "key": "510104"
    }, {
      "value": "青羊区",
      "key": "510105"
    }, {
      "value": "金牛区",
      "key": "510106"
    }, {
      "value": "武侯区",
      "key": "510107"
    }, {
      "value": "成华区",
      "key": "510108"
    }, {
      "value": "龙泉驿区",
      "key": "510112"
    }, {
      "value": "青白江区",
      "key": "510113"
    }, {
      "value": "新都区",
      "key": "510114"
    }, {
      "value": "温江区",
      "key": "510115"
    }, {
      "value": "金堂县",
      "key": "510121"
    }, {
      "value": "双流县",
      "key": "510122"
    }, {
      "value": "郫县",
      "key": "510124"
    }, {
      "value": "大邑县",
      "key": "510129"
    }, {
      "value": "蒲江县",
      "key": "510131"
    }, {
      "value": "新津县",
      "key": "510132"
    }, {
      "value": "都江堰市",
      "key": "510181"
    }, {
      "value": "彭州市",
      "key": "510182"
    }, {
      "value": "邛崃市",
      "key": "510183"
    }, {
      "value": "崇州市",
      "key": "510184"
    }],
    "key": "510100"
  }, {
    "value": "自贡市",
    "children": [{
      "value": "自流井区",
      "key": "510302"
    }, {
      "value": "贡井区",
      "key": "510303"
    }, {
      "value": "大安区",
      "key": "510304"
    }, {
      "value": "沿滩区",
      "key": "510311"
    }, {
      "value": "荣县",
      "key": "510321"
    }, {
      "value": "富顺县",
      "key": "510322"
    }],
    "key": "510300"
  }, {
    "value": "攀枝花市",
    "children": [{
      "value": "东区",
      "key": "510402"
    }, {
      "value": "西区",
      "key": "510403"
    }, {
      "value": "仁和区",
      "key": "510411"
    }, {
      "value": "米易县",
      "key": "510421"
    }, {
      "value": "盐边县",
      "key": "510422"
    }],
    "key": "510400"
  }, {
    "value": "泸州市",
    "children": [{
      "value": "江阳区",
      "key": "510502"
    }, {
      "value": "纳溪区",
      "key": "510503"
    }, {
      "value": "龙马潭区",
      "key": "510504"
    }, {
      "value": "泸县",
      "key": "510521"
    }, {
      "value": "合江县",
      "key": "510522"
    }, {
      "value": "叙永县",
      "key": "510524"
    }, {
      "value": "古蔺县",
      "key": "510525"
    }],
    "key": "510500"
  }, {
    "value": "德阳市",
    "children": [{
      "value": "旌阳区",
      "key": "510603"
    }, {
      "value": "中江县",
      "key": "510623"
    }, {
      "value": "罗江县",
      "key": "510626"
    }, {
      "value": "广汉市",
      "key": "510681"
    }, {
      "value": "什邡市",
      "key": "510682"
    }, {
      "value": "绵竹市",
      "key": "510683"
    }],
    "key": "510600"
  }, {
    "value": "绵阳市",
    "children": [{
      "value": "涪城区",
      "key": "510703"
    }, {
      "value": "游仙区",
      "key": "510704"
    }, {
      "value": "三台县",
      "key": "510722"
    }, {
      "value": "盐亭县",
      "key": "510723"
    }, {
      "value": "安县",
      "key": "510724"
    }, {
      "value": "梓潼县",
      "key": "510725"
    }, {
      "value": "北川羌族自治县",
      "key": "510726"
    }, {
      "value": "平武县",
      "key": "510727"
    }, {
      "value": "江油市",
      "key": "510781"
    }],
    "key": "510700"
  }, {
    "value": "广元市",
    "children": [{
      "value": "利州区",
      "key": "510802"
    }, {
      "value": "元坝区",
      "key": "510811"
    }, {
      "value": "朝天区",
      "key": "510812"
    }, {
      "value": "旺苍县",
      "key": "510821"
    }, {
      "value": "青川县",
      "key": "510822"
    }, {
      "value": "剑阁县",
      "key": "510823"
    }, {
      "value": "苍溪县",
      "key": "510824"
    }],
    "key": "510800"
  }, {
    "value": "遂宁市",
    "children": [{
      "value": "船山区",
      "key": "510903"
    }, {
      "value": "安居区",
      "key": "510904"
    }, {
      "value": "蓬溪县",
      "key": "510921"
    }, {
      "value": "射洪县",
      "key": "510922"
    }, {
      "value": "大英县",
      "key": "510923"
    }],
    "key": "510900"
  }, {
    "value": "内江市",
    "children": [{
      "value": "市中区",
      "key": "511002"
    }, {
      "value": "东兴区",
      "key": "511011"
    }, {
      "value": "威远县",
      "key": "511024"
    }, {
      "value": "资中县",
      "key": "511025"
    }, {
      "value": "隆昌县",
      "key": "511028"
    }],
    "key": "511000"
  }, {
    "value": "乐山市",
    "children": [{
      "value": "市中区",
      "key": "511102"
    }, {
      "value": "沙湾区",
      "key": "511111"
    }, {
      "value": "五通桥区",
      "key": "511112"
    }, {
      "value": "金口河区",
      "key": "511113"
    }, {
      "value": "犍为县",
      "key": "511123"
    }, {
      "value": "井研县",
      "key": "511124"
    }, {
      "value": "夹江县",
      "key": "511126"
    }, {
      "value": "沐川县",
      "key": "511129"
    }, {
      "value": "峨边彝族自治县",
      "key": "511132"
    }, {
      "value": "马边彝族自治县",
      "key": "511133"
    }, {
      "value": "峨眉山市",
      "key": "511181"
    }],
    "key": "511100"
  }, {
    "value": "南充市",
    "children": [{
      "value": "顺庆区",
      "key": "511302"
    }, {
      "value": "高坪区",
      "key": "511303"
    }, {
      "value": "嘉陵区",
      "key": "511304"
    }, {
      "value": "南部县",
      "key": "511321"
    }, {
      "value": "营山县",
      "key": "511322"
    }, {
      "value": "蓬安县",
      "key": "511323"
    }, {
      "value": "仪陇县",
      "key": "511324"
    }, {
      "value": "西充县",
      "key": "511325"
    }, {
      "value": "阆中市",
      "key": "511381"
    }],
    "key": "511300"
  }, {
    "value": "眉山市",
    "children": [{
      "value": "东坡区",
      "key": "511402"
    }, {
      "value": "仁寿县",
      "key": "511421"
    }, {
      "value": "彭山县",
      "key": "511422"
    }, {
      "value": "洪雅县",
      "key": "511423"
    }, {
      "value": "丹棱县",
      "key": "511424"
    }, {
      "value": "青神县",
      "key": "511425"
    }],
    "key": "511400"
  }, {
    "value": "宜宾市",
    "children": [{
      "value": "翠屏区",
      "key": "511502"
    }, {
      "value": "南溪区",
      "key": "511503"
    }, {
      "value": "宜宾县",
      "key": "511521"
    }, {
      "value": "南溪县",
      "key": "511522"
    }, {
      "value": "江安县",
      "key": "511523"
    }, {
      "value": "长宁县",
      "key": "511524"
    }, {
      "value": "高县",
      "key": "511525"
    }, {
      "value": "珙县",
      "key": "511526"
    }, {
      "value": "筠连县",
      "key": "511527"
    }, {
      "value": "兴文县",
      "key": "511528"
    }, {
      "value": "屏山县",
      "key": "511529"
    }],
    "key": "511500"
  }, {
    "value": "广安市",
    "children": [{
      "value": "广安区",
      "key": "511602"
    }, {
      "value": "前锋区",
      "key": "511603"
    }, {
      "value": "岳池县",
      "key": "511621"
    }, {
      "value": "武胜县",
      "key": "511622"
    }, {
      "value": "邻水县",
      "key": "511623"
    }, {
      "value": "华蓥市",
      "key": "511681"
    }],
    "key": "511600"
  }, {
    "value": "达州市",
    "children": [{
      "value": "通川区",
      "key": "511702"
    }, {
      "value": "达县",
      "key": "511721"
    }, {
      "value": "宣汉县",
      "key": "511722"
    }, {
      "value": "开江县",
      "key": "511723"
    }, {
      "value": "大竹县",
      "key": "511724"
    }, {
      "value": "渠县",
      "key": "511725"
    }, {
      "value": "万源市",
      "key": "511781"
    }],
    "key": "511700"
  }, {
    "value": "雅安市",
    "children": [{
      "value": "雨城区",
      "key": "511802"
    }, {
      "value": "名山县",
      "key": "511821"
    }, {
      "value": "荥经县",
      "key": "511822"
    }, {
      "value": "汉源县",
      "key": "511823"
    }, {
      "value": "石棉县",
      "key": "511824"
    }, {
      "value": "天全县",
      "key": "511825"
    }, {
      "value": "芦山县",
      "key": "511826"
    }, {
      "value": "宝兴县",
      "key": "511827"
    }],
    "key": "511800"
  }, {
    "value": "巴中市",
    "children": [{
      "value": "巴州区",
      "key": "511902"
    }, {
      "value": "通江县",
      "key": "511921"
    }, {
      "value": "南江县",
      "key": "511922"
    }, {
      "value": "平昌县",
      "key": "511923"
    }],
    "key": "511900"
  }, {
    "value": "资阳市",
    "children": [{
      "value": "雁江区",
      "key": "512002"
    }, {
      "value": "安岳县",
      "key": "512021"
    }, {
      "value": "乐至县",
      "key": "512022"
    }, {
      "value": "简阳市",
      "key": "512081"
    }],
    "key": "512000"
  }, {
    "value": "阿坝藏族羌族自治州",
    "children": [{
      "value": "汶川县",
      "key": "513221"
    }, {
      "value": "理县",
      "key": "513222"
    }, {
      "value": "茂县",
      "key": "513223"
    }, {
      "value": "松潘县",
      "key": "513224"
    }, {
      "value": "九寨沟县",
      "key": "513225"
    }, {
      "value": "金川县",
      "key": "513226"
    }, {
      "value": "小金县",
      "key": "513227"
    }, {
      "value": "黑水县",
      "key": "513228"
    }, {
      "value": "马尔康县",
      "key": "513229"
    }, {
      "value": "壤塘县",
      "key": "513230"
    }, {
      "value": "阿坝县",
      "key": "513231"
    }, {
      "value": "若尔盖县",
      "key": "513232"
    }, {
      "value": "红原县",
      "key": "513233"
    }],
    "key": "513200"
  }, {
    "value": "甘孜藏族自治州",
    "children": [{
      "value": "康定县",
      "key": "513321"
    }, {
      "value": "泸定县",
      "key": "513322"
    }, {
      "value": "丹巴县",
      "key": "513323"
    }, {
      "value": "九龙县",
      "key": "513324"
    }, {
      "value": "雅江县",
      "key": "513325"
    }, {
      "value": "道孚县",
      "key": "513326"
    }, {
      "value": "炉霍县",
      "key": "513327"
    }, {
      "value": "甘孜县",
      "key": "513328"
    }, {
      "value": "新龙县",
      "key": "513329"
    }, {
      "value": "德格县",
      "key": "513330"
    }, {
      "value": "白玉县",
      "key": "513331"
    }, {
      "value": "石渠县",
      "key": "513332"
    }, {
      "value": "色达县",
      "key": "513333"
    }, {
      "value": "理塘县",
      "key": "513334"
    }, {
      "value": "巴塘县",
      "key": "513335"
    }, {
      "value": "乡城县",
      "key": "513336"
    }, {
      "value": "稻城县",
      "key": "513337"
    }, {
      "value": "得荣县",
      "key": "513338"
    }],
    "key": "513300"
  }, {
    "value": "凉山彝族自治州",
    "children": [{
      "value": "西昌市",
      "key": "513401"
    }, {
      "value": "木里藏族自治县",
      "key": "513422"
    }, {
      "value": "盐源县",
      "key": "513423"
    }, {
      "value": "德昌县",
      "key": "513424"
    }, {
      "value": "会理县",
      "key": "513425"
    }, {
      "value": "会东县",
      "key": "513426"
    }, {
      "value": "宁南县",
      "key": "513427"
    }, {
      "value": "普格县",
      "key": "513428"
    }, {
      "value": "布拖县",
      "key": "513429"
    }, {
      "value": "金阳县",
      "key": "513430"
    }, {
      "value": "昭觉县",
      "key": "513431"
    }, {
      "value": "喜德县",
      "key": "513432"
    }, {
      "value": "冕宁县",
      "key": "513433"
    }, {
      "value": "越西县",
      "key": "513434"
    }, {
      "value": "甘洛县",
      "key": "513435"
    }, {
      "value": "美姑县",
      "key": "513436"
    }, {
      "value": "雷波县",
      "key": "513437"
    }],
    "key": "513400"
  }],
  "key": "510000"
}, {
  "value": "贵州",
  "children": [{
    "value": "贵阳市",
    "children": [{
      "value": "南明区",
      "key": "520102"
    }, {
      "value": "云岩区",
      "key": "520103"
    }, {
      "value": "花溪区",
      "key": "520111"
    }, {
      "value": "乌当区",
      "key": "520112"
    }, {
      "value": "白云区",
      "key": "520113"
    }, {
      "value": "小河区",
      "key": "520114"
    }, {
      "value": "开阳县",
      "key": "520121"
    }, {
      "value": "息烽县",
      "key": "520122"
    }, {
      "value": "修文县",
      "key": "520123"
    }, {
      "value": "清镇市",
      "key": "520181"
    }],
    "key": "520100"
  }, {
    "value": "六盘水市",
    "children": [{
      "value": "钟山区",
      "key": "520201"
    }, {
      "value": "六枝特区",
      "key": "520203"
    }, {
      "value": "水城县",
      "key": "520221"
    }, {
      "value": "盘县",
      "key": "520222"
    }],
    "key": "520200"
  }, {
    "value": "遵义市",
    "children": [{
      "value": "红花岗区",
      "key": "520302"
    }, {
      "value": "汇川区",
      "key": "520303"
    }, {
      "value": "遵义县",
      "key": "520321"
    }, {
      "value": "桐梓县",
      "key": "520322"
    }, {
      "value": "绥阳县",
      "key": "520323"
    }, {
      "value": "正安县",
      "key": "520324"
    }, {
      "value": "道真仡佬族苗族自治县",
      "key": "520325"
    }, {
      "value": "务川仡佬族苗族自治县",
      "key": "520326"
    }, {
      "value": "凤冈县",
      "key": "520327"
    }, {
      "value": "湄潭县",
      "key": "520328"
    }, {
      "value": "余庆县",
      "key": "520329"
    }, {
      "value": "习水县",
      "key": "520330"
    }, {
      "value": "赤水市",
      "key": "520381"
    }, {
      "value": "仁怀市",
      "key": "520382"
    }],
    "key": "520300"
  }, {
    "value": "安顺市",
    "children": [{
      "value": "西秀区",
      "key": "520402"
    }, {
      "value": "平坝县",
      "key": "520421"
    }, {
      "value": "普定县",
      "key": "520422"
    }, {
      "value": "镇宁布依族苗族自治县",
      "key": "520423"
    }, {
      "value": "关岭布依族苗族自治县",
      "key": "520424"
    }, {
      "value": "紫云苗族布依族自治县",
      "key": "520425"
    }],
    "key": "520400"
  }, {
    "value": "铜仁地区",
    "children": [{
      "value": "碧江区",
      "key": "522202"
    }, {
      "value": "万山区",
      "key": "522203"
    }, {
      "value": "江口县",
      "key": "522222"
    }, {
      "value": "玉屏侗族自治县",
      "key": "522223"
    }, {
      "value": "石阡县",
      "key": "522224"
    }, {
      "value": "思南县",
      "key": "522225"
    }, {
      "value": "印江土家族苗族自治县",
      "key": "522226"
    }, {
      "value": "德江县",
      "key": "522227"
    }, {
      "value": "沿河土家族自治县",
      "key": "522228"
    }, {
      "value": "松桃苗族自治县",
      "key": "522229"
    }],
    "key": "522200"
  }, {
    "value": "黔西南布依族苗族自治州",
    "children": [{
      "value": "兴义市",
      "key": "522301"
    }, {
      "value": "兴仁县",
      "key": "522322"
    }, {
      "value": "普安县",
      "key": "522323"
    }, {
      "value": "晴隆县",
      "key": "522324"
    }, {
      "value": "贞丰县",
      "key": "522325"
    }, {
      "value": "望谟县",
      "key": "522326"
    }, {
      "value": "册亨县",
      "key": "522327"
    }, {
      "value": "安龙县",
      "key": "522328"
    }],
    "key": "522300"
  }, {
    "value": "毕节地区",
    "children": [{
      "value": "七星关区",
      "key": "522402"
    }, {
      "value": "大方县",
      "key": "522422"
    }, {
      "value": "黔西县",
      "key": "522423"
    }, {
      "value": "金沙县",
      "key": "522424"
    }, {
      "value": "织金县",
      "key": "522425"
    }, {
      "value": "纳雍县",
      "key": "522426"
    }, {
      "value": "威宁彝族回族苗族自治县",
      "key": "522427"
    }, {
      "value": "赫章县",
      "key": "522428"
    }],
    "key": "522400"
  }, {
    "value": "黔东南苗族侗族自治州",
    "children": [{
      "value": "凯里市",
      "key": "522601"
    }, {
      "value": "黄平县",
      "key": "522622"
    }, {
      "value": "施秉县",
      "key": "522623"
    }, {
      "value": "三穗县",
      "key": "522624"
    }, {
      "value": "镇远县",
      "key": "522625"
    }, {
      "value": "岑巩县",
      "key": "522626"
    }, {
      "value": "天柱县",
      "key": "522627"
    }, {
      "value": "锦屏县",
      "key": "522628"
    }, {
      "value": "剑河县",
      "key": "522629"
    }, {
      "value": "台江县",
      "key": "522630"
    }, {
      "value": "黎平县",
      "key": "522631"
    }, {
      "value": "榕江县",
      "key": "522632"
    }, {
      "value": "从江县",
      "key": "522633"
    }, {
      "value": "雷山县",
      "key": "522634"
    }, {
      "value": "麻江县",
      "key": "522635"
    }, {
      "value": "丹寨县",
      "key": "522636"
    }],
    "key": "522600"
  }, {
    "value": "黔南布依族苗族自治州",
    "children": [{
      "value": "都匀市",
      "key": "522701"
    }, {
      "value": "福泉市",
      "key": "522702"
    }, {
      "value": "荔波县",
      "key": "522722"
    }, {
      "value": "贵定县",
      "key": "522723"
    }, {
      "value": "瓮安县",
      "key": "522725"
    }, {
      "value": "独山县",
      "key": "522726"
    }, {
      "value": "平塘县",
      "key": "522727"
    }, {
      "value": "罗甸县",
      "key": "522728"
    }, {
      "value": "长顺县",
      "key": "522729"
    }, {
      "value": "龙里县",
      "key": "522730"
    }, {
      "value": "惠水县",
      "key": "522731"
    }, {
      "value": "三都水族自治县",
      "key": "522732"
    }],
    "key": "522700"
  }],
  "key": "520000"
}, {
  "value": "云南",
  "children": [{
    "value": "昆明市",
    "children": [{
      "value": "五华区",
      "key": "530102"
    }, {
      "value": "盘龙区",
      "key": "530103"
    }, {
      "value": "官渡区",
      "key": "530111"
    }, {
      "value": "西山区",
      "key": "530112"
    }, {
      "value": "东川区",
      "key": "530113"
    }, {
      "value": "呈贡区",
      "key": "530114"
    }, {
      "value": "呈贡县",
      "key": "530121"
    }, {
      "value": "晋宁县",
      "key": "530122"
    }, {
      "value": "富民县",
      "key": "530124"
    }, {
      "value": "宜良县",
      "key": "530125"
    }, {
      "value": "石林彝族自治县",
      "key": "530126"
    }, {
      "value": "嵩明县",
      "key": "530127"
    }, {
      "value": "禄劝彝族苗族自治县",
      "key": "530128"
    }, {
      "value": "寻甸回族彝族自治县",
      "key": "530129"
    }, {
      "value": "安宁市",
      "key": "530181"
    }],
    "key": "530100"
  }, {
    "value": "曲靖市",
    "children": [{
      "value": "麒麟区",
      "key": "530302"
    }, {
      "value": "马龙县",
      "key": "530321"
    }, {
      "value": "陆良县",
      "key": "530322"
    }, {
      "value": "师宗县",
      "key": "530323"
    }, {
      "value": "罗平县",
      "key": "530324"
    }, {
      "value": "富源县",
      "key": "530325"
    }, {
      "value": "会泽县",
      "key": "530326"
    }, {
      "value": "沾益县",
      "key": "530328"
    }, {
      "value": "宣威市",
      "key": "530381"
    }],
    "key": "530300"
  }, {
    "value": "玉溪市",
    "children": [{
      "value": "红塔区",
      "key": "530402"
    }, {
      "value": "江川县",
      "key": "530421"
    }, {
      "value": "澄江县",
      "key": "530422"
    }, {
      "value": "通海县",
      "key": "530423"
    }, {
      "value": "华宁县",
      "key": "530424"
    }, {
      "value": "易门县",
      "key": "530425"
    }, {
      "value": "峨山彝族自治县",
      "key": "530426"
    }, {
      "value": "新平彝族傣族自治县",
      "key": "530427"
    }, {
      "value": "元江哈尼族彝族傣族自治县",
      "key": "530428"
    }],
    "key": "530400"
  }, {
    "value": "保山市",
    "children": [{
      "value": "隆阳区",
      "key": "530502"
    }, {
      "value": "施甸县",
      "key": "530521"
    }, {
      "value": "腾冲县",
      "key": "530522"
    }, {
      "value": "龙陵县",
      "key": "530523"
    }, {
      "value": "昌宁县",
      "key": "530524"
    }],
    "key": "530500"
  }, {
    "value": "昭通市",
    "children": [{
      "value": "昭阳区",
      "key": "530602"
    }, {
      "value": "鲁甸县",
      "key": "530621"
    }, {
      "value": "巧家县",
      "key": "530622"
    }, {
      "value": "盐津县",
      "key": "530623"
    }, {
      "value": "大关县",
      "key": "530624"
    }, {
      "value": "永善县",
      "key": "530625"
    }, {
      "value": "绥江县",
      "key": "530626"
    }, {
      "value": "镇雄县",
      "key": "530627"
    }, {
      "value": "彝良县",
      "key": "530628"
    }, {
      "value": "威信县",
      "key": "530629"
    }, {
      "value": "水富县",
      "key": "530630"
    }],
    "key": "530600"
  }, {
    "value": "丽江市",
    "children": [{
      "value": "古城区",
      "key": "530702"
    }, {
      "value": "玉龙纳西族自治县",
      "key": "530721"
    }, {
      "value": "永胜县",
      "key": "530722"
    }, {
      "value": "华坪县",
      "key": "530723"
    }, {
      "value": "宁蒗彝族自治县",
      "key": "530724"
    }],
    "key": "530700"
  }, {
    "value": "普洱市",
    "children": [{
      "value": "思茅区",
      "key": "530802"
    }, {
      "value": "宁洱哈尼族彝族自治县",
      "key": "530821"
    }, {
      "value": "墨江哈尼族自治县",
      "key": "530822"
    }, {
      "value": "景东彝族自治县",
      "key": "530823"
    }, {
      "value": "景谷傣族彝族自治县",
      "key": "530824"
    }, {
      "value": "镇沅彝族哈尼族拉祜族自治县",
      "key": "530825"
    }, {
      "value": "江城哈尼族彝族自治县",
      "key": "530826"
    }, {
      "value": "孟连傣族拉祜族佤族自治县",
      "key": "530827"
    }, {
      "value": "澜沧拉祜族自治县",
      "key": "530828"
    }, {
      "value": "西盟佤族自治县",
      "key": "530829"
    }],
    "key": "530800"
  }, {
    "value": "临沧市",
    "children": [{
      "value": "临翔区",
      "key": "530902"
    }, {
      "value": "凤庆县",
      "key": "530921"
    }, {
      "value": "云县",
      "key": "530922"
    }, {
      "value": "永德县",
      "key": "530923"
    }, {
      "value": "镇康县",
      "key": "530924"
    }, {
      "value": "双江拉祜族佤族布朗族傣族自治县",
      "key": "530925"
    }, {
      "value": "耿马傣族佤族自治县",
      "key": "530926"
    }, {
      "value": "沧源佤族自治县",
      "key": "530927"
    }],
    "key": "530900"
  }, {
    "value": "楚雄彝族自治州",
    "children": [{
      "value": "楚雄市",
      "key": "532301"
    }, {
      "value": "双柏县",
      "key": "532322"
    }, {
      "value": "牟定县",
      "key": "532323"
    }, {
      "value": "南华县",
      "key": "532324"
    }, {
      "value": "姚安县",
      "key": "532325"
    }, {
      "value": "大姚县",
      "key": "532326"
    }, {
      "value": "永仁县",
      "key": "532327"
    }, {
      "value": "元谋县",
      "key": "532328"
    }, {
      "value": "武定县",
      "key": "532329"
    }, {
      "value": "禄丰县",
      "key": "532331"
    }],
    "key": "532300"
  }, {
    "value": "红河哈尼族彝族自治州",
    "children": [{
      "value": "个旧市",
      "key": "532501"
    }, {
      "value": "开远市",
      "key": "532502"
    }, {
      "value": "蒙自市",
      "key": "532503"
    }, {
      "value": "蒙自市",
      "key": "532522"
    }, {
      "value": "屏边苗族自治县",
      "key": "532523"
    }, {
      "value": "建水县",
      "key": "532524"
    }, {
      "value": "石屏县",
      "key": "532525"
    }, {
      "value": "弥勒县",
      "key": "532526"
    }, {
      "value": "泸西县",
      "key": "532527"
    }, {
      "value": "元阳县",
      "key": "532528"
    }, {
      "value": "红河县",
      "key": "532529"
    }, {
      "value": "金平苗族瑶族傣族自治县",
      "key": "532530"
    }, {
      "value": "绿春县",
      "key": "532531"
    }, {
      "value": "河口瑶族自治县",
      "key": "532532"
    }],
    "key": "532500"
  }, {
    "value": "文山壮族苗族自治州",
    "children": [{
      "value": "文山市",
      "key": "532601"
    }, {
      "value": "文山市",
      "key": "532621"
    }, {
      "value": "砚山县",
      "key": "532622"
    }, {
      "value": "西畴县",
      "key": "532623"
    }, {
      "value": "麻栗坡县",
      "key": "532624"
    }, {
      "value": "马关县",
      "key": "532625"
    }, {
      "value": "丘北县",
      "key": "532626"
    }, {
      "value": "广南县",
      "key": "532627"
    }, {
      "value": "富宁县",
      "key": "532628"
    }],
    "key": "532600"
  }, {
    "value": "西双版纳傣族自治州",
    "children": [{
      "value": "景洪市",
      "key": "532801"
    }, {
      "value": "勐海县",
      "key": "532822"
    }, {
      "value": "勐腊县",
      "key": "532823"
    }],
    "key": "532800"
  }, {
    "value": "大理白族自治州",
    "children": [{
      "value": "大理市",
      "key": "532901"
    }, {
      "value": "漾濞彝族自治县",
      "key": "532922"
    }, {
      "value": "祥云县",
      "key": "532923"
    }, {
      "value": "宾川县",
      "key": "532924"
    }, {
      "value": "弥渡县",
      "key": "532925"
    }, {
      "value": "南涧彝族自治县",
      "key": "532926"
    }, {
      "value": "巍山彝族回族自治县",
      "key": "532927"
    }, {
      "value": "永平县",
      "key": "532928"
    }, {
      "value": "云龙县",
      "key": "532929"
    }, {
      "value": "洱源县",
      "key": "532930"
    }, {
      "value": "剑川县",
      "key": "532931"
    }, {
      "value": "鹤庆县",
      "key": "532932"
    }],
    "key": "532900"
  }, {
    "value": "德宏傣族景颇族自治州",
    "children": [{
      "value": "瑞丽市",
      "key": "533102"
    }, {
      "value": "芒市",
      "key": "533103"
    }, {
      "value": "梁河县",
      "key": "533122"
    }, {
      "value": "盈江县",
      "key": "533123"
    }, {
      "value": "陇川县",
      "key": "533124"
    }],
    "key": "533100"
  }, {
    "value": "怒江傈僳族自治州",
    "children": [{
      "value": "泸水县",
      "key": "533321"
    }, {
      "value": "福贡县",
      "key": "533323"
    }, {
      "value": "贡山独龙族怒族自治县",
      "key": "533324"
    }, {
      "value": "兰坪白族普米族自治县",
      "key": "533325"
    }],
    "key": "533300"
  }, {
    "value": "迪庆藏族自治州",
    "children": [{
      "value": "香格里拉县",
      "key": "533421"
    }, {
      "value": "德钦县",
      "key": "533422"
    }, {
      "value": "维西傈僳族自治县",
      "key": "533423"
    }],
    "key": "533400"
  }],
  "key": "530000"
}, {
  "value": "西藏",
  "children": [{
    "value": "拉萨市",
    "children": [{
      "value": "城关区",
      "key": "540102"
    }, {
      "value": "林周县",
      "key": "540121"
    }, {
      "value": "当雄县",
      "key": "540122"
    }, {
      "value": "尼木县",
      "key": "540123"
    }, {
      "value": "曲水县",
      "key": "540124"
    }, {
      "value": "堆龙德庆县",
      "key": "540125"
    }, {
      "value": "达孜县",
      "key": "540126"
    }, {
      "value": "墨竹工卡县",
      "key": "540127"
    }],
    "key": "540100"
  }, {
    "value": "昌都地区",
    "children": [{
      "value": "昌都县",
      "key": "542121"
    }, {
      "value": "江达县",
      "key": "542122"
    }, {
      "value": "贡觉县",
      "key": "542123"
    }, {
      "value": "类乌齐县",
      "key": "542124"
    }, {
      "value": "丁青县",
      "key": "542125"
    }, {
      "value": "察雅县",
      "key": "542126"
    }, {
      "value": "八宿县",
      "key": "542127"
    }, {
      "value": "左贡县",
      "key": "542128"
    }, {
      "value": "芒康县",
      "key": "542129"
    }, {
      "value": "洛隆县",
      "key": "542132"
    }, {
      "value": "边坝县",
      "key": "542133"
    }],
    "key": "542100"
  }, {
    "value": "山南地区",
    "children": [{
      "value": "乃东县",
      "key": "542221"
    }, {
      "value": "扎囊县",
      "key": "542222"
    }, {
      "value": "贡嘎县",
      "key": "542223"
    }, {
      "value": "桑日县",
      "key": "542224"
    }, {
      "value": "琼结县",
      "key": "542225"
    }, {
      "value": "曲松县",
      "key": "542226"
    }, {
      "value": "措美县",
      "key": "542227"
    }, {
      "value": "洛扎县",
      "key": "542228"
    }, {
      "value": "加查县",
      "key": "542229"
    }, {
      "value": "隆子县",
      "key": "542231"
    }, {
      "value": "错那县",
      "key": "542232"
    }, {
      "value": "浪卡子县",
      "key": "542233"
    }],
    "key": "542200"
  }, {
    "value": "日喀则地区",
    "children": [{
      "value": "日喀则市",
      "key": "542301"
    }, {
      "value": "南木林县",
      "key": "542322"
    }, {
      "value": "江孜县",
      "key": "542323"
    }, {
      "value": "定日县",
      "key": "542324"
    }, {
      "value": "萨迦县",
      "key": "542325"
    }, {
      "value": "拉孜县",
      "key": "542326"
    }, {
      "value": "昂仁县",
      "key": "542327"
    }, {
      "value": "谢通门县",
      "key": "542328"
    }, {
      "value": "白朗县",
      "key": "542329"
    }, {
      "value": "仁布县",
      "key": "542330"
    }, {
      "value": "康马县",
      "key": "542331"
    }, {
      "value": "定结县",
      "key": "542332"
    }, {
      "value": "仲巴县",
      "key": "542333"
    }, {
      "value": "亚东县",
      "key": "542334"
    }, {
      "value": "吉隆县",
      "key": "542335"
    }, {
      "value": "聂拉木县",
      "key": "542336"
    }, {
      "value": "萨嘎县",
      "key": "542337"
    }, {
      "value": "岗巴县",
      "key": "542338"
    }],
    "key": "542300"
  }, {
    "value": "那曲地区",
    "children": [{
      "value": "那曲县",
      "key": "542421"
    }, {
      "value": "嘉黎县",
      "key": "542422"
    }, {
      "value": "比如县",
      "key": "542423"
    }, {
      "value": "聂荣县",
      "key": "542424"
    }, {
      "value": "安多县",
      "key": "542425"
    }, {
      "value": "申扎县",
      "key": "542426"
    }, {
      "value": "索县",
      "key": "542427"
    }, {
      "value": "班戈县",
      "key": "542428"
    }, {
      "value": "巴青县",
      "key": "542429"
    }, {
      "value": "尼玛县",
      "key": "542430"
    }],
    "key": "542400"
  }, {
    "value": "阿里地区",
    "children": [{
      "value": "普兰县",
      "key": "542521"
    }, {
      "value": "札达县",
      "key": "542522"
    }, {
      "value": "噶尔县",
      "key": "542523"
    }, {
      "value": "日土县",
      "key": "542524"
    }, {
      "value": "革吉县",
      "key": "542525"
    }, {
      "value": "改则县",
      "key": "542526"
    }, {
      "value": "措勤县",
      "key": "542527"
    }],
    "key": "542500"
  }, {
    "value": "林芝地区",
    "children": [{
      "value": "林芝县",
      "key": "542621"
    }, {
      "value": "工布江达县",
      "key": "542622"
    }, {
      "value": "米林县",
      "key": "542623"
    }, {
      "value": "墨脱县",
      "key": "542624"
    }, {
      "value": "波密县",
      "key": "542625"
    }, {
      "value": "察隅县",
      "key": "542626"
    }, {
      "value": "朗县",
      "key": "542627"
    }],
    "key": "542600"
  }],
  "key": "540000"
}, {
  "value": "陕西",
  "children": [{
    "value": "西安市",
    "children": [{
      "value": "新城区",
      "key": "610102"
    }, {
      "value": "碑林区",
      "key": "610103"
    }, {
      "value": "莲湖区",
      "key": "610104"
    }, {
      "value": "灞桥区",
      "key": "610111"
    }, {
      "value": "未央区",
      "key": "610112"
    }, {
      "value": "雁塔区",
      "key": "610113"
    }, {
      "value": "阎良区",
      "key": "610114"
    }, {
      "value": "临潼区",
      "key": "610115"
    }, {
      "value": "长安区",
      "key": "610116"
    }, {
      "value": "长安县",
      "key": "610121"
    }, {
      "value": "蓝田县",
      "key": "610122"
    }, {
      "value": "周至县",
      "key": "610124"
    }, {
      "value": "户县",
      "key": "610125"
    }, {
      "value": "高陵县",
      "key": "610126"
    }],
    "key": "610100"
  }, {
    "value": "铜川市",
    "children": [{
      "value": "王益区",
      "key": "610202"
    }, {
      "value": "印台区",
      "key": "610203"
    }, {
      "value": "耀州区",
      "key": "610204"
    }, {
      "value": "宜君县",
      "key": "610222"
    }],
    "key": "610200"
  }, {
    "value": "宝鸡市",
    "children": [{
      "value": "渭滨区",
      "key": "610302"
    }, {
      "value": "金台区",
      "key": "610303"
    }, {
      "value": "陈仓区",
      "key": "610304"
    }, {
      "value": "凤翔县",
      "key": "610322"
    }, {
      "value": "岐山县",
      "key": "610323"
    }, {
      "value": "扶风县",
      "key": "610324"
    }, {
      "value": "眉县",
      "key": "610326"
    }, {
      "value": "陇县",
      "key": "610327"
    }, {
      "value": "千阳县",
      "key": "610328"
    }, {
      "value": "麟游县",
      "key": "610329"
    }, {
      "value": "凤县",
      "key": "610330"
    }, {
      "value": "太白县",
      "key": "610331"
    }],
    "key": "610300"
  }, {
    "value": "咸阳市",
    "children": [{
      "value": "秦都区",
      "key": "610402"
    }, {
      "value": "杨陵区",
      "key": "610403"
    }, {
      "value": "渭城区",
      "key": "610404"
    }, {
      "value": "三原县",
      "key": "610422"
    }, {
      "value": "泾阳县",
      "key": "610423"
    }, {
      "value": "乾县",
      "key": "610424"
    }, {
      "value": "礼泉县",
      "key": "610425"
    }, {
      "value": "永寿县",
      "key": "610426"
    }, {
      "value": "彬县",
      "key": "610427"
    }, {
      "value": "长武县",
      "key": "610428"
    }, {
      "value": "旬邑县",
      "key": "610429"
    }, {
      "value": "淳化县",
      "key": "610430"
    }, {
      "value": "武功县",
      "key": "610431"
    }, {
      "value": "兴平市",
      "key": "610481"
    }],
    "key": "610400"
  }, {
    "value": "渭南市",
    "children": [{
      "value": "临渭区",
      "key": "610502"
    }, {
      "value": "华县",
      "key": "610521"
    }, {
      "value": "潼关县",
      "key": "610522"
    }, {
      "value": "大荔县",
      "key": "610523"
    }, {
      "value": "合阳县",
      "key": "610524"
    }, {
      "value": "澄城县",
      "key": "610525"
    }, {
      "value": "蒲城县",
      "key": "610526"
    }, {
      "value": "白水县",
      "key": "610527"
    }, {
      "value": "富平县",
      "key": "610528"
    }, {
      "value": "韩城市",
      "key": "610581"
    }, {
      "value": "华阴市",
      "key": "610582"
    }],
    "key": "610500"
  }, {
    "value": "延安市",
    "children": [{
      "value": "宝塔区",
      "key": "610602"
    }, {
      "value": "延长县",
      "key": "610621"
    }, {
      "value": "延川县",
      "key": "610622"
    }, {
      "value": "子长县",
      "key": "610623"
    }, {
      "value": "安塞县",
      "key": "610624"
    }, {
      "value": "志丹县",
      "key": "610625"
    }, {
      "value": "吴起县",
      "key": "610626"
    }, {
      "value": "甘泉县",
      "key": "610627"
    }, {
      "value": "富县",
      "key": "610628"
    }, {
      "value": "洛川县",
      "key": "610629"
    }, {
      "value": "宜川县",
      "key": "610630"
    }, {
      "value": "黄龙县",
      "key": "610631"
    }, {
      "value": "黄陵县",
      "key": "610632"
    }],
    "key": "610600"
  }, {
    "value": "汉中市",
    "children": [{
      "value": "汉台区",
      "key": "610702"
    }, {
      "value": "南郑县",
      "key": "610721"
    }, {
      "value": "城固县",
      "key": "610722"
    }, {
      "value": "洋县",
      "key": "610723"
    }, {
      "value": "西乡县",
      "key": "610724"
    }, {
      "value": "勉县",
      "key": "610725"
    }, {
      "value": "宁强县",
      "key": "610726"
    }, {
      "value": "略阳县",
      "key": "610727"
    }, {
      "value": "镇巴县",
      "key": "610728"
    }, {
      "value": "留坝县",
      "key": "610729"
    }, {
      "value": "佛坪县",
      "key": "610730"
    }],
    "key": "610700"
  }, {
    "value": "榆林市",
    "children": [{
      "value": "榆阳区",
      "key": "610802"
    }, {
      "value": "神木县",
      "key": "610821"
    }, {
      "value": "府谷县",
      "key": "610822"
    }, {
      "value": "横山县",
      "key": "610823"
    }, {
      "value": "靖边县",
      "key": "610824"
    }, {
      "value": "定边县",
      "key": "610825"
    }, {
      "value": "绥德县",
      "key": "610826"
    }, {
      "value": "米脂县",
      "key": "610827"
    }, {
      "value": "佳县",
      "key": "610828"
    }, {
      "value": "吴堡县",
      "key": "610829"
    }, {
      "value": "清涧县",
      "key": "610830"
    }, {
      "value": "子洲县",
      "key": "610831"
    }],
    "key": "610800"
  }, {
    "value": "安康市",
    "children": [{
      "value": "汉滨区",
      "key": "610902"
    }, {
      "value": "汉阴县",
      "key": "610921"
    }, {
      "value": "石泉县",
      "key": "610922"
    }, {
      "value": "宁陕县",
      "key": "610923"
    }, {
      "value": "紫阳县",
      "key": "610924"
    }, {
      "value": "岚皋县",
      "key": "610925"
    }, {
      "value": "平利县",
      "key": "610926"
    }, {
      "value": "镇坪县",
      "key": "610927"
    }, {
      "value": "旬阳县",
      "key": "610928"
    }, {
      "value": "白河县",
      "key": "610929"
    }],
    "key": "610900"
  }, {
    "value": "商洛市",
    "children": [{
      "value": "商州区",
      "key": "611002"
    }, {
      "value": "洛南县",
      "key": "611021"
    }, {
      "value": "丹凤县",
      "key": "611022"
    }, {
      "value": "商南县",
      "key": "611023"
    }, {
      "value": "山阳县",
      "key": "611024"
    }, {
      "value": "镇安县",
      "key": "611025"
    }, {
      "value": "柞水县",
      "key": "611026"
    }],
    "key": "611000"
  }],
  "key": "610000"
}, {
  "value": "甘肃",
  "children": [{
    "value": "兰州市",
    "children": [{
      "value": "城关区",
      "key": "620102"
    }, {
      "value": "七里河区",
      "key": "620103"
    }, {
      "value": "西固区",
      "key": "620104"
    }, {
      "value": "安宁区",
      "key": "620105"
    }, {
      "value": "红古区",
      "key": "620111"
    }, {
      "value": "永登县",
      "key": "620121"
    }, {
      "value": "皋兰县",
      "key": "620122"
    }, {
      "value": "榆中县",
      "key": "620123"
    }],
    "key": "620100"
  }, {
    "value": "嘉峪关市",
    "children": [{
      "value": "峪泉镇",
      "key": "620201"
    }, {
      "value": "文殊镇",
      "key": "620202"
    }, {
      "value": "新城镇",
      "key": "620203"
    }],
    "key": "620200"
  }, {
    "value": "金昌市",
    "children": [{
      "value": "金川区",
      "key": "620302"
    }, {
      "value": "永昌县",
      "key": "620321"
    }],
    "key": "620300"
  }, {
    "value": "白银市",
    "children": [{
      "value": "白银区",
      "key": "620402"
    }, {
      "value": "平川区",
      "key": "620403"
    }, {
      "value": "靖远县",
      "key": "620421"
    }, {
      "value": "会宁县",
      "key": "620422"
    }, {
      "value": "景泰县",
      "key": "620423"
    }],
    "key": "620400"
  }, {
    "value": "天水市",
    "children": [{
      "value": "秦州区",
      "key": "620502"
    }, {
      "value": "麦积区",
      "key": "620503"
    }, {
      "value": "清水县",
      "key": "620521"
    }, {
      "value": "秦安县",
      "key": "620522"
    }, {
      "value": "甘谷县",
      "key": "620523"
    }, {
      "value": "武山县",
      "key": "620524"
    }, {
      "value": "张家川回族自治县",
      "key": "620525"
    }],
    "key": "620500"
  }, {
    "value": "武威市",
    "children": [{
      "value": "凉州区",
      "key": "620602"
    }, {
      "value": "民勤县",
      "key": "620621"
    }, {
      "value": "古浪县",
      "key": "620622"
    }, {
      "value": "天祝藏族自治县",
      "key": "620623"
    }],
    "key": "620600"
  }, {
    "value": "张掖市",
    "children": [{
      "value": "甘州区",
      "key": "620702"
    }, {
      "value": "肃南裕固族自治县",
      "key": "620721"
    }, {
      "value": "民乐县",
      "key": "620722"
    }, {
      "value": "临泽县",
      "key": "620723"
    }, {
      "value": "高台县",
      "key": "620724"
    }, {
      "value": "山丹县",
      "key": "620725"
    }],
    "key": "620700"
  }, {
    "value": "平凉市",
    "children": [{
      "value": "崆峒区",
      "key": "620802"
    }, {
      "value": "泾川县",
      "key": "620821"
    }, {
      "value": "灵台县",
      "key": "620822"
    }, {
      "value": "崇信县",
      "key": "620823"
    }, {
      "value": "华亭县",
      "key": "620824"
    }, {
      "value": "庄浪县",
      "key": "620825"
    }, {
      "value": "静宁县",
      "key": "620826"
    }],
    "key": "620800"
  }, {
    "value": "酒泉市",
    "children": [{
      "value": "肃州区",
      "key": "620902"
    }, {
      "value": "金塔县",
      "key": "620921"
    }, {
      "value": "瓜州县",
      "key": "620922"
    }, {
      "value": "肃北蒙古族自治县",
      "key": "620923"
    }, {
      "value": "阿克塞哈萨克族自治县",
      "key": "620924"
    }, {
      "value": "玉门市",
      "key": "620981"
    }, {
      "value": "敦煌市",
      "key": "620982"
    }],
    "key": "620900"
  }, {
    "value": "庆阳市",
    "children": [{
      "value": "西峰区",
      "key": "621002"
    }, {
      "value": "庆城县",
      "key": "621021"
    }, {
      "value": "环县",
      "key": "621022"
    }, {
      "value": "华池县",
      "key": "621023"
    }, {
      "value": "合水县",
      "key": "621024"
    }, {
      "value": "正宁县",
      "key": "621025"
    }, {
      "value": "宁县",
      "key": "621026"
    }, {
      "value": "镇原县",
      "key": "621027"
    }],
    "key": "621000"
  }, {
    "value": "定西市",
    "children": [{
      "value": "安定区",
      "key": "621102"
    }, {
      "value": "通渭县",
      "key": "621121"
    }, {
      "value": "陇西县",
      "key": "621122"
    }, {
      "value": "渭源县",
      "key": "621123"
    }, {
      "value": "临洮县",
      "key": "621124"
    }, {
      "value": "漳县",
      "key": "621125"
    }, {
      "value": "岷县",
      "key": "621126"
    }],
    "key": "621100"
  }, {
    "value": "陇南市",
    "children": [{
      "value": "武都区",
      "key": "621202"
    }, {
      "value": "成县",
      "key": "621221"
    }, {
      "value": "文县",
      "key": "621222"
    }, {
      "value": "宕昌县",
      "key": "621223"
    }, {
      "value": "康县",
      "key": "621224"
    }, {
      "value": "西和县",
      "key": "621225"
    }, {
      "value": "礼县",
      "key": "621226"
    }, {
      "value": "徽县",
      "key": "621227"
    }, {
      "value": "两当县",
      "key": "621228"
    }],
    "key": "621200"
  }, {
    "value": "临夏回族自治州",
    "children": [{
      "value": "临夏市",
      "key": "622901"
    }, {
      "value": "临夏县",
      "key": "622921"
    }, {
      "value": "康乐县",
      "key": "622922"
    }, {
      "value": "永靖县",
      "key": "622923"
    }, {
      "value": "广河县",
      "key": "622924"
    }, {
      "value": "和政县",
      "key": "622925"
    }, {
      "value": "东乡族自治县",
      "key": "622926"
    }, {
      "value": "积石山保安族东乡族撒拉族自治县",
      "key": "622927"
    }],
    "key": "622900"
  }, {
    "value": "甘南藏族自治州",
    "children": [{
      "value": "合作市",
      "key": "623001"
    }, {
      "value": "临潭县",
      "key": "623021"
    }, {
      "value": "卓尼县",
      "key": "623022"
    }, {
      "value": "舟曲县",
      "key": "623023"
    }, {
      "value": "迭部县",
      "key": "623024"
    }, {
      "value": "玛曲县",
      "key": "623025"
    }, {
      "value": "碌曲县",
      "key": "623026"
    }, {
      "value": "夏河县",
      "key": "623027"
    }],
    "key": "623000"
  }],
  "key": "620000"
}, {
  "value": "青海",
  "children": [{
    "value": "西宁市",
    "children": [{
      "value": "城东区",
      "key": "630102"
    }, {
      "value": "城中区",
      "key": "630103"
    }, {
      "value": "城西区",
      "key": "630104"
    }, {
      "value": "城北区",
      "key": "630105"
    }, {
      "value": "大通回族土族自治县",
      "key": "630121"
    }, {
      "value": "湟中县",
      "key": "630122"
    }, {
      "value": "湟源县",
      "key": "630123"
    }],
    "key": "630100"
  }, {
    "value": "海东地区",
    "children": [{
      "value": "平安县",
      "key": "632121"
    }, {
      "value": "民和回族土族自治县",
      "key": "632122"
    }, {
      "value": "乐都县",
      "key": "632123"
    }, {
      "value": "互助土族自治县",
      "key": "632126"
    }, {
      "value": "化隆回族自治县",
      "key": "632127"
    }, {
      "value": "循化撒拉族自治县",
      "key": "632128"
    }],
    "key": "632100"
  }, {
    "value": "海北藏族自治州",
    "children": [{
      "value": "门源回族自治县",
      "key": "632221"
    }, {
      "value": "祁连县",
      "key": "632222"
    }, {
      "value": "海晏县",
      "key": "632223"
    }, {
      "value": "刚察县",
      "key": "632224"
    }],
    "key": "632200"
  }, {
    "value": "黄南藏族自治州",
    "children": [{
      "value": "同仁县",
      "key": "632321"
    }, {
      "value": "尖扎县",
      "key": "632322"
    }, {
      "value": "泽库县",
      "key": "632323"
    }, {
      "value": "河南蒙古族自治县",
      "key": "632324"
    }],
    "key": "632300"
  }, {
    "value": "海南藏族自治州",
    "children": [{
      "value": "共和县",
      "key": "632521"
    }, {
      "value": "同德县",
      "key": "632522"
    }, {
      "value": "贵德县",
      "key": "632523"
    }, {
      "value": "兴海县",
      "key": "632524"
    }, {
      "value": "贵南县",
      "key": "632525"
    }],
    "key": "632500"
  }, {
    "value": "果洛藏族自治州",
    "children": [{
      "value": "玛沁县",
      "key": "632621"
    }, {
      "value": "班玛县",
      "key": "632622"
    }, {
      "value": "甘德县",
      "key": "632623"
    }, {
      "value": "达日县",
      "key": "632624"
    }, {
      "value": "久治县",
      "key": "632625"
    }, {
      "value": "玛多县",
      "key": "632626"
    }],
    "key": "632600"
  }, {
    "value": "玉树藏族自治州",
    "children": [{
      "value": "玉树县",
      "key": "632721"
    }, {
      "value": "杂多县",
      "key": "632722"
    }, {
      "value": "称多县",
      "key": "632723"
    }, {
      "value": "治多县",
      "key": "632724"
    }, {
      "value": "囊谦县",
      "key": "632725"
    }, {
      "value": "曲麻莱县",
      "key": "632726"
    }],
    "key": "632700"
  }, {
    "value": "海西蒙古族藏族自治州",
    "children": [{
      "value": "格尔木市",
      "key": "632801"
    }, {
      "value": "德令哈市",
      "key": "632802"
    }, {
      "value": "乌兰县",
      "key": "632821"
    }, {
      "value": "都兰县",
      "key": "632822"
    }, {
      "value": "天峻县",
      "key": "632823"
    }],
    "key": "632800"
  }],
  "key": "630000"
}, {
  "value": "宁夏",
  "children": [{
    "value": "银川市",
    "children": [{
      "value": "兴庆区",
      "key": "640104"
    }, {
      "value": "西夏区",
      "key": "640105"
    }, {
      "value": "金凤区",
      "key": "640106"
    }, {
      "value": "永宁县",
      "key": "640121"
    }, {
      "value": "贺兰县",
      "key": "640122"
    }, {
      "value": "灵武市",
      "key": "640181"
    }],
    "key": "640100"
  }, {
    "value": "石嘴山市",
    "children": [{
      "value": "大武口区",
      "key": "640202"
    }, {
      "value": "惠农区",
      "key": "640205"
    }, {
      "value": "平罗县",
      "key": "640221"
    }],
    "key": "640200"
  }, {
    "value": "吴忠市",
    "children": [{
      "value": "红寺堡区",
      "key": "640301"
    }, {
      "value": "利通区",
      "key": "640302"
    }, {
      "value": "盐池县",
      "key": "640323"
    }, {
      "value": "同心县",
      "key": "640324"
    }, {
      "value": "青铜峡市",
      "key": "640381"
    }],
    "key": "640300"
  }, {
    "value": "固原市",
    "children": [{
      "value": "原州区",
      "key": "640402"
    }, {
      "value": "西吉县",
      "key": "640422"
    }, {
      "value": "隆德县",
      "key": "640423"
    }, {
      "value": "泾源县",
      "key": "640424"
    }, {
      "value": "彭阳县",
      "key": "640425"
    }],
    "key": "640400"
  }, {
    "value": "中卫市",
    "children": [{
      "value": "沙坡头区",
      "key": "640502"
    }, {
      "value": "中宁县",
      "key": "640521"
    }, {
      "value": "海原县",
      "key": "640522"
    }],
    "key": "640500"
  }],
  "key": "640000"
}, {
  "value": "新疆",
  "children": [{
    "value": "乌鲁木齐市",
    "children": [{
      "value": "天山区",
      "key": "650102"
    }, {
      "value": "沙依巴克区",
      "key": "650103"
    }, {
      "value": "新市区",
      "key": "650104"
    }, {
      "value": "水磨沟区",
      "key": "650105"
    }, {
      "value": "头屯河区",
      "key": "650106"
    }, {
      "value": "达坂城区",
      "key": "650107"
    }, {
      "value": "东山区",
      "key": "650108"
    }, {
      "value": "米东区",
      "key": "650109"
    }, {
      "value": "乌鲁木齐县",
      "key": "650121"
    }],
    "key": "650100"
  }, {
    "value": "克拉玛依市",
    "children": [{
      "value": "独山子区",
      "key": "650202"
    }, {
      "value": "克拉玛依区",
      "key": "650203"
    }, {
      "value": "白碱滩区",
      "key": "650204"
    }, {
      "value": "乌尔禾区",
      "key": "650205"
    }],
    "key": "650200"
  }, {
    "value": "吐鲁番地区",
    "children": [{
      "value": "吐鲁番市",
      "key": "652101"
    }, {
      "value": "鄯善县",
      "key": "652122"
    }, {
      "value": "托克逊县",
      "key": "652123"
    }],
    "key": "652100"
  }, {
    "value": "哈密地区",
    "children": [{
      "value": "哈密市",
      "key": "652201"
    }, {
      "value": "巴里坤哈萨克自治县",
      "key": "652222"
    }, {
      "value": "伊吾县",
      "key": "652223"
    }],
    "key": "652200"
  }, {
    "value": "昌吉回族自治州",
    "children": [{
      "value": "昌吉市",
      "key": "652301"
    }, {
      "value": "阜康市",
      "key": "652302"
    }, {
      "value": "米泉市",
      "key": "652303"
    }, {
      "value": "呼图壁县",
      "key": "652323"
    }, {
      "value": "玛纳斯县",
      "key": "652324"
    }, {
      "value": "奇台县",
      "key": "652325"
    }, {
      "value": "吉木萨尔县",
      "key": "652327"
    }, {
      "value": "木垒哈萨克自治县",
      "key": "652328"
    }],
    "key": "652300"
  }, {
    "value": "博尔塔拉蒙古自治州",
    "children": [{
      "value": "博乐市",
      "key": "652701"
    }, {
      "value": "精河县",
      "key": "652722"
    }, {
      "value": "温泉县",
      "key": "652723"
    }],
    "key": "652700"
  }, {
    "value": "巴音郭楞蒙古自治州",
    "children": [{
      "value": "库尔勒市",
      "key": "652801"
    }, {
      "value": "轮台县",
      "key": "652822"
    }, {
      "value": "尉犁县",
      "key": "652823"
    }, {
      "value": "若羌县",
      "key": "652824"
    }, {
      "value": "且末县",
      "key": "652825"
    }, {
      "value": "焉耆回族自治县",
      "key": "652826"
    }, {
      "value": "和静县",
      "key": "652827"
    }, {
      "value": "和硕县",
      "key": "652828"
    }, {
      "value": "博湖县",
      "key": "652829"
    }],
    "key": "652800"
  }, {
    "value": "阿克苏地区",
    "children": [{
      "value": "阿克苏市",
      "key": "652901"
    }, {
      "value": "温宿县",
      "key": "652922"
    }, {
      "value": "库车县",
      "key": "652923"
    }, {
      "value": "沙雅县",
      "key": "652924"
    }, {
      "value": "新和县",
      "key": "652925"
    }, {
      "value": "拜城县",
      "key": "652926"
    }, {
      "value": "乌什县",
      "key": "652927"
    }, {
      "value": "阿瓦提县",
      "key": "652928"
    }, {
      "value": "柯坪县",
      "key": "652929"
    }],
    "key": "652900"
  }, {
    "value": "克孜勒苏柯尔克孜自治州",
    "children": [{
      "value": "阿图什市",
      "key": "653001"
    }, {
      "value": "阿克陶县",
      "key": "653022"
    }, {
      "value": "阿合奇县",
      "key": "653023"
    }, {
      "value": "乌恰县",
      "key": "653024"
    }],
    "key": "653000"
  }, {
    "value": "喀什地区",
    "children": [{
      "value": "喀什市",
      "key": "653101"
    }, {
      "value": "疏附县",
      "key": "653121"
    }, {
      "value": "疏勒县",
      "key": "653122"
    }, {
      "value": "英吉沙县",
      "key": "653123"
    }, {
      "value": "泽普县",
      "key": "653124"
    }, {
      "value": "莎车县",
      "key": "653125"
    }, {
      "value": "叶城县",
      "key": "653126"
    }, {
      "value": "麦盖提县",
      "key": "653127"
    }, {
      "value": "岳普湖县",
      "key": "653128"
    }, {
      "value": "伽师县",
      "key": "653129"
    }, {
      "value": "巴楚县",
      "key": "653130"
    }, {
      "value": "塔什库尔干塔吉克自治县",
      "key": "653131"
    }],
    "key": "653100"
  }, {
    "value": "和田地区",
    "children": [{
      "value": "和田市",
      "key": "653201"
    }, {
      "value": "和田县",
      "key": "653221"
    }, {
      "value": "墨玉县",
      "key": "653222"
    }, {
      "value": "皮山县",
      "key": "653223"
    }, {
      "value": "洛浦县",
      "key": "653224"
    }, {
      "value": "策勒县",
      "key": "653225"
    }, {
      "value": "于田县",
      "key": "653226"
    }, {
      "value": "民丰县",
      "key": "653227"
    }],
    "key": "653200"
  }, {
    "value": "伊犁哈萨克自治州",
    "children": [{
      "value": "伊宁市",
      "key": "654002"
    }, {
      "value": "奎屯市",
      "key": "654003"
    }, {
      "value": "伊宁县",
      "key": "654021"
    }, {
      "value": "察布查尔锡伯自治县",
      "key": "654022"
    }, {
      "value": "霍城县",
      "key": "654023"
    }, {
      "value": "巩留县",
      "key": "654024"
    }, {
      "value": "新源县",
      "key": "654025"
    }, {
      "value": "昭苏县",
      "key": "654026"
    }, {
      "value": "特克斯县",
      "key": "654027"
    }, {
      "value": "尼勒克县",
      "key": "654028"
    }],
    "key": "654000"
  }, {
    "value": "塔城地区",
    "children": [{
      "value": "塔城市",
      "key": "654201"
    }, {
      "value": "乌苏市",
      "key": "654202"
    }, {
      "value": "额敏县",
      "key": "654221"
    }, {
      "value": "沙湾县",
      "key": "654223"
    }, {
      "value": "托里县",
      "key": "654224"
    }, {
      "value": "裕民县",
      "key": "654225"
    }, {
      "value": "和布克赛尔蒙古自治县",
      "key": "654226"
    }],
    "key": "654200"
  }, {
    "value": "阿勒泰地区",
    "children": [{
      "value": "阿勒泰市",
      "key": "654301"
    }, {
      "value": "布尔津县",
      "key": "654321"
    }, {
      "value": "富蕴县",
      "key": "654322"
    }, {
      "value": "福海县",
      "key": "654323"
    }, {
      "value": "哈巴河县",
      "key": "654324"
    }, {
      "value": "青河县",
      "key": "654325"
    }, {
      "value": "吉木乃县",
      "key": "654326"
    }],
    "key": "654300"
  }, {
    "value": "石河子市",
    "key": "659001"
  }, {
    "value": "阿拉尔市",
    "key": "659002"
  }, {
    "value": "图木舒克市",
    "key": "659003"
  }, {
    "value": "五家渠市",
    "key": "659004"
  }],
  "key": "650000"
}, {
  "value": "台湾",
  "children": [{
    "value": "台北市",
    "children": [{
      "value": "中正区",
      "key": "710101"
    }, {
      "value": "大同区",
      "key": "710102"
    }, {
      "value": "中山区",
      "key": "710103"
    }, {
      "value": "松山区",
      "key": "710104"
    }, {
      "value": "大安区",
      "key": "710105"
    }, {
      "value": "万华区",
      "key": "710106"
    }, {
      "value": "信义区",
      "key": "710107"
    }, {
      "value": "士林区",
      "key": "710108"
    }, {
      "value": "北投区",
      "key": "710109"
    }, {
      "value": "内湖区",
      "key": "710110"
    }, {
      "value": "南港区",
      "key": "710111"
    }, {
      "value": "文山区",
      "key": "710112"
    }],
    "key": "710100"
  }, {
    "value": "基隆市",
    "children": [{
      "value": "仁爱区",
      "key": "710201"
    }, {
      "value": "信义区",
      "key": "710202"
    }, {
      "value": "中正区",
      "key": "710203"
    }, {
      "value": "中山区",
      "key": "710204"
    }, {
      "value": "安乐区",
      "key": "710205"
    }, {
      "value": "暖暖区",
      "key": "710206"
    }, {
      "value": "七堵区",
      "key": "710207"
    }],
    "key": "710200"
  }, {
    "value": "新北市",
    "children": [{
      "value": "万里区",
      "key": "710301"
    }, {
      "value": "金山区",
      "key": "710302"
    }, {
      "value": "板桥区",
      "key": "710303"
    }, {
      "value": "汐止区",
      "key": "710304"
    }, {
      "value": "深坑区",
      "key": "710305"
    }, {
      "value": "石碇区",
      "key": "710306"
    }, {
      "value": "瑞芳区",
      "key": "710307"
    }, {
      "value": "平溪区",
      "key": "710308"
    }, {
      "value": "双溪区",
      "key": "710309"
    }, {
      "value": "贡寮区",
      "key": "710310"
    }, {
      "value": "新店区",
      "key": "710311"
    }, {
      "value": "坪林区",
      "key": "710312"
    }, {
      "value": "乌来区",
      "key": "710313"
    }, {
      "value": "永和区",
      "key": "710314"
    }, {
      "value": "中和区",
      "key": "710315"
    }, {
      "value": "土城区",
      "key": "710316"
    }, {
      "value": "三峡区",
      "key": "710317"
    }, {
      "value": "树林区",
      "key": "710318"
    }, {
      "value": "莺歌区",
      "key": "710319"
    }, {
      "value": "三重区",
      "key": "710320"
    }, {
      "value": "新庄区",
      "key": "710321"
    }, {
      "value": "泰山区",
      "key": "710322"
    }, {
      "value": "林口区",
      "key": "710323"
    }, {
      "value": "芦洲区",
      "key": "710324"
    }, {
      "value": "五股区",
      "key": "710325"
    }, {
      "value": "八里区",
      "key": "710326"
    }, {
      "value": "淡水区",
      "key": "710327"
    }, {
      "value": "三芝区",
      "key": "710328"
    }, {
      "value": "石门区",
      "key": "710329"
    }],
    "key": "710300"
  }, {
    "value": "连江县",
    "children": [{
      "value": "南竿乡",
      "key": "710401"
    }, {
      "value": "北竿乡",
      "key": "710402"
    }, {
      "value": "莒光乡",
      "key": "710403"
    }, {
      "value": "东引乡",
      "key": "710404"
    }],
    "key": "710400"
  }, {
    "value": "宜兰县",
    "children": [{
      "value": "宜兰市",
      "key": "710501"
    }, {
      "value": "壮围乡",
      "key": "710502"
    }, {
      "value": "头城镇",
      "key": "710503"
    }, {
      "value": "礁溪乡",
      "key": "710504"
    }, {
      "value": "员山乡",
      "key": "710505"
    }, {
      "value": "罗东镇",
      "key": "710506"
    }, {
      "value": "三星乡",
      "key": "710507"
    }, {
      "value": "大同乡",
      "key": "710508"
    }, {
      "value": "五结乡",
      "key": "710509"
    }, {
      "value": "冬山乡",
      "key": "710510"
    }, {
      "value": "苏澳镇",
      "key": "710511"
    }, {
      "value": "南澳乡",
      "key": "710512"
    }, {
      "value": "钓鱼台",
      "key": "710513"
    }],
    "key": "710500"
  }, {
    "value": "新竹市",
    "children": [{
      "value": "东区",
      "key": "710601"
    }, {
      "value": "北区",
      "key": "710602"
    }, {
      "value": "香山区",
      "key": "710603"
    }],
    "key": "710600"
  }, {
    "value": "新竹县",
    "children": [{
      "value": "宝山乡",
      "key": "710701"
    }, {
      "value": "竹北市",
      "key": "710702"
    }, {
      "value": "湖口乡",
      "key": "710703"
    }, {
      "value": "新丰乡",
      "key": "710704"
    }, {
      "value": "新埔镇",
      "key": "710705"
    }, {
      "value": "关西镇",
      "key": "710706"
    }, {
      "value": "芎林乡",
      "key": "710707"
    }, {
      "value": "竹东镇",
      "key": "710708"
    }, {
      "value": "五峰乡",
      "key": "710709"
    }, {
      "value": "横山乡",
      "key": "710710"
    }, {
      "value": "尖石乡",
      "key": "710711"
    }, {
      "value": "北埔乡",
      "key": "710712"
    }, {
      "value": "峨眉乡",
      "key": "710713"
    }],
    "key": "710700"
  }, {
    "value": "桃园市",
    "children": [{
      "value": "中坜区",
      "key": "710801"
    }, {
      "value": "平镇区",
      "key": "710802"
    }, {
      "value": "龙潭区",
      "key": "710803"
    }, {
      "value": "杨梅区",
      "key": "710804"
    }, {
      "value": "新屋区",
      "key": "710805"
    }, {
      "value": "观音区",
      "key": "710806"
    }, {
      "value": "桃园区",
      "key": "710807"
    }, {
      "value": "龟山区",
      "key": "710808"
    }, {
      "value": "八德区",
      "key": "710809"
    }, {
      "value": "大溪区",
      "key": "710810"
    }, {
      "value": "复兴区",
      "key": "710811"
    }, {
      "value": "大园区",
      "key": "710812"
    }, {
      "value": "芦竹区",
      "key": "710813"
    }],
    "key": "710800"
  }, {
    "value": "苗栗县",
    "children": [{
      "value": "竹南镇",
      "key": "710901"
    }, {
      "value": "头份镇",
      "key": "710902"
    }, {
      "value": "三湾乡",
      "key": "710903"
    }, {
      "value": "南庄乡",
      "key": "710904"
    }, {
      "value": "狮潭乡",
      "key": "710905"
    }, {
      "value": "后龙镇",
      "key": "710906"
    }, {
      "value": "通霄镇",
      "key": "710907"
    }, {
      "value": "苑里镇",
      "key": "710908"
    }, {
      "value": "苗栗市",
      "key": "710909"
    }, {
      "value": "造桥乡",
      "key": "710910"
    }, {
      "value": "头屋乡",
      "key": "710911"
    }, {
      "value": "公馆乡",
      "key": "710912"
    }, {
      "value": "大湖乡",
      "key": "710913"
    }, {
      "value": "泰安乡",
      "key": "710914"
    }, {
      "value": "铜锣乡",
      "key": "710915"
    }, {
      "value": "三义乡",
      "key": "710916"
    }, {
      "value": "西湖乡",
      "key": "710917"
    }, {
      "value": "卓兰镇",
      "key": "710918"
    }],
    "key": "710900"
  }, {
    "value": "台中市",
    "children": [{
      "value": "中区",
      "key": "711001"
    }, {
      "value": "东区",
      "key": "711002"
    }, {
      "value": "南区",
      "key": "711003"
    }, {
      "value": "西区",
      "key": "711004"
    }, {
      "value": "北区",
      "key": "711005"
    }, {
      "value": "北屯区",
      "key": "711006"
    }, {
      "value": "西屯区",
      "key": "711007"
    }, {
      "value": "南屯区",
      "key": "711008"
    }, {
      "value": "太平区",
      "key": "711009"
    }, {
      "value": "大理区",
      "key": "711010"
    }, {
      "value": "雾峰区",
      "key": "711011"
    }, {
      "value": "乌日区",
      "key": "711012"
    }, {
      "value": "丰原区",
      "key": "711013"
    }, {
      "value": "后里区",
      "key": "711014"
    }, {
      "value": "石冈区",
      "key": "711015"
    }, {
      "value": "东势区",
      "key": "711016"
    }, {
      "value": "和平区",
      "key": "711017"
    }, {
      "value": "新小区",
      "key": "711018"
    }, {
      "value": "潭子区",
      "key": "711019"
    }, {
      "value": "大雅区",
      "key": "711020"
    }, {
      "value": "神冈区",
      "key": "711021"
    }, {
      "value": "大肚区",
      "key": "711022"
    }, {
      "value": "沙鹿区",
      "key": "711023"
    }, {
      "value": "龙井区",
      "key": "711024"
    }, {
      "value": "梧栖区",
      "key": "711025"
    }, {
      "value": "清水区",
      "key": "711026"
    }, {
      "value": "大甲区",
      "key": "711027"
    }, {
      "value": "外埔区",
      "key": "711028"
    }, {
      "value": "大安区",
      "key": "711029"
    }],
    "key": "711000"
  }, {
    "value": "彰化县",
    "children": [{
      "value": "彰化市",
      "key": "711101"
    }, {
      "value": "芬园乡",
      "key": "711102"
    }, {
      "value": "花坛乡",
      "key": "711103"
    }, {
      "value": "秀水乡",
      "key": "711104"
    }, {
      "value": "鹿港镇",
      "key": "711105"
    }, {
      "value": "福兴乡",
      "key": "711106"
    }, {
      "value": "线西乡",
      "key": "711107"
    }, {
      "value": "和美镇",
      "key": "711108"
    }, {
      "value": "伸港乡",
      "key": "711109"
    }, {
      "value": "员林镇",
      "key": "711110"
    }, {
      "value": "社头乡",
      "key": "711111"
    }, {
      "value": "永靖乡",
      "key": "711112"
    }, {
      "value": "埔心乡",
      "key": "711113"
    }, {
      "value": "溪湖镇",
      "key": "711114"
    }, {
      "value": "大村乡",
      "key": "711115"
    }, {
      "value": "埔盐乡",
      "key": "711116"
    }, {
      "value": "田中镇",
      "key": "711117"
    }, {
      "value": "北斗镇",
      "key": "711118"
    }, {
      "value": "田尾乡",
      "key": "711119"
    }, {
      "value": "埤头乡",
      "key": "711120"
    }, {
      "value": "溪州乡",
      "key": "711121"
    }, {
      "value": "竹塘乡",
      "key": "711122"
    }, {
      "value": "二林镇",
      "key": "711123"
    }, {
      "value": "大城乡",
      "key": "711124"
    }, {
      "value": "芳苑乡",
      "key": "711125"
    }, {
      "value": "二水乡",
      "key": "711126"
    }],
    "key": "711100"
  }, {
    "value": "南投县",
    "children": [{
      "value": "南投市",
      "key": "711201"
    }, {
      "value": "中寮乡",
      "key": "711202"
    }, {
      "value": "草屯镇",
      "key": "711203"
    }, {
      "value": "国姓乡",
      "key": "711204"
    }, {
      "value": "埔里镇",
      "key": "711205"
    }, {
      "value": "仁爱乡",
      "key": "711206"
    }, {
      "value": "名间乡",
      "key": "711207"
    }, {
      "value": "集集镇",
      "key": "711208"
    }, {
      "value": "水里乡",
      "key": "711209"
    }, {
      "value": "鱼池乡",
      "key": "711210"
    }, {
      "value": "信义乡",
      "key": "711211"
    }, {
      "value": "竹山镇",
      "key": "711212"
    }, {
      "value": "鹿谷乡",
      "key": "711213"
    }],
    "key": "711200"
  }, {
    "value": "嘉义市",
    "children": [{
      "value": "西区",
      "key": "711301"
    }, {
      "value": "东区",
      "key": "711302"
    }],
    "key": "711300"
  }, {
    "value": "嘉义县",
    "children": [{
      "value": "番路乡",
      "key": "711401"
    }, {
      "value": "梅山乡",
      "key": "711402"
    }, {
      "value": "竹崎乡",
      "key": "711403"
    }, {
      "value": "阿里山乡",
      "key": "711404"
    }, {
      "value": "中埔乡",
      "key": "711405"
    }, {
      "value": "大埔乡",
      "key": "711406"
    }, {
      "value": "水上乡",
      "key": "711407"
    }, {
      "value": "鹿草乡",
      "key": "711408"
    }, {
      "value": "太保市",
      "key": "711409"
    }, {
      "value": "朴子市",
      "key": "711410"
    }, {
      "value": "东石乡",
      "key": "711411"
    }, {
      "value": "六脚乡",
      "key": "711412"
    }, {
      "value": "新港乡",
      "key": "711413"
    }, {
      "value": "民雄乡",
      "key": "711414"
    }, {
      "value": "大林镇",
      "key": "711415"
    }, {
      "value": "溪口乡",
      "key": "711416"
    }, {
      "value": "义竹乡",
      "key": "711417"
    }, {
      "value": "布袋镇",
      "key": "711418"
    }],
    "key": "711400"
  }, {
    "value": "云林县",
    "children": [{
      "value": "斗南镇",
      "key": "711501"
    }, {
      "value": "大埤乡",
      "key": "711502"
    }, {
      "value": "虎尾镇",
      "key": "711503"
    }, {
      "value": "土库镇",
      "key": "711504"
    }, {
      "value": "褒忠乡",
      "key": "711505"
    }, {
      "value": "东势乡",
      "key": "711506"
    }, {
      "value": "台西乡",
      "key": "711507"
    }, {
      "value": "仑背乡",
      "key": "711508"
    }, {
      "value": "麦寮乡",
      "key": "711509"
    }, {
      "value": "斗六市",
      "key": "711510"
    }, {
      "value": "林内乡",
      "key": "711511"
    }, {
      "value": "古坑乡",
      "key": "711512"
    }, {
      "value": "莿桐乡",
      "key": "711513"
    }, {
      "value": "西螺镇",
      "key": "711514"
    }, {
      "value": "二仑乡",
      "key": "711515"
    }, {
      "value": "北港镇",
      "key": "711516"
    }, {
      "value": "水林乡",
      "key": "711517"
    }, {
      "value": "口湖乡",
      "key": "711518"
    }, {
      "value": "四湖乡",
      "key": "711519"
    }, {
      "value": "元长乡",
      "key": "711520"
    }],
    "key": "711500"
  }, {
    "value": "台南市",
    "children": [{
      "value": "中西区",
      "key": "711601"
    }, {
      "value": "东区",
      "key": "711602"
    }, {
      "value": "南区",
      "key": "711603"
    }, {
      "value": "北区",
      "key": "711604"
    }, {
      "value": "安平区",
      "key": "711605"
    }, {
      "value": "安南区",
      "key": "711606"
    }, {
      "value": "永康区",
      "key": "711607"
    }, {
      "value": "归仁区",
      "key": "711608"
    }, {
      "value": "新化区",
      "key": "711609"
    }, {
      "value": "左镇区",
      "key": "711610"
    }, {
      "value": "玉井区",
      "key": "711611"
    }, {
      "value": "楠西区",
      "key": "711612"
    }, {
      "value": "南化区",
      "key": "711613"
    }, {
      "value": "仁德区",
      "key": "711614"
    }, {
      "value": "关庙区",
      "key": "711615"
    }, {
      "value": "龙崎区",
      "key": "711616"
    }, {
      "value": "官田区",
      "key": "711617"
    }, {
      "value": "麻豆区",
      "key": "711618"
    }, {
      "value": "佳里区",
      "key": "711619"
    }, {
      "value": "西港区",
      "key": "711620"
    }, {
      "value": "七股区",
      "key": "711621"
    }, {
      "value": "将军区",
      "key": "711622"
    }, {
      "value": "学甲区",
      "key": "711623"
    }, {
      "value": "北门区",
      "key": "711624"
    }, {
      "value": "新营区",
      "key": "711625"
    }, {
      "value": "后壁区",
      "key": "711626"
    }, {
      "value": "白河区",
      "key": "711627"
    }, {
      "value": "东山区",
      "key": "711628"
    }, {
      "value": "六甲区",
      "key": "711629"
    }, {
      "value": "下营区",
      "key": "711630"
    }, {
      "value": "柳营区",
      "key": "711631"
    }, {
      "value": "盐水区",
      "key": "711632"
    }, {
      "value": "善化区",
      "key": "711633"
    }, {
      "value": "新市区",
      "key": "711634"
    }, {
      "value": "大内区",
      "key": "711635"
    }, {
      "value": "山上区",
      "key": "711636"
    }, {
      "value": "安定区",
      "key": "711637"
    }],
    "key": "711600"
  }, {
    "value": "高雄市",
    "children": [{
      "value": "新兴区",
      "key": "711701"
    }, {
      "value": "前金区",
      "key": "711702"
    }, {
      "value": "苓雅区",
      "key": "711703"
    }, {
      "value": "盐埕区",
      "key": "711704"
    }, {
      "value": "鼓山区",
      "key": "711705"
    }, {
      "value": "旗津区",
      "key": "711706"
    }, {
      "value": "前镇区",
      "key": "711707"
    }, {
      "value": "三民区",
      "key": "711708"
    }, {
      "value": "楠梓区",
      "key": "711709"
    }, {
      "value": "小港区",
      "key": "711710"
    }, {
      "value": "左营区",
      "key": "711711"
    }, {
      "value": "仁武区",
      "key": "711712"
    }, {
      "value": "大小区",
      "key": "711713"
    }, {
      "value": "东沙群岛",
      "key": "711714"
    }, {
      "value": "南沙群岛",
      "key": "711715"
    }, {
      "value": "冈山区",
      "key": "711716"
    }, {
      "value": "路竹区",
      "key": "711717"
    }, {
      "value": "阿莲区",
      "key": "711718"
    }, {
      "value": "田寮区",
      "key": "711719"
    }, {
      "value": "燕巢区",
      "key": "711720"
    }, {
      "value": "桥头区",
      "key": "711721"
    }, {
      "value": "梓官区",
      "key": "711722"
    }, {
      "value": "弥陀区",
      "key": "711723"
    }, {
      "value": "永安区",
      "key": "711724"
    }, {
      "value": "湖内区",
      "key": "711725"
    }, {
      "value": "凤山区",
      "key": "711726"
    }, {
      "value": "大寮区",
      "key": "711727"
    }, {
      "value": "林园区",
      "key": "711728"
    }, {
      "value": "鸟松区",
      "key": "711729"
    }, {
      "value": "大树区",
      "key": "711730"
    }, {
      "value": "旗山区",
      "key": "711731"
    }, {
      "value": "美浓区",
      "key": "711732"
    }, {
      "value": "六龟区",
      "key": "711733"
    }, {
      "value": "内门区",
      "key": "711734"
    }, {
      "value": "杉林区",
      "key": "711735"
    }, {
      "value": "甲仙区",
      "key": "711736"
    }, {
      "value": "桃源区",
      "key": "711737"
    }, {
      "value": "那玛夏区",
      "key": "711738"
    }, {
      "value": "茂林区",
      "key": "711739"
    }, {
      "value": "茄萣区",
      "key": "711740"
    }],
    "key": "711700"
  }, {
    "value": "南海岛",
    "children": [{
      "value": "东沙群岛",
      "key": "711801"
    }, {
      "value": "南沙群岛",
      "key": "711802"
    }],
    "key": "711800"
  }, {
    "value": "澎湖县",
    "children": [{
      "value": "马公市",
      "key": "711901"
    }, {
      "value": "西屿乡",
      "key": "711902"
    }, {
      "value": "望安乡",
      "key": "711903"
    }, {
      "value": "七美乡",
      "key": "711904"
    }, {
      "value": "白沙乡",
      "key": "711905"
    }, {
      "value": "湖西乡",
      "key": "711906"
    }],
    "key": "711900"
  }, {
    "value": "金门县",
    "children": [{
      "value": "金沙镇",
      "key": "712001"
    }, {
      "value": "金湖镇",
      "key": "712002"
    }, {
      "value": "金宁乡",
      "key": "712003"
    }, {
      "value": "金城镇",
      "key": "712004"
    }, {
      "value": "烈屿乡",
      "key": "712005"
    }, {
      "value": "乌坵乡",
      "key": "712006"
    }],
    "key": "712000"
  }, {
    "value": "屏东县",
    "children": [{
      "value": "屏东市",
      "key": "712101"
    }, {
      "value": "三地门乡",
      "key": "712102"
    }, {
      "value": "雾台乡",
      "key": "712103"
    }, {
      "value": "玛家乡",
      "key": "712104"
    }, {
      "value": "九如乡",
      "key": "712105"
    }, {
      "value": "里港乡",
      "key": "712106"
    }, {
      "value": "高树乡",
      "key": "712107"
    }, {
      "value": "盐埔乡",
      "key": "712108"
    }, {
      "value": "长治乡",
      "key": "712109"
    }, {
      "value": "麟洛乡",
      "key": "712110"
    }, {
      "value": "竹田乡",
      "key": "712111"
    }, {
      "value": "内埔乡",
      "key": "712112"
    }, {
      "value": "万丹乡",
      "key": "712113"
    }, {
      "value": "潮州镇",
      "key": "712114"
    }, {
      "value": "泰武乡",
      "key": "712115"
    }, {
      "value": "来义乡",
      "key": "712116"
    }, {
      "value": "万峦乡",
      "key": "712117"
    }, {
      "value": "崁顶乡",
      "key": "712118"
    }, {
      "value": "新埤乡",
      "key": "712119"
    }, {
      "value": "南州乡",
      "key": "712120"
    }, {
      "value": "林边乡",
      "key": "712121"
    }, {
      "value": "东港镇",
      "key": "712122"
    }, {
      "value": "琉球乡",
      "key": "712123"
    }, {
      "value": "佳冬乡",
      "key": "712124"
    }, {
      "value": "新园乡",
      "key": "712125"
    }, {
      "value": "枋寮乡",
      "key": "712126"
    }, {
      "value": "枋山乡",
      "key": "712127"
    }, {
      "value": "春日乡",
      "key": "712128"
    }, {
      "value": "狮子乡",
      "key": "712129"
    }, {
      "value": "车城乡",
      "key": "712130"
    }, {
      "value": "牡丹乡",
      "key": "712131"
    }, {
      "value": "恒春镇",
      "key": "712132"
    }, {
      "value": "满州乡",
      "key": "712133"
    }],
    "key": "712100"
  }, {
    "value": "台东县",
    "children": [{
      "value": "台东市",
      "key": "712201"
    }, {
      "value": "绿岛乡",
      "key": "712202"
    }, {
      "value": "兰屿乡",
      "key": "712203"
    }, {
      "value": "延平乡",
      "key": "712204"
    }, {
      "value": "卑南乡",
      "key": "712205"
    }, {
      "value": "鹿野乡",
      "key": "712206"
    }, {
      "value": "关山镇",
      "key": "712207"
    }, {
      "value": "海端乡",
      "key": "712208"
    }, {
      "value": "池上乡",
      "key": "712209"
    }, {
      "value": "东河乡",
      "key": "712210"
    }, {
      "value": "成功镇",
      "key": "712211"
    }, {
      "value": "长滨乡",
      "key": "712212"
    }, {
      "value": "太麻里乡",
      "key": "712213"
    }, {
      "value": "金峰乡",
      "key": "712214"
    }, {
      "value": "大武乡",
      "key": "712215"
    }, {
      "value": "达仁乡",
      "key": "712216"
    }],
    "key": "712200"
  }, {
    "value": "花莲县",
    "children": [{
      "value": "花莲市",
      "key": "712301"
    }, {
      "value": "新城乡",
      "key": "712302"
    }, {
      "value": "秀林乡",
      "key": "712303"
    }, {
      "value": "吉安乡",
      "key": "712304"
    }, {
      "value": "寿丰乡",
      "key": "712305"
    }, {
      "value": "凤林镇",
      "key": "712306"
    }, {
      "value": "光复乡",
      "key": "712307"
    }, {
      "value": "丰滨乡",
      "key": "712308"
    }, {
      "value": "瑞穗乡",
      "key": "712309"
    }, {
      "value": "万荣乡",
      "key": "712310"
    }, {
      "value": "玉里镇",
      "key": "712311"
    }, {
      "value": "卓溪乡",
      "key": "712312"
    }, {
      "value": "富里乡",
      "key": "712313"
    }],
    "key": "712300"
  }],
  "key": "710000"
}, {
  "value": "香港",
  "children": [{
    "value": "中西区",
    "key": "810101"
  }, {
    "value": "湾仔区",
    "key": "810102"
  }, {
    "value": "东区",
    "key": "810103"
  }, {
    "value": "南区",
    "key": "810104"
  }, {
    "value": "油尖旺区",
    "key": "810105"
  }, {
    "value": "深水埗区",
    "key": "810106"
  }, {
    "value": "九龙城区",
    "key": "810107"
  }, {
    "value": "黄大仙区",
    "key": "810108"
  }, {
    "value": "观塘区",
    "key": "810109"
  }, {
    "value": "北区",
    "key": "810110"
  }, {
    "value": "大埔区",
    "key": "810111"
  }, {
    "value": "沙田区",
    "key": "810112"
  }, {
    "value": "西贡区",
    "key": "810113"
  }, {
    "value": "荃湾区",
    "key": "810114"
  }, {
    "value": "屯门区",
    "key": "810115"
  }, {
    "value": "元朗区",
    "key": "810116"
  }, {
    "value": "葵青区",
    "key": "810117"
  }, {
    "value": "离岛区",
    "key": "810118"
  }],
  "key": "810000"
}, {
  "value": "澳门",
  "children": [{
    "value": "花地玛堂区",
    "key": "820101"
  }, {
    "value": "圣安多尼堂区",
    "key": "820102"
  }, {
    "value": "大堂区",
    "key": "820103"
  }, {
    "value": "望德堂区",
    "key": "820104"
  }, {
    "value": "风顺堂区",
    "key": "820105"
  }, {
    "value": "嘉模堂区",
    "key": "820106"
  }, {
    "value": "圣方济各堂区",
    "key": "820107"
  }, {
    "value": "路氹城",
    "key": "820108"
  }],
  "key": "820000"
}];

// Picker 滚动选择器
var Picker = function Picker(params) {
  /* ------------------------
  Model
  ------------------------ */
  var defaults = {
    overflowContainer: document.body,
    overflowContainerActiveClass: 'overflow-hidden',

    mask: null,

    maskClass: 'mask',
    maskActiveClass: 'active',
    maskFeatureClass: 'picker-mask',

    pickerClass: 'picker',
    pickerActiveClass: 'active',

    headerClass: 'picker-header',
    headerSubmitClass: 'picker-submit',
    headerSubmitText: '完成',
    headerCancelClass: 'picker-cancel',
    headerCancelText: '取消',

    wrapperClass: 'picker-wrapper',

    slotboxClass: 'picker-slotbox',
    slotClass: 'picker-slot',

    layerClass: 'picker-layer',
    layerFrameClass: 'picker-layer-frame',
    layerFrameHTML: '<div class=picker-layer-frame></div>',

    lockClass: 'lock',

    cellHeight: 44,
    bounceRange: 44 // 弹性值

    /* callbacks
    onInit:function (Picker)
    onClickCancel:function (Picker)
    onClickSubmit:function (Picker)
    onClickMask:functioin (Picker)
    onScrollStart:function (Picker)
    onScroll:function (Picker)
    onScrollEnd:function (Picker)
    onTransitionEnd:function (Picker)// 动画结束后回调
    onShowed(Picker)// 显示动画结束后回调
    onHid(Picker)// 隐藏动画结束后回调
      */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  // Picker
  var s = this;

  // Params
  s.params = params;
  // Dom元素
  s.overflowContainer = typeof s.params.overflowContainer === 'string' ? document.querySelector(s.params.overflowContainer) : s.params.overflowContainer;
  s.picker = null;
  s.mask = null;
  s.header = null;
  s.wrapper = null;
  s.slotbox = null;
  s.layer = null;
  s.headerSubmit = null;
  s.headerCancel = null;

  // 选中项
  s.activeOptions = [];
  // 新建Picker
  s.createPicker = function () {
    var picker = document.createElement('div');
    picker.setAttribute('class', s.params.pickerClass);
    return picker;
  };

  // 新建Header
  s.createHeader = function () {
    var header = document.createElement('div');
    header.setAttribute('class', s.params.headerClass);
    return header;
  };

  // 新建Header按钮
  s.createHeaderSubmit = function () {
    var headerSubmit = document.createElement('a');
    headerSubmit.setAttribute('class', s.params.headerSubmitClass);
    headerSubmit.innerHTML = s.params.headerSubmitText;
    return headerSubmit;
  };
  s.createHeaderCancel = function () {
    var headerCancel = document.createElement('a');
    headerCancel.setAttribute('class', s.params.headerCancelClass);
    headerCancel.innerHTML = s.params.headerCancelText;
    return headerCancel;
  };

  // 新建Wrapper
  s.createWrapper = function () {
    var wrapper = document.createElement('div');
    wrapper.setAttribute('class', s.params.wrapperClass);
    return wrapper;
  };

  // 新建Slotbox
  s.createSlotbox = function () {
    var slotbox = document.createElement('div');
    slotbox.setAttribute('class', s.params.slotboxClass);
    return slotbox;
  };

  // 新建Layer
  s.createLayer = function () {
    var layer = document.createElement('div');
    layer.setAttribute('class', s.params.layerClass);
    layer.innerHTML = s.params.layerFrameHTML;
    return layer;
  };

  // 新建Mask
  s.createMask = function () {
    var mask = document.createElement('div');
    mask.setAttribute('class', s.params.maskClass + ' ' + s.params.maskFeatureClass);
    return mask;
  };

  // 创建DOM
  s.create = function () {
    if (s.params.mask) s.mask = typeof s.params.mask === 'string' ? document.querySelector(s.params.mask) : s.params.mask;

    if (s.mask) {
      s.picker = s.mask.querySelector('.' + s.params.pickerClass);
      s.header = s.mask.querySelector('.' + s.params.headerClass);
      s.headerSubmit = s.mask.querySelector('.' + s.params.headerSubmitClass);
      s.headerCancel = s.mask.querySelector('.' + s.params.headerCancelClass);
      s.wrapper = s.mask.querySelector('.' + s.params.wrapperClass);
      s.slotbox = s.mask.querySelector('.' + s.params.slotboxClass);
      s.layer = s.mask.querySelector('.' + s.params.layerClass);
      return;
    }
    s.mask = s.createMask();
    s.picker = s.createPicker();
    s.header = s.createHeader();
    s.headerSubmit = s.createHeaderSubmit();
    s.headerCancel = s.createHeaderCancel();
    s.wrapper = s.createWrapper();
    s.slotbox = s.createSlotbox();
    s.layer = s.createLayer();

    s.header.appendChild(s.headerCancel);
    s.header.appendChild(s.headerSubmit);

    s.wrapper.appendChild(s.layer);
    s.wrapper.appendChild(s.slotbox);

    s.picker.appendChild(s.header);
    s.picker.appendChild(s.wrapper);

    s.mask.appendChild(s.picker);
    s.overflowContainer.appendChild(s.mask);
  };
  s.create();
  /* ------------------------
  Method
  ------------------------ */
  // 添加一列
  s.addSlot = function (values, defaultKey, classes) {
    if (!classes) classes = '';
    // 设置属性
    var slot = document.createElement('ul');
    slot.setAttribute('class', s.params.slotClass + ' ' + classes);
    slot.values = values;
    slot.defaultKey = defaultKey;
    if (classes.indexOf(s.params.lockClass) >= 0) slot.isLock = true;else slot.isLock = false;

    // 添加到集合里
    s.slotbox.appendChild(slot);

    // 渲染
    slot.index = s.slotbox.children.length - 1;
    s.renderSlot(slot);
  };
  // 替换一列
  s.replaceSlot = function (index, values, defaultKey, classes, fn) {
    if (!classes) classes = '';
    // 设置属性
    var slot = s.slotbox.children[index];
    slot.setAttribute('class', s.params.slotClass + ' ' + classes);
    slot.values = values;
    slot.defaultKey = defaultKey;
    if (classes.indexOf(s.params.lockClass) >= 0) slot.isLock = true;else slot.isLock = false;

    if (classes.indexOf(s.params.lockClass) >= 0) s.slotbox.children[index].isLock = true;else s.slotbox.children[index].isLock = false;
    // 渲染
    s.renderSlot(slot);
    // 回调
    if (fn) fn(s);
  };

  s.renderSlot = function (slot) {
    // 渲染一列
    var index = slot.index;
    var values = slot.values;
    slot.innerHTML = '';
    // 渲染
    var li = '';
    var defaultIndex = 0;
    for (var i = 0; i < values.length; i++) {
      // 获得defaultIndex
      if (slot.defaultKey && slot.defaultKey === values[i]['key']) {
        defaultIndex = i;
      }

      // 把li添加到槽中
      li += '<li>' + values[i]['value'] + '</li>';
    }
    slot.innerHTML = li;
    // 选中项
    s.activeOptions[index] = slot.values[defaultIndex];
    // 设置一槽的属性
    /*
    slot.values
    slot.defaultKey
    slot.index
    */
    slot.defaultPosY = -defaultIndex * s.params.cellHeight;
    slot.posY = -defaultIndex * s.params.cellHeight;
    slot.minPosY = 0;
    slot.maxPosY = -(slot.values.length - 1) * s.params.cellHeight;
    slot.minBouncePosY = s.params.bounceRange;
    slot.maxBouncePosY = slot.maxPosY - s.params.bounceRange;

    slot.style.webkitTransform = 'translate(0px,' + slot.posY + 'px)';
  };
  s.isHid = true;
  // 隐藏
  s.hide = function () {
    s.isHid = true;
    s.mask.classList.remove(s.params.maskActiveClass);
    s.picker.classList.remove(s.params.pickerActiveClass);
    // 显示滚动条
    if (s.overflowContainer) s.overflowContainer.classList.remove(s.params.overflowContainerActiveClass);
  };
  s.show = function () {
    // 显示
    s.isHid = false;
    s.mask.classList.add(s.params.maskActiveClass);
    s.picker.classList.add(s.params.pickerActiveClass);
    // 禁用滚动条
    if (s.overflowContainer) s.overflowContainer.classList.add(s.params.overflowContainerActiveClass);
  };
  s.clearSlots = function () {
    // 清除
    // 清空数据
    s.slotbox.innerHTML = '';
  };
  s.destroy = function () {
    // 销毁
    s.overflowContainer.removeChild(s.mask);
  };
  // 计算惯性时间与坐标，返回距离和时间
  s.calcInertance = function (opts) {
    // 摩擦力
    var friction = 0.002;
    // 滑动距离
    var opRange = opts.range;
    // 滑动时长
    var opDuration = opts.duration;

    // 使用公式算出duration(新时长)
    var duration = 2 * opRange / opDuration / friction;
    // 使用公式算出offset(新距离)
    var range = -(friction / 2) * (duration * duration);
    if (opRange < 0) {
      // 如果拖动间距为负值，则为向下拖动
      duration = -duration;
      range = -range;
    }
    /* console.log('滑动距离:' + opRange)
    console.log('滑动时长:' + opDuration)
    console.log('新时长:' + duration)
    console.log('新距离:' + range) */
    // 使用距离计算新的位置
    var value = opts.current + range;

    // 矫正位置与时长
    if (value > opts.min) {
      // 最上面
      // Math.abs(Math.round(value)) - Math.abs(Math.round(opts.min))
      duration = 300;
      value = opts.min;
    } else if (value < opts.max) {
      // 最下面
      duration = 300;
      value = opts.max;
    } else {
      // 在中间
      var remainder = value % s.params.cellHeight;
      if (remainder !== 0) {
        // 算出比例
        var divided = Math.round(value / s.params.cellHeight);
        // 对准位置
        value = s.params.cellHeight * divided;
      }
    }

    // 更新选中项
    s.updateActiveOptions(s.activeSlot, value);

    // 返回值
    return {
      duration: Math.round(duration),
      value: Math.round(value)
    };
  };
  // 更新列表激活状态
  s.updateActiveOptions = function (slot, posY) {
    var index = -Math.round((posY - s.params.cellHeight * 2) / s.params.cellHeight) - 2;
    // 添加到激活项
    var activeOption = slot.values[index];
    s.activeOptions[slot.index] = activeOption;
  };
  /* ------------------------
  Events
  ------------------------ */
  s.isSupportTouch = 'ontouchstart' in window;
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    s.slotbox[action]('touchstart', s.onTouchStart, false);
    s.slotbox[action]('touchmove', s.onTouchMove, false);
    s.slotbox[action]('touchend', s.onTouchEnd, false);
    s.slotbox[action]('touchcancel', s.onTouchEnd, false);
    // touch兼容pc事件
    if (s.isSupportTouch) {
      s.slotbox[action]('touchstart', s.onTouchStart, false);
      s.slotbox[action]('touchmove', s.onTouchMove, false);
      s.slotbox[action]('touchend', s.onTouchEnd, false);
      s.slotbox[action]('touchcancel', s.onTouchEnd, false);
    } else {
      s.slotbox[action]('mousedown', s.onTouchStart, false);
      s.slotbox[action]('mousemove', s.onTouchMove, false);
      s.slotbox[action]('mouseup', s.onTouchEnd, false);
    }
    // 选择器事件
    s.picker[action]('webkitTransitionEnd', s.onTransitionEnd, false);
    // 遮罩
    s.mask[action]('click', s.onClickMask, false);
    // 按钮
    s.header[action]('touchmove', s.preventDefault, false);
    s.headerSubmit[action]('click', s.onClickSubmit, false);
    s.headerCancel[action]('click', s.onClickCancel, false);
  };
  s.detach = function (event) {
    s.events(true);
  };
  s.attach = function (event) {
    s.events();
  };

  s.preventDefault = function (e) {
    e.preventDefault();
  };

  // Mask
  s.onClickMask = function (e) {
    if (e.target !== s.mask) return;
    if (s.params.onClickMask) s.params.onClickMask(e);else s.hide();
  };

  // Submit|Cancel
  s.onClickSubmit = function (e) {
    s.target = e.target;
    s.params.onClickSubmit(s);
  };
  s.onClickCancel = function (e) {
    s.target = e.target;
    if (s.params.onClickCancel) s.params.onClickCancel(s);else s.hide();
  };

  s.touches = {
    startX: 0,
    startY: 0,
    currentX: 0,
    currentY: 0,
    endX: 0,
    endY: 0,
    startTimeStamp: 0,
    duration: 0,
    diffX: 0,
    diffY: 0,
    posY: 0,
    currentPosY: 0,
    direction: null
  };
  s.startMouseMove = false;
  // 触摸事件
  s.onTouchStart = function (e) {
    s.startMouseMove = true;
    s.touches.startX = e.clientX || e.touches[0].clientX;
    s.touches.startY = e.clientY || e.touches[0].clientY;
    // 寻找当前点击的槽
    s.activeSlot = e.target;

    // 锁定的槽将不工作
    if (s.activeSlot.isLock) return;

    // 获得位置
    s.touches.posY = s.activeSlot.posY;

    // 清除动画
    s.activeSlot.style.webkitTransitionDuration = 0;

    // 记录点击时间
    s.touches.startTimeStamp = e.timeStamp;
    // Callback
    if (s.params.onScrollStart) s.params.onScrollStart(s);
  };
  s.onTouchMove = function (e) {
    if (!s.startMouseMove) return;
    e.preventDefault();
    // 锁定的槽将不工作
    if (s.activeSlot.isLock) return;

    s.touches.currentY = e.clientY || e.touches[0].clientY;
    s.touches.diffY = s.touches.startY - s.touches.currentY;
    s.touches.currentPosY = s.touches.posY - s.touches.diffY;
    if (s.touches.currentPosY > s.activeSlot.minBouncePosY) {
      s.touches.currentPosY = s.activeSlot.minBouncePosY;
    } else if (s.touches.currentPosY < s.activeSlot.maxBouncePosY) {
      s.touches.currentPosY = s.activeSlot.maxBouncePosY;
    }
    s.activeSlot.style.webkitTransform = 'translate(0px,' + s.touches.currentPosY + 'px)';

    // Callback
    if (s.params.onScroll) s.params.onScroll(s);
  };
  s.onTouchEnd = function (e) {
    s.startMouseMove = false;
    // 锁定的槽将不工作
    if (s.activeSlot.isLock) return;

    s.touches.endX = e.clientX || e.changedTouches[0].clientX;
    s.touches.endY = e.clientY || e.changedTouches[0].clientY;
    s.touches.diffX = s.touches.startX - s.touches.endX;
    s.touches.diffY = s.touches.startY - s.touches.endY;
    // 判断是否是tap
    if (Math.abs(s.touches.diffX) < 6 && Math.abs(s.touches.diffY) < 6) {
      return;
    }

    // 计算拖动时间
    s.touches.duration = e.timeStamp - s.touches.startTimeStamp;

    // 惯性值计算
    var inertance = s.calcInertance({
      range: s.touches.diffY,
      duration: s.touches.duration,
      current: s.touches.currentPosY,
      min: s.activeSlot.minPosY,
      max: s.activeSlot.maxPosY
    });
    // 滚动到指定位置
    s.activeSlot.style.webkitTransitionDuration = inertance.duration + 'ms';
    s.activeSlot.posY = inertance.value;
    s.activeSlot.style.webkitTransform = 'translate(0px,' + inertance.value + 'px)';

    // Callback onScrollEnd
    if (s.params.onScrollEnd) s.params.onScrollEnd(s);
  };

  s.onTransitionEnd = function (e) {
    var target = e.target;
    if (e.propertyName !== 'transform' || target !== s.picker) {
      return;
    }
    // 容器显隐
    if (target.classList.contains(s.params.pickerClass)) {
      if (s.params.onTransitionEnd) s.params.onTransitionEnd(s);
      if (s.isHid) {
        if (s.params.onHid) s.params.onHid(s);
      } else {
        if (s.params.onShowed) s.params.onShowed(s);
      }
    }
  };

  s.init = function () {
    if (s.params.onInit) s.params.onInit(s);
    s.attach();
  };
  s.init();
  return s;
};

// 需要string.js的trim方法
var PickerCity$3 = function PickerCity(params) {
  // 参数改写
  var onCityClickSubmit = params.onClickSubmit;
  var onCityScrollEnd = params.onScrollEnd;
  params.onClickSubmit = undefined;
  params.onScrollEnd = undefined;
  /* --------------------
    Model
    -------------------- */
  var defaults = {
    viewType: 'area',
    data: null,

    defaultProvince: '北京市',
    defaultCity: '东城区',
    defaultArea: '',

    provinceClass: 'text-center',
    cityClass: 'text-center',
    areaClass: 'text-center',

    defaultValues: [{
      key: '',
      value: '----'
    }],
    onClickSubmit: function onClickSubmit(e) {
      e.activeText = getActiveText(e.activeOptions);
      setActiveKeys(e.activeOptions);
      if (onCityClickSubmit) onCityClickSubmit(e);
    },
    onScrollEnd: function onScrollEnd(e) {
      // var activeOption = e.activeSlot.values[e.activeSlot.activeIndex]
      var activeOption = e.activeOptions[e.activeSlot.index];
      if (e.activeSlot.index === 0) {
        // 滚动省
        var city = replaceCity(activeOption.key); // 修改第二项
        replaceArea(city[0].key); // 修改第三项
      } else if (e.activeSlot.index === 1) {
        // 滚动市
        replaceArea(activeOption.key); // 修改第三项
      }
      // 回调
      if (onCityScrollEnd) onCityScrollEnd(e);
    }
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = new Picker(params);

  // Data
  s.data = s.params.data;
  if (!s.data) return;

  // 省、市、区数据
  s.province = null;
  s.city = null;
  s.area = null;
  // 省、市、区选中的key
  s.activeProvinceKey = null;
  s.activeCityKey = null;
  s.activeAreaKey = null;

  // 设置默认值
  s.setActiveProvinceKey = function (key) {
    s.activeProvinceKey = key.trim();
  };
  s.setActiveCityKey = function (key) {
    s.activeCityKey = key.trim();
  };
  s.setActiveAreaKey = function (key) {
    s.activeAreaKey = key.trim();
  };

  /* --------------------
  Method
  -------------------- */
  // 根据省市区名获得keys,返回:['320000','320100','320105'],参数:['江苏省','南京市','建邺区']
  function getKesByValues(values) {
    var keys = [];
    for (var i = 0, province; province = s.params.data[i++];) {
      // eslint-disable-line
      // 获得省, 兼容简称模式: 例如"江苏省"和"江苏"也能匹配成功
      if (values[0] && (province.value.indexOf(values[0]) > -1 || values[0].indexOf(province.value) > -1)) {
        keys.push(province.key);
        for (var j = 0, city; city = province.children[j++];) {
          // eslint-disable-line
          // 获得市
          if (values[1] && (city.value.indexOf(values[1]) > -1 || values[1].indexOf(city.value) > -1)) {
            keys.push(city.key);
            if (values[2]) {
              for (var k = 0, area; area = city.children[k++];) {
                // eslint-disable-line
                // 获得区
                if (values[2] && (area.value.indexOf(values[2]) > -1 || values[2].indexOf(area.value) > -1)) {
                  keys.push(area.key);
                  return keys;
                }
              }
            } else {
              return keys;
            }
          }
        }
      }
    }
    // 如果省市区不对,则返回第一个省第一个市
    return [s.params.data[0].key, s.params.data[0].children[0].key];
  }
  // 设置选中的省市区,不传参数则读取默认省市区
  s.setDefaults = function (argActiveValues) {
    var activeValues = argActiveValues || '';
    // 设置选中的key
    var keys = getKesByValues(activeValues);
    if (keys && keys[0]) s.setActiveProvinceKey(keys[0]);
    if (keys && keys[1]) s.setActiveCityKey(keys[1]);
    if (keys && keys[2]) s.setActiveAreaKey(keys[2]);
  };

  // 获得选中的文字
  function getActiveText(activeOptions) {
    var activeValues = activeOptions.map(function (n, i, a) {
      return n['value'];
    });
    var activeText = '';
    if (activeValues[0]) activeText += activeValues[0];
    if (activeValues[1]) activeText += '-' + activeValues[1];
    if (activeValues[2] && activeValues[2] !== s.params.defaultValues[0].value) activeText += '-' + activeValues[2];
    return activeText;
  }
  // 设置选中的keys
  function setActiveKeys(activeOptions) {
    var activeKeys = activeOptions.map(function (n, i, a) {
      return n['key'];
    });
    if (activeKeys[0]) s.setActiveProvinceKey(activeKeys[0]);
    if (activeKeys[1]) s.setActiveCityKey(activeKeys[1]);
    if (activeKeys[2]) s.setActiveAreaKey(activeKeys[2]);
  }

  // 获得第一层
  function getPureArray(array) {
    var arr = [];
    /* eslint-disable */
    for (var i = 0, opt; opt = array[i++];) {
      arr.push({
        key: opt.key,
        value: opt.value
      });
    }
    /* eslint-enable */
    return arr;
  }

  // 根据key获得children
  function getChildrenByKey(key) {
    // 如果没有传key，表示获得第一层
    if (!key) return getPureArray(s.params.data);
    // 如果传key，则找到对应key的子级
    /* eslint-disable */
    for (var i = 0, province; province = s.params.data[i++];) {
      if (province.key === key) return getPureArray(province.children);
      for (var j = 0, city; city = province.children[j++];) {
        if (!city.children) break;
        if (city.key === key) return getPureArray(city.children);
      }
    }
    /* eslint-enable */
    return null;
  }
  /* ----------------
  Init
  ---------------- */
  /* // 替换省
  function replaceProvince (activeKey) {
    var provinces = getChildrenByKey()
    s.replaceSlot(0, provinces, activeKey || provinces[0].key, s.params.cityClass)
    return provinces
  } */
  // 替换市
  function replaceCity(key, activeKey) {
    var citys = getChildrenByKey(key);
    s.replaceSlot(1, citys, activeKey || citys[0].key, s.params.cityClass);
    return citys;
  }
  // 替换区
  function replaceArea(key, activeKey) {
    if (s.params.viewType !== 'area') return;
    var areas = getChildrenByKey(key);
    if (areas && areas.length && areas.length > 0) {
      s.replaceSlot(2, areas, activeKey || areas[0].key, s.params.areaClass);
    } else {
      s.replaceSlot(2, s.params.defaultValues, s.params.defaultValues['key'], s.params.areaClass);
    }
  }
  // 添加省
  function addProvince() {
    if (!s.province) {
      s.province = getChildrenByKey();
    }
    if (!s.activeProvinceKey) {
      s.setActiveProvinceKey(s.province[0].key);
    }
    s.addSlot(s.province, s.activeProvinceKey, s.params.provinceClass);
  }
  // 添加市
  function addCity() {
    s.city = getChildrenByKey(s.activeProvinceKey);
    if (!s.activeCityKey) {
      s.setActiveCityKey(s.city[0].key);
    }
    s.addSlot(s.city, s.activeCityKey, s.params.cityClass);
  }
  // 添加区
  function addArea() {
    if (s.params.viewType !== 'area') return;
    s.area = getChildrenByKey(s.activeCityKey);
    if (!s.activeAreaKey) {
      s.setActiveAreaKey(s.city[0].key);
    }
    if (s.area) {
      s.addSlot(s.area, s.activeAreaKey, s.params.areaClass);
    } else {
      s.addSlot(s.params.defaultValues, '', s.params.areaClass);
    }
  }

  function initSlots() {
    // 渲染
    addProvince();
    addCity();
    addArea();
  }
  s.update = function () {
    s.clearSlots();
    initSlots();
  };
  // 设置默认选中项
  s.setDefaults([s.params.defaultProvince, s.params.defaultCity, s.params.defaultArea]);
  // 添加省市区
  initSlots();
  return s;
};

var PickerCity$1 = function (_Component) {
  inherits(PickerCity, _Component);

  function PickerCity(props) {
    classCallCheck(this, PickerCity);

    var _this = possibleConstructorReturn(this, (PickerCity.__proto__ || Object.getPrototypeOf(PickerCity)).call(this, props));

    _this.componentDidMount = function () {
      _this.initInstance();
    };

    _this.shouldComponentUpdate = function (nextProps) {
      if (nextProps.show === _this.props.show) return false;
      return true;
    };

    _this.componentDidUpdate = function (prevProps) {
      if (_this.state.instance) {
        if (_this.props.show) {
          _this.setDefault();
          _this.state.instance.show();
        } else _this.state.instance.hide();
      }
    };

    _this.setDefault = function () {
      var defaultValues = _this.getDefaults();
      _this.state.instance.setDefaults(defaultValues);
      _this.state.instance.update();
    };

    _this.getDefaults = function () {
      // 默认值
      var defaultValue = _this.props.value;
      var defaultValues = [];
      if (defaultValue) {
        defaultValues = defaultValue.split('-').map(function (item) {
          return item.trim();
        });
      }
      return defaultValues;
    };

    _this.initInstance = function () {
      var defaultValues = _this.getDefaults();
      // render数据
      var instance = new PickerCity$3({
        mask: _this.$el,
        viewType: _this.props.type,
        data: citys,
        defaultProvince: defaultValues[0] || '',
        defaultCity: defaultValues[1] || '',
        defaultArea: defaultValues[2] || '',
        onClickMask: function onClickMask(e) {
          if (_this.props.onClickMask) _this.props.onClickMask(e);
        },
        onClickCancel: function onClickCancel(e) {
          // e.hide()
          if (_this.props.onClickCancel) _this.props.onClickCancel(e);
        },
        onClickSubmit: function onClickSubmit(e) {
          // e.hide()
          if (_this.props.onClickSubmit) _this.props.onClickSubmit(e);
        },
        onHid: function onHid(e) {}
      });
      if (_this.props.show && instance) {
        setTimeout(function () {
          instance.show();
        }, 10);
      }
      _this.setState({
        instance: instance
      });
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(PickerCity, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { className: 'mask picker-mask', ref: function ref(el) {
            _this2.$el = el;
          } },
        React__default.createElement(
          'div',
          { className: 'picker' + (className ? ' ' + className : ''), style: style },
          React__default.createElement(
            'div',
            { className: 'picker-header' },
            React__default.createElement(
              'a',
              { className: 'picker-cancel' },
              '\u53D6\u6D88'
            ),
            React__default.createElement(
              'a',
              { className: 'picker-submit' },
              '\u5B8C\u6210'
            )
          ),
          React__default.createElement(
            'div',
            { className: 'picker-wrapper' },
            React__default.createElement(
              'div',
              { className: 'picker-layer' },
              React__default.createElement('div', { className: 'picker-layer-frame' })
            ),
            React__default.createElement('div', { className: 'picker-slotbox' })
          )
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return PickerCity;
}(React.Component);

PickerCity$1.propTypes = {
  portal: propTypes.object,
  type: propTypes.string, // area | city
  className: propTypes.string,
  style: propTypes.object,
  value: propTypes.string,
  show: propTypes.bool,
  onClickMask: propTypes.func,
  onClickCancel: propTypes.func,
  onClickSubmit: propTypes.func
};
PickerCity$1.defaultProps = {
  type: 'area'
};

var InputPicker = function (_Component) {
  inherits(InputPicker, _Component);

  function InputPicker(props) {
    classCallCheck(this, InputPicker);

    var _this = possibleConstructorReturn(this, (InputPicker.__proto__ || Object.getPrototypeOf(InputPicker)).call(this, props));

    _this.onClick = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickSubmit = function (e) {
      if (!_this.$input) _this.$input = _this.refs.$ComponentInputText.$input;
      var value = e.activeText;
      var options = e.activeOptions;
      // 赋值
      if (!_this.props.valueBindProp) _this.$input.value = value;
      _this.setState({
        show: !_this.state.show
      });
      if (_this.props.onChange) {
        _this.props.onChange(value, options, _this.refs.$ComponentInputText.getArgs());
      }
    };

    _this.onClickCancel = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickMask = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  createClass(InputPicker, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return [React__default.createElement(InputText$1, _extends({ key: 'input', ref: '$ComponentInputText' }, this.props, { type: 'text', readOnly: true, onClick: this.onClick })), React__default.createElement(PickerCity$1, {
        type: this.props.type || 'area' // 'area' | 'city'
        , value: this.$input ? this.$input.value : this.props.value, key: 'pickercity',
        show: this.state.show,
        style: this.props.pickerStyle, className: this.props.pickerClassName,
        onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel, onClickMask: this.onClickMask
      })];
    }
  }]);
  return InputPicker;
}(React.Component);

InputPicker.defaultProps = {
  error: {
    currentName: '',
    compareName: ''
  }
};

var InputPhone = function (_Component) {
  inherits(InputPhone, _Component);

  function InputPhone(props) {
    classCallCheck(this, InputPhone);
    return possibleConstructorReturn(this, (InputPhone.__proto__ || Object.getPrototypeOf(InputPhone)).call(this, props));
  }

  createClass(InputPhone, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputText$1, _extends({ ref: '$ComponentInputText' }, this.props, { type: 'color' }));
    }
  }]);
  return InputPhone;
}(React.Component);

// 扩展Picker日期控件 (require pikcer.js)
var PickerDate$3 = function PickerDate(params) {
  // 参数改写
  var onDateClickSubmit = params.onClickSubmit;
  var onDateScrollEnd = params.onScrollEnd;
  params.onClickSubmit = undefined;
  params.onScrollEnd = undefined;
  var nowDate = new Date();
  /* ----------------
    Model
    ---------------- */
  var defaults = {
    viewType: 'date', // 'date','month','time','datetime'
    isSimpleYear: false,

    yearClass: 'text-center',
    monthClass: 'text-center',
    dayClass: 'text-center',
    hourClass: 'text-center',
    minuteClass: 'text-center',

    yearsData: null,
    monthsData: null,
    daysData: null,
    hoursData: null,
    minutesData: null,

    defaultYear: '',
    defaultMonth: '',
    defaultDay: '',
    defaultHour: '',
    defaultMinute: '',

    minYear: nowDate.getFullYear() - 10, // 1950
    maxYear: nowDate.getFullYear() + 10, // 2050

    yyUnit: '年',
    MMUnit: '月',
    ddUnit: '日',
    hhUnit: '时',
    mmUnit: '分',

    onClickSubmit: function onClickSubmit(e) {
      e.activeText = getActiveText(e.activeOptions);
      var activeKeys = e.activeOptions.map(function (n, i, a) {
        return n['key'];
      });
      s.setDefaultsByKeys(activeKeys);
      if (onDateClickSubmit) onDateClickSubmit(e);
    },
    onScrollEnd: function onScrollEnd(e) {
      // 根据月份算日
      if ((e.params.viewType === 'date' || e.params.viewType === 'datetime') && (e.activeSlot.index === 0 || e.activeSlot.index === 1)) {
        var year = e.activeOptions[0]['key'];
        var month = e.activeOptions[1]['key'];
        var defaultDay = e.activeOptions[2]['key'];
        updateDays(year, month, defaultDay); // 更新总天数
      }
      // 回调
      if (onDateScrollEnd) onDateScrollEnd(e);
    }
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = new Picker(params);

  function trim(str) {
    return str.replace(/(^\s*)|(\s*$)/g, '');
  }
  // 设置默认值
  s.setDefaultYear = function (yearKey) {
    s.params.defaultYear = trim('' + yearKey);
  };
  s.setDefaultMonth = function (monthKey) {
    s.params.defaultMonth = trim('' + monthKey);
  };
  s.setDefaultDay = function (dayKey) {
    s.params.defaultDay = trim('' + dayKey);
  };
  s.setDefaultHour = function (hourKey) {
    s.params.defaultHour = trim('' + hourKey);
  };
  s.setDefaultMinute = function (minuteKey) {
    s.params.defaultMinute = trim('' + minuteKey);
  };

  // 默认时间
  s.updateDetault = function () {
    nowDate = new Date();
    // 默认值
    if (!s.params.defaultYear) {
      var yyyy = nowDate.getFullYear();
      var _yyyy = '' + yyyy;
      s.setDefaultYear(_yyyy);
    }
    if (!s.params.defaultMonth) {
      var MM = nowDate.getMonth() + 1;
      var _MM = MM.toString().length === 1 ? '0' + MM : MM;
      s.setDefaultMonth(_MM);
    }
    if (!s.params.defaultDay) {
      var dd = nowDate.getDate();
      var _dd = dd.toString().length === 1 ? '0' + dd : dd;
      s.setDefaultDay(_dd);
    }
    if (!s.params.defaultHour) {
      var hh = nowDate.getHours();
      var _hh = hh.toString().length === 1 ? '0' + hh : hh;
      s.setDefaultHour(_hh);
    }
    if (!s.params.defaultMinute) {
      var mm = nowDate.getMinutes();
      var _mm = mm.toString().length === 1 ? '0' + mm : mm;
      s.setDefaultMinute(_mm);
    }
  };
  s.updateDetault();

  // 年
  s.years = [];
  if (s.params.yearsData) {
    s.years = s.params.yearsData;
  } else {
    for (var yyyy = s.params.minYear; yyyy <= s.params.maxYear; yyyy++) {
      s.years.push({
        'key': '' + yyyy,
        'value': s.params.isSimpleYear ? yyyy.toString().substring(2, 4) + s.params.yyUnit : yyyy + s.params.yyUnit
      });
    }
  }
  // 月
  s.months = [];
  if (s.params.monthsData) {
    s.months = s.params.monthsData;
  } else {
    for (var MM = 1; MM <= 12; MM++) {
      var _MM = MM.toString().length === 1 ? '0' + MM : MM;
      s.months.push({
        'key': '' + _MM,
        'value': _MM + s.params.MMUnit
      });
    }
  }
  // 日
  s.days = [];
  var currentMaxday = new Date(nowDate.getFullYear(), nowDate.getMonth() + 1, 0).getDate();
  if (s.params.daysData) {
    s.days = Object.clone(s.params.daysData);
  } else {
    for (var dd = 1; dd <= currentMaxday; dd++) {
      var _dd = dd.toString().length === 1 ? '0' + dd : dd;
      s.days.push({
        'key': '' + _dd,
        'value': _dd + s.params.ddUnit
      });
    }
  }

  function updateDaysForDefault(year, month) {
    var lastDay = '' + new Date(year, month, 0).getDate();
    var currentLastDay = s.days[s.days.length - 1]['key'];
    if (lastDay === currentLastDay) return;
    if (lastDay > currentLastDay) {
      for (var i = 1 + parseInt(currentLastDay, 10); i <= lastDay; i++) {
        s.days.push({
          'key': '' + i,
          'value': '' + i + s.params.ddUnit
        });
      }
    } else if (lastDay < currentLastDay) {
      var spliceCount = currentLastDay - lastDay;
      s.days.splice(s.days.length - spliceCount, spliceCount);
    }
  }
  function updateDaysForCustom(year, month) {
    var lastDay = '' + new Date(year, month, 0).getDate();
    var currentLastDay = s.days[s.days.length - 1]['key'];
    var customData = s.params.daysData;
    if (lastDay === currentLastDay) return;
    if (lastDay > currentLastDay) {
      customData.forEach(function (n) {
        if (n['key'] <= lastDay && n['key'] > currentLastDay) s.days.push(n);
      });
    } else if (lastDay < currentLastDay) {
      for (var j = currentLastDay; j > lastDay; j--) {
        s.days.forEach(function (n) {
          // eslint-disable-line
          if (n['key'] === '' + j) s.days.pop();
        });
      }
    }
  }
  function updateDays(year, month, defaultDay) {
    if (s.params.daysData) {
      updateDaysForCustom(year, month);
    } else {
      updateDaysForDefault(year, month);
    }
    var defaultKey = defaultDay;
    if (s.days.length < defaultDay) defaultKey = s.days[s.days.length - 1]['key'];
    s.replaceSlot(2, s.days, defaultKey, s.params.dayClass); // 修改第三项
  }

  // 时
  s.hours = [];
  if (s.params.hoursData) {
    s.hours = s.params.hoursData;
  } else {
    for (var hh = 0; hh <= 23; hh++) {
      var _hh = hh.toString().length === 1 ? '0' + hh : hh;
      s.hours.push({
        'key': '' + _hh,
        'value': _hh + s.params.hhUnit
      });
    }
  }

  // 分
  s.minutes = [];
  if (s.params.minutesData) {
    s.minutes = s.params.minutesData;
  } else {
    for (var mm = 0; mm <= 59; mm++) {
      var _mm = mm.toString().length === 1 ? '0' + mm : mm;
      s.minutes.push({
        'key': '' + _mm,
        'value': _mm + s.params.mmUnit
      });
    }
  }

  /* ----------------
  Method
  ---------------- */
  function getActiveText(activeData) {
    var activeKeys = activeData.map(function (n, i, a) {
      return n['key'];
    });
    if (s.params.viewType === 'date') return activeKeys[0] + '-' + activeKeys[1] + '-' + activeKeys[2];else if (s.params.viewType === 'datetime') return activeKeys[0] + '-' + activeKeys[1] + '-' + activeKeys[2] + ' ' + activeKeys[3] + ':' + activeKeys[4];else if (s.params.viewType === 'time') return activeKeys[0] + ':' + activeKeys[1];else if (s.params.viewType === 'month') return activeKeys[0] + '-' + activeKeys[1];
  }
  s.setDefaultsByKeys = function (activeKeys) {
    if (s.params.viewType === 'date' || s.params.viewType === 'datetime' || s.params.viewType === 'month') {
      if (activeKeys[0]) s.setDefaultYear(activeKeys[0]);
      if (activeKeys[1]) s.setDefaultMonth(activeKeys[1]);
      if (activeKeys[2]) s.setDefaultDay(activeKeys[2]);
      if (activeKeys[3]) s.setDefaultHour(activeKeys[3]);
      if (activeKeys[4]) s.setDefaultMinute(activeKeys[4]);
    } else if (s.params.viewType === 'time') {
      if (activeKeys[0]) s.setDefaultHour(activeKeys[0]);
      if (activeKeys[1]) s.setDefaultMinute(activeKeys[1]);
    }
  };
  s.setDefaults = function (activeData) {
    if (activeData.year) s.setDefaultYear(activeData.year);
    if (activeData.month) s.setDefaultMonth(activeData.month);
    if (activeData.day) s.setDefaultDay(activeData.day);
    if (activeData.hour) s.setDefaultHour(activeData.hour);
    if (activeData.minute) s.setDefaultMinute(activeData.minute);
  };
  /* ----------------
  Init
  ---------------- */

  // 添加数据
  function addMonthSlot() {
    s.addSlot(s.years, s.params.defaultYear, s.params.yearClass);
    s.addSlot(s.months, s.params.defaultMonth, s.params.monthClass);
  }

  function addDateSlot() {
    addMonthSlot();
    s.addSlot(s.days, s.params.defaultDay, s.params.dayClass);
  }

  function addTimeSlot() {
    s.addSlot(s.hours, s.params.defaultHour, s.params.hourClass);
    s.addSlot(s.minutes, s.params.defaultMinute, s.params.minuteClass);
  }

  function addDateTime() {
    addDateSlot();
    addTimeSlot();
  }

  function initSlots() {
    switch (s.params.viewType) {
      case 'date':
        addDateSlot();
        break;
      case 'month':
        addMonthSlot();
        break;
      case 'time':
        addTimeSlot();
        break;
      case 'datetime':
        addDateTime();
        break;
      default:
        console.log('SeedsUI Error: initSlots失败');
    }
  }
  s.update = function () {
    s.clearSlots();
    initSlots();
  };
  initSlots();
  return s;
};

var PickerDate$1 = function (_Component) {
  inherits(PickerDate, _Component);

  function PickerDate(props) {
    classCallCheck(this, PickerDate);

    var _this = possibleConstructorReturn(this, (PickerDate.__proto__ || Object.getPrototypeOf(PickerDate)).call(this, props));

    _this.componentDidMount = function () {
      _this.initInstance();
    };

    _this.shouldComponentUpdate = function (nextProps) {
      if (nextProps.show === _this.props.show) return false;
      return true;
    };

    _this.componentDidUpdate = function (prevProps) {
      if (_this.state.instance) {
        if (_this.props.show) {
          _this.setDefault();
          _this.state.instance.show();
        } else _this.state.instance.hide();
      }
    };

    _this.setDefault = function () {
      var def = _this.getDefault();
      _this.state.instance.setDefaults(def);
      _this.state.instance.update();
    };

    _this.getDefault = function () {
      var _this$props = _this.props,
          type = _this$props.type,
          onError = _this$props.onError;

      var defaultValue = _this.props.value;
      var defaultYear = '';
      var defaultMonth = '';
      var defaultDay = '';
      var defaultHour = '';
      var defaultMinute = '';
      // 默认值
      if (type === 'date') {
        // 如果不是合法的日期格式
        if (!defaultValue || !defaultValue.isDate()) {
          if (onError) onError('请传入合法的日期');
          defaultValue = new Date().format('yyyy-MM-dd');
        }
        var dateValues = defaultValue.split('-');
        defaultYear = dateValues[0];
        defaultMonth = dateValues[1];
        defaultDay = dateValues[2] || '01';
      } else if (type === 'month') {
        // 如果不是合法的日期格式
        if (!defaultValue.isMonth()) {
          if (onError) onError('请传入合法的年月日期');
          defaultValue = new Date().format('yyyy-MM');
        }
        var monthValues = defaultValue.split('-');
        defaultYear = monthValues[0];
        defaultMonth = monthValues[1];
      } else if (type === 'datetime') {
        // 如果不是合法的日期格式
        if (!defaultValue.isMonth()) {
          if (onError) onError('请传入合法的日期时间');
          defaultValue = new Date().format('yyyy-MM-dd hh:mm');
        }
        var values = defaultValue.split(' ');
        var _dateValues = values[0].split('-');
        var timeValues = values[1].split(':');
        defaultYear = _dateValues[0];
        defaultMonth = _dateValues[1];
        defaultDay = _dateValues[2];
        defaultHour = timeValues[0];
        defaultMinute = timeValues[1];
      } else if (type === 'time') {
        // 如果不是合法的日期格式
        if (!defaultValue.isTime()) {
          if (onError) onError('请传入合法的时间');
          defaultValue = new Date().format('hh:mm');
        }
        var _timeValues = defaultValue.split(':');
        defaultHour = _timeValues[0];
        defaultMinute = _timeValues[1];
      }
      return {
        year: defaultYear,
        month: defaultMonth,
        day: defaultDay,
        hour: defaultHour,
        minute: defaultMinute
      };
    };

    _this.getData = function () {
      // 自定义数据
      var yearsData = null;
      var monthsData = null;
      var daysData = null;
      var hoursData = null;
      var minutesData = null;
      if (_this.props.data) {
        if (_this.props.data.year) {
          yearsData = _this.props.data.year.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + '年'
            };
          });
        }
        if (_this.props.data.month) {
          monthsData = _this.props.data.month.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + '月'
            };
          });
        }
        if (_this.props.data.day) {
          daysData = _this.props.data.day.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + '日'
            };
          });
        }
        if (_this.props.data.hour) {
          hoursData = _this.props.data.hour.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + '时'
            };
          });
        }
        if (_this.props.data.minute) {
          minutesData = _this.props.data.minute.map(function (n) {
            return {
              'key': '' + n,
              'value': '' + n + '分'
            };
          });
        }
      }
      return {
        yearsData: yearsData,
        monthsData: monthsData,
        daysData: daysData,
        hoursData: hoursData,
        minutesData: minutesData
      };
    };

    _this.initInstance = function () {
      var data = _this.getData();
      var def = _this.getDefault();
      // render数据
      var instance = new PickerDate$3({
        mask: _this.$el,
        viewType: _this.props.type,
        yearsData: data.yearsData,
        monthsData: data.monthsData,
        daysData: data.daysData,
        hoursData: data.hoursData,
        minutesData: data.minutesData,
        defaultYear: def.year,
        defaultMonth: def.month,
        defaultDay: def.day,
        defaultHour: def.hour,
        defaultMinute: def.minute,
        onClickMask: function onClickMask(e) {
          if (_this.props.onClickMask) _this.props.onClickMask(e);
        },
        onClickCancel: function onClickCancel(e) {
          // e.hide()
          if (_this.props.onClickCancel) _this.props.onClickCancel(e);
        },
        onClickSubmit: function onClickSubmit(e) {
          // e.hide()
          if (_this.props.onClickSubmit) _this.props.onClickSubmit(e);
        },
        onHid: function onHid(e) {}
      });
      if (_this.props.show && instance) {
        setTimeout(function () {
          instance.show();
        }, 10);
      }
      _this.setState({
        instance: instance
      });
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(PickerDate, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { className: 'mask picker-mask', ref: function ref(el) {
            _this2.$el = el;
          } },
        React__default.createElement(
          'div',
          { className: 'picker' + (className ? ' ' + className : ''), style: style },
          React__default.createElement(
            'div',
            { className: 'picker-header' },
            React__default.createElement(
              'a',
              { className: 'picker-cancel' },
              '\u53D6\u6D88'
            ),
            React__default.createElement(
              'a',
              { className: 'picker-submit' },
              '\u5B8C\u6210'
            )
          ),
          React__default.createElement(
            'div',
            { className: 'picker-wrapper' },
            React__default.createElement(
              'div',
              { className: 'picker-layer' },
              React__default.createElement('div', { className: 'picker-layer-frame' })
            ),
            React__default.createElement('div', { className: 'picker-slotbox' })
          )
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return PickerDate;
}(React.Component);

PickerDate$1.propTypes = {
  portal: propTypes.object,
  type: propTypes.string, // 'date','month','time','datetime'
  className: propTypes.string,
  style: propTypes.object,
  data: propTypes.object, // {year: [], month: [], day: [], hour: [], minute: []}
  value: propTypes.string, // 例: 2018-02-26
  show: propTypes.bool,
  onClickMask: propTypes.func,
  onClickCancel: propTypes.func,
  onClickSubmit: propTypes.func,
  onError: propTypes.func
};
PickerDate$1.defaultProps = {
  type: 'date'
};

var InputPicker$1 = function (_Component) {
  inherits(InputPicker, _Component);

  function InputPicker(props) {
    classCallCheck(this, InputPicker);

    var _this = possibleConstructorReturn(this, (InputPicker.__proto__ || Object.getPrototypeOf(InputPicker)).call(this, props));

    _this.onClick = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickSubmit = function (e) {
      if (!_this.$input) _this.$input = _this.refs.$ComponentInputText.$input;
      var value = _this.correctDate(e.activeText);
      if (!value) return;
      var options = e.activeOptions;
      // 赋值
      if (!_this.props.valueBindProp) _this.$input.value = value;
      _this.setState({
        show: !_this.state.show
      });
      if (_this.props.onChange) {
        _this.props.onChange(value, options, _this.refs.$ComponentInputText.getArgs());
      }
    };

    _this.onClickCancel = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickMask = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.correctDate = function (value) {
      var text = value;
      var _this$props = _this.props,
          type = _this$props.type,
          min = _this$props.min,
          max = _this$props.max,
          onError = _this$props.onError;

      console.log(onError);
      var selectDate = new Date(text);
      var current = _this.$input.value;
      var error = _this.props.error;
      if (min && (min.isDate() || min.isTime())) {
        if (type === 'date' && selectDate.compareDate(min) === -1) {
          if (onError) {
            onError(_extends({ msg: '不能小于' + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        }
        if (type === 'month' && selectDate.compareMonth(min) === -1) {
          if (onError) {
            onError(_extends({ msg: '不能小于' + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        }
        if (type === 'time' && selectDate.compareTime(min) === -1) {
          if (onError) {
            onError(_extends({ msg: '不能小于' + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        }
        if (type === 'datetime' && selectDate.compareDateTime(min) === -1) {
          if (onError) {
            onError(_extends({ msg: '不能小于' + min, select: text, min: min, current: current }, error));
            return false;
          }
          text = min;
        }
      }
      if (max && (max.isDate() || max.isTime())) {
        if (type === 'date' && selectDate.compareDate(max) === 1) {
          if (onError) {
            onError(_extends({ msg: '不能大于' + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        }
        if (type === 'month' && selectDate.compareMonth(max) === 1) {
          if (onError) {
            onError(_extends({ msg: '不能大于' + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        }
        if (type === 'time' && selectDate.compareTime(max) === 1) {
          if (onError) {
            onError(_extends({ msg: '不能大于' + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        }
        if (type === 'datetime' && selectDate.compareDateTime(max) === 1) {
          if (onError) {
            onError(_extends({ msg: '不能大于' + max, select: text, max: max, current: current }, error));
            return false;
          }
          text = max;
        }
      }
      return text;
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  createClass(InputPicker, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
    // 日期纠正

  }, {
    key: 'render',
    value: function render() {
      return [React__default.createElement(InputText$1, _extends({ key: 'input', ref: '$ComponentInputText' }, this.props, { type: 'text', readOnly: true, onClick: this.onClick })), React__default.createElement(PickerDate$1, {
        type: this.props.type || 'date' // 'date','month','time','datetime'
        , value: this.$input ? this.$input.value : this.props.value, key: 'pickerdate',
        show: this.state.show,
        style: this.props.pickerStyle, className: this.props.pickerClassName,
        onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel, onClickMask: this.onClickMask
      })];
    }
  }]);
  return InputPicker;
}(React.Component);

InputPicker$1.defaultProps = {
  type: 'date',
  error: {
    currentName: '',
    compareName: ''
  }
};

var InputLocation$1 = function (_Component) {
  inherits(InputLocation, _Component);

  function InputLocation(props) {
    classCallCheck(this, InputLocation);

    var _this = possibleConstructorReturn(this, (InputLocation.__proto__ || Object.getPrototypeOf(InputLocation)).call(this, props));

    _this.onClick = function (e) {
      var _this$props = _this.props,
          onChange = _this$props.onChange,
          onClick = _this$props.onClick;

      var locationingText = '定位中...';
      if (onClick) onClick(_this.refs.$ComponentInputText.getArgs(e));
      if (_this.$input.value === locationingText) return;
      // 定位中...
      if (!_this.props.valueBindProp) _this.$input.value = locationingText;
      Bridge$1.getLocation({
        onSuccess: function onSuccess(data) {
          Bridge$1.getAddress({
            latitude: data.latitude,
            longitude: data.longitude,
            type: 'gcj02',
            onSuccess: function onSuccess(addrs) {
              // 赋值
              if (!_this.props.valueBindProp) _this.$input.value = addrs.address;
              if (onChange) onChange(addrs.address, _this.refs.$ComponentInputText.getArgs(e));
            },
            onError: function onError(err) {
              // 赋值
              if (!_this.props.valueBindProp) _this.$input.value = '';
              if (onChange) onChange('', _this.refs.$ComponentInputText.getArgs(e));
              // 提示获取地址失败
              Bridge$1.showToast(err.msg, { mask: false });
            }
          });
        },
        onError: function onError(err) {
          // 赋值
          if (!_this.props.valueBindProp) _this.$input.value = '';
          if (onChange) onChange('', _this.refs.$ComponentInputText.getArgs(e));
          // 提示定位失败
          Bridge$1.showToast(err.msg, { mask: false });
        }
      });
    };

    return _this;
  }

  createClass(InputLocation, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputText$1, _extends({ ref: '$ComponentInputText' }, this.props, { readOnly: true, onClick: this.onClick }));
    }
  }]);
  return InputLocation;
}(React.Component);

var InputNumber$1 = function (_Component) {
  inherits(InputNumber, _Component);

  function InputNumber(props) {
    classCallCheck(this, InputNumber);
    return possibleConstructorReturn(this, (InputNumber.__proto__ || Object.getPrototypeOf(InputNumber)).call(this, props));
  }

  createClass(InputNumber, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputText$1, _extends({ ref: '$ComponentInputText' }, this.props, { type: 'number' }));
    }
  }]);
  return InputNumber;
}(React.Component);

var InputPassword$1 = function (_Component) {
  inherits(InputPassword, _Component);

  function InputPassword(props) {
    classCallCheck(this, InputPassword);
    return possibleConstructorReturn(this, (InputPassword.__proto__ || Object.getPrototypeOf(InputPassword)).call(this, props));
  }

  createClass(InputPassword, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputText$1, _extends({ ref: '$ComponentInputText' }, this.props, { type: 'password' }));
    }
  }]);
  return InputPassword;
}(React.Component);

var InputPhone$2 = function (_Component) {
  inherits(InputPhone, _Component);

  function InputPhone(props) {
    classCallCheck(this, InputPhone);
    return possibleConstructorReturn(this, (InputPhone.__proto__ || Object.getPrototypeOf(InputPhone)).call(this, props));
  }

  createClass(InputPhone, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputText$1, _extends({ ref: '$ComponentInputText' }, this.props, { type: 'phone', maxLength: '11' }));
    }
  }]);
  return InputPhone;
}(React.Component);

var Picker$2 = function (_Component) {
  inherits(Picker$$1, _Component);

  function Picker$$1(props) {
    classCallCheck(this, Picker$$1);

    var _this = possibleConstructorReturn(this, (Picker$$1.__proto__ || Object.getPrototypeOf(Picker$$1)).call(this, props));

    _this.componentDidMount = function () {
      _this.initInstance();
    };

    _this.shouldComponentUpdate = function (nextProps) {
      if (nextProps.show === _this.props.show) return false;
      return true;
    };

    _this.componentDidUpdate = function (prevProps) {
      if (_this.state.instance) {
        if (_this.props.show) {
          _this.setDefault();
          _this.state.instance.show();
        } else _this.state.instance.hide();
      } else {
        if (_this.props.list.length > 0) {
          _this.initInstance();
        }
      }
    };

    _this.setDefault = function () {
      var list = _this.props.list;

      var key = '';
      var defaultOpt = _this.getDefaults();
      if (defaultOpt && defaultOpt.key) key = defaultOpt.key;
      _this.state.instance.clearSlots();
      _this.state.instance.addSlot(list, key || '', _this.props.slotClassName); // 添加列,参数:数据,默认key,样式(lock样式为锁定列)
    };

    _this.getDefaults = function () {
      var _this$props = _this.props,
          list = _this$props.list,
          value = _this$props.value;

      if (!value) return value;
      var values = list.filter(function (item) {
        return item.value === value;
      });
      return values[0];
    };

    _this.initInstance = function () {
      var list = _this.props.list;

      if (!list || list.length === 0 || _this.state.instance) return;
      // render数据
      var instance = new Picker({
        mask: _this.$el,
        onClickMask: function onClickMask(e) {
          if (_this.props.onClickMask) _this.props.onClickMask(e);
        },
        onClickCancel: function onClickCancel(e) {
          // e.hide()
          if (_this.props.onClickCancel) _this.props.onClickCancel(e);
        },
        onClickSubmit: function onClickSubmit(e) {
          // e.hide()
          if (_this.props.onClickSubmit) _this.props.onClickSubmit(e);
        },
        onHid: function onHid(e) {}
      });
      // 默认项
      var defaultOpt = _this.getDefaults();
      var key = '';
      if (defaultOpt && defaultOpt.key) key = defaultOpt.key;
      instance.addSlot(list, key, _this.props.slotClassName);
      if (_this.props.show && instance) {
        instance.show();
      }
      _this.setState({
        instance: instance
      });
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(Picker$$1, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { className: 'mask picker-mask', ref: function ref(el) {
            _this2.$el = el;
          } },
        React__default.createElement(
          'div',
          { className: 'picker' + (className ? ' ' + className : ''), style: style },
          React__default.createElement(
            'div',
            { className: 'picker-header' },
            React__default.createElement(
              'a',
              { className: 'picker-cancel' },
              '\u53D6\u6D88'
            ),
            React__default.createElement(
              'a',
              { className: 'picker-submit' },
              '\u5B8C\u6210'
            )
          ),
          React__default.createElement(
            'div',
            { className: 'picker-wrapper' },
            React__default.createElement(
              'div',
              { className: 'picker-layer' },
              React__default.createElement('div', { className: 'picker-layer-frame' })
            ),
            React__default.createElement('div', { className: 'picker-slotbox' })
          )
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Picker$$1;
}(React.Component);

Picker$2.propTypes = {
  portal: propTypes.object,
  list: propTypes.array, // [{key: '', value: ''}]
  className: propTypes.string,
  style: propTypes.object,
  slotClassName: propTypes.string,
  value: propTypes.string,
  show: propTypes.bool,
  onClickMask: propTypes.func,
  onClickCancel: propTypes.func,
  onClickSubmit: propTypes.func
};
Picker$2.defaultProps = {
  slotClassName: 'text-center'
};

var InputPicker$3 = function (_Component) {
  inherits(InputPicker, _Component);

  function InputPicker(props) {
    classCallCheck(this, InputPicker);

    var _this = possibleConstructorReturn(this, (InputPicker.__proto__ || Object.getPrototypeOf(InputPicker)).call(this, props));

    _this.onClick = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickSubmit = function (e) {
      if (!_this.$input) _this.$input = _this.refs.$ComponentInputText.$input;
      var value = e.activeOptions[0].value;
      // 赋值
      if (!_this.props.valueBindProp) _this.$input.value = value;
      _this.setState({
        show: !_this.state.show
      });
      if (_this.props.onChange) {
        _this.props.onChange(value, e.activeOptions[0], _this.refs.$ComponentInputText.getArgs());
      }
    };

    _this.onClickCancel = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickMask = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  createClass(InputPicker, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return [React__default.createElement(InputText$1, _extends({ key: 'input', ref: '$ComponentInputText' }, this.props, { readOnly: true, onClick: this.onClick })), React__default.createElement(Picker$2, {
        list: this.props.list, value: this.$input ? this.$input.value : this.props.value, key: 'picker',
        show: this.state.show,
        style: this.props.pickerStyle, className: this.props.pickerClassName,
        onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel, onClickMask: this.onClickMask
      })];
    }
  }]);
  return InputPicker;
}(React.Component);

// require string.js
var InputSafe$1 = function (_Component) {
  inherits(InputSafe, _Component);

  function InputSafe(props) {
    classCallCheck(this, InputSafe);
    return possibleConstructorReturn(this, (InputSafe.__proto__ || Object.getPrototypeOf(InputSafe)).call(this, props));
  }

  createClass(InputSafe, [{
    key: 'componentDidMount',
    value: function componentDidMount() {}
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          style = _props.style,
          className = _props.className;

      var lvl = value.safeLvl();
      return React__default.createElement(
        'ul',
        { className: 'input-safe lvl' + lvl + (className ? ' ' + className : ''), style: style },
        React__default.createElement(
          'li',
          null,
          React__default.createElement('div', { className: 'input-safe-progress' }),
          React__default.createElement(
            'span',
            { className: 'input-safe-caption' },
            '\u5F31'
          )
        ),
        React__default.createElement(
          'li',
          null,
          React__default.createElement('div', { className: 'input-safe-progress' }),
          React__default.createElement(
            'span',
            { className: 'input-safe-caption' },
            '\u4E2D'
          )
        ),
        React__default.createElement(
          'li',
          null,
          React__default.createElement('div', { className: 'input-safe-progress' }),
          React__default.createElement(
            'span',
            { className: 'input-safe-caption' },
            '\u5F3A'
          )
        )
      );
    }
  }]);
  return InputSafe;
}(React.Component);

InputSafe$1.propTypes = {
  value: propTypes.string,

  style: propTypes.object,
  className: propTypes.string
};
InputSafe$1.defaultProps = {
  value: ''
};

// SelectPicker 滚动选择器
var SelectPicker$3 = function SelectPicker(params) {
  /* ------------------------
  Model
  ------------------------ */
  var defaults = {
    multiple: true, // 是否允许多选
    overflowContainer: document.body,
    overflowContainerActiveClass: 'overflow-hidden',

    mask: null,

    maskClass: 'mask',
    maskActiveClass: 'active',
    maskFeatureClass: 'picker-mask',

    pickerClass: 'selectpicker',
    pickerActiveClass: 'active',

    headerClass: 'picker-header',
    headerSubmitClass: 'picker-submit',
    headerSubmitText: '完成',
    headerCancelClass: 'picker-cancel',
    headerCancelText: '取消',

    wrapperClass: 'selectpicker-wrapper',
    optionClass: 'selectpicker-option',
    optionActiveClass: 'active'
    /* callbacks
    onInit:function (Picker)
    onClickCancel:function (Picker)
    onClickSubmit:function (Picker)
    onClickMask:functioin (Picker)
    onTransitionEnd:function (Picker)// 动画结束后回调
    onShowed(Picker)// 显示动画结束后回调
    onHid(Picker)// 隐藏动画结束后回调
      */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  // Picker
  var s = this;

  // Params
  s.params = params;
  // Dom元素
  s.overflowContainer = typeof s.params.overflowContainer === 'string' ? document.querySelector(s.params.overflowContainer) : s.params.overflowContainer;
  s.picker = null;
  s.mask = null;
  s.header = null;
  s.wrapper = null;
  s.headerSubmit = null;
  s.headerCancel = null;

  // 新建Picker
  s.createPicker = function () {
    var picker = document.createElement('div');
    picker.setAttribute('class', s.params.pickerClass);
    return picker;
  };

  // 新建Header
  s.createHeader = function () {
    var header = document.createElement('div');
    header.setAttribute('class', s.params.headerClass);
    return header;
  };

  // 新建Header按钮
  s.createHeaderSubmit = function () {
    var headerSubmit = document.createElement('a');
    headerSubmit.setAttribute('class', s.params.headerSubmitClass);
    headerSubmit.innerHTML = s.params.headerSubmitText;
    return headerSubmit;
  };
  s.createHeaderCancel = function () {
    var headerCancel = document.createElement('a');
    headerCancel.setAttribute('class', s.params.headerCancelClass);
    headerCancel.innerHTML = s.params.headerCancelText;
    return headerCancel;
  };

  // 新建Wrapper
  s.createWrapper = function () {
    var wrapper = document.createElement('div');
    wrapper.setAttribute('class', s.params.wrapperClass);
    return wrapper;
  };

  // 新建Mask
  s.createMask = function () {
    var mask = document.createElement('div');
    mask.setAttribute('class', s.params.maskClass + ' ' + s.params.maskFeatureClass);
    return mask;
  };

  // 创建DOM
  s.create = function () {
    if (s.params.mask) s.mask = typeof s.params.mask === 'string' ? document.querySelector(s.params.mask) : s.params.mask;

    if (s.mask) {
      s.picker = s.mask.querySelector('.' + s.params.pickerClass);
      s.header = s.mask.querySelector('.' + s.params.headerClass);
      s.headerSubmit = s.mask.querySelector('.' + s.params.headerSubmitClass);
      s.headerCancel = s.mask.querySelector('.' + s.params.headerCancelClass);
      s.wrapper = s.mask.querySelector('.' + s.params.wrapperClass);
      return;
    }
    s.mask = s.createMask();
    s.picker = s.createPicker();
    s.header = s.createHeader();
    s.headerSubmit = s.createHeaderSubmit();
    s.headerCancel = s.createHeaderCancel();
    s.wrapper = s.createWrapper();

    s.header.appendChild(s.headerCancel);
    s.header.appendChild(s.headerSubmit);

    s.picker.appendChild(s.header);
    s.picker.appendChild(s.wrapper);

    s.mask.appendChild(s.picker);
    s.overflowContainer.appendChild(s.mask);
  };
  s.create();
  /* ------------------------
  Method
  ------------------------ */
  // 选中项
  s.activeOptions = [];
  s.setActiveOptions = function (options) {
    s.activeOptions = options;
    s.updateActive();
  };
  s.updateActive = function () {
    var options = [].slice.call(s.picker.querySelectorAll('.' + s.params.optionClass));
    var activeKeys = s.activeOptions.map(function (item) {
      return item.key;
    });
    options.forEach(function (n, i) {
      var key = n.getAttribute('data-key');
      if (activeKeys.indexOf(key) >= 0) {
        n.classList.add(s.params.optionActiveClass);
      } else {
        n.classList.remove(s.params.optionActiveClass);
      }
    });
  };
  s.isHid = true;
  // 隐藏
  s.hide = function () {
    s.isHid = true;
    s.mask.classList.remove(s.params.maskActiveClass);
    s.picker.classList.remove(s.params.pickerActiveClass);
    // 显示滚动条
    if (s.overflowContainer) s.overflowContainer.classList.remove(s.params.overflowContainerActiveClass);
  };
  s.show = function () {
    // 显示
    s.isHid = false;
    s.mask.classList.add(s.params.maskActiveClass);
    s.picker.classList.add(s.params.pickerActiveClass);
    // 禁用滚动条
    if (s.overflowContainer) s.overflowContainer.classList.add(s.params.overflowContainerActiveClass);
  };
  s.destroy = function () {
    // 销毁
    s.overflowContainer.removeChild(s.mask);
  };
  /* ------------------------
  Control
  ------------------------ */
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    // 选择器事件
    s.picker[action]('webkitTransitionEnd', s.onTransitionEnd, false);
    // 遮罩
    // s.mask[action]('touchmove', s.preventDefault, false)
    s.mask[action]('click', s.onClickMask, false);
    // 按钮
    // s.header[action]('touchmove', s.preventDefault, false)
    s.headerSubmit[action]('click', s.onClickSubmit, false);
    s.headerCancel[action]('click', s.onClickCancel, false);
    // 列表
    s.wrapper[action]('click', s.onClickWrapper, false);
  };
  s.detach = function (event) {
    s.events(true);
  };
  s.attach = function (event) {
    s.events();
  };

  s.preventDefault = function (e) {
    e.preventDefault();
  };

  // Mask
  s.onClickMask = function (e) {
    if (e.target !== s.mask) return;
    if (s.params.onClickMask) s.params.onClickMask(e);else s.hide();
  };
  // Wrapper
  s.onClickWrapper = function (e) {
    if (e.target.classList.contains(s.params.optionClass)) {
      s.onClickOption(e);
    }
  };
  s.onClickOption = function (e) {
    s.target = e.target;
    var options = [].slice.call(s.picker.querySelectorAll('.' + s.params.optionClass));
    s.activeOptions = [];
    // 多选
    if (s.params.multiple) {
      if (e.target.classList.contains(s.params.optionActiveClass)) {
        e.target.classList.remove(s.params.optionActiveClass);
      } else {
        e.target.classList.add(s.params.optionActiveClass);
      }
      // 获得选中项
      options.forEach(function (n, i) {
        if (n.classList.contains(s.params.optionActiveClass)) {
          var key = n.getAttribute('data-key');
          var value = n.getAttribute('data-value');
          s.activeOptions.push({
            key: key,
            value: value
          });
        }
      });
      // 单选
    } else {
      // 重置选中项
      options.forEach(function (n, i) {
        n.classList.remove(s.params.optionActiveClass);
      });
      // 设置点中的为选中项
      e.target.classList.add(s.params.optionActiveClass);
      var key = e.target.getAttribute('data-key');
      var value = e.target.getAttribute('data-value');
      s.activeOptions = [{
        key: key,
        value: value
      }];
    }

    // Callback
    if (s.params.onClickOption) s.params.onClickOption(s);
  };
  // Submit|Cancel
  s.onClickSubmit = function (e) {
    s.target = e.target;
    s.params.onClickSubmit(s);
  };
  s.onClickCancel = function (e) {
    s.target = e.target;
    if (s.params.onClickCancel) s.params.onClickCancel(s);else s.hide();
  };

  s.onTransitionEnd = function (e) {
    var target = e.target;
    if (e.propertyName !== 'transform' || target !== s.picker) {
      return;
    }
    // 容器显隐
    if (target.classList.contains(s.params.pickerClass)) {
      if (s.params.onTransitionEnd) s.params.onTransitionEnd(s);
      if (s.isHid) {
        if (s.params.onHid) s.params.onHid(s);
      } else {
        if (s.params.onShowed) s.params.onShowed(s);
      }
    }
  };

  s.init = function () {
    if (s.params.onInit) s.params.onInit(s);
    s.attach();
  };
  s.init();
  return s;
};

var SelectPicker$1 = function (_Component) {
  inherits(SelectPicker, _Component);

  function SelectPicker(props) {
    classCallCheck(this, SelectPicker);

    var _this = possibleConstructorReturn(this, (SelectPicker.__proto__ || Object.getPrototypeOf(SelectPicker)).call(this, props));

    _this.componentDidMount = function () {
      _this.initInstance();
    };

    _this.shouldComponentUpdate = function (nextProps) {
      if (nextProps.show === _this.props.show) return false;
      return true;
    };

    _this.componentDidUpdate = function (prevProps) {
      if (_this.state.instance) {
        if (_this.props.show) {
          _this.setDefaults();
          _this.state.instance.show();
        } else _this.state.instance.hide();
      }
    };

    _this.setDefaults = function () {
      if (_this.props.value) {
        var options = _this.props.value.split(',').map(function (value) {
          for (var i = 0, li; li = _this.props.list[i++];) {
            // eslint-disable-line
            if (li.value === value) {
              return li;
            }
          }
          return {
            key: value,
            value: value
          };
        });
        _this.state.instance.setActiveOptions(options);
      } else {
        _this.state.instance.setActiveOptions([]);
      }
    };

    _this.initInstance = function () {
      if (_this.state.instance) return;
      // render数据
      var instance = new SelectPicker$3({
        multiple: _this.props.multiple || false,
        mask: _this.$el,
        onClickMask: function onClickMask(e) {
          if (_this.props.onClickMask) _this.props.onClickMask(e);
        },
        onClickCancel: function onClickCancel(e) {
          // e.hide()
          if (_this.props.onClickCancel) _this.props.onClickCancel(e);
        },
        onClickSubmit: function onClickSubmit(e) {
          // e.hide()
          if (_this.props.onClickSubmit) _this.props.onClickSubmit(e);
        },
        onClickOption: function onClickOption(e) {
          if (!_this.props.multiple && _this.props.onClickSubmit) _this.props.onClickSubmit(e);
        },
        onHid: function onHid(e) {}
      });
      _this.setState({
        instance: instance
      }, function () {
        _this.setDefaults();
        if (_this.props.show && instance) {
          instance.show();
        }
      });
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(SelectPicker, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          list = _props.list,
          multiple = _props.multiple,
          className = _props.className,
          style = _props.style;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { className: 'mask picker-mask', ref: function ref(el) {
            _this2.$el = el;
          } },
        React__default.createElement(
          'div',
          { className: 'selectpicker' + (className ? ' ' + className : ''), style: style },
          React__default.createElement(
            'div',
            { className: 'picker-header' },
            React__default.createElement(
              'a',
              { className: 'picker-cancel' },
              '\u53D6\u6D88'
            ),
            React__default.createElement(
              'a',
              { className: 'picker-submit' + (multiple ? '' : ' disabled') },
              '\u5B8C\u6210'
            )
          ),
          React__default.createElement(
            'div',
            { className: 'selectpicker-wrapper' },
            list && list.length && list.map(function (item, index) {
              return React__default.createElement(
                'div',
                { key: index, className: 'selectpicker-option', 'data-key': item.key, 'data-value': item.value },
                React__default.createElement(
                  'p',
                  { className: 'selectpicker-option-caption' },
                  item.value
                ),
                React__default.createElement('i', { className: 'selectpicker-option-icon' })
              );
            })
          )
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return SelectPicker;
}(React.Component);

SelectPicker$1.propTypes = {
  portal: propTypes.object,
  multiple: propTypes.bool, // 是否允许多选
  list: propTypes.array, // [key: 'xx', value: 'xx']
  className: propTypes.string,
  style: propTypes.object,
  slotClassName: propTypes.string,
  value: propTypes.string,
  show: propTypes.bool,
  onChange: propTypes.func,
  onClickMask: propTypes.func,
  onClickCancel: propTypes.func,
  onClickSubmit: propTypes.func
};
SelectPicker$1.defaultProps = {
  slotClassName: 'text-center'
};

var InputSelect$1 = function (_Component) {
  inherits(InputSelect, _Component);

  function InputSelect(props) {
    classCallCheck(this, InputSelect);

    var _this = possibleConstructorReturn(this, (InputSelect.__proto__ || Object.getPrototypeOf(InputSelect)).call(this, props));

    _this.getValue = function (options) {
      if (!_this.props.multiple) return options[0].value;
      var value = options.map(function (item) {
        return item.value;
      });
      return value.join(',');
    };

    _this.getOptions = function (options) {
      return _this.props.multiple ? options : options[0];
    };

    _this.onClick = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickSubmit = function (e) {
      if (!_this.$input) _this.$input = _this.refs.$ComponentInputText.$input;
      var value = _this.getValue(e.activeOptions);
      var options = _this.getOptions(e.activeOptions);
      // 赋值
      if (!_this.props.valueBindProp) _this.$input.value = value;
      _this.setState({
        show: !_this.state.show
      });
      if (_this.props.onChange) {
        _this.props.onChange(value, options, _this.refs.$ComponentInputText.getArgs());
      }
    };

    _this.onClickCancel = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.onClickMask = function () {
      _this.setState({
        show: !_this.state.show
      });
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  createClass(InputSelect, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return [React__default.createElement(InputText$1, _extends({ key: 'input', ref: '$ComponentInputText' }, this.props, { readOnly: true, onClick: this.onClick })), React__default.createElement(SelectPicker$1, {
        list: this.props.list, value: this.$input ? this.$input.value : this.props.value, key: 'picker',
        show: this.state.show,
        multiple: this.props.multiple,
        style: this.props.pickerStyle, className: this.props.pickerClassName,
        onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel, onClickMask: this.onClickMask
      })];
    }
  }]);
  return InputSelect;
}(React.Component);

var InputVerify$1 = function (_Component) {
  inherits(InputVerify, _Component);

  function InputVerify(props) {
    classCallCheck(this, InputVerify);

    var _this = possibleConstructorReturn(this, (InputVerify.__proto__ || Object.getPrototypeOf(InputVerify)).call(this, props));

    _this.onClickSent = function (e) {
      var target = e.currentTarget.parentNode.querySelector('input[type=number]');
      target.focus();
      if (_this.props.onClickSent) _this.props.onClickSent();
    };

    return _this;
  }

  createClass(InputVerify, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.$input = this.refs.$ComponentInputText.$input;
    }
  }, {
    key: 'render',
    value: function render() {
      return React__default.createElement(InputNumber$1, _extends({ ref: '$ComponentInputText' }, this.props, { type: 'number', digits: 0, rcaption: [React__default.createElement('span', { className: 'splitter', key: 'rsentsplitter' }), React__default.createElement(
          'a',
          { onClick: this.onClickSent, disabled: this.props.sentDisabled, className: 'button primary outline', style: { border: 0 }, key: 'rsentbutton' },
          this.props.sentCaption || '发送验证码'
        )] }));
    }
  }]);
  return InputVerify;
}(React.Component);

var Legend$1 = function (_Component) {
  inherits(Legend, _Component);

  function Legend(props) {
    classCallCheck(this, Legend);
    return possibleConstructorReturn(this, (Legend.__proto__ || Object.getPrototypeOf(Legend)).call(this, props));
  }

  createClass(Legend, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          children = _props.children,
          style = _props.style,
          className = _props.className,
          onClick = _props.onClick;

      return React__default.createElement(
        'div',
        { className: className, style: style, onClick: onClick },
        React__default.createElement(
          'div',
          { className: 'legend-caption' },
          children
        )
      );
    }
  }]);
  return Legend;
}(React.Component);

Legend$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  children: propTypes.node,
  onClick: propTypes.func
};
Legend$1.defaultProps = {
  className: 'legend-through'
};

var List$1 = function (_Component) {
  inherits(List, _Component);

  function List(props) {
    classCallCheck(this, List);

    var _this = possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      var _this$props = _this.props,
          onClick = _this$props.onClick,
          onClickLicon = _this$props.onClickLicon,
          onClickRicon = _this$props.onClickRicon,
          onClickRcaption = _this$props.onClickRcaption;

      var classList = e.target.classList;
      if (classList.contains('licon') && onClickLicon) {
        onClickLicon(_this.getArgs(e));
        e.stopPropagation();
      } else if (classList.contains('ricon') && onClickRicon) {
        onClickRicon(_this.getArgs(e));
        e.stopPropagation();
      } else if (classList.contains('list-rcaption') && onClickRcaption) {
        onClickRcaption(_this.getArgs(e));
        e.stopPropagation();
      } else if (onClick) {
        onClick(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickContainer = function (e) {
      if (_this.props.onClickContainer) {
        _this.props.onClickContainer(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickThumbnail = function (e) {
      if (_this.props.onClickThumbnail) {
        _this.props.onClickThumbnail(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.onClickAvatar = function (e) {
      if (_this.props.onClickAvatar) {
        _this.props.onClickAvatar(_this.getArgs(e));
        e.stopPropagation();
      }
    };

    _this.state = {};
    return _this;
  }

  createClass(List, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          licon = _props.licon,
          liconSrc = _props.liconSrc,
          liconClassName = _props.liconClassName,
          liconStyle = _props.liconStyle,
          ricon = _props.ricon,
          riconSrc = _props.riconSrc,
          riconClassName = _props.riconClassName,
          riconStyle = _props.riconStyle,
          showThumbnail = _props.showThumbnail,
          thumbnailSrc = _props.thumbnailSrc,
          thumbnailClassName = _props.thumbnailClassName,
          thumbnailStyle = _props.thumbnailStyle,
          thumbnailAfter = _props.thumbnailAfter,
          showAvatar = _props.showAvatar,
          avatarSrc = _props.avatarSrc,
          avatarStyle = _props.avatarStyle,
          avatarAfter = _props.avatarAfter,
          caption = _props.caption,
          captionClassName = _props.captionClassName,
          captionStyle = _props.captionStyle,
          rcaption = _props.rcaption,
          rcaptionClassName = _props.rcaptionClassName,
          rcaptionStyle = _props.rcaptionStyle,
          sndcaption = _props.sndcaption,
          sndcaptionClassName = _props.sndcaptionClassName,
          sndcaptionStyle = _props.sndcaptionStyle,
          containerClassName = _props.containerClassName,
          containerStyle = _props.containerStyle,
          containerAfter = _props.containerAfter;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'list-li' + (className ? ' ' + className : ''), style: style, onClick: this.onClick },
        (liconSrc || liconClassName) && React__default.createElement(Icon$1, { className: 'licon' + (liconClassName ? ' ' + liconClassName : ''), src: liconSrc, style: liconStyle }),
        licon && licon,
        showThumbnail && React__default.createElement(
          'div',
          { className: 'list-thumbnail' + (thumbnailClassName ? ' ' + thumbnailClassName : ''), style: thumbnailStyle, onClick: this.onClickThumbnail },
          thumbnailSrc && React__default.createElement('span', { className: 'list-thumbnail-img', style: { backgroundImage: 'url(' + thumbnailSrc + ')' } }),
          thumbnailAfter
        ),
        showAvatar && React__default.createElement(
          'div',
          { className: 'list-avatar', style: avatarStyle, onClick: this.onClickAvatar },
          avatarSrc && React__default.createElement('span', { className: 'list-avatar-img', style: { backgroundImage: 'url(' + avatarSrc + ')' } }),
          avatarAfter
        ),
        React__default.createElement(
          'div',
          { className: 'list-container' + (containerClassName ? ' ' + containerClassName : ''), style: containerStyle, onClick: this.onClickContainer },
          caption && React__default.createElement(
            'div',
            { className: 'list-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
            caption
          ),
          sndcaption && React__default.createElement(
            'div',
            { className: 'list-sndcaption' + (sndcaptionClassName ? ' ' + sndcaptionClassName : ''), style: sndcaptionStyle },
            sndcaption
          ),
          containerAfter
        ),
        rcaption && React__default.createElement(
          'div',
          { className: 'list-rcaption' + (rcaptionClassName ? ' ' + rcaptionClassName : ''), style: rcaptionStyle },
          rcaption
        ),
        (riconSrc || riconClassName) && React__default.createElement(Icon$1, { className: 'ricon size16' + (riconClassName ? ' ' + riconClassName : ''), src: riconSrc, style: riconStyle }),
        ricon && ricon
      );
    }
  }]);
  return List;
}(React.Component);

List$1.propTypes = {
  args: propTypes.any,
  style: propTypes.object,
  className: propTypes.string,
  onClick: propTypes.func,

  onClickContainer: propTypes.func,

  licon: propTypes.node,
  liconSrc: propTypes.string,
  liconClassName: propTypes.string,
  liconStyle: propTypes.object,
  onClickLicon: propTypes.func,

  ricon: propTypes.node,
  riconSrc: propTypes.string,
  riconClassName: propTypes.string,
  riconStyle: propTypes.object,
  onClickRicon: propTypes.func,

  showThumbnail: propTypes.bool,
  thumbnailStyle: propTypes.object,
  thumbnailSrc: propTypes.string,
  thumbnailAfter: propTypes.node,
  onClickThumbnail: propTypes.func,

  showAvatar: propTypes.bool,
  avatar: propTypes.bool,
  avatarStyle: propTypes.object,
  avatarSrc: propTypes.string,
  avatarAfter: propTypes.node,
  onClickAvatar: propTypes.func,

  caption: propTypes.node,
  captionClassName: propTypes.string,
  captionStyle: propTypes.object,

  rcaption: propTypes.node,
  rcaptionClassName: propTypes.string,
  rcaptionStyle: propTypes.object,
  onClickRcaption: propTypes.func,

  sndcaption: propTypes.node,
  sndcaptionClassName: propTypes.string,
  sndcaptionStyle: propTypes.object,

  containerClassName: propTypes.string,
  containerStyle: propTypes.object,
  containerAfter: propTypes.node
};
List$1.defaultProps = {
  args: null
};

var Loading$3 = function (_Component) {
  inherits(Loading, _Component);

  function Loading(props) {
    classCallCheck(this, Loading);

    var _this = possibleConstructorReturn(this, (Loading.__proto__ || Object.getPrototypeOf(Loading)).call(this, props));

    _this.state = {};
    return _this;
  }

  createClass(Loading, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          type = _props.type,
          iconSrc = _props.iconSrc,
          caption = _props.caption,
          loadingStyle = _props.loadingStyle,
          maskBefore = _props.maskBefore;

      var content = React__default.createElement(
        'div',
        null,
        '\u52A0\u8F7D\u4E2D...'
      );
      if (iconSrc) {
        // 自定义样式
        content = React__default.createElement(
          'div',
          { className: 'loading-wrapper', style: loadingStyle },
          iconSrc && React__default.createElement('img', { alt: '', src: iconSrc, className: 'loading-icon' }),
          caption && React__default.createElement(
            'p',
            null,
            caption
          )
        );
      } else if (type === 'filling') {
        // 填料环
        content = React__default.createElement(
          'div',
          { className: 'loading-filling active', style: loadingStyle },
          React__default.createElement('div', { className: 'loading-filling-wrapper' })
        );
      } else if (type === 'floating') {
        // 流光
        content = React__default.createElement(
          'div',
          { className: 'loading-floating animated', style: loadingStyle },
          React__default.createElement(
            'div',
            { className: 'loading-floating-wrapper' },
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' }),
            React__default.createElement('div', { className: 'loading-floating-blade' })
          ),
          React__default.createElement(
            'div',
            { className: 'loading-floating-caption' },
            caption
          )
        );
      }
      if (this.props.portal) {
        return ReactDOM.createPortal(React__default.createElement(
          'div',
          { className: 'loading-mask mask active' + (className ? ' ' + className : ''), style: style },
          maskBefore,
          content
        ), this.props.portal);
      }
      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'loading-mask mask active' + (className ? ' ' + className : ''), style: style },
        maskBefore,
        content
      );
    }
  }]);
  return Loading;
}(React.Component);

Loading$3.propTypes = {
  portal: propTypes.object, // 传送至DOM
  type: propTypes.string, // floating | filling
  maskBefore: propTypes.node,
  iconSrc: propTypes.string,
  caption: propTypes.string,
  style: propTypes.object,
  className: propTypes.string,
  loadingStyle: propTypes.object
};
Loading$3.defaultProps = {
  caption: '正在加载...',
  type: 'floating',
  style: {}
};

// Marquee 滚动框
var Marquee$3 = function Marquee(container, params) {
  /* --------------------
  Model
  -------------------- */
  var defaults = {
    start: 0,
    end: 300,
    step: 50,
    duration: 300,
    delay: 2000,
    direction: 'top', // top | bottom | left | right
    loop: false,
    duplicateClass: 'duplicate'
    /*
    Callbacks:
    onSlideChange:function(Marquee)
    onSlideChangeEnd:function(Marquee)
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  s.params = params;
  // Container
  s.container = typeof container === 'string' ? document.querySelector(container) : container;
  // 定时器
  s.interval = null;
  // 循环
  s.updateLoop = function () {
    var dups = [].slice.call(s.container.querySelectorAll('.' + s.params.duplicateClass));
    dups.forEach(function (item) {
      s.container.removeChild(item);
    });
    if (s.params.loop) {
      var beforeDupContainer = s.container.cloneNode(true);
      var afterDupContainer = s.container.cloneNode(true);
      beforeDupContainer.classList.add(s.params.duplicateClass);
      afterDupContainer.classList.add(s.params.duplicateClass);
      s.container.insertBefore(beforeDupContainer, s.container.firstElementChild);
      s.container.appendChild(afterDupContainer);
    }
  };
  // 设置开始位置
  s.setStart = function (start) {
    s.params.start = start;
  };
  // 设置结束位置
  s.setEnd = function (end) {
    s.params.end = end;
  };
  /* --------------------
  Method
  -------------------- */
  // 设置动画时长
  s.setDuration = function (duration) {
    s.container.style.webkitTransitionDuration = duration + 'ms';
  };
  // 设置移动位置
  s.setPosition = function (pos) {
    switch (s.params.direction) {
      case 'top':
        s.container.style.webkitTransform = 'translate(0px, ' + pos + 'px)';
        break;
      default:
        s.container.style.webkitTransform = 'translate(0px, ' + pos + 'px)';
    }
  };
  // 初始化位置变量
  s.start = 0;
  s.end = 0;
  s.move = 0;
  s.update = function () {
    s.start = s.params.start;
    s.end = s.params.end;
    var range = s.params.end - s.params.start;
    if (s.params.loop) {
      s.updateLoop();
      s.start = s.params.end + s.params.step;
      s.end = s.start + range;
    }
    s.setDuration(0);
    // 设置起始位置
    s.setPosition(-s.start);
    // 设置动画时长
    setTimeout(function () {
      s.setDuration(s.params.duration);
    }, 10);
    // 设置起始位置
    s.move = s.start;
    // 初始化播放
    if (s.interval) window.clearInterval(s.interval);
  };
  s.update();
  // 播放
  s.play = function () {
    if (s.interval) window.clearInterval(s.interval);
    s.interval = window.setInterval(function () {
      s.move += s.params.step;
      if (s.params.loop) {
        if (s.move >= s.end + s.params.step) {
          // 回到复制相同处
          var initPos = s.start - s.params.step;
          s.setDuration(0);
          s.setPosition(-initPos);
          // 再移动一格
          s.move = initPos + s.params.step;
          setTimeout(function () {
            s.setDuration(s.params.duration);
            s.setPosition(-s.move);
          }, 10);
        } else {
          s.setPosition(-s.move);
        }
      } else {
        s.setPosition(-s.move);
        if (s.move >= s.end) {
          window.clearInterval(s.interval);
        }
      }
    }, s.params.delay);
  };
  s.pause = function () {
    window.clearInterval(s.interval);
  };
};

var Marquee$1 = function (_Component) {
  inherits(Marquee, _Component);

  function Marquee(props) {
    classCallCheck(this, Marquee);

    var _this = possibleConstructorReturn(this, (Marquee.__proto__ || Object.getPrototypeOf(Marquee)).call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (!_this.props.list.equals(prevProps.list)) {
        _this.update();
      }
    };

    _this.componentDidMount = function () {
      if (_this.state.instance || _this.props.list.length === 0) return;
      _this.init();
    };

    _this.update = function () {
      _this.state.instance.setStart(0);
      _this.state.instance.setEnd(_this.props.step * (_this.props.list.length - 1));
      _this.state.instance.update();
      _this.state.instance.play();
    };

    _this.init = function () {
      var _this$props = _this.props,
          list = _this$props.list,
          step = _this$props.step,
          duration = _this$props.duration,
          delay = _this$props.delay,
          direction = _this$props.direction,
          loop = _this$props.loop;

      var instance = new Marquee$3(_this.$el, {
        start: 0,
        end: step * (list.length - 1),
        step: step,
        duration: duration,
        delay: delay,
        direction: direction,
        loop: loop
      });
      instance.play();
      _this.setState({
        instance: instance
      });
    };

    _this.onClick = function (item, index) {
      if (_this.props.onClick) _this.props.onClick(item, index);
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(Marquee, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          list = _props.list,
          contentClassName = _props.contentClassName,
          contentStyle = _props.contentStyle,
          step = _props.step;

      return React__default.createElement(
        'ul',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'marquee' + (className ? ' ' + className : ''), style: style },
        list && list.map(function (item, index) {
          return React__default.createElement(
            'li',
            { className: 'marquee-li' + (contentClassName ? ' ' + contentClassName : ''), style: Object.assign({ height: step + 'px' }, contentStyle), key: index, onClick: function onClick() {
                _this2.onClick(item, index);
              } },
            item.value
          );
        })
      );
    }
  }]);
  return Marquee;
}(React.Component);

Marquee$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  list: propTypes.array, // [{key: 'xx', value: ''}]

  contentStyle: propTypes.object,
  contentClassName: propTypes.string,

  step: propTypes.number,
  duration: propTypes.number,
  delay: propTypes.number,
  direction: propTypes.string, // top | bottom | left | right
  loop: propTypes.bool,
  onClick: propTypes.func
};
Marquee$1.defaultProps = {
  step: 50,
  duration: 300,
  delay: 2000,
  direction: 'top',
  loop: true
};

// 左侧菜单
var MenuTree$3 = function MenuTree(container, params) {
  /* ------------------
  Model
  ------------------ */
  var defaults = {
    // DATA
    data: null,
    tagClass: 'menutree-tag',
    activeClass: 'active',
    extandClass: 'extand',
    itemAttr: 'data-item',

    activeId: '' // 默认选中项的id
    // parentHasData: true, // 父节点是否有数据,如果有,则选中父节点时,子节点的选中得去掉
    /*
    callbacks
    onClick:function(item, isActived, isExtand) // 点击项的数据,是否是选中状态,是否是展开状态
    */

    /* 参数data: [{
      id: '',
      caption: '',
      active: false,
      children
    }] */
  };params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  // MenuTree
  var s = this;

  // Params
  s.params = params;
  // Container
  s.container = typeof container === 'string' ? document.querySelector(container) : container;
  if (!s.container) {
    console.log('SeedsUI Error：未找到MenuTree的DOM对象，请检查传入参数是否正确');
    return;
  }
  s.initData = function (list, ulContainer) {
    for (var i = 0, option; option = list[i++];) {
      // eslint-disable-line
      var li = document.createElement('li');
      var html = '<div data-index="' + i + '" ' + s.params.itemAttr + '=\'' + JSON.stringify(option) + '\' class="' + s.params.tagClass + (option.id === s.params.activeId ? ' active' : '') + '" id="ID-MenuTree' + option.id + '">' + '<p class="menutree-tag-font">' + option.caption + '</p>' + (option.children && option.children.length > 0 ? '<i class="menutree-more"></i>' : '') + '</div><ul></ul>';
      li.innerHTML = html;
      ulContainer.appendChild(li);
      var ul = s.container.querySelector('#ID-MenuTree' + option.id).nextElementSibling;
      if (option.children && option.children.length > 0) {
        s.initData(option.children, ul);
      }
    }
  };
  s.container.innerHTML = '';

  /* ------------------
  Method
  ------------------ */
  // 设置选中项
  s.setActiveId = function (id) {
    s.params.activeId = id;
  };
  // 重新设置数据
  s.setData = function (data) {
    s.params.data = data;
    s.container.innerHTML = '';
    s.initData(data, s.container);
  };
  // 添加数据
  s.addData = function (data, childNode) {
    s.initData(data, childNode);
  };

  /* ------------------
    Events
    ------------------ */
  // 绑定事件
  s.isSupportTouch = 'ontouchstart' in window;
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    // touch兼容pc事件
    if (s.isSupportTouch) {
      s.container[action]('touchstart', s.onTouchStart, false);
      s.container[action]('touchend', s.onTouchEnd, false);
    } else {
      s.container[action]('click', s.onClick, false);
    }
  };
  // attach、dettach事件
  s.attach = function (event) {
    s.events();
  };
  s.detach = function (event) {
    s.events(true);
  };
  /* ------------------
  Event Handler
  ------------------ */
  // Tap
  s.touches = {
    startX: 0,
    startY: 0,
    endX: 0,
    endY: 0,
    diffX: 0,
    diffY: 0
  };
  s.onTouchStart = function (e) {
    s.touches.startX = e.touches[0].clientX;
    s.touches.startY = e.touches[0].clientY;
  };
  s.onTouchEnd = function (e) {
    s.touches.endX = e.changedTouches[0].clientX;
    s.touches.endY = e.changedTouches[0].clientY;
    s.touches.diffX = s.touches.startX - s.touches.endX;
    s.touches.diffY = s.touches.startY - s.touches.endY;
    // 单击事件
    if (Math.abs(s.touches.diffX) < 6 && Math.abs(s.touches.diffY) < 6) {
      s.onClick(e);
    }
  };
  // 点击树
  s.onClick = function (e) {
    var target = e.target;
    if (!target.classList.contains(s.params.tagClass)) return;
    var isActived = target.classList.contains(s.params.activeClass);
    var isExtand = target.classList.contains(s.params.extandClass);
    // 如果已经展开,则收缩
    if (isExtand) {
      target.classList.remove(s.params.extandClass);
      // 如果父节点有数据,则将子节点的选中效果去掉
      // if (s.params.parentHasData) {
      var tags = target.nextElementSibling.querySelectorAll('.' + s.params.tagClass);
      for (var i = 0, subtag; subtag = tags[i++];) {
        // eslint-disable-line
        subtag.classList.remove(s.params.extandClass);
        subtag.classList.remove(s.params.activeClass);
      }
      // }
    } else {
      // 移除同级所有的选中项与展开项
      var lis = target.parentNode.parentNode.children;
      for (var i = 0, li; li = lis[i++];) {
        // eslint-disable-line
        var tag = li.querySelector('.' + s.params.tagClass);
        if (tag) {
          tag.classList.remove(s.params.extandClass);
          tag.classList.remove(s.params.activeClass);
        }
      }
      // 添加当前节点为选中项和展开项
      target.classList.add(s.params.extandClass);
      target.classList.add(s.params.activeClass);
    }
    // 返回item
    var item = target.getAttribute('data-item') ? JSON.parse(target.getAttribute('data-item')) : null;
    // 是否有子节点
    var hasChildren = item.children && item.children.length;
    if (s.params.onClick) s.params.onClick(item, isActived, !isExtand, hasChildren);
  };
  // 主函数
  s.init = function () {
    s.initData(s.params.data, s.container);
    s.attach();
  };
  s.init();
};

var MenuTree$1 = function (_Component) {
  inherits(MenuTree, _Component);

  function MenuTree(props) {
    classCallCheck(this, MenuTree);

    var _this = possibleConstructorReturn(this, (MenuTree.__proto__ || Object.getPrototypeOf(MenuTree)).call(this, props));

    _this.shouldComponentUpdate = function (nextProps) {
      if (_this.props.list.length === nextProps.list.length) {
        return false;
      }
      return true;
    };

    _this.componentDidUpdate = function (prevProps) {
      _this.state.instance.setActiveId(_this.props.activeId);
      _this.state.instance.setData(_this.props.list);
    };

    _this.componentDidMount = function () {
      var _this$props = _this.props,
          list = _this$props.list,
          activeId = _this$props.activeId;

      if (_this.state.instance) return;
      var instance = new MenuTree$3(_this.$el, {
        data: list,
        activeId: activeId,
        onClick: _this.onClick
      });
      _this.setState({
        instance: instance
      });
    };

    _this.onClick = function (item, isActived, isExtand, hasChildren) {
      if (_this.props.onClick) _this.props.onClick(item, isActived, isExtand, hasChildren);
    };

    _this.state = {
      instance: null
    };
    return _this;
  }
  /* list: [{
    id: '',
    caption: '',
    active: false,
    children
  }] */


  createClass(MenuTree, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return React__default.createElement('ul', { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'menutree' + (className ? ' ' + className : ''), style: style });
    }
  }]);
  return MenuTree;
}(React.Component);

MenuTree$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  activeId: propTypes.string, // 默认选中项的id
  onClick: propTypes.func,

  list: propTypes.array };
MenuTree$1.defaultProps = {};

var NoNetwork$1 = function (_Component) {
  inherits(NoNetwork, _Component);

  function NoNetwork(props) {
    classCallCheck(this, NoNetwork);

    var _this = possibleConstructorReturn(this, (NoNetwork.__proto__ || Object.getPrototypeOf(NoNetwork)).call(this, props));

    _this.state = {
      isOnLine: Device.isOnLine
    };
    Device.onLine(function (isOnLine) {
      _this.setState({
        isOnLine: isOnLine
      });
    });
    return _this;
  }

  createClass(NoNetwork, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var isOnLine = this.state.isOnLine;
      var _props = this.props,
          caption = _props.caption,
          sndcaption = _props.sndcaption;

      return isOnLine ? null : React__default.createElement(Notice$1, { ref: function ref(el) {
          _this2.$el = el;
        }, iconClassName: 'icon-no-network', caption: caption, sndcaption: sndcaption });
    }
  }]);
  return NoNetwork;
}(React.Component);

NoNetwork$1.propTypes = {
  caption: propTypes.string,
  sndcaption: propTypes.string
};
NoNetwork$1.defaultProps = {
  caption: '网络状态不佳',
  sndcaption: '请尝试开关飞行模式后再试'
};

var NumBox$1 = function (_Component) {
  inherits(NumBox, _Component);

  function NumBox(props) {
    classCallCheck(this, NumBox);

    var _this = possibleConstructorReturn(this, (NumBox.__proto__ || Object.getPrototypeOf(NumBox)).call(this, props));

    _this.componentDidUpdate = function () {
      // 如果prop的value和文本框里的值不一致
      if (_this.$input) {
        if (_this.$input.value !== _this.props.value) {
          _this.$input.value = _this.props.value;
          // 更新disabled
          _this.updateDisabled();
        }
      }
    };

    _this.updateDisabled = function () {
      var _this$props = _this.props,
          min = _this$props.min,
          max = _this$props.max,
          value = _this$props.value;

      if (_this.$input) value = _this.$input.value;
      if (!value) return;
      if (value <= min) {
        _this.$minus.disabled = true;
      } else {
        _this.$minus.disabled = false;
      }
      if (value >= max) {
        _this.$plus.disabled = true;
      } else {
        _this.$plus.disabled = false;
      }
    };

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onFocus = function (e) {
      var target = _this.$input || e.target;
      var value = target.value;
      if (!value || value === '0') {
        // 赋值
        target.value = '';
      }
    };

    _this.onInput = function (e) {
      var target = e.target;
      var value = target.value.toString();
      // 如果value有值不为空,则矫正数值
      if (value) {
        value = _this.correctNum(value);
      }
      target.value = value;
      // 更新disabled
      _this.updateDisabled();
    };

    _this.onBlur = function (e) {
      var target = e.target;
      var value = e.target.value;
      if (!value) value = _this.correctNum(value);
      target.value = value;
      // Callback
      if (_this.props.value !== value) {
        if (_this.props.onChange) _this.props.onChange(value, _this.getArgs(e));
      }
      // 更新disabled
      _this.updateDisabled();
    };

    _this.onClickMinus = function (e) {
      var value = Math.Calc.subtract(_this.$input.value, 1);
      if (value < _this.props.min) value = _this.props.min;
      if (value > _this.props.max) value = _this.props.max;
      // 赋值
      _this.$input.value = value;
      // Callback
      if (_this.props.onChange) {
        _this.props.onChange('' + value, _this.getArgs(e));
      }
      // 更新disabled
      _this.updateDisabled();
      if (_this.props.changeFocus) _this.$input.focus();
    };

    _this.onClickPlus = function (e) {
      var value = Math.Calc.add(_this.$input.value, 1);
      if (value < _this.props.min) value = _this.props.min;
      if (value > _this.props.max) value = _this.props.max;
      // 赋值
      _this.$input.value = value;
      // Callback
      if (_this.props.onChange) {
        _this.props.onChange('' + value, _this.getArgs(e));
      }
      // 更新disabled
      _this.updateDisabled();
      if (_this.props.changeFocus) _this.$input.focus();
    };

    _this.correctNum = function (argNumstr) {
      if (!argNumstr || isNaN(argNumstr)) {
        return '' + _this.props.min;
      }
      var num = Number(argNumstr);
      // 判断是否超出限制
      var _this$props2 = _this.props,
          max = _this$props2.max,
          min = _this$props2.min;

      if (!isNaN(max) && num > max) {
        // callback onError
        if (_this.props.onError) _this.props.onError('最大不能超过' + max);
        return '' + max;
      }
      if (!isNaN(min) && num < min) {
        // callback onError
        if (_this.props.onError) _this.props.onError('最小不能小于' + min);
        return '' + min;
      }
      var value = argNumstr;
      // 截取小数位数
      if (_this.props.digits) {
        if (String(num).indexOf('.') >= 0) value = Math.Calc.toDigits(num, _this.props.digits);
        // 整数
      } else {
        value = Math.floor(num);
      }
      // 最大长度限制
      if (_this.props.maxLength && value && value.length > _this.props.maxLength) {
        value = value.slice(0, _this.props.maxLength);
      }
      return '' + value;
    };

    _this.getInputDOM = function () {
      var _this$props3 = _this.props,
          inputClassName = _this$props3.inputClassName,
          inputStyle = _this$props3.inputStyle,
          value = _this$props3.value,
          max = _this$props3.max,
          min = _this$props3.min,
          maxLength = _this$props3.maxLength,
          placeholder = _this$props3.placeholder,
          name = _this$props3.name,
          readOnly = _this$props3.readOnly,
          onClickInput = _this$props3.onClickInput;

      return React__default.createElement('input', { ref: function ref(el) {
          _this.$input = el;
        }, type: 'number', defaultValue: value, min: min, max: max, maxLength: maxLength, readOnly: readOnly, placeholder: placeholder, name: name, onInput: _this.onInput, onBlur: _this.onBlur, onFocus: _this.onFocus, onClick: onClickInput, className: 'numbox-input' + (inputClassName ? ' ' + inputClassName : ''), style: inputStyle });
    };

    _this.state = {};
    return _this;
  }

  createClass(NumBox, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.updateDisabled();
    }
    // shouldComponentUpdate (nextProps) {
    //   if(nextProps.value === this.props.value){
    //     return false
    //   }
    //   return true;
    // }

    // Methods

    // 点击减

    // 点击加

    // 矫正数字

    // render

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          min = _props.min,
          max = _props.max,
          style = _props.style,
          className = _props.className,
          disabled = _props.disabled,
          onClick = _props.onClick;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, disabled: min >= max || disabled, style: style, className: 'numbox bordered ' + (className ? className : ''), onClick: onClick },
        React__default.createElement('input', { ref: function ref(el) {
            _this2.$minus = el;
          }, type: 'button', className: 'numbox-button', value: '-', onClick: this.onClickMinus }),
        this.getInputDOM(),
        React__default.createElement('input', { ref: function ref(el) {
            _this2.$plus = el;
          }, type: 'button', className: 'numbox-button', value: '+', onClick: this.onClickPlus })
      );
    }
  }]);
  return NumBox;
}(React.Component);

NumBox$1.propTypes = {
  args: propTypes.any,
  changeFocus: propTypes.bool, // 点击加减时激活
  // 容器
  style: propTypes.object,
  className: propTypes.string,
  // 文本框
  inputStyle: propTypes.object,
  inputClassName: propTypes.string,
  value: propTypes.string,
  placeholder: propTypes.string,
  name: propTypes.string,
  type: propTypes.string,
  maxLength: propTypes.string,
  disabled: propTypes.bool,
  readOnly: propTypes.bool,
  // events
  onClick: propTypes.func,
  onClickMinus: propTypes.func,
  onClickPlus: propTypes.func,
  onClickInput: propTypes.func,
  onChange: propTypes.func,
  onError: propTypes.func,
  // rule设置
  digits: propTypes.oneOfType([propTypes.bool, propTypes.number]),
  max: propTypes.number,
  min: propTypes.number
};
NumBox$1.defaultProps = {
  args: null,
  maxLength: '8',
  min: 0,
  max: 99999999,
  value: '0',
  readOnly: false
};

var NumBoxPop$1 = function (_Component) {
  inherits(NumBoxPop, _Component);

  function NumBoxPop(props) {
    classCallCheck(this, NumBoxPop);

    var _this = possibleConstructorReturn(this, (NumBoxPop.__proto__ || Object.getPrototypeOf(NumBoxPop)).call(this, props));

    _this.componentDidUpdate = function (prevProps) {
      if (prevProps.show !== _this.props.show) {
        _this.setState({
          show: _this.props.show
        });
        // 当此组件显示时,重新注入值
        if (_this.props.show === true) {
          _this.setState({
            value: _this.props.value
          }, function () {
            _this.focusValue();
          });
        }
      }
    };

    _this.onChange = function (value) {
      _this.setState({
        value: value
      });
    };

    _this.onClickSubmit = function (args) {
      var onClickSubmit = _this.props.onClickSubmit;

      if (onClickSubmit) onClickSubmit(_this.state.value, args);
    };

    _this.focusValue = function () {
      _this.$numbox.$input.focus();
      setTimeout(function () {
        _this.$numbox.onFocus();
        _this.$numbox.$input.select();
      }, 100);
    };

    _this.onClickCancel = function () {
      _this.$numbox.$input.value = _this.props.value;
      if (_this.props.onClickCancel) _this.props.onClickCancel();
    };

    _this.state = {
      value: props.value || '1'
    };
    return _this;
  }

  createClass(NumBoxPop, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          args = _props.args,
          show = _props.show,
          caption = _props.caption,
          min = _props.min,
          max = _props.max,
          digits = _props.digits;

      return React__default.createElement(
        Alert$1,
        { args: args, ref: function ref(el) {
            _this2.$el = el;
          }, duration: 0, caption: caption, show: show, onClickSubmit: this.onClickSubmit, onClickCancel: this.onClickCancel },
        React__default.createElement(NumBox$1, { ref: function ref(el) {
            _this2.$numbox = el;
          }, min: min, max: max, digits: digits, changeFocus: true, value: this.state.value, style: { margin: '0 auto' }, className: 'flex xl', onChange: this.onChange })
      );
    }
  }]);
  return NumBoxPop;
}(React.Component);

NumBoxPop$1.propTypes = {
  args: propTypes.any,
  // 文本框
  value: propTypes.string,
  // events
  onClickCancel: propTypes.func,
  onClickSubmit: propTypes.func,
  show: propTypes.bool,
  caption: propTypes.string,
  // rule设置
  min: propTypes.number,
  max: propTypes.number,
  digits: propTypes.number
};
NumBoxPop$1.defaultProps = {
  show: false,
  caption: '修改购买数量',
  min: 0,
  max: 99999,
  digits: 0,
  value: '0',
  args: null
};

var UnitStyle = {
  fontSize: '13px',
  marginLeft: '8px'
};

var NumBoxPopPointer$1 = function (_Component) {
  inherits(NumBoxPopPointer, _Component);

  function NumBoxPopPointer(props) {
    classCallCheck(this, NumBoxPopPointer);

    var _this = possibleConstructorReturn(this, (NumBoxPopPointer.__proto__ || Object.getPrototypeOf(NumBoxPopPointer)).call(this, props));

    _this.onClickCancel = function () {
      _this.setState({ show: false });
    };

    _this.onClickSubmit = function (value, args) {
      if (!value) return;
      // Callback
      if (_this.props.onChange) _this.props.onChange(value, args);
      // 隐藏
      _this.setState({
        show: false
      });
    };

    _this.onClickNumBox = function () {
      _this.setState({
        show: true
      });
    };

    _this.state = {
      show: false
    };
    return _this;
  }

  createClass(NumBoxPopPointer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          numboxClassName = _props.numboxClassName,
          numboxStyle = _props.numboxStyle,
          value = _props.value,
          min = _props.min,
          max = _props.max,
          digits = _props.digits,
          unit = _props.unit,
          disabled = _props.disabled,
          args = _props.args,
          onChange = _props.onChange;
      var show = this.state.show;

      return React__default.createElement(
        'div',
        { style: Object.assign({ position: 'relative' }, style), className: className },
        React__default.createElement(NumBox$1, { className: numboxClassName, args: args, style: numboxStyle, value: value, disabled: disabled, readOnly: true, min: min, max: max, onChange: onChange, onClickInput: this.onClickNumBox }),
        React__default.createElement(
          'span',
          { style: UnitStyle },
          unit || ''
        ),
        React__default.createElement(NumBoxPop$1, { show: show, args: args, value: this.$input ? this.$input.value : value.toString(), digits: digits, min: min, max: max, onClickCancel: this.onClickCancel, onClickSubmit: this.onClickSubmit })
      );
    }
  }]);
  return NumBoxPopPointer;
}(React.Component);

NumBoxPopPointer$1.propTypes = {
  args: propTypes.any,
  className: propTypes.string,
  style: propTypes.object,
  // numbox
  numboxClassName: propTypes.string,
  numboxStyle: propTypes.object,
  value: propTypes.string,
  disabled: propTypes.bool,
  unit: propTypes.string,
  // events
  onChange: propTypes.func,
  // rule设置
  min: propTypes.number,
  max: propTypes.number,
  digits: propTypes.oneOfType([propTypes.bool, propTypes.number])
};
NumBoxPopPointer$1.defaultProps = {
  args: null,
  min: 0,
  max: 99999,
  numboxClassName: 'sm'
};

var OnOff$1 = function (_Component) {
  inherits(OnOff, _Component);

  function OnOff(props) {
    classCallCheck(this, OnOff);

    var _this = possibleConstructorReturn(this, (OnOff.__proto__ || Object.getPrototypeOf(OnOff)).call(this, props));

    _this.onClick = function () {
      var _this$props = _this.props,
          readOnly = _this$props.readOnly,
          checked = _this$props.checked,
          onClick = _this$props.onClick;

      if (readOnly) return;
      if (onClick) {
        if (checked) onClick(true);else onClick(false);
      }
    };

    _this.state = {};
    return _this;
  }

  createClass(OnOff, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          checked = _props.checked,
          onCaption = _props.onCaption,
          offCaption = _props.offCaption;

      return React__default.createElement(
        'div',
        { className: 'onoff' + (className ? ' ' + className : '') + (onCaption && offCaption ? '' : ' notext') + (checked ? ' active' : ''), style: style, 'data-on': onCaption, 'data-off': offCaption, onClick: this.onClick },
        React__default.createElement('div', { className: 'onoff-handle' })
      );
    }
  }]);
  return OnOff;
}(React.Component);

OnOff$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,
  readOnly: propTypes.bool,
  checked: propTypes.bool,
  onCaption: propTypes.string,
  offCaption: propTypes.string,
  onClick: propTypes.func
};
OnOff$1.defaultProps = {
  onCaption: '',
  offCaption: ''
};

var Page$1 = function (_Component) {
  inherits(Page, _Component);

  function Page(props) {
    classCallCheck(this, Page);

    var _this = possibleConstructorReturn(this, (Page.__proto__ || Object.getPrototypeOf(Page)).call(this, props));

    _this.state = {};
    return _this;
  }

  createClass(Page, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _props = this.props,
          onScroll = _props.onScroll,
          onTouchStart = _props.onTouchStart,
          onTouchMove = _props.onTouchMove,
          onTouchEnd = _props.onTouchEnd;

      var touchTarget = this.$el;
      if (onTouchStart) {
        touchTarget['addEventListener']('touchstart', onTouchStart, false);
      }
      if (onTouchStart) {
        touchTarget['addEventListener']('touchmove', onTouchMove, false);
      }
      if (onTouchEnd) {
        touchTarget['addEventListener']('touchend', onTouchEnd, false);
        touchTarget['addEventListener']('touchcancel', onTouchEnd, false);
      }
      if (onScroll) {
        touchTarget['addEventListener']('scroll', onScroll, false);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          animation = _props2.animation,
          style = _props2.style,
          className = _props2.className,
          children = _props2.children;

      return React__default.createElement(
        'section',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'page' + (className ? ' ' + className : ''), 'data-animation': animation, style: style },
        children
      );
    }
  }]);
  return Page;
}(React.Component);

Page$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  animation: propTypes.string,
  onScroll: propTypes.func,
  onTouchStart: propTypes.func,
  onTouchMove: propTypes.func,
  onTouchEnd: propTypes.func,
  children: propTypes.node
};

var Peg$1 = function (_Component) {
  inherits(Peg, _Component);

  function Peg(props) {
    classCallCheck(this, Peg);
    return possibleConstructorReturn(this, (Peg.__proto__ || Object.getPrototypeOf(Peg)).call(this, props));
  }

  createClass(Peg, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return React__default.createElement('i', { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'peg' + (className ? ' ' + className : ''), style: style });
    }
  }]);
  return Peg;
}(React.Component);

Peg$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object
};
Peg$1.defaultProps = {};

var Popover$1 = function (_Component) {
  inherits(Popover, _Component);

  function Popover(props) {
    classCallCheck(this, Popover);

    var _this = possibleConstructorReturn(this, (Popover.__proto__ || Object.getPrototypeOf(Popover)).call(this, props));

    _this.componentDidMount = function () {};

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClickMask = function (e) {
      if (_this.props.onClickMask) _this.props.onClickMask(_this.getArgs(e));
      e.stopPropagation();
    };

    return _this;
  }

  createClass(Popover, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          show = _props.show,
          maskClassName = _props.maskClassName,
          maskStyle = _props.maskStyle,
          className = _props.className,
          style = _props.style,
          animation = _props.animation,
          children = _props.children;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'mask popover-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: maskStyle, onClick: this.onClickMask },
        React__default.createElement(
          'div',
          { style: style, className: 'popover' + (className ? ' ' + className : '') + (show ? ' active' : ''), 'data-animation': animation },
          children && children
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Popover;
}(React.Component);

Popover$1.propTypes = {
  args: propTypes.any,
  portal: propTypes.object,
  show: propTypes.bool,

  animation: propTypes.string, // slideLeft | slideRight | slideUp | slideDown | zoom | fade
  isClickMaskHide: propTypes.bool,

  maskClassName: propTypes.string,
  maskStyle: propTypes.object,
  onClickMask: propTypes.func,

  className: propTypes.string,
  style: propTypes.object,

  children: propTypes.node
};
Popover$1.defaultProps = {
  isClickMaskHide: true,
  animation: 'zoom'
};

var Progress$1 = function (_Component) {
  inherits(Progress, _Component);

  function Progress(props) {
    classCallCheck(this, Progress);

    var _this = possibleConstructorReturn(this, (Progress.__proto__ || Object.getPrototypeOf(Progress)).call(this, props));

    _this.componentDidMount = function () {
      var _this$props = _this.props,
          percentage = _this$props.percentage,
          max = _this$props.max,
          min = _this$props.min,
          value = _this$props.value;
      // 计算百分比

      var barPercentage = 0;
      if (percentage) {
        barPercentage = percentage;
      } else if (max && value) {
        barPercentage = value / (max - min) * 100;
      }
      _this.$bar.style.width = barPercentage + '%';
    };

    _this.onClick = function () {};

    return _this;
  }

  createClass(Progress, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          barStyle = _props.barStyle,
          barClassName = _props.barClassName,
          percentage = _props.percentage,
          max = _props.max,
          min = _props.min,
          value = _props.value,
          showPercentage = _props.showPercentage;

      // 计算百分比

      var barPercentage = 0;
      if (percentage) {
        barPercentage = percentage;
      } else if (max && value) {
        barPercentage = value / (max - min) * 100;
      }

      return React__default.createElement(
        'div',
        { className: 'progress' + (className ? ' ' + className : ''), style: style },
        React__default.createElement(
          'span',
          { ref: function ref(el) {
              _this2.$bar = el;
            }, className: 'progress-bar' + (barClassName ? ' ' + barClassName : ''), style: barStyle },
          showPercentage && React__default.createElement(Counter$1, { duration: 1000, to: barPercentage, from: 0, suffix: '%', style: { fontSize: '12px', marginRight: '4px' } }),
          !showPercentage && React__default.createElement(Counter$1, { duration: 1000, to: Number(value), from: min, suffix: '/' + max, style: { fontSize: '12px', marginRight: '4px' } })
        )
      );
    }
  }]);
  return Progress;
}(React.Component);

Progress$1.propTypes = {
  args: propTypes.any,
  style: propTypes.object,
  className: propTypes.string,
  barStyle: propTypes.object,
  barClassName: propTypes.string,

  percentage: propTypes.number,
  max: propTypes.number,
  min: propTypes.number,
  value: propTypes.string,
  showPercentage: propTypes.bool
};
Progress$1.defaultProps = {
  showPercentage: true,
  max: 0,
  min: 0,
  value: '0'
};

var Radio$1 = function (_Component) {
  inherits(Radio, _Component);

  function Radio(props) {
    classCallCheck(this, Radio);

    var _this = possibleConstructorReturn(this, (Radio.__proto__ || Object.getPrototypeOf(Radio)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.disabled) return;
      if (_this.props.onClick) {
        _this.props.onClick(_this.$input.checked, _this.getArgs(e));
      }
    };

    return _this;
  }

  createClass(Radio, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          style = _props.style,
          className = _props.className,
          name = _props.name,
          value = _props.value,
          checked = _props.checked,
          caption = _props.caption,
          captionClassName = _props.captionClassName,
          captionStyle = _props.captionStyle;

      return React__default.createElement(
        'div',
        { className: 'radio-box' + (className ? ' ' + className : ''), onClick: this.onClick, style: style },
        React__default.createElement('input', { readOnly: true, checked: checked, type: 'radio', className: 'radio events-none', name: name, value: value, ref: function ref(el) {
            _this2.$input = el;
          } }),
        caption && React__default.createElement(
          'span',
          { className: 'radio-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
          caption
        )
      );
    }
  }]);
  return Radio;
}(React.Component);

Radio$1.propTypes = {
  args: propTypes.any,
  style: propTypes.object,
  className: propTypes.string,
  onClick: propTypes.func,

  name: propTypes.string,
  value: propTypes.string,
  checked: propTypes.bool,
  disabled: propTypes.bool,

  caption: propTypes.string,
  captionClassName: propTypes.string,
  captionStyle: propTypes.object
};
Radio$1.defaultProps = {
  args: null,
  value: '',
  checked: false
};

var SearchBar$1 = function (_Component) {
  inherits(SearchBar, _Component);

  function SearchBar(props, context) {
    classCallCheck(this, SearchBar);

    var _this = possibleConstructorReturn(this, (SearchBar.__proto__ || Object.getPrototypeOf(SearchBar)).call(this, props, context));

    _this.componentDidUpdate = function (prevProps) {
      if (prevProps.value !== _this.props.value) {
        _this.setState({
          value: _this.props.value,
          showClear: true
        });
      }
    };

    _this.onClear = function () {
      _this.setState({
        value: '',
        showClear: false
      });
      _this.searchInput.focus();
      if (_this.props.onClear) _this.props.onClear();
    };

    _this.onChange = function () {
      if (_this.searchInput.value.length === 0) {
        _this.setState({ showClear: false });
      } else {
        _this.setState({ showClear: true });
      }
      _this.searchInput.focus();
      _this.setState({
        value: _this.searchInput.value
      });
      if (_this.props.onChange) _this.props.onChange(_this.searchInput.value);
    };

    _this.onSubmit = function (e) {
      e.preventDefault();
      _this.props.onSubmit(_this.state.value);
      _this.searchInput.blur();
    };

    _this.state = {
      value: props.value || '',
      showClear: false
    };
    return _this;
  }

  createClass(SearchBar, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.searchInput.focus();
      if (this.searchInput.value) {
        this.setState({
          showClear: true
        });
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style,
          placeholder = _props.placeholder,
          onClickCancel = _props.onClickCancel;

      return React__default.createElement(
        'div',
        { className: 'searchbar' + (className ? ' ' + className : ''), style: style },
        React__default.createElement(
          'form',
          { className: 'searchbar-form', onSubmit: this.onSubmit },
          React__default.createElement('i', { className: 'icon searchbar-icon-search' }),
          React__default.createElement('input', { type: 'search', ref: function ref(input) {
              return _this2.searchInput = input;
            }, className: 'searchbar-input', placeholder: placeholder, onChange: this.onChange, value: this.state.value }),
          this.state.showClear && React__default.createElement('i', { className: 'searchbar-icon-clear', onClick: this.onClear })
        ),
        onClickCancel && React__default.createElement(
          'div',
          { className: 'searchbar-button', onClick: onClickCancel },
          '\u53D6\u6D88'
        )
      );
    }
  }]);
  return SearchBar;
}(React.Component);

SearchBar$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,
  placeholder: propTypes.string,
  value: propTypes.string,
  onClear: propTypes.func,
  onChange: propTypes.func,
  onSubmit: propTypes.func,
  onClickCancel: propTypes.func
};

var SearchBarPointer$1 = function (_Component) {
  inherits(SearchBarPointer, _Component);

  function SearchBarPointer(props) {
    classCallCheck(this, SearchBarPointer);
    return possibleConstructorReturn(this, (SearchBarPointer.__proto__ || Object.getPrototypeOf(SearchBarPointer)).call(this, props));
  }

  createClass(SearchBarPointer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          inputClassName = _props.inputClassName,
          inputStyle = _props.inputStyle,
          placeholder = _props.placeholder,
          _onClick = _props.onClick;

      return React__default.createElement(
        'div',
        { className: 'searchbar' + (className ? ' ' + className : ''), style: style },
        React__default.createElement(
          'div',
          { className: 'searchbar-form' + (inputClassName ? ' ' + inputClassName : ''), style: inputStyle, onClick: function onClick() {
              _onClick();
            } },
          React__default.createElement('i', { className: 'icon searchbar-icon-search' }),
          React__default.createElement('input', { type: 'search', className: 'searchbar-input', readOnly: true, placeholder: placeholder })
        )
      );
    }
  }]);
  return SearchBarPointer;
}(React.Component);

SearchBarPointer$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,

  inputClassName: propTypes.string,
  inputStyle: propTypes.object,
  placeholder: propTypes.string,

  onClick: propTypes.func
};

var SearchBoard$1 = function (_Component) {
  inherits(SearchBoard, _Component);

  function SearchBoard(props, context) {
    classCallCheck(this, SearchBoard);

    // 初始化标签
    var _this = possibleConstructorReturn(this, (SearchBoard.__proto__ || Object.getPrototypeOf(SearchBoard)).call(this, props, context));

    _this.onClear = function () {
      DB.removeStore(_this.props.dbKey);
      _this.setState({
        tags: []
      });
      if (_this.props.onClear) _this.props.onClear();
    };

    _this.add = function (item) {
      if (!item.value) return;
      var tags = DB.getStore(_this.props.dbKey) || [];
      // 删除重复项
      for (var i in tags) {
        if (tags[i].value === item.value) {
          tags.splice(i, 1);
          break;
        }
      }
      // 添加到第一项
      tags.unshift(item);
      DB.setStore(_this.props.dbKey, tags);
      _this.setState({
        tags: tags
      });
    };

    _this.state = {
      tags: DB.getStore(_this.props.dbKey) || []
    };
    return _this;
  }
  // 清空历史记录

  // 新增历史记录


  createClass(SearchBoard, [{
    key: 'render',
    value: function render() {
      var tags = this.state.tags;
      var _props = this.props,
          style = _props.style,
          className = _props.className,
          show = _props.show,
          expandCaption = _props.expandCaption,
          expandTags = _props.expandTags,
          _onClick = _props.onClick,
          onClickExpand = _props.onClickExpand,
          children = _props.children;

      var isHide = false;
      if (this.props.showValidTags && tags.length === 0) {
        isHide = true;
      }
      var DOM = null;
      if (!isHide) {
        DOM = React__default.createElement(
          'div',
          { className: 'searchboard ' + (className ? ' ' + className : '') + (show ? '' : ' hide'), style: style },
          tags.length > 0 && React__default.createElement(
            'div',
            { className: 'searchboard-caption' },
            React__default.createElement(
              'div',
              { className: 'searchboard-caption-title' },
              '\u641C\u7D22\u5386\u53F2'
            ),
            React__default.createElement(
              'div',
              { className: 'searchboard-caption-ricon', onClick: this.onClear },
              React__default.createElement('i', { className: 'searchboard-icon-trash' }),
              React__default.createElement(
                'span',
                null,
                '\u6E05\u9664'
              )
            )
          ),
          tags.map(function (item, index) {
            return React__default.createElement(
              'div',
              { className: 'searchboard-tag', onClick: function onClick() {
                  if (_onClick) _onClick(item, index);
                }, key: index },
              item.value
            );
          }),
          expandCaption && React__default.createElement(
            'div',
            { className: 'searchboard-caption' },
            React__default.createElement(
              'div',
              { className: 'searchboard-caption-title' },
              expandCaption
            )
          ),
          expandTags && expandTags.map(function (item, index) {
            return React__default.createElement(
              'div',
              { className: 'searchboard-tag', onClick: function onClick() {
                  if (onClickExpand) onClickExpand(item, index);
                }, key: index },
              item.value
            );
          }),
          children
        );
      }
      return DOM;
    }
  }]);
  return SearchBoard;
}(React.Component);

SearchBoard$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  dbKey: propTypes.string, // 存储到db中的key
  show: propTypes.bool,
  showValidTags: propTypes.bool,
  onClick: propTypes.func,
  onClear: propTypes.func,
  expandCaption: propTypes.string, // 扩展标题
  expandTags: propTypes.array, // 扩展标签, 格式: {value: 'xx'}
  onClickExpand: propTypes.func,
  children: propTypes.node
};
SearchBoard$1.defaultProps = {
  show: true,
  showValidTags: true,
  className: 'border-b',
  dbKey: 'app_search_history'
};

var Star$1 = function (_Component) {
  inherits(Star, _Component);

  function Star(props) {
    classCallCheck(this, Star);

    var _this = possibleConstructorReturn(this, (Star.__proto__ || Object.getPrototypeOf(Star)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    _this.onClick = function (e) {
      if (_this.props.onClick) {
        _this.props.onClick(_this.getArgs(e));
      }
    };

    return _this;
  }

  createClass(Star, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          active = _props.active,
          className = _props.className,
          style = _props.style;

      return React__default.createElement('i', { className: 'star' + (active ? ' active' : '') + (className ? ' ' + className : ''), style: style, onClick: this.onClick });
    }
  }]);
  return Star;
}(React.Component);

Star$1.propTypes = {
  args: propTypes.any,
  active: propTypes.bool,
  className: propTypes.string,
  style: propTypes.object,
  onClick: propTypes.func
};
Star$1.defaultProps = {
  args: null
};

var StarGroup$1 = function (_Component) {
  inherits(StarGroup, _Component);

  function StarGroup(props) {
    classCallCheck(this, StarGroup);

    var _this = possibleConstructorReturn(this, (StarGroup.__proto__ || Object.getPrototypeOf(StarGroup)).call(this, props));

    _this.getArgs = function (e) {
      var args = _this.props.args;
      if (args !== undefined) {
        if (typeof args === 'string' && args === '$event') {
          args = e;
        } else if (Array.isArray(args) && args.indexOf('$event') > -1) {
          args[args.indexOf('$event')] = e;
        }
      } else {
        args = e;
      }
      return args;
    };

    return _this;
  }

  createClass(StarGroup, [{
    key: 'onChange',
    value: function onChange(e, argNum) {
      var _props = this.props,
          min = _props.min,
          onChange = _props.onChange,
          onError = _props.onError;

      var num = argNum;
      if (num < min) {
        if (onError) {
          onError('\u6700\u5C0F\u4E0D\u80FD\u5C0F\u4E8E' + min + '\u9897\u661F');
        } else {
          num = min;
        }
      }
      if (onChange) onChange(num, this.getArgs(e));
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          max = _props2.max,
          star = _props2.star,
          className = _props2.className,
          style = _props2.style;

      var stars = [];
      for (var i = 1; i <= max; i++) {
        stars.push(i);
      }
      return React__default.createElement(
        'div',
        { className: 'stargroup' + (className ? ' ' + className : ''), style: style },
        stars.map(function (num) {
          return React__default.createElement(Star$1, { onClick: function onClick(e) {
              _this2.onChange(e, num);
            }, key: num, active: num <= star ? true : false });
        })
      );
    }
  }]);
  return StarGroup;
}(React.Component);

StarGroup$1.propTypes = {
  min: propTypes.number,
  max: propTypes.number,
  star: propTypes.number,
  onChange: propTypes.func,
  className: propTypes.string,
  style: propTypes.object
  // args: PropTypes.array
};
StarGroup$1.defaultProps = {
  args: null,
  min: 0,
  max: 5
};

var Dialog$4 = function (_Component) {
  inherits(Dialog, _Component);

  function Dialog(props) {
    classCallCheck(this, Dialog);
    return possibleConstructorReturn(this, (Dialog.__proto__ || Object.getPrototypeOf(Dialog)).call(this, props));
  }

  createClass(Dialog, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return ReactDOM.createPortal(React__default.createElement('div', { ref: function ref(el) {
          _this2.$el = el;
        }, className: 'stencil' + (className ? ' ' + className : ''), style: style }), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Dialog;
}(React.Component);

Dialog$4.propTypes = {
  className: propTypes.string,
  style: propTypes.object
};
Dialog$4.defaultProps = {
  className: 'stencil-list'
};

var Peg$3 = function (_Component) {
  inherits(Peg, _Component);

  function Peg(props) {
    classCallCheck(this, Peg);
    return possibleConstructorReturn(this, (Peg.__proto__ || Object.getPrototypeOf(Peg)).call(this, props));
  }

  createClass(Peg, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          type = _props.type,
          iconClassName = _props.iconClassName,
          className = _props.className,
          style = _props.style,
          children = _props.children;

      var newClassName = '';
      switch (type) {
        case 'line':
          newClassName = 'sticker-line';
          break;
        default:
          newClassName = 'sticker';
      }
      return React__default.createElement(
        'span',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: '' + newClassName + (iconClassName ? ' sticker-icon' : '') + (className ? ' ' + className : ''), style: style },
        iconClassName && React__default.createElement('span', { 'class': 'size12 ' + iconClassName }),
        children && React__default.createElement(
          'span',
          null,
          children
        )
      );
    }
  }]);
  return Peg;
}(React.Component);

Peg$3.propTypes = {
  type: propTypes.string, // line
  iconClassName: propTypes.string,
  className: propTypes.string,
  style: propTypes.object,
  children: propTypes.node
};
Peg$3.defaultProps = {
  className: 'top right'
};

var Ticket$1 = function (_Component) {
  inherits(Ticket, _Component);

  function Ticket(props) {
    classCallCheck(this, Ticket);
    return possibleConstructorReturn(this, (Ticket.__proto__ || Object.getPrototypeOf(Ticket)).call(this, props));
  }

  createClass(Ticket, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          style = _props.style,
          className = _props.className,
          legend = _props.legend,
          legendStyle = _props.legendStyle,
          legendClassName = _props.legendClassName,
          children = _props.children,
          containerStyle = _props.containerStyle,
          containerClassName = _props.containerClassName,
          onClick = _props.onClick;

      return React__default.createElement(
        'div',
        { className: 'ticket' + (className ? ' ' + className : ''), style: style, onClick: onClick },
        React__default.createElement(
          'div',
          { className: 'ticket-legend' + (legendClassName ? ' ' + legendClassName : ''), style: legendStyle },
          legend
        ),
        React__default.createElement(
          'div',
          { className: 'ticket-container' + (containerClassName ? ' ' + containerClassName : ''), style: containerStyle },
          children
        )
      );
    }
  }]);
  return Ticket;
}(React.Component);

Ticket$1.propTypes = {
  style: propTypes.object,
  className: propTypes.string,
  legendStyle: propTypes.object,
  legendClassName: propTypes.string,
  legend: propTypes.node,
  containerStyle: propTypes.object,
  containerClassName: propTypes.string,
  children: propTypes.node,
  onClick: propTypes.func
};

var Timeline$1 = function (_Component) {
  inherits(Timeline, _Component);

  function Timeline(props) {
    classCallCheck(this, Timeline);
    return possibleConstructorReturn(this, (Timeline.__proto__ || Object.getPrototypeOf(Timeline)).call(this, props));
  }

  createClass(Timeline, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          list = _props.list,
          style = _props.style,
          badgeStyle = _props.badgeStyle,
          top = _props.top,
          bottom = _props.bottom;

      var listDOM = list.map(function (item, index) {
        return React__default.createElement(
          'div',
          { key: index, className: 'timeline-case' + (item.active ? ' active' : '') },
          React__default.createElement(
            'div',
            { className: 'timeline-badge', style: badgeStyle },
            item.icon || React__default.createElement(Dot$1, { className: item.active ? ' active' : '' })
          ),
          item.content
        );
      });
      return React__default.createElement(
        'div',
        { className: 'timeline', style: style },
        React__default.createElement('span', { className: 'timeline-line', style: { top: top, bottom: bottom } }),
        listDOM
      );
    }
  }]);
  return Timeline;
}(React.Component);

Timeline$1.propTypes = {
  list: propTypes.array,
  style: propTypes.object,
  badgeStyle: propTypes.object,
  top: propTypes.string,
  bottom: propTypes.string
};
Timeline$1.defaultProps = {
  list: [],
  style: {}
};

// Timepart 时间段
var Timepart$3 = function Timepart(container, params) {
  /* -----------------------
  Model
  ----------------------- */
  var defaults = {
    rowClass: 'timepart-row',
    progressClass: 'timepart-progress',
    progressCaptionClass: 'progress-caption',
    dataProgressAttr: 'data-progress',
    partClass: 'timepart-part',
    partStartClass: 'timepart-startTime',
    partEndClass: 'timepart-endTime',
    activeClass: 'active',
    disableClass: 'disabled',

    colCount: 6, // 一行6格
    partMinute: 30, // 一格的30分钟
    startTime: '7:00',
    endTime: '22:00',

    colAttr: 'data-col',

    isEnableActive: true // 是否启用点击选中

    /*
    Callbacks:
    onConflictOver:function(Timepart)
    onConflictContain:function(Timepart)
    onClick:function(Timepart)
    onClickDisabled:function(Timepart)
    onClickActive:function(Timepart)
    onClickChoose:function(Timepart)
    onClickValid:function(Timepart)
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  var s = this;
  // Params
  s.params = params;
  // Container
  s.container = typeof container === 'string' ? document.querySelector(container) : container;
  // 设置Container的data-col
  s.container.setAttribute(s.params.colAttr, s.params.colCount);

  if (!s.container) {
    console.log('SeedsUI Error：未找到Timepart的DOM对象，请检查传入参数是否正确');
    return;
  }
  // 点击次数
  s.clickCount = 0;

  var partMilliSecond = s.params.partMinute * 60 * 1000;
  // 行
  s.rows = [];
  s.rowsCount = 0;
  var rowMilliSecond = partMilliSecond * s.params.colCount;

  // 字符串转换成Date对象，参数格式如8:00
  s.parseDate = function (timeStr) {
    var date = new Date();
    var hour = timeStr.split(':')[0];
    var minute = timeStr.split(':')[1];
    date.setYear(0);
    date.setMonth(0, 0);
    date.setHours(hour);
    date.setMinutes(minute);
    date.setSeconds(0, 0);
    return date;
  };
  // 开始和结束时间
  s.startTime = s.parseDate(s.params.startTime);
  s.endTime = s.parseDate(s.params.endTime);

  // 总格数
  s.partsCount = 0;
  s.updateParsCount = function () {
    var startTime = s.parseDate(s.params.startTime);
    var endTime = s.parseDate(s.params.endTime);
    s.partsCount = (endTime.getTime() - startTime.getTime()) / partMilliSecond;
    if (Math.ceil(s.partsCount) !== s.partsCount) {
      // 是否是整数
      s.partsCount = 0;
      console.log('SeedsUI Error：时间区间参数partMinute不正确，不能整除');
      return;
    }
    return s.partsCount;
  };
  // 总行数
  s.updateRowsCount = function () {
    if (s.partsCount === 0) s.updateParsCount();
    s.rowsCount = Math.ceil(s.partsCount / s.params.colCount);
    return s.rowsCount;
  };
  // 创建时间段
  s.createParts = function () {
    s.updateRowsCount();
    // 总格数
    s.parts = [];
    // 总行数
    s.rows = [];
    // 创建行
    for (var i = 0; i < s.rowsCount; i++) {
      var rowStartTime = s.startTime.getTime() + rowMilliSecond * i;
      var rowEndTime = rowStartTime + rowMilliSecond;
      if (rowEndTime > s.endTime.getTime()) rowEndTime = s.endTime.getTime();

      var row = document.createElement('div');
      row.setAttribute('class', s.params.rowClass);
      row.startTime = new Date(rowStartTime);
      row.endTime = new Date(rowEndTime);

      s.rows.push(row);
      s.container.appendChild(row);

      // 创建列
      for (var j = 0; j < s.params.colCount; j++) {
        var partStartTime = rowStartTime + partMilliSecond * j;
        var partEndTime = partStartTime + partMilliSecond;
        if (partStartTime > s.endTime.getTime() || partEndTime > s.endTime.getTime()) return;

        var part = document.createElement('label');
        part.setAttribute('class', s.params.partClass);
        part.startTime = new Date(partStartTime);
        part.endTime = new Date(partEndTime);

        var startHour = part.startTime.getHours() < 10 ? '0' + part.startTime.getHours() : part.startTime.getHours();
        var startMinute = part.startTime.getMinutes() < 10 ? '0' + part.startTime.getMinutes() : part.startTime.getMinutes();
        var endHour = part.endTime.getHours() < 10 ? '0' + part.endTime.getHours() : part.endTime.getHours();
        var endMinute = part.endTime.getMinutes() < 10 ? '0' + part.endTime.getMinutes() : part.endTime.getMinutes();
        part.innerHTML = '<span class=' + s.params.partStartClass + '>' + startHour + ':' + startMinute + '</span>' + '<span class=' + s.params.partEndClass + '>' + endHour + ':' + endMinute + '</span>';
        s.parts.push(part);
        row.appendChild(part);
      }
    }
  };
  s.createParts();

  /* -----------------------
  Method
  ----------------------- */
  s.reset = function () {
    // 重置点击次数
    s.clickCount = 0;
    // 清空容器
    s.container.innerHTML = '';
    // 重新绘制时间段
    s.createParts();
  };
  // 获得进度条的开始行数、结束行数、开始位置、结束位置、开始段数、结束段数
  s.getTimesRange = function (startTime, endTime) {
    // 开始结束位置总比例
    var startRatio = ((startTime.getTime() - s.startTime.getTime()) / rowMilliSecond).toString();
    var endRatio = ((endTime.getTime() - s.startTime.getTime()) / rowMilliSecond).toString();
    /*
     *行数:开始结束位置行数
     */
    var startRow = Math.floor(startRatio);
    var endRow = Math.floor(endRatio);
    /*
     *左右:开始结束行左右值
     */
    var left = Math.round(startRatio.replace(/\d+\./, '0.') * 100);
    var right = Math.round(100 - endRatio.replace(/\d+\./, '0.') * 100);

    /*
     *段数:开始结束段数字
     */
    var startNum = Math.floor(startRatio * s.params.colCount);
    var endNum = Math.floor(endRatio * s.params.colCount) - 1; // 半格的情况，则此格为正常状态，所以-1
    /*
     *整比例
     */
    // 结束比例为整数时得减1
    if (endRatio % 1 === 0) {
      endRow--;
      right = 0;
    }
    // 结束时间是一格的倍数得减1
    /*
    if(endTime.getMinutes()%s.params.partMinute===0){
        endNum++
    }
    */
    // 如果开始位置在最左边，则左边间距为0
    if (startRatio % 1 === 0) {
      left = 0;
    }

    return {
      startRatio: startRatio,
      endRatio: endRatio,

      startRow: startRow,
      endRow: endRow,

      left: left,
      right: right,

      startNum: startNum,
      endNum: endNum
    };
  };
  s.hasProgress = function (startTime, endTime, isCallback) {
    var progress = s.container.querySelectorAll('.progress-caption');
    s.conflictTimes = {
      conflictStartTime: startTime,
      conflictEndTime: endTime
      /* eslint-disable */
    };for (var i = 0, pro; pro = progress[i++];) {
      // 相交
      if (startTime > pro.startTime && startTime < pro.endTime || endTime > pro.startTime && endTime < pro.endTime) {
        s.target = pro;
        if (s.params.onConflictContain && isCallback) s.params.onConflictContain(s);
        return true;
      }
      // 包含
      if (pro.startTime > startTime && pro.startTime < endTime || pro.endTime > startTime && pro.endTime < endTime) {
        s.target = pro;
        if (s.params.onConflictOver && isCallback) s.params.onConflictOver(s);
        return true;
      }
    }
    /* eslint-enable */
    return false;
  };

  // 设置进度条
  s.setProgress = function (startTime, endTime, classes, data, isListenerConflict) {
    /* eslint-disable */
    var startTime = Object.prototype.toString.call(startTime) === '[object Date]' ? startTime : s.parseDate(startTime || s.params.startTime);
    var endTime = Object.prototype.toString.call(endTime) === '[object Date]' ? endTime : s.parseDate(endTime || s.params.endTime);
    var classes = classes && Object.prototype.toString.call(classes) === '[object Array]' ? classes : [];
    /* eslint-enable */
    startTime.setYear(0);
    startTime.setMonth(0, 0);
    startTime.setSeconds(0, 0);

    endTime.setYear(0);
    endTime.setMonth(0, 0);
    endTime.setSeconds(0, 0);

    // 时间范围限制
    if (startTime.getTime() < s.startTime.getTime()) {
      startTime = s.startTime;
    } else if (startTime.getTime() > s.endTime.getTime()) {
      startTime = s.endTime;
    }
    if (endTime.getTime() < s.startTime.getTime()) {
      endTime = s.startTime;
    } else if (endTime.getTime() > s.endTime.getTime()) {
      endTime = s.endTime;
    }
    // 如果开启冲突监听，并且存在冲突，则停止进度条绘制
    if (isListenerConflict && s.hasProgress(startTime, endTime, true)) return false;

    var range = s.getTimesRange(startTime, endTime);
    // 设置parts的class
    /*
    for(var i=range.startNum;i<=range.endNum;i++){
        for(var k=0,className;className=classes[k++];){
            s.parts[i].classList.add(className)
        }
    }
    */

    // 设置progress的left和right
    for (var j = range.startRow; j <= range.endRow; j++) {
      var progress = document.createElement('div');
      progress.setAttribute('class', s.params.progressClass);

      // 设置classes
      /* eslint-disable */
      for (var l = 0, className; className = classes[l++];) {
        progress.classList.add(className);
      }
      /* eslint-enable */

      // 设置style
      progress.style.display = 'block';
      progress.style.left = 0;
      progress.style.right = 0;

      // 设置data
      if (data) progress.setAttribute(s.params.dataProgressAttr, data);

      if (j === range.startRow) {
        progress.style.left = range.left + '%';

        progress.startTime = startTime;
        progress.endTime = endTime;
        progress.classList.add(s.params.progressCaptionClass);
        progress.setAttribute('data-starttime', startTime);
        progress.setAttribute('data-endtime', endTime);
      }
      if (j === range.endRow) {
        progress.style.right = range.right + '%';
      }

      s.rows[j].appendChild(progress);
    }
    return true;
  };
  s.activeTimes = function (startTime, endTime, argClassName, data) {
    var className = s.params.activeClass + (argClassName ? ' ' + argClassName : '');
    var isDrawed = s.setProgress(startTime, endTime, className.split(' '), data || '', true);
    if (isDrawed) {
      s.clickCount = 2;
    }
  };
  s.disableTimes = function (startTime, endTime, argClassName, data) {
    var className = s.params.disableClass + (argClassName ? ' ' + argClassName : '');
    s.setProgress(startTime, endTime, className.split(' '), data || '', true);
  };
  s.chooseTimes = function (startTime, endTime, argClassName, data) {
    var className = argClassName ? argClassName.split(' ') : [];
    s.setProgress(startTime, endTime, className, data);
  };
  // 获取选中的时间段
  s.getActiveTimes = function () {
    var activeProgress = s.container.querySelectorAll('.' + s.params.progressCaptionClass + '.' + s.params.activeClass);
    if (activeProgress.length === 0) {
      activeProgress = s.container.querySelectorAll('.' + s.params.partClass + '.' + s.params.activeClass);
    }
    if (activeProgress.length <= 0) {
      return {
        startTime: null,
        endTime: null,
        startTimeString: null,
        endTimeString: null
      };
    }
    var startTime = activeProgress[0].startTime;
    var startHour = startTime.getHours() < 10 ? '0' + startTime.getHours() : startTime.getHours();
    var startMinute = startTime.getMinutes() < 10 ? '0' + startTime.getMinutes() : startTime.getMinutes();

    var endTime = activeProgress[activeProgress.length - 1].endTime;
    var endHour = endTime.getHours() < 10 ? '0' + endTime.getHours() : endTime.getHours();
    var endMinute = endTime.getMinutes() < 10 ? '0' + endTime.getMinutes() : endTime.getMinutes();

    return {
      startTime: startTime,
      endTime: endTime,
      startTimeString: startHour + ':' + startMinute,
      endTimeString: endHour + ':' + endMinute
    };
  };

  // 删除进度条
  s.removeProgress = function (className) {
    // 清空parts
    for (var i = 0, part; part = s.parts[i++];) {
      // eslint-disable-line
      part.classList.remove(className);
    }
    // 清空progress
    var activeProgress = s.container.querySelectorAll('.' + s.params.progressClass + '.' + className);
    Array.prototype.slice.call(activeProgress).forEach(function (n, i) {
      n.parentNode.removeChild(n);
    });
  };
  s.removeAllActive = function () {
    s.clickCount = 0;

    s.removeProgress(s.params.activeClass);
  };
  s.removeAllDisabled = function () {
    s.removeProgress(s.params.disableClass);
  };
  // 时间排序
  s.sortTimes = function () {
    var args = [].slice.call(arguments);
    return args.sort(function (x, y) {
      if (x < y) return -1;
      if (x > y) return 1;
      return 0;
    });
  };
  // 根据段获得时间
  s.getTimesByParts = function (part1, part2) {
    var times = s.sortTimes(part1.startTime, part1.endTime, part2.startTime, part2.endTime);
    return {
      startTime: times[0],
      endTime: times[times.length - 1]
    };
  };
  /* -----------------------
  Events
  ----------------------- */
  s.events = function (detach) {
    var target = s.container;
    var action = detach ? 'removeEventListener' : 'addEventListener';
    target[action]('click', s.onClickContainer, false);
  };
  // attach、dettach事件
  s.attach = function (event) {
    s.events();
  };
  s.detach = function (event) {
    s.events(true);
  };
  /* -----------------------
  Events Handler
  ----------------------- */
  s.onClickContainer = function (e) {
    if (e.target.classList.contains(s.params.partClass) || e.target.classList.contains(s.params.progressClass)) {
      // 点击part
      s.onClickPart(e);
    }
  };
  s.onClickPart = function (e) {
    s.target = e.target;
    // Callback onClick
    if (s.params.onClick) s.params.onClick(s);

    // 点击禁用
    if (s.target.classList.contains(s.params.disableClass)) {
      // Callback onClickDisabled
      if (s.params.onClickDisabled) s.params.onClickDisabled(s);
      return;
    }
    // 点击激活
    if (s.target.classList.contains(s.params.activeClass)) {
      // Callback onClickActive
      if (s.params.onClickActive) s.params.onClickActive(s);
      return;
    }
    // 点击进度条
    if (s.target.classList.contains(s.params.progressClass)) {
      // Callback onClickChoose
      if (s.params.onClickChoose) s.params.onClickChoose(s);
      return;
    }

    // 记录点击次数
    s.clickCount++;

    // 点击合法区域
    // Callback onClick
    if (s.params.onClickValid) s.params.onClickValid(s);
  };
  /* -----------------------
  Init
  ----------------------- */
  s.init = function () {
    s.attach();
  };
  s.init();
};

var Timepart$1 = function (_Component) {
  inherits(Timepart, _Component);

  function Timepart(props) {
    classCallCheck(this, Timepart);

    var _this = possibleConstructorReturn(this, (Timepart.__proto__ || Object.getPrototypeOf(Timepart)).call(this, props));

    _this.onChange = function () {
      console.log(_this.state.instance.getActiveTimes());
      var _this$props = _this.props,
          disabledTimes = _this$props.disabledTimes,
          customTimes = _this$props.customTimes;

      if (_this.props.onChange) _this.props.onChange({
        disabledTimes: disabledTimes,
        customTimes: customTimes,
        selectedTimes: _this.state.instance.getActiveTimes()
      });
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(Timepart, [{
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _this2 = this;

      if (this.props.disabledTimes && prevProps.disabledTimes.length !== this.props.disabledTimes.length) {
        this.props.disabledTimes.forEach(function (time) {
          _this2.state.instance.disableTimes(time.startTime, time.endTime, time.className, time.data);
        });
      }
      if (this.props.customTimes && prevProps.customTimes.length !== this.props.customTimes.length) {
        this.props.customTimes.forEach(function (time) {
          _this2.state.instance.chooseTimes(time.startTime, time.endTime, time.className || 'active', time.data);
        });
      }
    }
  }, {
    key: 'componentDidMount',
    value: function componentDidMount() {
      var _this3 = this;

      var instance = new Timepart$3(this.$el, {
        startTime: this.props.startTime,
        endTime: this.props.endTime,
        onClick: function onClick(e) {},
        onConflictOver: function onConflictOver(e) {
          _this3.onError('不能跨选禁用时间段', e);
        },
        onConflictContain: function onConflictContain(e) {
          _this3.error && _this3.error('时间段冲突', e.target);
        },
        onClickActive: function onClickActive(e) {
          // 点击选中区域
          if (!_this3.props.multiple) e.removeAllActive();
        },
        onClickDisabled: function onClickDisabled(e) {// 点击禁用区域
        },
        onClickChoose: function onClickChoose(e) {
          var data = JSON.parse(e.target.getAttribute('data-progress'));
          console.log('点击选择区域，数据：{startTime:' + data.startTime + ',endTime:' + data.endTime + '}');
        },
        onClickValid: function onClickValid(s) {
          // 点击空白有效区域
          console.log('有效区域');
          console.log(s.params.activeClass);
          if (s.clickCount === 1) {
            // 如果点击了一次
            _this3.part1 = s.target;
            _this3.part1.classList.add(s.params.activeClass);
          } else if (s.clickCount === 2) {
            // 如果点击了两次
            _this3.part2 = s.target;
            // 选中
            var times = s.getTimesByParts(_this3.part1, _this3.part2);
            s.activeTimes(times.startTime, times.endTime);
          } else if (s.clickCount === 3) {
            // 如果点击了三次
            s.removeAllActive();
          }
        }
      });
      // 禁用时间
      if (this.props.disabledTimes) {
        this.props.disabledTimes.forEach(function (time) {
          instance.disableTimes(time.startTime, time.endTime, time.className, time.data);
        });
      }
      // 自定义时间
      if (this.props.customTimes) {
        this.props.customTimes.forEach(function (time) {
          instance.chooseTimes(time.startTime, time.endTime, time.className || 'active', time.data);
        });
      }
      // 选中时间
      if (this.props.selectedTimes) {
        var selectedTimes = this.props.selectedTimes;
        if (!this.props.multiple) selectedTimes = [this.props.selectedTimes[0]];
        selectedTimes.forEach(function (time) {
          instance.activeTimes(time.startTime, time.endTime, time.className || 'active', time.data);
        });
      }
      this.setState({
        instance: instance
      }, function () {
        _this3.onChange();
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this4 = this;

      var _props = this.props,
          className = _props.className,
          style = _props.style;

      return React__default.createElement('div', { ref: function ref(el) {
          _this4.$el = el;
        }, className: 'timepart' + (className ? ' ' + className : ''), style: style });
    }
  }]);
  return Timepart;
}(React.Component);

Timepart$1.propTypes = {
  multiple: propTypes.bool, // 是否支持多选
  className: propTypes.string,
  style: propTypes.object,

  startTime: propTypes.string, // hh:ss
  endTime: propTypes.string,

  disabledTimes: propTypes.array, // [{startTime: 'hh:ss', endTime: 'hh:ss', className: string, data: string}]
  selectedTimes: propTypes.array, // 同上
  customTimes: propTypes.array, // 同上

  onChange: propTypes.func, // onChange({})
  onError: propTypes.func
};
Timepart$1.defaultProps = {
  startTime: '7:00',
  endTime: '22:00'
};

var Titlebar$1 = function (_Component) {
  inherits(Titlebar, _Component);

  function Titlebar(props) {
    classCallCheck(this, Titlebar);

    var _this = possibleConstructorReturn(this, (Titlebar.__proto__ || Object.getPrototypeOf(Titlebar)).call(this, props));

    _this.onClickBack = function () {
      var onClickBack = _this.props.onClickBack;
      // 如果有onClickBack的props,则优先执行props的方法

      if (onClickBack) {
        onClickBack();
        return;
      }
      // 否则走默认的返回
      var isFromApp = Device.getUrlParameter('isFromApp', location.search) || '';
      if (isFromApp === '1') {
        try {
          Bridge$1.closeWindow();
        } catch (error) {
          console.log(error);
        }
      } else if (isFromApp === 'home') {
        try {
          Bridge$1.goHome();
        } catch (error) {
          console.log(error);
        }
      } else if (isFromApp === 'confirm') {
        try {
          Bridge$1.showConfirm('您确定要离开此页面吗?', {
            onSuccess: function onSuccess(e) {
              e.hide();
              Bridge$1.closeWindow();
            }
          });
        } catch (error) {
          console.log(error);
        }
      } else {
        history.back();
      }
    };

    _this.getButtonsDOM = function (arr) {
      return arr.map(function (item, index) {
        if (item === '$back') {
          item = {
            iconClassName: 'shape-arrow-left',
            onClick: _this.onClickBack
          };
        }
        return React__default.createElement(
          'a',
          { key: index, onClick: function onClick() {
              if (item.onClick) item.onClick(item.args || '');
            }, className: 'titlebar-button button' + (item.className ? ' ' + item.className : ' bar'), style: item.style },
          (item.iconSrc || item.iconClassName) && React__default.createElement(Icon$1, { className: '' + (item.iconClassName ? ' ' + item.iconClassName : ''), src: item.iconSrc ? item.iconSrc : '', style: item.iconStyle }),
          item.icon && item.icon,
          item.caption && React__default.createElement(
            'span',
            null,
            item.caption
          )
        );
      });
    };

    _this.state = {};
    return _this;
  }

  createClass(Titlebar, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          className = _props.className,
          style = _props.style,
          caption = _props.caption,
          captionClassName = _props.captionClassName,
          captionStyle = _props.captionStyle,
          children = _props.children,
          onClickCaption = _props.onClickCaption,
          lButtons = _props.lButtons,
          rButtons = _props.rButtons;

      var lButtonsDOM = null;
      if (Array.isArray(lButtons)) {
        lButtonsDOM = this.getButtonsDOM(lButtons);
      }
      var rButtonsDOM = null;
      if (Array.isArray(rButtons)) {
        rButtonsDOM = this.getButtonsDOM(rButtons);
      }
      var captionDOM = children ? children : React__default.createElement(
        'h1',
        { className: 'titlebar-caption nowrap text-center' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle, onClick: onClickCaption },
        caption
      );
      return React__default.createElement(
        'div',
        { className: 'titlebar' + (className ? ' ' + className : ''), style: style },
        React__default.createElement(
          'div',
          { className: 'titlebar-left' },
          lButtonsDOM
        ),
        captionDOM,
        React__default.createElement(
          'div',
          { className: 'titlebar-right' },
          rButtonsDOM
        )
      );
    }
  }]);
  return Titlebar;
}(React.Component);

Titlebar$1.propTypes = {
  className: propTypes.string,
  style: propTypes.object,

  caption: propTypes.node,
  captionClassName: propTypes.string,
  captionStyle: propTypes.object,

  onClickBack: propTypes.func,
  onClickCaption: propTypes.func,
  lButtons: propTypes.array, // [{className: string, style: object, iconClassName: string, icon: node, caption: string}]
  rButtons: propTypes.array,
  children: propTypes.node
};
Titlebar$1.defaultProps = {
  lButtons: ['$back'],
  className: 'border-b'
};

var Toast$3 = function (_Component) {
  inherits(Toast, _Component);

  function Toast(props) {
    classCallCheck(this, Toast);

    var _this = possibleConstructorReturn(this, (Toast.__proto__ || Object.getPrototypeOf(Toast)).call(this, props));

    _this.componentDidMount = function () {};

    return _this;
  }

  createClass(Toast, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          duration = _props.duration,
          show = _props.show,
          maskClassName = _props.maskClassName,
          maskStyle = _props.maskStyle,
          className = _props.className,
          style = _props.style,
          icon = _props.icon,
          iconSrc = _props.iconSrc,
          iconStyle = _props.iconStyle,
          iconClassName = _props.iconClassName,
          caption = _props.caption,
          captionStyle = _props.captionStyle,
          captionClassName = _props.captionClassName;

      return ReactDOM.createPortal(React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'mask toast-mask' + (maskClassName ? ' ' + maskClassName : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, maskStyle) },
        React__default.createElement(
          'div',
          { className: 'toast' + (className ? ' ' + className : '') + (show ? ' active' : ''), style: Object.assign(duration !== undefined ? { WebkitTransitionDuration: duration + 'ms' } : {}, style) },
          React__default.createElement(
            'div',
            { className: 'toast-wrapper' },
            (iconSrc || iconClassName) && React__default.createElement(Icon$1, { className: 'toast-icon' + (iconClassName ? ' ' + iconClassName : ''), src: iconSrc ? iconSrc : '', style: iconStyle }),
            icon,
            caption && React__default.createElement(
              'span',
              { className: 'toast-caption' + (captionClassName ? ' ' + captionClassName : ''), style: captionStyle },
              caption
            )
          )
        )
      ), this.props.portal || document.getElementById('root'));
    }
  }]);
  return Toast;
}(React.Component);

Toast$3.propTypes = {
  portal: propTypes.object,
  show: propTypes.bool,

  duration: propTypes.number,

  maskClassName: propTypes.string,
  maskStyle: propTypes.object,

  className: propTypes.string,
  style: propTypes.object,

  caption: propTypes.node,
  captionStyle: propTypes.object,
  captionClassName: propTypes.string,

  icon: propTypes.node,
  iconSrc: propTypes.string,
  iconStyle: propTypes.object,
  iconClassName: propTypes.string
};
Toast$3.defaultProps = {};

// Tree 树结构
var Tree$3 = function Tree(container, params) {
  function getElementByParent(parent, selector) {
    return typeof selector === 'string' && selector !== '' ? parent.querySelector(selector) : selector;
  }
  /* ------------------
  Model
  ------------------ */
  var defaults = {
    // DATA
    data: null, // [{id: '', name: '', parentid: ''}]
    // DOM
    checkbox: false, // 是否可选
    bar: null,
    barOptionClass: 'tree-bar-button',
    barButtonDelClass: 'tree-bar-button-del',

    extandClass: 'extand',
    activeClass: 'active',

    treeClass: 'tree',
    lineClass: 'tree-line', // 行
    titleClass: 'tree-title', // 标题
    arrowClass: 'tree-icon-arrow',
    iconClass: 'tree-icon', // 左侧图标

    buttonAddHTML: '',
    buttonAddClass: 'tree-button-add',
    buttonAddSrc: '',
    buttonDelHTML: '',
    buttonDelClass: 'tree-button-del',
    buttonDelSrc: '',

    idAttr: 'data-id',
    parentidAttr: 'data-parentid',
    nameAttr: 'data-name'

    /*
    callbacks
    onClick:function(Tree)
    onClickLastChild:function(Tree)
    onClickAdd: function(option)
    onData:function(option)
    */
  };
  params = params || {};
  for (var def in defaults) {
    if (params[def] === undefined) {
      params[def] = defaults[def];
    }
  }
  // Tree
  var s = this;

  // Params
  s.params = params;

  // Container
  s.container = getElementByParent(document, container);
  if (!s.container) {
    console.log('SeedsUI Error：未找到Tree的DOM对象，请检查传入参数是否正确');
    return;
  }

  // Bar
  s.updateBar = function () {
    if (s.params.bar) {
      s.bar = getElementByParent(document, s.params.bar);
      if (!s.bar) {
        console.log('SeedsUI Error：未找到Bar的DOM对象，请检查传入参数是否正确');
        return;
      }
    }
  };
  s.updateBar();
  s.setBar = function (bar) {
    s.params.bar = bar;
  };

  // Selected
  s.selected = {};
  var _data = s.params.data;
  s.getChildren = function (id) {
    var children = [];
    /* eslint-disable */
    for (var i = 0, child; child = _data[i++];) {
      if (id && child.parentid === id.toString()) {
        children.push(child);
      }
    }
    /* eslint-enable */
    return children;
  };
  s.initData = function (id, ulContainer) {
    // 指定的部门id，根节点为-1
    var group = s.getChildren(id);
    /* eslint-disable */
    for (var i = 0, option; option = group[i++];) {
      // 拷贝option，方便传入回调中而不影响原option
      var copyOption = Object.create(option);
      // line的data-xxx属性html
      var lineDataHTML = '';
      for (var n in option) {
        lineDataHTML += 'data-' + n + '="' + option[n] + '" ';
      }

      // tree-icon和tree-title的html
      copyOption.html = '<div class="' + s.params.iconClass + '">' + '<i class="' + s.params.arrowClass + '"></i>' + '</div>' + '<div class="' + s.params.titleClass + '">' + option.name + '</div>';
      // Callback onData
      if (s.params.onData) s.params.onData(copyOption);

      var li = document.createElement('li');

      // tree-btnadd
      var btnHTML = '';
      var addBtnHTML = '';
      var delBtnHTML = '';
      if (s.params.checkbox) {
        // if (!s.selected[option.id]) {
        // 添加按钮
        if (s.params.buttonAddHTML) {
          addBtnHTML = s.params.buttonAddHTML;
        } else if (s.params.buttonAddSrc) {
          addBtnHTML = '<span class="' + s.params.buttonAddClass + '" style="background-image:url(' + s.params.buttonAddSrc + ')"></span>';
        } else {
          addBtnHTML = '<span class="' + s.params.buttonAddClass + '"></span>';
        }
        // 删除按钮
        if (s.params.buttonDelHTML) {
          delBtnHTML = s.params.buttonDelHTML;
        } else if (s.params.buttonDelSrc) {
          delBtnHTML = '<span class="' + s.params.buttonDelClass + '" style="background-image:url(' + s.params.buttonDelSrc + ')"></span>';
        } else {
          delBtnHTML = '<span class="' + s.params.buttonDelClass + '"></span>';
        }
        // 如果html没有添加和删除样式,则默认增加添加和删除样式,用于后续的点击操作识别
        if (addBtnHTML && !addBtnHTML.hasClass(s.params.buttonAddClass)) addBtnHTML.addClass(s.params.buttonAddClass);
        if (delBtnHTML && !delBtnHTML.hasClass(s.params.buttonDelClass)) delBtnHTML.addClass(s.params.buttonDelClass);
        // 合成html
        btnHTML = addBtnHTML + delBtnHTML;
        // }
      }

      // 父级和当前都被选中,则移除当前选中项
      if (s.isSelected(option.id, option.parentid) === 2) {
        s.removeSelected(option.id);
      }

      // 生成完整的html
      var html = '<div class="' + s.params.lineClass + '" ' + lineDataHTML + '>' + copyOption.html + btnHTML + '</div><ul></ul>';
      if (s.selected[option.id]) {
        html = '<div class="' + s.params.lineClass + ' ' + s.params.activeClass + '" ' + lineDataHTML + '>' + copyOption.html + btnHTML + '</div><ul></ul>';
      }
      li.innerHTML = html;

      ulContainer.appendChild(li);
      var ul = s.container.querySelector('[' + s.params.idAttr + '="' + option.id + '"]').nextElementSibling;
      s.initData(option.id, ul);
    }
    /* eslint-enable */
  };
  s.update = function () {
    if (!s.params.data) {
      console.log('SeedsUI Warn：未找到Tree的Data数据，可在初始化时传入data参数，或者通过setData方法设置数据');
      return;
    }
    if (!s.params.data[0].id || !s.params.data[0].parentid || !s.params.data[0].name) {
      console.log('SeedsUI Error：Tree的Data数据格式不正确，请检查data参数是否有id、name、parentid属性');
      return;
    }
    s.updateBar();

    s.container.innerHTML = '';
    s.initData(-1, s.container); // 根节点
  };
  // s.update()
  /* ------------------
    Method
    ------------------ */
  s.setData = function (data) {
    _data = s.params.data = data;
  };
  // 添加数据
  s.addData = function (data, id, childNode) {
    _data = data;
    s.initData(id, childNode);
  };
  // 获得数据
  s.getDataByTarget = function (target) {
    var opts = {};
    /* eslint-disable */
    for (var i = 0, att; att = target.attributes[i++];) {
      if (att.nodeName.indexOf('data-') !== -1) {
        opts[att.nodeName.substring(5)] = att.nodeValue;
      }
    }
    /* eslint-enable */
    return opts;
  };
  // 获得所有父节点
  s.getParentOptions = function (parentid) {
    var parentOptions = [];
    var currentId = parentid;
    while (currentId !== '-1') {
      // 提取所有父级节点
      for (var i = 0, opt; opt = s.params.data[i++];) {
        // eslint-disable-line
        if (opt.id === currentId) {
          parentOptions.push(opt);
          currentId = opt.parentid;
          break;
        }
      }
    }
    return parentOptions;
  };
  // 当前被选中返回1，父级被选中返回-1，当前和父级都被选中返回2，没有被选中返回0
  s.isSelected = function (id, parentid) {
    var currentFlag = false;
    var parentFlag = false;
    // 判断当前和父级是否被选中
    if (s.selected[id]) {
      currentFlag = true;
    }
    if (s.selected[parentid]) {
      parentFlag = true;
    }

    // 判断树中是否存在此节点,比较id和parentid
    var hasNode = false;
    if (!s.params.data || !s.params.data.length) return 0;
    for (var i = 0, opt; opt = s.params.data[i++];) {
      // eslint-disable-line
      if (opt.id === id && opt.parentid === parentid) {
        hasNode = true;
        break;
      }
    }
    if (!hasNode) return 0;

    // 向上查询是否已添加到选中项，一直查到顶级
    var parentNodes = s.getParentOptions(parentid);
    for (var i = 0, opt; opt = parentNodes[i++];) {
      // eslint-disable-line
      if (s.selected[opt.id]) {
        parentFlag = true;
        break;
      }
    }

    if (currentFlag && parentFlag) return 2;
    if (currentFlag) return 1;
    if (parentFlag) return -1;
    return 0;
  };

  // Json是否为空
  s.isEmptyJson = function (json) {
    var temp = '';
    for (var j in json) {
      temp += j;
    }
    if (temp === '') return true;
    return false;
  };
  // 创建选中项
  s.createBarOption = function (id, name, parentid) {
    var div = document.createElement('span');
    div.setAttribute('class', s.params.barOptionClass);
    div.setAttribute(s.params.idAttr, id);
    if (parentid) div.setAttribute(s.params.parentidAttr, parentid);
    div.setAttribute(s.params.nameAttr, name);

    var label = document.createElement('label');
    label.innerHTML = name;

    var del = document.createElement('a');
    del.classList.add(s.params.barButtonDelClass);

    div.appendChild(label);
    div.appendChild(del);
    return div;
  };
  // 删除选中项
  s.removeSelected = function (id) {
    if (s.selected[id]) {
      // 删除数组
      delete s.selected[id];
      // 删除bar上元素
      if (s.bar) s.bar.removeChild(s.bar.querySelector('[' + s.params.idAttr + '="' + id + '"]'));
      // 清空树上的选中状态
      var node = s.container.querySelector('[' + s.params.idAttr + '="' + id + '"]');
      if (node) node.classList.remove(s.params.activeClass);
    }
  };
  s.removeAllSelected = function () {
    for (var id in s.selected) {
      s.removeSelected(id);
    }
    s.hideBar();
  };
  s.removeAllExtand = function () {
    var extands = s.container.querySelectorAll('.' + s.params.extandClass);
    /* eslint-disable */
    for (var i = 0, ex; ex = extands[i++];) {
      ex.classList.remove(s.params.extandClass);
    }
    /* eslint-enable */
  };
  s.addAllExtand = function () {
    var extands = s.container.querySelectorAll('.' + s.params.lineClass);
    /* eslint-disable */
    for (var i = 0, ex; ex = extands[i++];) {
      ex.classList.add(s.params.extandClass);
    }
    /* eslint-enable */
  };
  s.addSelected = function (opts) {
    if (!opts.id || !opts.name || !opts.parentid) {
      console.log('SeedsUI Error:id、name、parentid三个参数不正确');
      return;
    }
    if (s.selected[opts.id]) {
      console.log('SeedsUI Info:您要选中的节点已经选中');
      return;
    }

    if (s.isSelected(opts.id, opts.parentid)) {
      console.log('SeedsUI Info:您要选中的节点已经选中');
      return;
    }

    // bar上添加选中
    if (s.bar) {
      var barOption = s.createBarOption(opts.id, opts.name, opts.parentid);
      s.bar.appendChild(barOption);
      s.showBar();
    }

    // tree中激活选中
    var treeOption = s.container.querySelector('[' + s.params.idAttr + '="' + opts.id + '"]');
    if (treeOption) treeOption.classList.add(s.params.activeClass);

    // s.selected中添加选中
    s.selected[opts.id] = opts;

    // 回调
    if (s.params.onClickAdd) s.params.onClickAdd(opts);
  };
  // 显示选中项
  s.showBar = function () {
    s.bar.classList.add(s.params.activeClass);
  };
  // 隐藏选中项
  s.hideBar = function () {
    s.bar.classList.remove(s.params.activeClass);
  };

  s.reset = function () {
    s.removeAllSelected();
    s.removeAllExtand();
  };
  /* ------------------
    Events
    ------------------ */
  // 绑定事件
  s.isSupportTouch = 'ontouchstart' in window;
  s.events = function (detach) {
    var action = detach ? 'removeEventListener' : 'addEventListener';
    // 点击树,touch兼容pc事件
    if (s.isSupportTouch) {
      s.container[action]('touchstart', s.onTouchStart, false);
      s.container[action]('touchend', s.onTouchEnd, false);
    } else {
      s.container[action]('click', s.onClickTree, false);
    }

    // 点击选中容器
    if (s.bar) {
      s.bar[action]('click', s.onClickBar, false);
    }
  };
  // attach、dettach事件
  s.attach = function (event) {
    s.events();
  };
  s.detach = function (event) {
    s.events(true);
  };
  /* ------------------
    Event Handler
    ------------------ */
  // Tap
  s.touches = {
    startX: 0,
    startY: 0,
    endX: 0,
    endY: 0,
    diffX: 0,
    diffY: 0
  };
  s.onTouchStart = function (e) {
    s.touches.startX = e.touches[0].clientX;
    s.touches.startY = e.touches[0].clientY;
  };
  s.onTouchEnd = function (e) {
    s.touches.endX = e.changedTouches[0].clientX;
    s.touches.endY = e.changedTouches[0].clientY;
    s.touches.diffX = s.touches.startX - s.touches.endX;
    s.touches.diffY = s.touches.startY - s.touches.endY;
    // 单击事件
    if (Math.abs(s.touches.diffX) < 6 && Math.abs(s.touches.diffY) < 6) {
      s.onClickTree(e);
    }
  };
  // 点击树
  s.onClickTree = function (e) {
    // 点击树
    s.targetLi = null;
    s.targetLine = null;
    s.target = e.target;

    if (s.target.classList.contains(s.params.lineClass)) {
      // 点击二级
      s.targetLine = s.target;
      s.targetLi = s.target.parentNode;
    } else if (s.target.classList.contains(s.params.iconClass) || s.target.classList.contains(s.params.titleClass)) {
      // 点击三级
      s.targetLine = s.target.parentNode;
      s.targetLi = s.target.parentNode.parentNode;
    }
    if (s.target.classList.contains(s.params.buttonAddClass)) {
      // 点击添加
      s.onClickBtnAdd(e);
    } else if (s.target.classList.contains(s.params.buttonDelClass)) {
      // 点击删除
      s.onClickBtnDel(e);
    } else if (s.targetLine) {
      // 点击其它元素,但s.targetLine存在的情况下
      // 展开与收缩
      s.targetLine.classList.toggle(s.params.extandClass);
      var lines = s.targetLine.nextElementSibling.querySelectorAll('li > .' + s.params.lineClass);
      /* eslint-disable */
      for (var i = 0, line; line = lines[i++];) {
        if (s.selected[line.getAttribute(s.params.idAttr)]) {
          line.classList.add(s.params.activeClass);
        }
      }
      /* eslint-enable */

      // Callback onClickLastChild(点击底层)
      if ((!s.targetLine.nextElementSibling || !s.targetLine.nextElementSibling.hasChildNodes()) && s.params.onClickLastChild) s.params.onClickLastChild(s);
    }
    // Callback onClick
    if (s.params.onClick) s.params.onClick(s);
  };
  // 点击添加按钮
  s.onClickBtnAdd = function (e) {
    var elLine = e.target.parentNode;
    // 删除子级
    var elLines = elLine.parentNode.querySelectorAll('.' + s.params.lineClass);
    /* eslint-disable */
    for (var i = 0, el; el = elLines[i++];) {
      var elId = el.getAttribute(s.params.idAttr);
      s.removeSelected(elId);
    }
    /* eslint-enable */
    // 显示此级
    elLine.classList.add(s.params.activeClass);
    /*
    var id=elLine.getAttribute(s.params.idAttr)
    var name=elLine.getAttribute(s.params.nameAttr)
    var parentid=elLine.getAttribute(s.params.parentidAttr)
    */
    var opts = s.getDataByTarget(elLine);
    // 添加到s.selected
    s.addSelected(opts);
  };
  // 点击bar
  s.onClickBar = function (e) {
    if (e.target.classList.contains(s.params.barButtonDelClass)) {
      s.onClickBtnDel(e);
    }
  };
  // 点击删除按钮
  s.onClickBtnDel = function (e) {
    s.option = e.target.parentNode;
    s.target = e.target;
    // 选中选中项
    var id = s.option.getAttribute(s.params.idAttr);
    s.removeSelected(id);
    // 如果为空，则隐藏选中容器
    if (s.isEmptyJson(s.selected)) {
      if (s.bar) s.hideBar();
    }
  };

  // 主函数
  s.init = function () {
    s.attach();
  };
  s.init();
};

var Tree$1 = function (_Component) {
  inherits(Tree, _Component);

  function Tree(props) {
    classCallCheck(this, Tree);

    var _this = possibleConstructorReturn(this, (Tree.__proto__ || Object.getPrototypeOf(Tree)).call(this, props));

    _this.shouldComponentUpdate = function (nextProps) {
      if (!nextProps.list.length) {
        return false;
      }
      if (_this.props.list.length !== nextProps.list.length) {
        return true;
      }
      if (!_this.$tree.children.length) {
        return true;
      }
      return false;
    };

    _this.componentDidUpdate = function () {
      var _this$props = _this.props,
          selected = _this$props.selected,
          list = _this$props.list;
      //渲染

      if (list.length) {
        // 设置已选中
        if (Array.isArray(selected) && selected.length) {
          var _iteratorNormalCompletion = true;
          var _didIteratorError = false;
          var _iteratorError = undefined;

          try {
            for (var _iterator = selected[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
              var opt = _step.value;

              _this.state.instance.addSelected(opt);
            }
          } catch (err) {
            _didIteratorError = true;
            _iteratorError = err;
          } finally {
            try {
              if (!_iteratorNormalCompletion && _iterator.return) {
                _iterator.return();
              }
            } finally {
              if (_didIteratorError) {
                throw _iteratorError;
              }
            }
          }
        }
        // 开始渲染
        _this.state.instance.setData(list);
        _this.state.instance.update();
        _this.state.instance.addAllExtand();
      }
    };

    _this.componentDidMount = function () {
      if (_this.state.instance) return;
      var _this$props2 = _this.props,
          checkbox = _this$props2.checkbox,
          bar = _this$props2.bar,
          buttonAddHTML = _this$props2.buttonAddHTML,
          buttonAddClassName = _this$props2.buttonAddClassName,
          buttonAddSrc = _this$props2.buttonAddSrc,
          onClickAdd = _this$props2.onClickAdd,
          buttonDelHTML = _this$props2.buttonDelHTML,
          buttonDelClassName = _this$props2.buttonDelClassName,
          buttonDelSrc = _this$props2.buttonDelSrc,
          onClickDel = _this$props2.onClickDel,
          onClickLastChild = _this$props2.onClickLastChild;

      var instance = new Tree$3(_this.$tree, {
        checkbox: checkbox,
        bar: bar,
        buttonAddHTML: buttonAddHTML,
        buttonAddClassName: buttonAddClassName,
        buttonAddSrc: buttonAddSrc,
        onClickAdd: onClickAdd,
        buttonDelHTML: buttonDelHTML,
        buttonDelClassName: buttonDelClassName,
        buttonDelSrc: buttonDelSrc,
        onClickDel: onClickDel,
        onClickLastChild: onClickLastChild // 没有子节点
      });
      _this.setState({
        instance: instance
      });
    };

    _this.state = {
      instance: null
    };
    return _this;
  }

  createClass(Tree, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      return React__default.createElement(
        'div',
        { ref: function ref(el) {
            _this2.$el = el;
          }, className: 'tree-box' },
        React__default.createElement('ul', { ref: function ref(el) {
            _this2.$tree = el;
          }, className: 'tree' })
      );
    }
  }]);
  return Tree;
}(React.Component);

Tree$1.propTypes = {
  checkbox: propTypes.bool,
  bar: propTypes.oneOfType([// 选中栏
  propTypes.string, propTypes.node]),
  selected: propTypes.array, // [{id: '', name: '', parentid: ''}]
  list: propTypes.array, // [{id: '', name: '', parentid: ''}]

  buttonAddHTML: propTypes.string,
  buttonAddClassName: propTypes.string,
  buttonAddSrc: propTypes.string,
  onClickAdd: propTypes.func,

  buttonDelHTML: propTypes.string,
  buttonDelClassName: propTypes.string,
  buttonDelSrc: propTypes.string,
  onClickDel: propTypes.func,

  onClickLastChild: propTypes.func
};
Tree$1.defaultProps = {
  list: []
};

// 新增: 转为ES6模式
var _FastClick = null;(function () {
	'use strict';

	/**
  * @preserve FastClick: polyfill to remove click delays on browsers with touch UIs.
  *
  * @codingstandard ftlabs-jsv2
  * @copyright The Financial Times Limited [All Rights Reserved]
  * @license MIT License (see LICENSE.txt)
  */

	/*jslint browser:true, node:true*/
	/*global define, Event, Node*/

	/**
  * Instantiate fast-clicking listeners on the specified layer.
  *
  * @constructor
  * @param {Element} layer The layer to listen on
  * @param {Object} [options={}] The options to override the defaults
  */
	// 新增: 转为ES6模式

	_FastClick = function FastClick(layer, options) {
		var oldOnClick;

		options = options || {};

		/**
   * Whether a click is currently being tracked.
   *
   * @type boolean
   */
		this.trackingClick = false;

		/**
   * Timestamp for when click tracking started.
   *
   * @type number
   */
		this.trackingClickStart = 0;

		/**
   * The element being tracked for a click.
   *
   * @type EventTarget
   */
		this.targetElement = null;

		/**
   * X-coordinate of touch start event.
   *
   * @type number
   */
		this.touchStartX = 0;

		/**
   * Y-coordinate of touch start event.
   *
   * @type number
   */
		this.touchStartY = 0;

		/**
   * ID of the last touch, retrieved from Touch.identifier.
   *
   * @type number
   */
		this.lastTouchIdentifier = 0;

		/**
   * Touchmove boundary, beyond which a click will be cancelled.
   *
   * @type number
   */
		this.touchBoundary = options.touchBoundary || 10;

		/**
   * The FastClick layer.
   *
   * @type Element
   */
		this.layer = layer;

		/**
   * The minimum time between tap(touchstart and touchend) events
   *
   * @type number
   */
		this.tapDelay = options.tapDelay || 200;

		/**
   * The maximum time for a tap
   *
   * @type number
   */
		this.tapTimeout = options.tapTimeout || 700;

		if (_FastClick.notNeeded(layer)) {
			return;
		}

		// Some old versions of Android don't have Function.prototype.bind
		function bind(method, context) {
			return function () {
				return method.apply(context, arguments);
			};
		}

		var methods = ['onMouse', 'onClick', 'onTouchStart', 'onTouchMove', 'onTouchEnd', 'onTouchCancel'];
		var context = this;
		for (var i = 0, l = methods.length; i < l; i++) {
			context[methods[i]] = bind(context[methods[i]], context);
		}

		// Set up event handlers as required
		if (deviceIsAndroid) {
			layer.addEventListener('mouseover', this.onMouse, true);
			layer.addEventListener('mousedown', this.onMouse, true);
			layer.addEventListener('mouseup', this.onMouse, true);
		}

		layer.addEventListener('click', this.onClick, true);
		layer.addEventListener('touchstart', this.onTouchStart, false);
		layer.addEventListener('touchmove', this.onTouchMove, false);
		layer.addEventListener('touchend', this.onTouchEnd, false);
		layer.addEventListener('touchcancel', this.onTouchCancel, false);

		// Hack is required for browsers that don't support Event#stopImmediatePropagation (e.g. Android 2)
		// which is how FastClick normally stops click events bubbling to callbacks registered on the FastClick
		// layer when they are cancelled.
		if (!Event.prototype.stopImmediatePropagation) {
			layer.removeEventListener = function (type, callback, capture) {
				var rmv = Node.prototype.removeEventListener;
				if (type === 'click') {
					rmv.call(layer, type, callback.hijacked || callback, capture);
				} else {
					rmv.call(layer, type, callback, capture);
				}
			};

			layer.addEventListener = function (type, callback, capture) {
				var adv = Node.prototype.addEventListener;
				if (type === 'click') {
					adv.call(layer, type, callback.hijacked || (callback.hijacked = function (event) {
						if (!event.propagationStopped) {
							callback(event);
						}
					}), capture);
				} else {
					adv.call(layer, type, callback, capture);
				}
			};
		}

		// If a handler is already declared in the element's onclick attribute, it will be fired before
		// FastClick's onClick handler. Fix this by pulling out the user-defined handler function and
		// adding it as listener.
		if (typeof layer.onclick === 'function') {

			// Android browser on at least 3.2 requires a new reference to the function in layer.onclick
			// - the old one won't work if passed to addEventListener directly.
			oldOnClick = layer.onclick;
			layer.addEventListener('click', function (event) {
				oldOnClick(event);
			}, false);
			layer.onclick = null;
		}
	};

	/**
 * Windows Phone 8.1 fakes user agent string to look like Android and iPhone.
 *
 * @type boolean
 */
	var deviceIsWindowsPhone = navigator.userAgent.indexOf("Windows Phone") >= 0;

	/**
  * Android requires exceptions.
  *
  * @type boolean
  */
	var deviceIsAndroid = navigator.userAgent.indexOf('Android') > 0 && !deviceIsWindowsPhone;

	/**
  * iOS requires exceptions.
  *
  * @type boolean
  */
	var deviceIsIOS = /iP(ad|hone|od)/.test(navigator.userAgent) && !deviceIsWindowsPhone;

	/**
  * iOS 4 requires an exception for select elements.
  *
  * @type boolean
  */
	var deviceIsIOS4 = deviceIsIOS && /OS 4_\d(_\d)?/.test(navigator.userAgent);

	/**
  * iOS 6.0-7.* requires the target element to be manually derived
  *
  * @type boolean
  */
	var deviceIsIOSWithBadTarget = deviceIsIOS && /OS [6-7]_\d/.test(navigator.userAgent);

	/**
  * BlackBerry requires exceptions.
  *
  * @type boolean
  */
	var deviceIsBlackBerry10 = navigator.userAgent.indexOf('BB10') > 0;

	/**
  * Determine whether a given element requires a native click.
  *
  * @param {EventTarget|Element} target Target DOM element
  * @returns {boolean} Returns true if the element needs a native click
  */
	_FastClick.prototype.needsClick = function (target) {
		switch (target.nodeName.toLowerCase()) {

			// Don't send a synthetic click to disabled inputs (issue #62)
			case 'button':
			case 'select':
			case 'textarea':
				if (target.disabled) {
					return true;
				}

				break;
			case 'input':

				// File inputs need real clicks on iOS 6 due to a browser bug (issue #68)
				if (deviceIsIOS && target.type === 'file' || target.disabled) {
					return true;
				}

				break;
			case 'label':
			case 'iframe': // iOS8 homescreen apps can prevent events bubbling into frames
			case 'video':
				return true;
		}

		return (/\bneedsclick\b/.test(target.className)
		);
	};

	/**
  * Determine whether a given element requires a call to focus to simulate click into element.
  *
  * @param {EventTarget|Element} target Target DOM element
  * @returns {boolean} Returns true if the element requires a call to focus to simulate native click.
  */
	_FastClick.prototype.needsFocus = function (target) {
		switch (target.nodeName.toLowerCase()) {
			case 'textarea':
				return true;
			case 'select':
				return !deviceIsAndroid;
			case 'input':
				switch (target.type) {
					case 'button':
					case 'checkbox':
					case 'file':
					case 'image':
					case 'radio':
					case 'submit':
						return false;
				}

				// No point in attempting to focus disabled inputs
				return !target.disabled && !target.readOnly;
			default:
				return (/\bneedsfocus\b/.test(target.className)
				);
		}
	};

	/**
  * Send a click event to the specified element.
  *
  * @param {EventTarget|Element} targetElement
  * @param {Event} event
  */
	_FastClick.prototype.sendClick = function (targetElement, event) {
		var clickEvent, touch;

		// On some Android devices activeElement needs to be blurred otherwise the synthetic click will have no effect (#24)
		if (document.activeElement && document.activeElement !== targetElement) {
			document.activeElement.blur();
		}

		touch = event.changedTouches[0];

		// Synthesise a click event, with an extra attribute so it can be tracked
		clickEvent = document.createEvent('MouseEvents');
		clickEvent.initMouseEvent(this.determineEventType(targetElement), true, true, window, 1, touch.screenX, touch.screenY, touch.clientX, touch.clientY, false, false, false, false, 0, null);
		clickEvent.forwardedTouchEvent = true;
		targetElement.dispatchEvent(clickEvent);
	};

	_FastClick.prototype.determineEventType = function (targetElement) {

		//Issue #159: Android Chrome Select Box does not open with a synthetic click event
		if (deviceIsAndroid && targetElement.tagName.toLowerCase() === 'select') {
			return 'mousedown';
		}

		return 'click';
	};

	/**
  * @param {EventTarget|Element} targetElement
  */
	_FastClick.prototype.focus = function (targetElement) {
		var length;

		// Issue #160: on iOS 7, some input elements (e.g. date datetime month) throw a vague TypeError on setSelectionRange. These elements don't have an integer value for the selectionStart and selectionEnd properties, but unfortunately that can't be used for detection because accessing the properties also throws a TypeError. Just check the type instead. Filed as Apple bug #15122724.
		if (deviceIsIOS && targetElement.setSelectionRange && targetElement.type.indexOf('date') !== 0 && targetElement.type !== 'time' && targetElement.type !== 'month' && targetElement.type !== 'email') {
			length = targetElement.value.length;
			// 新增: 修复number框无法执行'setSelectionRange'的bug
			// targetElement.setSelectionRange(length, length);
			if (deviceIsIOS) {
				try {
					length = targetElement.value.length;
					targetElement.setSelectionRange(length, length);
				} catch (error) {
					console.log(error);
				}
				// 修复bug ios 11.3不弹出键盘，这里加上聚焦代码，让其强制聚焦弹出键盘
				targetElement.focus();
			}
		} else {
			targetElement.focus();
		}
	};

	/**
  * Check whether the given target element is a child of a scrollable layer and if so, set a flag on it.
  *
  * @param {EventTarget|Element} targetElement
  */
	_FastClick.prototype.updateScrollParent = function (targetElement) {
		var scrollParent, parentElement;

		scrollParent = targetElement.fastClickScrollParent;

		// Attempt to discover whether the target element is contained within a scrollable layer. Re-check if the
		// target element was moved to another parent.
		if (!scrollParent || !scrollParent.contains(targetElement)) {
			parentElement = targetElement;
			do {
				if (parentElement.scrollHeight > parentElement.offsetHeight) {
					scrollParent = parentElement;
					targetElement.fastClickScrollParent = parentElement;
					break;
				}

				parentElement = parentElement.parentElement;
			} while (parentElement);
		}

		// Always update the scroll top tracker if possible.
		if (scrollParent) {
			scrollParent.fastClickLastScrollTop = scrollParent.scrollTop;
		}
	};

	/**
  * @param {EventTarget} targetElement
  * @returns {Element|EventTarget}
  */
	_FastClick.prototype.getTargetElementFromEventTarget = function (eventTarget) {

		// On some older browsers (notably Safari on iOS 4.1 - see issue #56) the event target may be a text node.
		if (eventTarget.nodeType === Node.TEXT_NODE) {
			return eventTarget.parentNode;
		}

		return eventTarget;
	};

	/**
  * On touch start, record the position and scroll offset.
  *
  * @param {Event} event
  * @returns {boolean}
  */
	_FastClick.prototype.onTouchStart = function (event) {
		var targetElement, touch, selection;

		// Ignore multiple touches, otherwise pinch-to-zoom is prevented if both fingers are on the FastClick element (issue #111).
		if (event.targetTouches.length > 1) {
			return true;
		}

		targetElement = this.getTargetElementFromEventTarget(event.target);
		touch = event.targetTouches[0];

		if (deviceIsIOS) {

			// Only trusted events will deselect text on iOS (issue #49)
			selection = window.getSelection();
			if (selection.rangeCount && !selection.isCollapsed) {
				return true;
			}

			if (!deviceIsIOS4) {

				// Weird things happen on iOS when an alert or confirm dialog is opened from a click event callback (issue #23):
				// when the user next taps anywhere else on the page, new touchstart and touchend events are dispatched
				// with the same identifier as the touch event that previously triggered the click that triggered the alert.
				// Sadly, there is an issue on iOS 4 that causes some normal touch events to have the same identifier as an
				// immediately preceeding touch event (issue #52), so this fix is unavailable on that platform.
				// Issue 120: touch.identifier is 0 when Chrome dev tools 'Emulate touch events' is set with an iOS device UA string,
				// which causes all touch events to be ignored. As this block only applies to iOS, and iOS identifiers are always long,
				// random integers, it's safe to to continue if the identifier is 0 here.
				if (touch.identifier && touch.identifier === this.lastTouchIdentifier) {
					event.preventDefault();
					return false;
				}

				this.lastTouchIdentifier = touch.identifier;

				// If the target element is a child of a scrollable layer (using -webkit-overflow-scrolling: touch) and:
				// 1) the user does a fling scroll on the scrollable layer
				// 2) the user stops the fling scroll with another tap
				// then the event.target of the last 'touchend' event will be the element that was under the user's finger
				// when the fling scroll was started, causing FastClick to send a click event to that layer - unless a check
				// is made to ensure that a parent layer was not scrolled before sending a synthetic click (issue #42).
				this.updateScrollParent(targetElement);
			}
		}

		this.trackingClick = true;
		this.trackingClickStart = event.timeStamp;
		this.targetElement = targetElement;

		this.touchStartX = touch.pageX;
		this.touchStartY = touch.pageY;

		// Prevent phantom clicks on fast double-tap (issue #36)
		if (event.timeStamp - this.lastClickTime < this.tapDelay) {
			event.preventDefault();
		}

		return true;
	};

	/**
  * Based on a touchmove event object, check whether the touch has moved past a boundary since it started.
  *
  * @param {Event} event
  * @returns {boolean}
  */
	_FastClick.prototype.touchHasMoved = function (event) {
		var touch = event.changedTouches[0],
		    boundary = this.touchBoundary;

		if (Math.abs(touch.pageX - this.touchStartX) > boundary || Math.abs(touch.pageY - this.touchStartY) > boundary) {
			return true;
		}

		return false;
	};

	/**
  * Update the last position.
  *
  * @param {Event} event
  * @returns {boolean}
  */
	_FastClick.prototype.onTouchMove = function (event) {
		if (!this.trackingClick) {
			return true;
		}

		// If the touch has moved, cancel the click tracking
		if (this.targetElement !== this.getTargetElementFromEventTarget(event.target) || this.touchHasMoved(event)) {
			this.trackingClick = false;
			this.targetElement = null;
		}

		return true;
	};

	/**
  * Attempt to find the labelled control for the given label element.
  *
  * @param {EventTarget|HTMLLabelElement} labelElement
  * @returns {Element|null}
  */
	_FastClick.prototype.findControl = function (labelElement) {

		// Fast path for newer browsers supporting the HTML5 control attribute
		if (labelElement.control !== undefined) {
			return labelElement.control;
		}

		// All browsers under test that support touch events also support the HTML5 htmlFor attribute
		if (labelElement.htmlFor) {
			return document.getElementById(labelElement.htmlFor);
		}

		// If no for attribute exists, attempt to retrieve the first labellable descendant element
		// the list of which is defined here: http://www.w3.org/TR/html5/forms.html#category-label
		return labelElement.querySelector('button, input:not([type=hidden]), keygen, meter, output, progress, select, textarea');
	};

	/**
  * On touch end, determine whether to send a click event at once.
  *
  * @param {Event} event
  * @returns {boolean}
  */
	_FastClick.prototype.onTouchEnd = function (event) {
		var forElement,
		    trackingClickStart,
		    targetTagName,
		    scrollParent,
		    touch,
		    targetElement = this.targetElement;

		if (!this.trackingClick) {
			return true;
		}

		// Prevent phantom clicks on fast double-tap (issue #36)
		if (event.timeStamp - this.lastClickTime < this.tapDelay) {
			this.cancelNextClick = true;
			return true;
		}

		if (event.timeStamp - this.trackingClickStart > this.tapTimeout) {
			return true;
		}

		// Reset to prevent wrong click cancel on input (issue #156).
		this.cancelNextClick = false;

		this.lastClickTime = event.timeStamp;

		trackingClickStart = this.trackingClickStart;
		this.trackingClick = false;
		this.trackingClickStart = 0;

		// On some iOS devices, the targetElement supplied with the event is invalid if the layer
		// is performing a transition or scroll, and has to be re-detected manually. Note that
		// for this to function correctly, it must be called *after* the event target is checked!
		// See issue #57; also filed as rdar://13048589 .
		if (deviceIsIOSWithBadTarget) {
			touch = event.changedTouches[0];

			// In certain cases arguments of elementFromPoint can be negative, so prevent setting targetElement to null
			targetElement = document.elementFromPoint(touch.pageX - window.pageXOffset, touch.pageY - window.pageYOffset) || targetElement;
			targetElement.fastClickScrollParent = this.targetElement.fastClickScrollParent;
		}

		targetTagName = targetElement.tagName.toLowerCase();
		if (targetTagName === 'label') {
			forElement = this.findControl(targetElement);
			if (forElement) {
				this.focus(targetElement);
				if (deviceIsAndroid) {
					return false;
				}

				targetElement = forElement;
			}
		} else if (this.needsFocus(targetElement)) {

			// Case 1: If the touch started a while ago (best guess is 100ms based on tests for issue #36) then focus will be triggered anyway. Return early and unset the target element reference so that the subsequent click will be allowed through.
			// Case 2: Without this exception for input elements tapped when the document is contained in an iframe, then any inputted text won't be visible even though the value attribute is updated as the user types (issue #37).
			if (event.timeStamp - trackingClickStart > 100 || deviceIsIOS && window.top !== window && targetTagName === 'input') {
				this.targetElement = null;
				return false;
			}

			this.focus(targetElement);
			this.sendClick(targetElement, event);

			// Select elements need the event to go through on iOS 4, otherwise the selector menu won't open.
			// Also this breaks opening selects when VoiceOver is active on iOS6, iOS7 (and possibly others)
			if (!deviceIsIOS || targetTagName !== 'select') {
				this.targetElement = null;
				event.preventDefault();
			}

			return false;
		}

		if (deviceIsIOS && !deviceIsIOS4) {

			// Don't send a synthetic click event if the target element is contained within a parent layer that was scrolled
			// and this tap is being used to stop the scrolling (usually initiated by a fling - issue #42).
			scrollParent = targetElement.fastClickScrollParent;
			if (scrollParent && scrollParent.fastClickLastScrollTop !== scrollParent.scrollTop) {
				return true;
			}
		}

		// Prevent the actual click from going though - unless the target node is marked as requiring
		// real clicks or if it is in the whitelist in which case only non-programmatic clicks are permitted.
		if (!this.needsClick(targetElement)) {
			event.preventDefault();
			this.sendClick(targetElement, event);
		}

		return false;
	};

	/**
  * On touch cancel, stop tracking the click.
  *
  * @returns {void}
  */
	_FastClick.prototype.onTouchCancel = function () {
		this.trackingClick = false;
		this.targetElement = null;
	};

	/**
  * Determine mouse events which should be permitted.
  *
  * @param {Event} event
  * @returns {boolean}
  */
	_FastClick.prototype.onMouse = function (event) {

		// If a target element was never set (because a touch event was never fired) allow the event
		if (!this.targetElement) {
			return true;
		}

		if (event.forwardedTouchEvent) {
			return true;
		}

		// Programmatically generated events targeting a specific element should be permitted
		if (!event.cancelable) {
			return true;
		}

		// Derive and check the target element to see whether the mouse event needs to be permitted;
		// unless explicitly enabled, prevent non-touch click events from triggering actions,
		// to prevent ghost/doubleclicks.
		if (!this.needsClick(this.targetElement) || this.cancelNextClick) {

			// Prevent any user-added listeners declared on FastClick element from being fired.
			if (event.stopImmediatePropagation) {
				event.stopImmediatePropagation();
			} else {

				// Part of the hack for browsers that don't support Event#stopImmediatePropagation (e.g. Android 2)
				event.propagationStopped = true;
			}

			// Cancel the event
			event.stopPropagation();
			event.preventDefault();

			return false;
		}

		// If the mouse event is permitted, return true for the action to go through.
		return true;
	};

	/**
  * On actual clicks, determine whether this is a touch-generated click, a click action occurring
  * naturally after a delay after a touch (which needs to be cancelled to avoid duplication), or
  * an actual click which should be permitted.
  *
  * @param {Event} event
  * @returns {boolean}
  */
	_FastClick.prototype.onClick = function (event) {
		var permitted;

		// It's possible for another FastClick-like library delivered with third-party code to fire a click event before FastClick does (issue #44). In that case, set the click-tracking flag back to false and return early. This will cause onTouchEnd to return early.
		if (this.trackingClick) {
			this.targetElement = null;
			this.trackingClick = false;
			return true;
		}

		// Very odd behaviour on iOS (issue #18): if a submit element is present inside a form and the user hits enter in the iOS simulator or clicks the Go button on the pop-up OS keyboard the a kind of 'fake' click event will be triggered with the submit-type input element as the target.
		if (event.target.type === 'submit' && event.detail === 0) {
			return true;
		}

		permitted = this.onMouse(event);

		// Only unset targetElement if the click is not permitted. This will ensure that the check for !targetElement in onMouse fails and the browser's click doesn't go through.
		if (!permitted) {
			this.targetElement = null;
		}

		// If clicks are permitted, return true for the action to go through.
		return permitted;
	};

	/**
  * Remove all FastClick's event listeners.
  *
  * @returns {void}
  */
	_FastClick.prototype.destroy = function () {
		var layer = this.layer;

		if (deviceIsAndroid) {
			layer.removeEventListener('mouseover', this.onMouse, true);
			layer.removeEventListener('mousedown', this.onMouse, true);
			layer.removeEventListener('mouseup', this.onMouse, true);
		}

		layer.removeEventListener('click', this.onClick, true);
		layer.removeEventListener('touchstart', this.onTouchStart, false);
		layer.removeEventListener('touchmove', this.onTouchMove, false);
		layer.removeEventListener('touchend', this.onTouchEnd, false);
		layer.removeEventListener('touchcancel', this.onTouchCancel, false);
	};

	/**
  * Check whether FastClick is needed.
  *
  * @param {Element} layer The layer to listen on
  */
	_FastClick.notNeeded = function (layer) {
		var metaViewport;
		var chromeVersion;
		var blackberryVersion;
		var firefoxVersion;

		// Devices that don't support touch don't need FastClick
		if (typeof window.ontouchstart === 'undefined') {
			return true;
		}

		// Chrome version - zero for other browsers
		chromeVersion = +(/Chrome\/([0-9]+)/.exec(navigator.userAgent) || [, 0])[1];

		if (chromeVersion) {

			if (deviceIsAndroid) {
				metaViewport = document.querySelector('meta[name=viewport]');

				if (metaViewport) {
					// Chrome on Android with user-scalable="no" doesn't need FastClick (issue #89)
					if (metaViewport.content.indexOf('user-scalable=no') !== -1) {
						return true;
					}
					// Chrome 32 and above with width=device-width or less don't need FastClick
					if (chromeVersion > 31 && document.documentElement.scrollWidth <= window.outerWidth) {
						return true;
					}
				}

				// Chrome desktop doesn't need FastClick (issue #15)
			} else {
				return true;
			}
		}

		if (deviceIsBlackBerry10) {
			blackberryVersion = navigator.userAgent.match(/Version\/([0-9]*)\.([0-9]*)/);

			// BlackBerry 10.3+ does not require Fastclick library.
			// https://github.com/ftlabs/fastclick/issues/251
			if (blackberryVersion[1] >= 10 && blackberryVersion[2] >= 3) {
				metaViewport = document.querySelector('meta[name=viewport]');

				if (metaViewport) {
					// user-scalable=no eliminates click delay.
					if (metaViewport.content.indexOf('user-scalable=no') !== -1) {
						return true;
					}
					// width=device-width (or less than device-width) eliminates click delay.
					if (document.documentElement.scrollWidth <= window.outerWidth) {
						return true;
					}
				}
			}
		}

		// IE10 with -ms-touch-action: none or manipulation, which disables double-tap-to-zoom (issue #97)
		if (layer.style.msTouchAction === 'none' || layer.style.touchAction === 'manipulation') {
			return true;
		}

		// Firefox version - zero for other browsers
		firefoxVersion = +(/Firefox\/([0-9]+)/.exec(navigator.userAgent) || [, 0])[1];

		if (firefoxVersion >= 27) {
			// Firefox 27+ does not have tap delay if the content is not zoomable - https://bugzilla.mozilla.org/show_bug.cgi?id=922896

			metaViewport = document.querySelector('meta[name=viewport]');
			if (metaViewport && (metaViewport.content.indexOf('user-scalable=no') !== -1 || document.documentElement.scrollWidth <= window.outerWidth)) {
				return true;
			}
		}

		// IE11: prefixed -ms-touch-action is no longer supported and it's recomended to use non-prefixed version
		// http://msdn.microsoft.com/en-us/library/windows/apps/Hh767313.aspx
		if (layer.style.touchAction === 'none' || layer.style.touchAction === 'manipulation') {
			return true;
		}

		return false;
	};

	/**
  * Factory method for creating a FastClick object
  *
  * @param {Element} layer The layer to listen on
  * @param {Object} [options={}] The options to override the defaults
  */
	_FastClick.attach = function (layer, options) {
		return new _FastClick(layer, options);
	};

	if (typeof define === 'function' && _typeof(define.amd) === 'object' && define.amd) {

		// AMD. Register as an anonymous module.
		define(function () {
			return _FastClick;
		});
	} else if (typeof module !== 'undefined' && module.exports) {
		module.exports = _FastClick.attach;
		module.exports.FastClick = _FastClick;
	} else {
		window.FastClick = _FastClick;
	}
})();

// 新增: 转为ES6模式
/* eslint-enable */
var _FastClick$1 = _FastClick;

// import './PrototypePinyin.js'; // 不常用

// components
// import Aside from './Aside'; // 待定
// utils
// import Ajax from './Ajax.js'; // 原生的Ajax,如不需要，不要加载
// import Animate from './Animate.js'; // 用于帧率测试一次动画等,如不需要，不要加载
// import Superagent from './ApiSuperagent.js'; // 与Axios同类型,推荐使用Axios
// import BackboneRoute from './Route.js'; // 用于路由监听,如不需要，不要加载
// import EditUtil from './EditUtil.js'; // 用于富文本,如不需要，不要加载
// import Form from './Form.js'; // 用于表单序列化等操作,如不需要，不要加载
// import FormControls from './FormControls.js'; // 用于表单动画控件如小眼睛、安全校验框等,如不需要，不要加载
// import Fullscreen from './Fullscreen.js'; // 用于判断浏览器是否处于全屏状态,如不需要，不要加载
// import History from './History.js'; // 用于路由监听,如不需要，不要加载
// import MediaUtil from './MediaUtil.js'; // 用于视频音频
// import Pubsub from './Pubsub.js'; // 用于订阅发布模式
// import ValidateID from './ValidateID.js'; // 用于身份证信息查询,很大,如不需要,不要加载
// import Validator from './Validator.js'; // 用于表单校验,如不需要,不要加载

// bridge

exports.Actionsheet = Actionsheet$1;
exports.Alert = Alert$1;
exports.Article = Article$1;
exports.Attribute = Attributes;
exports.Attributes = Attributes$2;
exports.Badge = Badge$1;
exports.BiDoughnut = BiDoughnut$1;
exports.BiGauge = BiGauge$1;
exports.Button = Button$1;
exports.Calendar = Calendar$1;
exports.Card = Card$1;
exports.Carrousel = Carrousel$1;
exports.Chat = Chat$1;
exports.Checkbox = Checkbox$1;
exports.Clock = Clock$1;
exports.Close = Close$1;
exports.Container = Container$1;
exports.Counter = Counter$1;
exports.Dialog = Dialog$1;
exports.Dot = Dot$1;
exports.Dragrefresh = Dragrefresh$1;
exports.Dropdown = Dropdown$1;
exports.Emoji = Dialog$3;
exports.Footer = Footer$1;
exports.Grid = Grid$1;
exports.Group = Group$1;
exports.Handsign = Handsign$1;
exports.Header = Header$1;
exports.Icon = Icon$1;
exports.ImgLazy = ImgLazy$2;
exports.ImgUploader = ImgUploader$1;
exports.InputArea = InputArea$1;
exports.InputCity = InputPicker;
exports.InputColor = InputPhone;
exports.InputDate = InputPicker$1;
exports.InputLocation = InputLocation$1;
exports.InputNumber = InputNumber$1;
exports.InputPassword = InputPassword$1;
exports.InputPhone = InputPhone$2;
exports.InputPicker = InputPicker$3;
exports.InputPre = InputPre$1;
exports.InputSafe = InputSafe$1;
exports.InputSelect = InputSelect$1;
exports.InputText = InputText$1;
exports.InputVerify = InputVerify$1;
exports.Legend = Legend$1;
exports.List = List$1;
exports.Loading = Loading$3;
exports.Mark = Mark$1;
exports.Marquee = Marquee$1;
exports.MenuTiled = MenuTiled$1;
exports.MenuTree = MenuTree$1;
exports.NoNetwork = NoNetwork$1;
exports.Notice = Notice$1;
exports.NumBox = NumBox$1;
exports.NumBoxPop = NumBoxPop$1;
exports.NumBoxPopPointer = NumBoxPopPointer$1;
exports.OnOff = OnOff$1;
exports.Page = Page$1;
exports.Peg = Peg$1;
exports.Picker = Picker$2;
exports.PickerCity = PickerCity$1;
exports.PickerDate = PickerDate$1;
exports.Popover = Popover$1;
exports.Price = Price$1;
exports.Progress = Progress$1;
exports.Radio = Radio$1;
exports.SearchBar = SearchBar$1;
exports.SearchBarPointer = SearchBarPointer$1;
exports.SearchBoard = SearchBoard$1;
exports.SelectPicker = SelectPicker$1;
exports.Star = Star$1;
exports.StarGroup = StarGroup$1;
exports.Stencil = Dialog$4;
exports.Sticker = Peg$3;
exports.Tabbar = Tabbar$1;
exports.Ticket = Ticket$1;
exports.Timeline = Timeline$1;
exports.Timepart = Timepart$1;
exports.Titlebar = Titlebar$1;
exports.Toast = Toast$3;
exports.Tree = Tree$1;
exports.Axios = Api;
exports.Clipboard = Clipboard;
exports.DB = DB;
exports.Device = Device;
exports.EventUtil = EventUtil;
exports.FastClick = _FastClick$1;
exports.Bridge = Bridge$1;

}((this.seedsui = this.seedsui || {}),React,ReactDOM,axios));
//# sourceMappingURL=seedsui-react.js.map
